package com.engine.kq.util;

import java.time.Duration;
import java.time.LocalTime;

public class TimeRangeCalculator {
    public static double getRestTime(String startTime, String endTime, String restStartTime, String restEndTime) {
        LocalTime workStart = LocalTime.parse(startTime);
        LocalTime workEnd = LocalTime.parse(endTime);
        LocalTime restStart = LocalTime.parse(restStartTime);
        LocalTime restEnd = LocalTime.parse(restEndTime);
        Duration restDuration = Duration.ZERO;
        if (!restStart.isAfter(workEnd) && !restEnd.isBefore(workStart)) {

            LocalTime effectiveRestStart = restStart.isBefore(workStart) ? workStart : restStart;
            LocalTime effectiveRestEnd = restEnd.isAfter(workEnd) ? workEnd : restEnd;
            restDuration = Duration.between(effectiveRestStart, effectiveRestEnd);
        }
        return restDuration.getSeconds();
    }
}