package com.engine.nbkq.web;

import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONObject;
import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.kq.biz.KQGroupMemberComInfo;
import com.engine.nbkq.service.NbkqService;
import com.engine.nbkq.service.impl.NbkqServiceImpl;
import com.engine.workflow.util.CommonUtil;
import org.apache.commons.lang3.StringUtils;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.TimeUtil;
import weaver.general.Util;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;
import weaver.workflow.webservices.WorkflowServiceImpl;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.*;


/**
 * Created with IntelliJ IDEA.
 *
 * @Auther: chenxu
 * @Date: 2023/09/06/15:21
 * @Description:
 */
public class NbkqInfoAction {

    private NbkqService nbkqService = null;

    private void setService() {
        nbkqService = (NbkqServiceImpl) ServiceUtil.getService(NbkqServiceImpl.class);
    }

    /**
     * 校验加班流程是否可以提交
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/checkOverTime")
    @Produces({MediaType.TEXT_PLAIN})
    public String checkOverTime(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        JSONObject jsonObject = new JSONObject();
        BaseBean bb = new BaseBean();
        RecordSet rs = new RecordSet();
        User user = HrmUserVarify.getUser(request, response);
        bb.writeLog("checkOverTime==>");
        String code = "200";
        String msg = "success";
        try{
            Integer userId = user.getUID();
            bb.writeLog("checkOverTime==>userId:"+userId);
            String jblx = Util.null2String(request.getParameter("jblx"));
            String sqsc = Util.null2String(request.getParameter("sqsc"));
            bb.writeLog("jblx:"+jblx);
            bb.writeLog("sqsc:"+sqsc);
            Double sqscNew = Double.valueOf(sqsc);
            /*获取考勤组的ID，因为考勤组有有效期，所以需要传入日期*/
            KQGroupMemberComInfo kqGroupMemberComInfo = new KQGroupMemberComInfo();
            String dateThis = TimeUtil.getMonthBeginDay();
            String groupId = kqGroupMemberComInfo.getKQGroupId(String.valueOf(userId), dateThis);
            bb.writeLog("获取当前人员groupId:"+groupId);
            //管理人员考勤组id
            String glgroupid = bb.getPropValue("nbkq_main","glgroupid");
            //管理人员12小时班制考勤组id
            String glrygroupid = bb.getPropValue("nbkq_main","glrygroupid");
            Boolean checkBxs = checkBxs(sqscNew);
            if(groupId.equals(glgroupid)){
                //是管理人员单双休
                if("0".equals(jblx)){
                    //临时去一线
                    //判断是否小于0.5
                    if(sqscNew<0.5){
                        code = "2";
                        msg = "最小加班时长为0.5小时";
                    }else{
                        if(!checkBxs){
                            //非半小时计提
                            code = "3";
                            msg = "需要以半小时计提";
                        }else{

                        }
                    }
                }else{
                    //管理人员的单双休班次加班规则是加班最小单位是2小时，以1小时为递增计算单位,例如2、3、4
                    //判断申请时长是否为整数
                    Boolean checkZs = checkZs(sqscNew);
                    if (checkZs){
                        //判断是否小于2
                        if(sqscNew<2){
                            code = "1";
                            msg = "最小加班时长为2小时";
                        }else{
                            //暂不做处理
                        }
                    }else{
                        code = "0";
                        msg = "需要以1小时计提";
                    }
                }
            }else if(groupId.equals(glrygroupid)){
                //是管理人员12小时班
                if("0".equals(jblx)){
                    //临时去一线
                    //判断是否小于0.5
                    if(sqscNew<0.5){
                        code = "2";
                        msg = "最小加班时长为0.5小时";
                    }else{
                        if(!checkBxs){
                            //非半小时计提
                            code = "3";
                            msg = "需要以半小时计提";
                        }else{
                            //暂不做处理
                        }
                    }
                }else{
                    //管理人员的12小时班制加班规则是加班最小单位是1小时，以1小时为递增计算单位,例如1、2、3
                    //判断申请时长是否为整数
                    Boolean checkZs = checkZs(sqscNew);
                    if (checkZs){
                        //判断是否小于1
                        if(sqscNew<1){
                            code = "1";
                            msg = "最小加班时长为1小时";
                        }else{
                            //暂不做处理
                        }
                    }else{
                        code = "0";
                        msg = "需要以1小时计提";
                    }
                }
            }else{
                //不是管理人员
                //判断是否小于0.5
                if(sqscNew<0.5){
                    code = "2";
                    msg = "最小加班时长为0.5小时";
                }else{
                    if(!checkBxs){
                        //非半小时计提
                        code = "3";
                        msg = "需要以半小时计提";
                    }else{
                        //暂不做处理
                    }
                }
            }
            jsonObject.put("code",code);
            jsonObject.put("msg",msg);
        }catch (Exception e) {
            e.printStackTrace();
            jsonObject.put("code","500");
            jsonObject.put("msg","fail");
        }
        return JSONObject.toJSONString(jsonObject);
    }


    /**
     * 是否整数
     * @param value
     * @return
     */
    public static Boolean checkZs(Double value){
        return value % 1 == 0;
    }


    /**
     * 是否半小时
     * @param value
     * @return
     */
    public static Boolean checkBxs(Double value){
        return value % 0.5 == 0;
    }



    /**
     * 创建预入职流程
     */
    @GET
    @Path("/createYrzBatch")
    @Produces("text/plain;charset=utf-8")
    public String createYrzBatch(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        Map<String, Object> apidatas = new HashMap<String, Object>();
        try {
            setService();
            apidatas = nbkqService.createYrzBatch(ParamUtil.request2Map(request));
        } catch (Exception e) {
            e.printStackTrace();
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }
        return JSONObject.toJSONString(apidatas);

    }

}
