package com.engine.workflow.cmd.requestForm;

import com.api.doc.mobile.systemDoc.util.DocDetailUtil;
import com.api.odoc.bean.OfficalConditionInfo;
import com.api.odoc.bean.OfficalResultInfo;
import com.api.odoc.util.WorkflowCreateDocPublicUtil;
import com.api.workflow.constant.RequestAuthenticationConstant;
import com.api.workflow.constant.RequestAuthenticationEnum;
import com.api.workflow.service.RequestAuthenticationService;
import com.api.workflow.util.ServiceUtil;
import com.cloudstore.dev.api.util.EMManager;
import com.cloudstore.dev.api.util.Util_TableMap;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.common.service.impl.DocCommonServiceImpl;
import com.engine.common.service.impl.PortalCommonServiceImpl;
import com.engine.common.util.AttrSignatureUtil;
import com.engine.common.util.ParamUtil;
import com.engine.core.exception.ECException;
import com.engine.core.interceptor.CommandContext;
import com.engine.hrm.biz.HrmClassifiedProtectionBiz;
import com.engine.workflow.biz.NodeFieldCheckBiz;
import com.engine.workflow.biz.WorkflowCommunicationBiz;
import com.engine.workflow.biz.excelDesign.DoSaveFreeExcelDesignBiz;
import com.engine.workflow.biz.freeNode.FreeNodeBiz;
import com.engine.workflow.biz.freeNode.SimpleModeFreeNodeBiz;
import com.engine.workflow.biz.requestForm.*;
import com.engine.workflow.biz.requestList.RequestListBiz;
import com.engine.workflow.biz.systemBill.SystemBillManagerBiz;
import com.engine.workflow.biz.wfPathSet.WaterMarkBiz;
import com.engine.workflow.constant.RemindTypeEnum;
import com.engine.workflow.constant.requestForm.PromptType;
import com.engine.workflow.constant.requestForm.RequestConstant;
import com.engine.workflow.constant.requestForm.RequestType;
import com.engine.workflow.entity.core.RequestInfoEntity;
import com.engine.workflow.entity.freeNode.FreeNodeEntity;
import com.engine.workflow.entity.requestForm.RequestOperationResultBean;
import com.engine.workflow.entity.wfPathSet.WfWaterMarkEntity;
import com.engine.workflow.service.RequestSecondAuthService;
import com.engine.workflow.service.impl.RequestSecondAuthServiceImpl;
import com.engine.workflow.util.ChuanyueUtil;
import com.engine.workflow.util.SecondAuthUtil;
import com.engine.workflow.util.WfListCusTitleUtil;
import com.google.common.base.Strings;
import weaver.common.DateUtil;
import weaver.conn.RecordSet;
import weaver.cowork.CoworkDAO;
import weaver.cpt.util.CptWfUtil;
import weaver.crm.Maint.CustomerInfoComInfo;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.hrm.moduledetach.ManageDetachComInfo;
import weaver.hrm.resource.ResourceComInfo;
import weaver.mobile.webservices.workflow.soa.RequestPreProcessing;
import weaver.system.SysWFLMonitor;
import weaver.systeminfo.SystemEnv;
import weaver.workflow.agent.AgentManager;
import weaver.workflow.msg.MsgPushUtil;
import weaver.workflow.msg.entity.MsgEntity;
import weaver.workflow.report.ReportAuthorization;
import weaver.workflow.request.*;
import weaver.workflow.workflow.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.net.URLEncoder;
import java.util.*;
import java.util.regex.Pattern;
import com.engine.workflow.biz.AgentBiz;

/**
 * 功能 1：加载流程表单权限信息 2：加载右键菜单 3：加载签字意见相关基础数据
 * * @author wuser0326
 */
public class LoadParamCmd extends AbstractCommonCommand<Map<String, Object>> {

    private HttpServletRequest request;
    private HttpSession session;
    private int userid;
    private int usertype = 0;
    private String logintype;

    private int workflowid = 0; // 工作流id
    private int nodeid = 0; // 节点id
    private int formid = 0; // 表单或者单据的id
    private int requestid;
    private String isbill = "0"; // 是否单据 0:否 1:是
    private int lastOperator = 0; // 最后操作者id
    private String lastOperateDate = ""; // 最后操作日期
    private String lastOperateTime = ""; // 最后操作时间
    private String f_weaver_belongto_userid;
    private String f_weaver_belongto_usertype;

    private String currentdate;
    private String currenttime;
    private char flag = Util.getSeparator();
    private boolean isprint;
    private Map<String, Object> submitParams = new HashMap<String, Object>();
    private AttrSignatureUtil attrSignatureUtil;
    private int configId = -1;
    private boolean isnewFreeLayout;

    //二开使用request参数
    private Map<String, Object> reqParams;

    public LoadParamCmd(HttpServletRequest request, User user) {
        this.request = request;
        this.user = user;
        session = request.getSession();
        reqParams = ParamUtil.request2Map(request);
        f_weaver_belongto_userid = Util.null2String(request.getParameter("f_weaver_belongto_userid"));
        f_weaver_belongto_usertype = Util.null2String(request.getParameter("f_weaver_belongto_usertype"));
        //user = HrmUserVarify.getUser(request, response, f_weaver_belongto_userid, f_weaver_belongto_usertype);
        userid = user.getUID();
        usertype = "2".equals(user.getLogintype()) ? 1 : 0;
        usertype = "3".equals(user.getLogintype()) ? 2 : usertype;
        logintype = user.getLogintype();

        requestid = Util.getIntValue(request.getParameter("requestid"), -1);

        String iscreate = Util.null2String(request.getParameter("iscreate"));
        DoSaveFreeExcelDesignBiz doSaveFreeExcelDesignBiz = new DoSaveFreeExcelDesignBiz(user);
        if (!iscreate.equals("1")) {
            this.configId = doSaveFreeExcelDesignBiz.getLayoutConfigId(requestid);
        } else {
            configId = Util.getIntValue(request.getParameter("configid"), -1);
        }
        doSaveFreeExcelDesignBiz.getFreeNodeFormConfig(Util.null2String(configId));
        isnewFreeLayout = DoSaveFreeExcelDesignBiz.isNewFreeLayout(Util.null2String(this.configId));//是否是自由流程自定义表单
        if (isnewFreeLayout) {
            this.workflowid = doSaveFreeExcelDesignBiz.getWorkflowid();
        }
        Calendar today = Calendar.getInstance();
        currentdate = Util.add0(today.get(Calendar.YEAR), 4) + "-" + Util.add0(today.get(Calendar.MONTH) + 1, 2) + "-" + Util.add0(today.get(Calendar.DAY_OF_MONTH), 2);
        currenttime = Util.add0(today.get(Calendar.HOUR_OF_DAY), 2) + ":" + Util.add0(today.get(Calendar.MINUTE), 2) + ":" + Util.add0(today.get(Calendar.SECOND), 2);
        //取数据库服务器的当前时间
        RecordSet rs = new RecordSet();
        rs.executeProc("GetDBDateAndTime", "");
        if (rs.next()) {
            currentdate = rs.getString("dbdate");
            currenttime = rs.getString("dbtime");
        }
        isprint = Util.null2String(request.getParameter("isprint")).equals("1");
        f_weaver_belongto_userid = "".equals(f_weaver_belongto_userid) ? userid + "" : f_weaver_belongto_userid;
        f_weaver_belongto_usertype = "".equals(f_weaver_belongto_usertype) ? usertype + "" : f_weaver_belongto_usertype;
        submitParams.put("requestid", requestid);
        submitParams.put("f_weaver_belongto_userid", f_weaver_belongto_userid);
        submitParams.put("f_weaver_belongto_usertype", f_weaver_belongto_usertype);
        submitParams.put("comemessage", Util.null2String(request.getParameter("comemessage")));
        if (isnewFreeLayout) {
            submitParams.put("configid", this.configId);
        }
        attrSignatureUtil = new AttrSignatureUtil(user.getUID(), request.getHeader("user-agent"));
    }

    /**
     * 加载权限
     *
     * @throws Exception
     */
    public Map<String, Object> execute(CommandContext commandContext) throws ECException {
        Map<String, Object> apidatas = new HashMap<String, Object>();
        WorkflowConfigComInfo wcc = new WorkflowConfigComInfo();
        long start = System.currentTimeMillis();
        try {
            Map<String, Object> resultDatas = new HashMap<String, Object>();
            apidatas.put("params", resultDatas);
			//当前用户id，也用于方便确认单点直接打开表单，认证的人是谁
			resultDatas.put("currentUserid", userid);
            //签字意见框和签字意见列表是否使用系统默认的----start
            resultDatas.put("showDefaultSign", Util.null2String(wcc.getValue("signinout_defaultshow")));
            resultDatas.put("showDefaultLogList", Util.null2String(wcc.getValue("requestloglist_defaultshow")));
            //签字意见框和签字意见列表是否使用系统默认的----end

            //是否开启智能预测
            resultDatas.put("openAutoForecast", Util.null2String(wcc.getValue("form_openAutoForecast")));
            //默认显示智能预测
            resultDatas.put("showAutoForecastResult", Util.null2String(wcc.getValue("form_showAutoForecastResult")));
            //em地址，内网和外网----start
            Map<String, String> emData = EMManager.getEMData();
            resultDatas.put("em_url", emData.get(EMManager.em_url));//em内网地址
            resultDatas.put("em_url_open", emData.get(EMManager.em_url_open));//em外网地址
            //em地址，内网和外网----end

            //是否允许使用“所有人”常用组
            resultDatas.put("allowAllPersonGroup", RequestFormBiz.hasAllPersionGroupAuth(user));
            String uuid = UUID.randomUUID().toString().replace("-", "").toUpperCase();
            resultDatas.put("linkageUUID", uuid);
            submitParams.put("linkageUUID", uuid);
            resultDatas.put("layoutconfigid", configId);//自由流程自定义表单配置id
            resultDatas.put("isFreeCustomeForm", DoSaveFreeExcelDesignBiz.judgeIsFreeCustomForm(Util.null2String(workflowid)) ? 1 : 0);
            if (isnewFreeLayout) {
                DoSaveFreeExcelDesignBiz doSaveFreeExcelDesignBiz = new DoSaveFreeExcelDesignBiz(user);
                String freeStartNodeid = doSaveFreeExcelDesignBiz.getCreateNodeid(Util.null2String(workflowid));
                resultDatas.put("freeStartNodeid", freeStartNodeid);
            }

            RecordSet recordSet = new RecordSet();
            String iscreate = Util.null2String(request.getParameter("iscreate"));
            if ("1".equals(iscreate)) {
                return loadCreateCompetence(resultDatas);
            }

            RequestOperationResultBean lastOperationResult = new RequestOperationResultBean();
            //表单顶部提示信息(错误提示、提交预览下一节点操作者、流程编辑锁定)
            //List<String,Object> promptInfoList;

            List<Map<String, Object>> promptInfos = new ArrayList<>();

            Map<String, Object> promptInfo = new HashMap<String, Object>();
            String sessionkey = Util.null2String(request.getParameter("sessionkey"));
            if (!"".equals(sessionkey)) {
                lastOperationResult = (RequestOperationResultBean) Util_TableMap.getObjVal(sessionkey);
//				Util_TableMap.clearVal(sessionkey);
                if (lastOperationResult == null)
                    lastOperationResult = new RequestOperationResultBean();
                promptInfo = lastOperationResult.getMessageInfo();
                apidatas.put("conflictFieldInfo", lastOperationResult.getConflictFieldInfo());
                if (promptInfo != null && !"".equals(Util.null2String(promptInfo.get("prompttype")))) {
                    promptInfos.add(promptInfo);
                    if (promptInfo.get("prompttype").equals("showContent")) {
                        resultDatas.put("needReloadList", true);
                        if ("1".equals(Util.null2String(promptInfo.get("isCustomUrl")))) {
                            resultDatas.put("isCustomUrl", "1");
                        }
                    }
                }
            }

            resultDatas.put("isaffirmanceSrc", Util.null2String(request.getParameter("isaffirmanceSrc")));
            String addressKey = Util.null2String(request.getParameter("address"));
            if (!"".equals(addressKey)) {
                resultDatas.put("position", Util.null2String(request.getParameter("position")));
                resultDatas.put("address", Util_TableMap.getVal(addressKey));
                Util_TableMap.clearVal(addressKey);
            }

            WFLinkInfo wfLinkInfo = new WFLinkInfo();
            RecordSet rs = new RecordSet();
            SysWFLMonitor sysWFLMonitor = new SysWFLMonitor();
            WorkflowComInfo workflowComInfo = new WorkflowComInfo();
            WFUrgerManager wfUrgerManager = new WFUrgerManager();
            WFShareAuthorization wfShareAuthorization = new WFShareAuthorization();
            ReportAuthorization reportAuthorization = new ReportAuthorization();
            CoworkDAO coworkDAO = new CoworkDAO();
            WFManager wfManager = new WFManager();
            WFForwardManager wfForwardManager = new WFForwardManager();
            WFCoadjutantManager wfCoadjutantManager = new WFCoadjutantManager();
            // 设置跳转
            resultDatas.put("sendPage", "");
            resultDatas.put("verifyRight", true);

            boolean isfromtab = Util.null2String(request.getParameter("isfromtab")).equals("true");
            String isworkflowhtmldoc = Util.null2String(request.getParameter("isworkflowhtmldoc"));
            String fromFlowDoc = Util.null2String(request.getParameter("fromFlowDoc")); // 是否从流程创建文档而来

            String info = Util.null2String(request.getParameter("infoKey"));
            int seeflowdoc = Util.getIntValue(request.getParameter("seeflowdoc"), 0);
            String isSubmitDirect = Util.null2String(request.getParameter("isSubmitDirect"));
            //String wfdoc = Util.null2String((String) session.getAttribute(requestid + "_wfdoc"));
            // 是否显示提示 取值"true"或者"false"
            String isShowPrompt = Util.null2String(request.getParameter("isShowPrompt"));
            String viewdoc = Util.null2String(request.getParameter("viewdoc"));

            int isovertime = Util.getIntValue(request.getParameter("isovertime"), 0);
            int isonlyview = Util.getIntValue(request.getParameter("isonlyview"), 0);

            //当点击编辑时，表单可以编辑
            int reEdit = Util.getIntValue(request.getParameter("reEdit"), 0);// 是否为编辑
            String isaffirmance = Util.null2String(request.getParameter("isaffirmance"));
            if (1 == reEdit) isaffirmance = "0";
            resultDatas.put("isaffirmance", isaffirmance);

            String isrequest = Util.null2String(request.getParameter("isrequest"));
            String nodetypedoc = Util.null2String(request.getParameter("nodetypedoc"));
            int desrequestid = 0;
            int wflinkno = Util.getIntValue(request.getParameter("wflinkno"));
            String fromoperation = Util.null2String(request.getParameter("fromoperation"));

            String src = Util.null2String(request.getParameter("src"));// 进入该界面前的操作，"submit"：提交，"reject"：退回。
            // TD4262 增加提示信息 开始
            if (requestid < 0) {// 异构系统跳转
                int _workflowid = Util.getIntValue(request.getParameter("_workflowid"), 0);
                int _workflowtype = Util.getIntValue(request.getParameter("_workflowtype"), 0);
                String sendPageUrl = weaver.general.GCONST.getContextPath() + "/workflow/request/ViewRequestOS.jsp?requestid=" + requestid + "&workflowid=" + _workflowid + "&sysid=" + _workflowtype;
                resultDatas.put("sendPage", sendPageUrl);
                resultDatas.put("verifyRight", false);
                return apidatas;
            }

            int wfcurrrid = 0;
            boolean canview = false; // 是否可以查看

            boolean isurger = false; // 督办人可查看
            boolean wfmonitor = false; // 流程监控人

            String nodetype = "";
            int preisremark = -1;// 如果是流程参与人，该值会被赋予正确的值，在初始化时先设为错误值，以解决主流程参与人查看子流程时权限判断问题。TD10126
            String isremarkForRM = "";
            int groupdetailid = 0;
            int takisremark = -1;
            boolean istoManagePage = false;

            String isSignInput = "0"; // 是否显示签字意见输入框
            String currentnodetype = "";
            int currentnodeid = 0;
            int creater = 0; // 请求的创建人
            int creatertype = 0; // 创建人类型 0: 内部用户 1: 外部用户
            int deleted = 0; // 请求是否删除 1:是 0或者其它 否
            int billid = 0; // 如果是单据,对应的单据表的id
            // TD:8835
            String workflowtype = ""; // 工作流种类
            int helpdocid = 0; // 帮助文档 id
            String workflowname = ""; // 工作流名称
            String status = ""; // 当前的操作类型
            String requestname = ""; // 请求名称
            String requestnamenew = ""; // 请求名称
            String requestlevel = ""; // 请求重要级别 0:正常 1:重要 2:紧急
            String requestmark = ""; // 请求编号
            int currentstatus = -1;
            // 查询请求的相关工作流基本信息
            recordSet.executeProc("workflow_Requestbase_SByID", requestid + "");
            if (recordSet.next()) {
                status = Util.null2String(recordSet.getString("status"));
                requestname = ServiceUtil.convertChar(Util.null2String(recordSet.getString("requestname")));
                requestnamenew = ServiceUtil.convertChar(Util.null2String(recordSet.getString("requestnamenew")));
                requestlevel = Util.null2String(recordSet.getString("requestlevel"));
                requestmark = Util.null2String(recordSet.getString("requestmark"));
                creater = Util.getIntValue(recordSet.getString("creater"), 0);
                creatertype = Util.getIntValue(recordSet.getString("creatertype"), 0);
                deleted = Util.getIntValue(recordSet.getString("deleted"), 0);
                this.workflowid = Util.getIntValue(recordSet.getString("workflowid"), 0);
                currentnodeid = Util.getIntValue(recordSet.getString("currentnodeid"), 0);
                if (nodeid < 1)
                    nodeid = currentnodeid;
                currentnodetype = Util.null2String(recordSet.getString("currentnodetype"));
                if (nodetype.equals(""))
                    nodetype = currentnodetype;
                workflowname = workflowComInfo.getWorkflowname(this.workflowid + "");
                workflowtype = workflowComInfo.getWorkflowtype(this.workflowid + "");

                lastOperator = Util.getIntValue(recordSet.getString("lastOperator"), 0);
                lastOperateDate = Util.null2String(recordSet.getString("lastOperateDate"));
                lastOperateTime = Util.null2String(recordSet.getString("lastOperateTime"));
                currentstatus = Util.getIntValue(recordSet.getString("currentstatus"), -1);
            } else {
                //流程被删除时，强制删除消息
                RequestOperationMsgManager romm = new RequestOperationMsgManager();
                List<MsgEntity> requestMsgEntity = romm.deleteMsgByUserId(Arrays.asList(String.valueOf(requestid)), String.valueOf(userid));
                new MsgPushUtil().pushMsg(requestMsgEntity);

                resultDatas.put("sendPage", weaver.general.GCONST.getContextPath() + "/notice/Deleted.jsp?showtype=wf");
                resultDatas.put("verifyRight", false);
                resultDatas.put("requestIsDelete", true);
                return apidatas;
            }

            if (creater == userid && creatertype == usertype) { // 创建者本人有查看权限
                canview = true;
            }

            String isfromreport = Util.null2String(request.getParameter("isfromreport"));
            String isfromflowreport = Util.null2String(request.getParameter("isfromflowreport"));
            String reportid = Util.null2String(request.getParameter("reportid"));
            String isintervenor = Util.null2String(request.getParameter("isintervenor"));
            String _ec_ismobile = Util.null2String(request.getParameter("_ec_ismobile"));
            int urger = Util.getIntValue(request.getParameter("urger"), 0);
            int ismonitor = Util.getIntValue(request.getParameter("ismonitor"), 0);
            int iscowork = Util.getIntValue(request.getParameter("iscowork"), 0);
            int coworkid = Util.getIntValue(request.getParameter("coworkid"), 0);
            int intervenorright = 0;
            String iswfshare = "0";

            RequestAuthenticationService authService = new RequestAuthenticationService();
            authService.setUser(user);
            //权限验证
            if (authService.verify(request, requestid)) {
                canview = true;
                Map<String, Object> authInfo = authService.getAuthInfo();

                int agentType = Util.getIntValue(Util.null2String(authInfo.get("agentType")));
                int agentorByAgentId = Util.getIntValue(Util.null2String(authInfo.get("agentorByAgentId")));
                submitParams.put("agentType", agentType);
                submitParams.put("agentorByAgentId", agentorByAgentId);
                resultDatas.put("agentType", agentType);
                resultDatas.put("agentorByAgentId", agentorByAgentId);
                if (agentType == 1) {//如果流程被代理出去，被代理人也要能办理
                    RecordSet recordSetInner = new RecordSet();
                    String sql = AgentManager.getAgentorSql(agentorByAgentId, user.getUID(), requestid);
                    recordSetInner.executeQuery(sql);
                    if (recordSetInner.next()) {
                        String tempIsremark = recordSetInner.getString("isremark");
                        String tempNodeType = Util.null2String(authInfo.get("nodetype"));
                        authInfo.put("isremarkForRM", tempIsremark);
                        if (tempIsremark.equals("1") || tempIsremark.equals("5") || tempIsremark.equals("7") || tempIsremark.equals("9") || (tempIsremark.equals("0") && !tempNodeType.equals("3")) || tempIsremark.equals("11")) {
                            authInfo.put("istoManagePage", 1);
                        }
                    }
                }

                RequestAuthenticationEnum authEnum = (RequestAuthenticationEnum) authInfo.get(RequestAuthenticationConstant.KEY_AUTHORITYTYPE);
                //rs.writeLog("========= = = == = = RequestAuthenticationEnum.SELF = "+RequestAuthenticationEnum.SELF);
                //rs.writeLog("========= = = == = = authEnum = "+authEnum);
                if (authEnum.equals(RequestAuthenticationEnum.SELF)) {
                    resultDatas.put("isSelfAuth", 1);
                    istoManagePage = Util.getIntValue(Util.null2String(authInfo.get("istoManagePage")), 0) > 0;
                    nodeid = Util.getIntValue(Util.null2String(authInfo.get("nodeid")), 0);
                    nodetype = Util.null2String(authInfo.get("nodetype"));
                    wfcurrrid = Util.getIntValue(Util.null2String(authInfo.get("wfcurrrid")), 0);
                    preisremark = Util.getIntValue(Util.null2String(authInfo.get("preisremark")), 0);
                    isremarkForRM = Util.null2String(authInfo.get("isremarkForRM"));
                    groupdetailid = Util.getIntValue(Util.null2String(authInfo.get("groupdetailid")), 0);
                    takisremark = Util.getIntValue(Util.null2String(authInfo.get("takisremark")), 0);
					/*if(isremarkForRM.equals("8")){----跟需求沟通，这个特殊处理先去掉，哪个节点抄送过去的，就要看到哪个节点的表单
						nodeid = currentnodeid;
						nodetype = currentnodetype;
					}*/
                    if (("2".equals(new WorkflowAllComInfo().getIsValid(this.workflowid + ""))) && !"true".equals(Util.null2String(request.getParameter("belongTest")))) {
                        if (deleted != 1) {
                            resultDatas.put("sendPage", weaver.general.GCONST.getContextPath() + "/notice/noRight.jsp");
                            resultDatas.put("verifyRight", false);
                            resultDatas.put("isTest", true);
                            return apidatas;
                        }
                    }
                } else {
                    istoManagePage = false;
                    nodeid = currentnodeid;
                    nodetype = currentnodetype;
                }


                try {
                    if ("0".equals(Util.null2String(Util_TableMap.getObjVal("ConformCheck_" + requestid + "_" + nodeid + "_" + userid)))) {
                        lastOperationResult = (RequestOperationResultBean) Util_TableMap.getObjVal("ConformCheck_" + requestid + "_" + nodeid);
                        promptInfo = lastOperationResult.getMessageInfo();
                        promptInfos.clear();
                        promptInfos.add(promptInfo);
                        Util_TableMap.setObjVal("ConformCheck_" + requestid + "_" + nodeid + "_" + userid, "1");
                    } else if (Util_TableMap.getObjVal("ConformCheck_" + requestid + "_" + nodeid) != null && "0".equals(isremarkForRM)) {
                        if (Util_TableMap.getObjVal("ConformCheck_" + requestid + "_" + nodeid + "_" + userid) == null) {
                            rs.executeQuery("select 1 from workflow_currentoperator where nodeid = ? and userid = ? and requestid = ? and (isprocessed <> '' or isprocessed is not null)", nodeid, userid, requestid);
                            if (rs.next()) {
                                lastOperationResult = (RequestOperationResultBean) Util_TableMap.getObjVal("ConformCheck_" + requestid + "_" + nodeid);
                                promptInfo = lastOperationResult.getMessageInfo();
                                promptInfos.clear();
                                promptInfos.add(promptInfo);
                                Util_TableMap.setObjVal("ConformCheck_" + requestid + "_" + nodeid + "_" + userid, "1");
                            }
                        }
                    }
                } catch (Exception e) {
                }

                if (authEnum.equals(RequestAuthenticationEnum.INTERVENOR) || authEnum.equals(RequestAuthenticationEnum.MONITOR)) {
                    isSignInput = "1";
                    //监控人是否有干预权限
                    if (authEnum.equals(RequestAuthenticationEnum.INTERVENOR)) {
                        if ("true".equals(_ec_ismobile)) {
                            wfmonitor = true;
                            attrSignatureUtil.setAttribute("ismonitor", "" + ismonitor);
                            attrSignatureUtil.setAttribute("wfmonitor", wfmonitor + "");
                        }
                        intervenorright = Util.getIntValue(Util.null2String(authInfo.get("intervenorright")), 0);
                        attrSignatureUtil.setAttribute("isintervenor", "" + isintervenor);

                    }
                    if (authEnum.equals(RequestAuthenticationEnum.MONITOR)) {
                        wfmonitor = true;
                        attrSignatureUtil.setAttribute("ismonitor", "" + ismonitor);
                        attrSignatureUtil.setAttribute("wfmonitor", wfmonitor + "");
                        intervenorright = 0;
                    }
                }

                //督办
                if (authEnum.equals(RequestAuthenticationEnum.URGER)) {
                    isurger = true;
                    attrSignatureUtil.setAttribute("urger", "" + urger);
                    attrSignatureUtil.setAttribute("isurger", isurger + "");
                    intervenorright = 0;
                }
                //相关流程、主子流程
                if (authEnum.equals(RequestAuthenticationEnum.RELATE) || authEnum.equals(RequestAuthenticationEnum.MAINCHILD)) {
                    desrequestid = Util.getIntValue(Util.null2String(authInfo.get("desrequestid")), 0);
                    attrSignatureUtil.setAttribute("isrequest", isrequest);
                    attrSignatureUtil.setAttribute("desrequestid", desrequestid + "");
                    attrSignatureUtil.setAttribute("isfromTd", Util.null2String(authInfo.get("isfromTd")));
                }
                //报表
                if (authEnum.equals(RequestAuthenticationEnum.REPORT)) {
                    attrSignatureUtil.setAttribute("isfromreport", isfromreport);
                    attrSignatureUtil.setAttribute("isfromflowreport", isfromflowreport);
                    attrSignatureUtil.setAttribute("reportid", reportid);
                }

                //共享
                if (authEnum.equals(RequestAuthenticationEnum.WFSHARE)) {
                    iswfshare = Util.null2String(authInfo.get("iswfshare"));
                    attrSignatureUtil.setAttribute("iswfshare", "" + iswfshare);
                }

                //流程分享
                if (authEnum.equals(RequestAuthenticationEnum.CHATSHARE)) {
                    attrSignatureUtil.setAttribute("isfromchatshare", request.getParameter("isfromchatshare"));
                    attrSignatureUtil.setAttribute("sharer", request.getParameter("sharer"));
                    attrSignatureUtil.setAttribute("sharegroupid", request.getParameter("sharegroupid"));
                    attrSignatureUtil.setAttribute("firstSharer", request.getParameter("firstSharer"));
                }

                //计划任务
                if (authEnum.equals(RequestAuthenticationEnum.WORKTAST)) {
                    //TODO
                }
                //计划会议
                if (authEnum.equals(RequestAuthenticationEnum.PLANMEETING)) {
                    //TODO
                }
                //建模
                if (authEnum.equals(RequestAuthenticationEnum.MODE)) {
                    //TODO
                    attrSignatureUtil.setAttribute("formmodeflag", "1");
                }

                //相关交流
                if (authEnum.equals(RequestAuthenticationEnum.COMMUNICATION)) {
                    attrSignatureUtil.setAttribute("isFromCommunication", Util.null2String(authInfo.get("isFromCommunication")));
                }

                //协作
                if (authEnum.equals(RequestAuthenticationEnum.COWORK)) {
                    attrSignatureUtil.setAttribute("iscowork", Util.null2String(authInfo.get("iscowork")));
                    attrSignatureUtil.setAttribute("coworkid", Util.null2String(authInfo.get("coworkid")));
                }

                String authStr = authService.getAuthString();
                String authSignatureStr = authService.getAuthSignatureString();
                resultDatas.put("authStr", authStr);
                resultDatas.put("authSignatureStr", authSignatureStr);
                submitParams.put("authStr", authStr);
                submitParams.put("authSignatureStr", authSignatureStr);
                attrSignatureUtil.setAttribute("canview", canview + "");
                attrSignatureUtil.setAttribute("preisremark", preisremark + "");
                attrSignatureUtil.setAttribute("wfcurrrid", wfcurrrid + "");
                attrSignatureUtil.setAttribute("groupdetailid", groupdetailid + "");
                attrSignatureUtil.setAttribute("intervenorright", "" + intervenorright);
                attrSignatureUtil.setAttribute("requestid", "" + requestid);
            }

            //打印校验modeid是否是当前操作者的,防止直接更改url中的modeid进行打印
            if (canview && isprint) { // 增加canview条件防止 通过modeid经行打印
                canview = new PrintInfoBiz().verify(request, user);
            }

            boolean hasSecRight = true;//是否有对应的密级权限
            boolean isOpenSec = HrmClassifiedProtectionBiz.isOpenClassification();
            if (HrmClassifiedProtectionBiz.isOpenClassification()) {
                Map<String, Object> otherParams = new HashMap<>();
                otherParams.put("ismonitor", ismonitor);
                otherParams.put("isintervenor", isintervenor);
                otherParams.put("isprint", isprint);
                RequestSecLevelBiz secLevelBiz = new RequestSecLevelBiz();
                if (isOpenSec && !secLevelBiz.hasWfRight(requestid, user, otherParams)) {
                    hasSecRight = false;
                }
                if (secLevelBiz.existExceptionModifySecLevel(requestid + "")) {
                    System.err.println("请求：" + requestid + "存在密级被篡改");
                    resultDatas.put("exceptionModifySecLevel", true);
                    resultDatas.put("verifyRight", false);
                    return apidatas;
                }
            }

            if (!canview || !hasSecRight) {
                //无权
                RequestOperationMsgManager romm = new RequestOperationMsgManager();
                List<MsgEntity> requestMsgEntity = romm.deleteMsgByUserId(Arrays.asList(String.valueOf(requestid)), String.valueOf(userid));
                new MsgPushUtil().pushMsg(requestMsgEntity);

                attrSignatureUtil.setAttribute(userid + "_" + requestid + "currentusercanview", "true");
                resultDatas.put("sendPage", weaver.general.GCONST.getContextPath() + "/notice/noright.jsp?isovertime=" + isovertime);
                resultDatas.put("verifyRight", false);
                resultDatas.put("canview", canview);
                resultDatas.put("hasSecRight", hasSecRight);
                resultDatas.put("userid", userid);
                resultDatas.put("usertype", usertype);
                resultDatas.put("logintype", user.getLogintype());
                resultDatas.put("isSecNoRight", canview && !hasSecRight ? "1" : "0");//有权限但是密级不够，则弹出密级不够的提示
                return apidatas;
            }

            resultDatas.put("iswfshare", iswfshare);
            resultDatas.put("isurger", isurger);
            resultDatas.put("wfmonitor", wfmonitor);
            resultDatas.put("isrequest", isrequest);
            resultDatas.put("desrequestid", desrequestid);
            resultDatas.put("iscowork", iscowork);
            resultDatas.put("coworkid", coworkid);

            resultDatas.put("creater", creater);
            resultDatas.put("creatertype", creatertype);
            resultDatas.put("isOpenTextTab", false);

            //权限添加时“所有人”可选项受控于组织机构应用分权
            boolean appDetachDisableAll = new ManageDetachComInfo().appDetachDisableAll(user);
            resultDatas.put("appDetachDisableAll", appDetachDisableAll);

            String IsFromWFRemark = "";
            if (currentnodetype.equals("3")) {
                IsFromWFRemark = "2";
            } else {
                if ("1".equals(isremarkForRM) || "0".equals(isremarkForRM) || "7".equals(isremarkForRM) || "8".equals(isremarkForRM) || "9".equals(isremarkForRM)) {
                    IsFromWFRemark = "0";
                } else if ("2".equals(isremarkForRM)) {
                    IsFromWFRemark = "1";
                }
            }
            attrSignatureUtil.setAttribute("IsFromWFRemark", "" + IsFromWFRemark);
            resultDatas.put("intervenorright", intervenorright);

            session.removeAttribute(userid + "_" + requestid + "currentusercanview");

            // TD8715 获取工作流信息，是否显示流程图
            wfManager.setWfid(this.workflowid);
            wfManager.getWfInfo();
            String isFree = Util.null2String(wfManager.getIsFree());
            //是否记录表单修改日志
            String isOpenModifyLog = Util.null2String(wfManager.getIsModifyLog());
            //是否可查看表单修改日志
            String isModifyLog = Util.null2String(wfManager.getIsShowModifyLog());
            formid = wfManager.getFormid();
            isbill = wfManager.getIsBill();
            helpdocid = wfManager.getHelpdocid();
            resultDatas.put("needconfirm", Util.null2String(wfManager.getIsaffirmance()));
            resultDatas.put("isshared", Util.null2String(wfManager.getIsshared()));
            if (HrmClassifiedProtectionBiz.isOpenClassification()) {//开启涉密，内部以上流程不能共享
                int defaultSecLevel = Util.getIntValue(new HrmClassifiedProtectionBiz().getDefaultResourceSecLevel());
                int secLevel = new RequestSecLevelBiz().getSecLevelByRequestId(requestid + "");
                if (secLevel < defaultSecLevel) {
                    resultDatas.put("isshared", 0);
                }
            }
            resultDatas.put("isFree", isFree);
            resultDatas.put("newdocpath", Util.null2String(wfManager.getNewdocpath()));

            if (isnewFreeLayout) {
                DoSaveFreeExcelDesignBiz doSaveFreeExcelDesignBiz = new DoSaveFreeExcelDesignBiz(user);
                doSaveFreeExcelDesignBiz.getFreeNodeFormConfig(Util.null2String(configId));
                formid = doSaveFreeExcelDesignBiz.getFormid();
                isbill = Util.null2String(doSaveFreeExcelDesignBiz.getIsbill());
            }

            int extendnodeid = nodeid;
            boolean isViewNode = false;
            FreeNodeEntity nodeEntity = FreeNodeBiz.getCurrentFreeNodeEntity(requestid, nodeid);
            if (nodeEntity != null) {
                extendnodeid = nodeEntity.getExtendnodeid();
                isViewNode = nodeEntity.getNodetype() == 4 && "0".equals(isremarkForRM);
                resultDatas.put("freeNodeExtendNodeId", extendnodeid);
                attrSignatureUtil.setAttribute("freeNodeExtendNodeId", Util.null2String(extendnodeid));
            }
            //判断流程是否设置过自由节点，在加载流程图时进行校验是否走获取自由流程接口数据
            resultDatas.put("hasFreeNode", FreeNodeBiz.hasFreeNode(requestid));
            int isFormSignature = 0;
            int isUseWebRevision_t = Util.getIntValue(new weaver.general.BaseBean().getPropValue("weaver_iWebRevision", "isUseWebRevision"), 0);
            //添加selectnextflowpattern参数到params  add by jym
            recordSet.executeSql("select issignmustinput,ismode,showdes,printdes,toexcel,ishidearea,ishideinput,selectNextFlow,isFormSignature,selectnextflowpattern from workflow_flownode where workflowid=" + this.workflowid + " and nodeid=" + extendnodeid);
            // 0：普通模式 1：模板模式 2：html模式
            String ismode = "";
            int showdes = 0;
            int printdes = 0;
            int toexcel = 0;
            String isHideArea = "0";
            String isHideInput = "0";
            String selectNextFlow = "0";
            //流转设定 模式 add by jym
            int selectNextFlowPattern = 0;
            if (recordSet.next()) {
                // 签字意见必填
                resultDatas.put("issignmustinput", Util.getIntValue(recordSet.getString("issignmustinput"), 0));
                ismode = Util.null2String(recordSet.getString("ismode"));
                showdes = Util.getIntValue(Util.null2String(recordSet.getString("showdes")), 0);
                printdes = Util.getIntValue(Util.null2String(recordSet.getString("printdes")), 0);
                toexcel = Util.getIntValue(Util.null2String(recordSet.getString("toexcel")), 0);
                isHideArea = Util.null2String(recordSet.getString("ishidearea"), "0");
                isHideInput = Util.null2String(recordSet.getString("ishideinput"), "0");
                selectNextFlow = Util.null2String(recordSet.getString("selectNextFlow"), "0");
                //add by jym
                selectNextFlowPattern = Util.getIntValue(Util.null2String(recordSet.getString("selectnextflowpattern")), -1);
                if (isUseWebRevision_t == 1 && recordSet.getInt("isFormSignature") == 1) {
                    isFormSignature = 1;
                }

            }
            if (isnewFreeLayout) {
                ismode = "2";
            }

            resultDatas.put("toexcel", toexcel);
            resultDatas.put("isHideArea", isHideArea);
            resultDatas.put("isHideInput", isHideInput);
            resultDatas.put("selectNextFlow", selectNextFlow);
            boolean openNodeCheck = false;
            if (nodeid < 0) {
                recordSet.executeQuery("select allowModify from workflow_freenode where id = ?", nodeid);
                if (recordSet.next()) {
                    String allowModify = recordSet.getString(1);
                    if ("1".equals(allowModify)) {
                        openNodeCheck = new NodeFieldCheckBiz().isOpenNodeFieldCheckInfo(this.workflowid, FreeNodeBiz.getExtendNodeId(requestid, nodeid));
                    }
                }
            } else {
                openNodeCheck = new NodeFieldCheckBiz().isOpenNodeFieldCheckInfo(this.workflowid, nodeid);
            }
            wfCoadjutantManager.getCoadjutantRights(groupdetailid);
            if (openNodeCheck) {
                rs.executeQuery("select 1 from workflow_currentoperator where (isremark='7' or preisremark='7') and groupdetailid=? and nodeid=? and requestid=? and userid=?", groupdetailid, nodeid, requestid, userid);
                if (rs.next() && "0".equals(wfCoadjutantManager.getIsmodify()) && "2".equals(wfCoadjutantManager.getSigntype())) {
                    openNodeCheck = false;
                }
            }
            resultDatas.put("openNodeCheck", openNodeCheck);


            //add by jym
            WFManager wfm = new WFManager();
            wfm.setWfid(this.workflowid);
            try {
                wfm.getWfInfo();
            } catch (Exception e) {
                throw new ECException(this.getClass().getName() + "执行过程中异常", e);
            }
            //判断是否自由流程，如果是则为高级模式
            if ("1".equals(wfm.getIsFree())) {
                selectNextFlowPattern = (Util.getIntValue(wfManager.getFreewftype(), -1) == 1) ? 0 : 1;
            }
            resultDatas.put("selectNextFlowPattern", selectNextFlowPattern + "");
            boolean isOrgBeforeCoadSubmit = false;
            if (isremarkForRM.equals("0")) {// 协办人已经提交后，由于勾选"未查看一直停留在待办"，所以主办人打开代办流程，直接就变成已办
                recordSet
                        .execute("select c1.id from workflow_currentoperator c1 where c1.requestid="
                                + requestid
                                + " and c1.isremark='2' and c1.preisremark='7' "
                                + " and exists(select 1 from workflow_currentoperator c2 where c2.id="
                                + wfcurrrid
                                + " and c1.receivedate=c2.receivedate and c1.receivetime=c2.receivetime and c1.nodeid=c2.nodeid and c1.groupdetailid=c2.groupdetailid ) and exists(select id from workflow_groupdetail g where g.id=c1.groupdetailid and g.signtype='0')");
                if (recordSet.next()) {
                    int c1id_t = Util.getIntValue(recordSet.getString("id"));
                    if (c1id_t > 0) {
                        isOrgBeforeCoadSubmit = true;
                        isremarkForRM = "2";
                        istoManagePage = false;
                    }
                }
            }

            //attrSignatureUtil.setAttribute(userid + "_" + requestid + "f_weaver_belongto_userid", userid);
            //attrSignatureUtil.setAttribute(userid + "_" + requestid + "f_weaver_belongto_usertype", usertype);
            attrSignatureUtil.setAttribute("helpdocid", "" + helpdocid);
            attrSignatureUtil.setAttribute("isModifyLog", "" + isModifyLog);
            attrSignatureUtil.setAttribute("isOpenModifyLog", "" + isOpenModifyLog);
            attrSignatureUtil.setAttribute("currentnodeid", "" + currentnodeid);
            attrSignatureUtil.setAttribute("currentnodetype", currentnodetype);
            //session.setAttribute(userid + "_" + requestid + "isaffirmance", isaffirmance);
            //session.setAttribute(userid + "_" + requestid + "reEdit", reEdit + "");
            attrSignatureUtil.setAttribute("workflowname", workflowname);
            request.setAttribute(userid + "_" + this.workflowid + "workflowname", workflowname);
            attrSignatureUtil.setAttribute("currentstatus", "" + currentstatus);

            resultDatas.put("workflowname", workflowname);
            resultDatas.put("currentnodeid", currentnodeid);
            resultDatas.put("currentNodeAttribute", new WorkflowNodeComInfo().getNodeattribute(currentnodeid + ""));
            resultDatas.put("currentnodetype", currentnodetype);
            resultDatas.put("nodetype", currentnodetype);

            // 判断是否有流程创建文档，并且在该节点是有正文字段
            // 判断是否有流程创建文档，并且在该节点是有正文字段
            OfficalConditionInfo docConditionInfo = new OfficalConditionInfo();
            docConditionInfo.setWorkflowId(this.workflowid);
            docConditionInfo.setNodeId(nodeid);
            OfficalResultInfo resultInfo = WorkflowCreateDocPublicUtil.getWorkflowCreateDocData(docConditionInfo);

            resultDatas.put("isWorkflowDoc", resultInfo.isWorkflowDoc());
            resultDatas.put("flowDocFieldId", resultInfo.getFlowDocFieldId());
            submitParams.put("isWorkflowDoc", resultInfo.isWorkflowDoc());

            // fromoperation=1表示对流程做过操作,当做提交，退回操作时返回到流程图页面。
            if (fromoperation.equals("1") && (src.equals("submit") || src.equals("reject"))) {
                // TODO JHY
            }

            wfForwardManager.init();
            wfForwardManager.setWorkflowid(this.workflowid);
            wfForwardManager.setNodeid(extendnodeid);
            wfForwardManager.setIsremark(isremarkForRM);
            wfForwardManager.setTakIsremark(takisremark + "");
            wfForwardManager.setRequestid(requestid);
            wfForwardManager.setBeForwardid(wfcurrrid);
            wfForwardManager.getWFNodeInfo();
            String IsPendingForward = wfForwardManager.getIsPendingForward();
            String IsTakingOpinions = wfForwardManager.getIsTakingOpinions();
            String IsHandleForward = wfForwardManager.getIsHandleForward();
            String IsBeForward = wfForwardManager.getIsBeForward();
            String IsSubmitedOpinion = wfForwardManager.getIsSubmitedOpinion();
            String IsSubmitForward = wfForwardManager.getIsSubmitForward();
            String IsAlreadyForward = wfForwardManager.getIsAlreadyForward();
            String IsWaitForwardOpinion = wfForwardManager.getIsWaitForwardOpinion();
            String IsBeForwardSubmit = wfForwardManager.getIsBeForwardSubmit();
            String IsBeForwardModify = wfForwardManager.getIsBeForwardModify();
            String IsBeForwardPending = wfForwardManager.getIsBeForwardPending();
            String IsBeForwardTodo = wfForwardManager.getIsBeForwardTodo();
            String IsBeForwardSubmitAlready = wfForwardManager.getIsBeForwardSubmitAlready();
            String IsBeForwardAlready = wfForwardManager.getIsBeForwardAlready();
            String IsBeForwardSubmitNotaries = wfForwardManager.getIsBeForwardSubmitNotaries();
            String IsFromWFRemark_T = wfForwardManager.getIsFromWFRemark();
            boolean IsFreeWorkflow = wfForwardManager.getIsFreeWorkflow(requestid, nodeid, Util.getIntValue(isremarkForRM));
            String IsFreeNode = wfForwardManager.getIsFreeNode(nodeid);
            attrSignatureUtil.setAttribute("wfcurrrid", "" + wfcurrrid);
            wfForwardManager.setCurrentNodeId(currentnodeid);
            wfForwardManager.setNodeid(nodeid);
            boolean IsCanSubmit = wfForwardManager.getCanSubmit();
            // boolean IsCanSubmit2=wfForwardManager.getCanSubmit(forwardflag);
            boolean IsBeForwardCanSubmitOpinion = wfForwardManager.getBeForwardCanSubmitOpinion();
            boolean IsCanModify = wfForwardManager.getCanModify();
            wfCoadjutantManager.getCoadjutantRights(groupdetailid);
            String coadsigntype = wfCoadjutantManager.getSigntype();
            String coadissubmitdesc = wfCoadjutantManager.getIssubmitdesc();
            String coadisforward = wfCoadjutantManager.getIsforward();
            String coadismodify = wfCoadjutantManager.getIsmodify();
            String coadispending = wfCoadjutantManager.getIspending();
            if (!IsCanModify && coadismodify.equals("1"))
                IsCanModify = true;
            if (nodeid != currentnodeid && coadismodify.equals("1") && isremarkForRM.equals("7"))
                IsCanModify = false;

            if (IsCanModify) {
                isSignInput = "1";
            }
            boolean coadCanSubmit = wfCoadjutantManager.getCoadjutantCanSubmit(requestid, wfcurrrid, isremarkForRM, coadsigntype);
            boolean isMainSubmitted = wfCoadjutantManager.isMainSubmitted();
            attrSignatureUtil.setAttribute("isMainSubmitted", "" + isMainSubmitted);
            attrSignatureUtil.setAttribute("coadsigntype", coadsigntype);
            attrSignatureUtil.setAttribute("coadissubmitdesc", coadissubmitdesc);
            attrSignatureUtil.setAttribute("coadisforward", coadisforward);
            attrSignatureUtil.setAttribute("coadismodify", coadismodify);
            attrSignatureUtil.setAttribute("coadispending", coadispending);
            attrSignatureUtil.setAttribute("coadCanSubmit", "" + coadCanSubmit);
            attrSignatureUtil.setAttribute("IsPendingForward", IsPendingForward);
            attrSignatureUtil.setAttribute("IsTakingOpinions", IsTakingOpinions);
            attrSignatureUtil.setAttribute("IsHandleForward", IsHandleForward);
            attrSignatureUtil.setAttribute("IsBeForward", IsBeForward);
            attrSignatureUtil.setAttribute("IsBeForwardTodo", IsBeForwardTodo);
            attrSignatureUtil.setAttribute("IsBeForwardSubmitAlready", IsBeForwardSubmitAlready);
            attrSignatureUtil.setAttribute("IsBeForwardAlready", IsBeForwardAlready);
            attrSignatureUtil.setAttribute("IsBeForwardSubmitNotaries", IsBeForwardSubmitNotaries);
            attrSignatureUtil.setAttribute("IsFromWFRemark_T", IsFromWFRemark_T);
            attrSignatureUtil.setAttribute("IsSubmitedOpinion", IsSubmitedOpinion);
            attrSignatureUtil.setAttribute("IsSubmitForward", IsSubmitForward);
            attrSignatureUtil.setAttribute("IsAlreadyForward", IsAlreadyForward);
            attrSignatureUtil.setAttribute("IsWaitForwardOpinion", IsWaitForwardOpinion);
            attrSignatureUtil.setAttribute("IsBeForwardSubmit", IsBeForwardSubmit);
            attrSignatureUtil.setAttribute("IsBeForwardModify", IsBeForwardModify);
            attrSignatureUtil.setAttribute("IsBeForwardPending", IsBeForwardPending);
            attrSignatureUtil.setAttribute("IsCanSubmit", "" + IsCanSubmit);
            attrSignatureUtil.setAttribute("IsBeForwardCanSubmitOpinion", "" + IsBeForwardCanSubmitOpinion);
            attrSignatureUtil.setAttribute("IsCanModify", "" + IsCanModify);
            attrSignatureUtil.setAttribute("IsFreeWorkflow", "" + IsFreeWorkflow);
            attrSignatureUtil.setAttribute("IsFreeNode", "" + IsFreeNode);
            attrSignatureUtil.setAttribute("forwardBack", wfForwardManager.getForwardBack());
            attrSignatureUtil.setAttribute("takeBack", wfForwardManager.getTakeBack());

            //如果可以流转并且是简易模式 显示流转设置div
            boolean isAllowNodeFreeFlow = FreeNodeBiz.isAllowNodeFreeFlow(Util.getIntValue(isremarkForRM), nodeid);
            resultDatas.put("showFreeWfSimpleCom", (isAllowNodeFreeFlow && takisremark != -2 && selectNextFlowPattern == 0) ? 1 : 0);
            // 判断可否转发
            int Forwardid = 0;
            recordSet.executeSql("select isremark,isreminded,preisremark,id,groupdetailid,nodeid from workflow_currentoperator where requestid=" + requestid + " and userid=" + userid + " and usertype="
                    + usertype + " and islasttimes = '1' order by isremark,id");
            while (recordSet.next()) {
                Forwardid = Util.getIntValue(recordSet.getString("id"));
            }
            String wfSQL = "select * from workflow_Forward where requestid=" + requestid + " and BeForwardid=" + Forwardid;
            recordSet.executeSql(wfSQL);
            if (recordSet.next()) {
                IsFromWFRemark_T = Util.null2String(recordSet.getString("IsFromWFRemark")); // 待办提交后被转发人是否可提交意见
                IsBeForwardTodo = Util.null2String(recordSet.getString("IsBeForwardTodo")); // 待办可转发
                IsBeForwardAlready = Util.null2String(recordSet.getString("IsBeForwardAlready")); // 已办被转发人可转发
                IsBeForward = Util.null2String(recordSet.getString("IsBeForward")); // 办结被转发人是否可转发
            }
            boolean canForwd = false;
            if (takisremark == -2 && "1".equals(IsAlreadyForward)) { // 征询意见人\
                canForwd = true;
            }
            if (takisremark == 2 && "1".equals(IsAlreadyForward)) { // 征询意见接收人\
                canForwd = true;
            }
            if (takisremark != 2) {
                if (("0".equals(IsFromWFRemark_T) && "1".equals(IsBeForwardTodo)) || ("1".equals(IsFromWFRemark_T) && "1".equals(IsBeForwardAlready))
                        || ("2".equals(IsFromWFRemark_T) && "1".equals(IsBeForward))) {
                    canForwd = true;
                }
            }

            attrSignatureUtil.setAttribute("canForwd", "" + canForwd);

            boolean isPendingRemark = false;
            if ("0".equals(isremarkForRM))
                isPendingRemark = true;
            if (currentnodetype.equals("3") || isViewNode)
                resultDatas.put("needReloadList", true);    //归档流程刷新操作时间
            //如果提交到下一节点又抄送回上一节点操作人，有可能导致已经更新消息但是抄送消息还未创建，因此设置每次打开流程时如果是抄送不提交，则直接更新消息状态.
            if ("8".equals(isremarkForRM) || preisremark == 8){
                RequestOperationMsgManager romm = new RequestOperationMsgManager();
                List<MsgEntity> requestMsgEntity = romm.getForwardReplyMsg(String.valueOf(requestid), String.valueOf(userid), isremarkForRM);
                new MsgPushUtil().pushMsg(requestMsgEntity);
            }
            if (!isprint && (isremarkForRM.equals("8")
                    || (isremarkForRM.equals("1") && !IsCanSubmit)
                    || ("7".equals(isremarkForRM) && !coadCanSubmit)
                    || isOrgBeforeCoadSubmit
                    || (isremarkForRM.equals("11") && !ChuanyueUtil.isSubmitSignByRequestId(this.workflowid, requestid, nodeid, userid, usertype, isremarkForRM)))) {//打印模板加载loadform，不做数据更新
                resultDatas.put("needReloadList", true);    //不需提交等情况打开流程需刷新列表
                RequestOperationMsgManager romm = new RequestOperationMsgManager();
                List<MsgEntity> requestMsgEntity = romm.getForwardReplyMsg(String.valueOf(requestid), String.valueOf(userid), isremarkForRM);
				if (isremarkForRM.equals("1") && wfForwardManager.hasChildCanSubmit(requestid + "", userid + "")) {
                    recordSet.executeProc("workflow_CurrentOperator_Copy", requestid + "" + flag + userid + flag + usertype + "");
                        new MsgPushUtil().pushMsg(requestMsgEntity);
                } else if (isremarkForRM.equals("8") || ("7".equals(isremarkForRM) && !coadCanSubmit) || isOrgBeforeCoadSubmit) {
                    // recordSet.executeProc("workflow_CurrentOperator_Copy", requestid + "" + flag + userid + flag + usertype + "");
                    wcCopy(requestid, userid, usertype);
                    //抄送不需提交消息
//                    if ("8".equals(isremarkForRM)) new MsgPushUtil().pushMsg(requestMsgEntity);
                } else if (isremarkForRM.equals("11")) {
                    new MsgPushUtil().pushMsg(requestMsgEntity);
                    ChuanyueUtil.executeProc4Chuanyue(this.workflowid, requestid, nodeid, userid, usertype);
                }
                if (currentnodetype.equals("3")) {
                    recordSet.executeSql("update workflow_currentoperator set iscomplete=1 where requestid=" + requestid + " and userid=" + userid + " and usertype=" + usertype);
                }
                isPendingRemark = true;
                if (currentnodetype.equals("3")) {
                    recordSet.executeSql("select isremark from workflow_currentoperator  where requestid=" + requestid + " and nodeid=" + nodeid + " and userid=" + userid + " and usertype=" + usertype);
                    if (recordSet.next()) {
                        isremarkForRM = Util.null2String(recordSet.getString("isremark"));
                    } else {
                        isremarkForRM = "2";
                    }
                } else {
                    isremarkForRM = "2";
                }
                //attrSignatureUtil.setAttribute(userid + "_" + requestid + "isremarkForRM", isremarkForRM + "");
                istoManagePage = false;
            }

            if (ismonitor == 1 || "1".equals(isintervenor)) resultDatas.put("needReloadList", false);

            //钉钉、企业微信pc客户端以默认浏览器打开流程，提交时保存客户端和浏览器交互数据
            String openByDefaultBrowser = Util.null2String(request.getParameter("openByDefaultBrowser"));
            submitParams.put("openByDefaultBrowser", "1".equals(iscreate) ? "0" : openByDefaultBrowser);
            if ("1".equals(openByDefaultBrowser) && "true".equals(Util.null2String(resultDatas.get("needReloadList")))) {
                RequestListBiz.putRecord(user, requestid + "");//状态改变，通知钉钉回刷
            }
            //钉钉、企业微信pc客户端以默认浏览器打开流程，提交时保存客户端和浏览器交互数据

            attrSignatureUtil.setAttribute("isremarkForRM", isremarkForRM + "");
            attrSignatureUtil.setAttribute("takisremark", takisremark + "");
            attrSignatureUtil.setAttribute("isPendingRemark", "" + isPendingRemark);
            billid = this.calculateBillid(this.formid, Util.getIntValue(this.isbill), this.requestid);
            if (isbill.equals("1") && formid == 207) {// 计划任务审批单单独处理
                // 特殊处理，直接跳转到计划任务界面，进行审批操作
                int approverequest = Util.getIntValue(request.getParameter("requestid"), 0);
                int wt_requestid = 0;
                rs.execute("select * from worktask_requestbase where approverequest=" + approverequest);
                if (rs.next()) {
                    wt_requestid = Util.getIntValue(rs.getString("requestid"), 0);
                }
                resultDatas.put("sendPage", weaver.general.GCONST.getContextPath() + "/worktask/request/ViewWorktask.jsp?requestid=" + wt_requestid + "&f_weaver_belongto_userid=" + userid + "&f_weaver_belongto_usertype=" + usertype);
                resultDatas.put("verifyRight", false);
                return apidatas;
            }


            attrSignatureUtil.setAttribute("requestname", requestname);
            attrSignatureUtil.setAttribute("workflowid", "" + this.workflowid);
            attrSignatureUtil.setAttribute("nodeid", "" + nodeid);
            attrSignatureUtil.setAttribute("preisremark", "" + preisremark);
            if (((isremarkForRM.equals("0") || isremarkForRM.equals("1")) && !IsCanSubmit) || (isremarkForRM.equals("7") && !coadCanSubmit)) {
                istoManagePage = false;
            }
            attrSignatureUtil.setAttribute("formid", "" + formid);
            attrSignatureUtil.setAttribute("billid", "" + billid);
            attrSignatureUtil.setAttribute("isbill", isbill);
            attrSignatureUtil.setAttribute("nodetype", nodetype);
            attrSignatureUtil.setAttribute("creater", "" + creater);
            attrSignatureUtil.setAttribute("creatertype", "" + creatertype);
            attrSignatureUtil.setAttribute("requestlevel", requestlevel);


            //实时计算自定义标题
            RequestBaseUtil rbu = new RequestBaseUtil();
            requestnamenew = rbu.formatRequestname(requestname, this.workflowid + "", requestid + "", Util.getIntValue(isbill + ""), formid, user.getLanguage());
            requestnamenew = new WfListCusTitleUtil().getNewRequestName(this.workflowid, requestnamenew);

            resultDatas.put("requestname", requestname);
            resultDatas.put("requestnamenew", requestnamenew);
            resultDatas.put("helpdocid", helpdocid);
            resultDatas.put("workflowid", this.workflowid);
            resultDatas.put("nodeid", nodeid);
            resultDatas.put("nodetype", nodetype);
            resultDatas.put("formid", formid);
            resultDatas.put("isbill", isbill);
            resultDatas.put("isprint", isprint ? "1" : "0");
            resultDatas.put("isremark", isremarkForRM);
            resultDatas.putAll(appendLayoutInfo(ismode, showdes, printdes, extendnodeid));

            //资产自定义流程类型
            String cptwftype = new CptWfUtil().getAllCptWftype("" + this.workflowid);
            boolean isCptwf = false;
            boolean ismodeCptwf = false;
            if (!"".equals(cptwftype)) {
                isCptwf = "fetch".equalsIgnoreCase(cptwftype)
                        || "move".equalsIgnoreCase(cptwftype)
                        || "lend".equalsIgnoreCase(cptwftype)
                        || "discard".equalsIgnoreCase(cptwftype)
                        || "back".equalsIgnoreCase(cptwftype)
                        || "loss".equalsIgnoreCase(cptwftype)
                        || "mend".equalsIgnoreCase(cptwftype)
                        || "mode_fetch".equalsIgnoreCase(cptwftype)
                        || "mode_move".equalsIgnoreCase(cptwftype)
                        || "mode_lend".equalsIgnoreCase(cptwftype)
                        || "mode_discard".equalsIgnoreCase(cptwftype)
                        || "mode_back".equalsIgnoreCase(cptwftype)
                        || "mode_loss".equalsIgnoreCase(cptwftype)
                        || "mode_mend".equalsIgnoreCase(cptwftype);
                ismodeCptwf = cptwftype.startsWith("mode_");
            }

            resultDatas.put("isCptwf", isCptwf);
            resultDatas.put("ismodeCptwf", ismodeCptwf);
            // writeLog("---------912-----time:" + (System.currentTimeMillis() -
            // start));
            // start = System.currentTimeMillis();

            String titlename = SystemEnv.getHtmlLabelName(18015, user.getLanguage()) + ":" + SystemEnv.getHtmlLabelName(553, user.getLanguage()) + " - " + Util.toScreen(workflowname, user.getLanguage())
                    + " - " + Util.toScreen(status,user.getLanguage()) + " " + "<span id='requestmarkSpan'>" + requestmark + "</span>";

			/*if(requestid>0 && !wfmonitor){
				User loginUser = (User) session.getAttribute("weaver_user@bean");
				String attentionTag = new RequestAttentionBiz().getAttentionTag2(requestid,loginUser,user);
				titlename += attentionTag;
			}*/

            resultDatas.put("titlename", titlename);

            resultDatas.put("btnLabelName", getTabName());

            apidatas.put("submitParams", submitParams);

            resultDatas.put("requestid", requestid);
            resultDatas.put("takisremark", takisremark);

            // 生成隐藏域信息
            submitParams.put("workflowid", this.workflowid);
            submitParams.put("workflowtype", workflowtype);
            submitParams.put("nodeid", nodeid);
            submitParams.put("nodetype", nodetype);
            submitParams.put("formid", formid);
            submitParams.put("isbill", isbill);
            submitParams.put("billid", billid);
            submitParams.put("iscreate", "0");
            submitParams.put("needcheck", "");
            submitParams.put("inputcheck", "");
            submitParams.put("src", "");
            submitParams.put("topage", "");
            submitParams.put("uploadType", "");
            submitParams.put("selectfieldvalue", "");
            submitParams.put("isMultiDoc", "");
            submitParams.put("needoutprint", "");
            submitParams.put("htmlfieldids", "");
            submitParams.put("annexmaxUploadImageSize", "");
            submitParams.put("isremark", isremarkForRM);
            submitParams.put("takisremark", takisremark);
            submitParams.put("currentdate", currentdate);
            submitParams.put("currenttime", currenttime);
            submitParams.put("creater", creater);
            submitParams.put("creatertype", creatertype);
            submitParams.put("workflowRequestLogId", "");
            submitParams.put("RejectNodes", "");
            submitParams.put("RejectToNodeid", "");
            submitParams.put("RejectToType", "");
            submitParams.put("SubmitToNodeid", "");
            submitParams.put("remarkLocation", "");
            submitParams.put("isdialog", "1");
            submitParams.put("isovertime", "");
            submitParams.put("needwfback", "");
            submitParams.put("lastOperator", lastOperator);
            submitParams.put("lastOperateDate", lastOperateDate);
            submitParams.put("lastOperateTime", lastOperateTime);
            submitParams.put("needcheckLock", "false");
            // JS事件需要隐藏域
            submitParams.put("isCptwf", isCptwf);
            submitParams.put("isSubmitDirectNode", "");
            submitParams.put("lastnodeid", ""); // 值在右键按钮里面计算
            submitParams.put("isSignMustInput", "");
            submitParams.put("isFormSignature", isFormSignature);
            submitParams.put("fromFlowDoc", "");
            submitParams.put("temphasUseTempletSucceed", "");
            submitParams.put("createdoc", "");
            submitParams.put("edesign_layout", "");

            // 默认动态加载签字意见
            boolean signListType = false;
            recordSet.executeSql("select signlisttype from workflow_RequestUserDefault where userId = " + user.getUID());
            if (recordSet.next()) {
                signListType = "0".equals(recordSet.getString("signlisttype"));
            }
            resultDatas.put("signListType", signListType);

            if (istoManagePage && !isprint && !wfmonitor && isonlyview != 1 && !"1".equals(isworkflowhtmldoc) && !isViewNode) {
                int isremark = Util.getIntValue(isremarkForRM, -1);//取权限中计算好的isremark luosy 2019/3/7
                isSignInput = "1";
//                String topage = URLEncoder.encode(Util.null2String(request.getParameter("topage"))); // 返回的页面
                String docfileid = Util.null2String(request.getParameter("docfileid")); // 新建文档的工作流字段
                String newdocid = Util.null2String(request.getParameter("docid")); // 新建的文档
                String uselessFlag = Util.null2String(request.getParameter("uselessFlag"));
                // 加入下一节点的操作人与当前节点的操作人是同一人，需要重新判断是否跳转到正文tab页
                if ("submit".equals(src)) {
                    uselessFlag = "";
                }

                attrSignatureUtil.setAttribute("status", status);
                attrSignatureUtil.setAttribute("requestmark", requestmark);
                attrSignatureUtil.setAttribute("deleted", "" + deleted);
                attrSignatureUtil.setAttribute("workflowtype", workflowtype);
                attrSignatureUtil.setAttribute("helpdocid", "" + helpdocid);
                attrSignatureUtil.setAttribute("newdocid", newdocid);
                attrSignatureUtil.setAttribute("lastOperator", "" + lastOperator);
                attrSignatureUtil.setAttribute("lastOperateDate", lastOperateDate);
                attrSignatureUtil.setAttribute("lastOperateTime", lastOperateTime);

                int isviewonly = 0;
                if (isremark != 0 || "3".equals(nodetype) || isprint) {
                    isviewonly = 1;
                }

                //E9自由是否允许编辑表单
                if (nodeEntity != null) {
                    //待办 或意见征询
                    if (nodeEntity.isAllowModify() && isremark == 0 || isnewFreeLayout) {
                        isviewonly = 0;
                    } else {
                        isviewonly = 1;
                    }
                }

                if (IsCanModify) {
                    isviewonly = 0;
                }

                //判断当前节点是否为自由节点且可编辑表单
                if ("1".equals(isFree)) {
                    recordSet.executeSql("select istableedit from workflow_freeright where nodeid = " + nodeid);
                    if (recordSet.next()) {
                        int istableedit = Util.getIntValue(recordSet.getString("istableedit"), 0);
                        if (istableedit == 0) {
                            isviewonly = 1;
                        }
                    }
                }

                //计算顶部流程编辑锁定信息(不能覆盖错误提示信息)(编辑锁定屏蔽)
				/*String prompttype = Util.null2String(promptInfo.get("prompttype"));
				if(!"errormsg".equals(prompttype)){
					LockUtil lockUtil = new LockUtil();
					boolean needcheckLock = lockUtil.isNeedCheckLock(requestid,workflowid,nodeid,Util.getIntValue(isremarkForRM,0),takisremark,userid);
					if(needcheckLock){
						String timestamp = Util.null2String(request.getParameter("timestamp"));
						Map<String,Object> lockPromptInfo = lockUtil.generateLockPromptInfo(requestid, nodeid, timestamp, user);
						if((Boolean)lockPromptInfo.get("haveLocked"))
							isviewonly = 1;
						submitParams.put("timestamp", lockPromptInfo.get("timestamp"));
						if(!"confirminfo".equals(prompttype))	//不覆盖提交确认信息
							promptInfo.putAll(lockPromptInfo);
					}
				}*/

                //流程打开显示退回信息
                Map<String, Object> rejectPromptInfo = RequestFormBiz.getRejectPromptInfo(requestid, nodeid, user);
                if (promptInfo.isEmpty() && rejectPromptInfo != null && !rejectPromptInfo.isEmpty()) {
                    promptInfo = rejectPromptInfo;
                    promptInfo.put("prompttype", PromptType.REJECTINFO.getType());
                    promptInfos.add(promptInfo);
                }

                //流程打开显示代理信息
                int agentType = Util.getIntValue(Util.null2String(submitParams.get("agentType")));
                int agentorByAgentId = Util.getIntValue(Util.null2String(submitParams.get("agentorByAgentId")));
                Map<String, Object> agentPromptInfo = RequestFormBiz.getAgentPromptInfo(agentType, agentorByAgentId, user);
                if (agentPromptInfo != null && !agentPromptInfo.isEmpty()) {
                    Map<String, Object> otherPromptInfo = new HashMap<>();
                    otherPromptInfo.putAll(promptInfo);
                    promptInfo = agentPromptInfo;
                    promptInfo.put("otherPromptInfo", otherPromptInfo);
                    promptInfo.put("prompttype", PromptType.AGENTINFO.getType());
                    promptInfos.add(promptInfo);
                }

                //如果有加签节点且是简易模式，提示确认加签设置 jym

                if (!"1".equals(isaffirmance) && isremark == 0 && SimpleModeFreeNodeBiz.hasAddSignNode(requestid, nodeid) && selectNextFlowPattern == 0) {
                    promptInfo = new HashMap<>();
                    promptInfo.put("prompttype", "freeWorkflowSimpleInfo");
                    promptInfos.add(promptInfo);
                }

                //if ("1".equals(isaffirmance) && reEdit == 0) {
                //isviewonly = 0;
                //}

                if (isremark == 5) {//流程超时干预
                    attrSignatureUtil.setAttribute("intervenorright", "" + 2);
                    resultDatas.put("intervenorright", 2);
                }
                // 获得被代理人
                int beagenter = 0;
                rs.executeSql("select agentorbyagentid,agenttype from workflow_currentoperator where usertype=0 and isremark='0' and requestid=" + requestid + " and userid=" + user.getUID() + " and nodeid=" + nodeid + " order by id desc");
                if (rs.next()) {
                    int tembeagenter = rs.getInt(1);
                    if (tembeagenter > 0) {
                        beagenter = tembeagenter;
                    }
                }
                resultDatas.put("isagent", beagenter > 0 ? 1 : 0);
                resultDatas.put("beagenter", beagenter);


                attrSignatureUtil.setAttribute("isagent", beagenter > 0 ? "1" : "0");
                attrSignatureUtil.setAttribute("beagenter", "" + beagenter);

                resultDatas.put("requestType", RequestType.MANAGE_REQ.getId());
                //			resultDatas.put("isworkflowdoc", isworkflowdoc);
                resultDatas.put("docfileid", docfileid);
                resultDatas.put("isSignInput", isSignInput);
                resultDatas.put("isviewonly", isviewonly);

                if (!FreeNodeBiz.isFreeFlow(this.workflowid)) {
                    resultDatas.put("isNeedFlowFreeNodeTips", 1 == selectNextFlowPattern && FreeNodeBiz.isNeedFlowFreeNodeTips(requestid, nodeid, extendnodeid));
                }
                boolean canSubmitToRejectNode = FreeNodeBiz.canSubmitToRejectNode(requestid, nodeid, user);
                resultDatas.put("canSubmitToRejectNode", canSubmitToRejectNode);
            } else {
                if ("8".equals(isremarkForRM)) {
                    WFPathUtil wfutil = new WFPathUtil();
                    wfutil.getFixedThreadPool().execute(new RequestPreProcessing(this.workflowid, Util.getIntValue(isbill), formid, requestid, requestname, "", nodeid, 0, false, "", user, true));
                }

                resultDatas.put("requestType", RequestType.VIEW_REQ.getId());
                resultDatas.put("isviewonly", "1");
                resultDatas.put("isSignInput", isSignInput);
            }
            //设置流程二次验证的信息
            Map<String, Object> authInfo = new HashMap<String, Object>();
            apidatas.put("secondAuthInfo", authInfo);

            String isCAAuth = Util.null2String(request.getParameter("isCAAuth"));        //CA数据保护时，此值为1

            RequestSecondAuthService requestSecondAuthService = com.engine.common.util.ServiceUtil.getService(RequestSecondAuthServiceImpl.class, user);
            if ("0".equals(isremarkForRM) && !"1".equals(iscreate) && !"1".equals(isCAAuth)) {
                Map<String, Object> checkResult = requestSecondAuthService.checkProtectDatas(requestid, this.workflowid, formid, Util.getIntValue(isbill), nodeid);
                String checkSuccess = Util.null2String(checkResult.get("success"));
                if ("0".equals(checkSuccess)) {        //说明数据验证失败
                    String checkMsg = Util.null2String(checkResult.get("message"));
                    authInfo.putAll(SecondAuthUtil.getSecondAuthInfo(user, checkSuccess, checkMsg));
                } else if ("2".equals(checkSuccess)) {        //数据被篡改
                    String checkMsg = SystemEnv.getHtmlLabelName(501098, user.getLanguage());        //数据被篡改
                    authInfo.putAll(SecondAuthUtil.getSecondAuthInfo(user, checkSuccess, checkMsg));
                }
            }
            //CA认证，加载CA认证的信息
            if ("1".equals(isCAAuth)) {
                Map<String, Object> authParams = new HashMap<String, Object>();
                authParams.put("requestid", requestid);
                authParams.put("workflowid", this.workflowid);
                authParams.put("nodeid", nodeid);
                Map<String, Object> secondAuthConfig = requestSecondAuthService.getSecondAuthConfig(authParams);
                apidatas.put("secondAuthConfig", secondAuthConfig);

                //因为扫描二维码后就执行提交操作，没有执行verifyRemark方法，导致取不到签字意见，
                // 因此将签字意见直接返回到submitParams中，如果直接扫码提交没有机会修改签字意见，肯定跟加载时的意见保持一致的。
                String myRemark = SecondAuthUtil.getMyRemark(requestid, user);
                submitParams.put("remark", myRemark);
            }

            Map<String, Object> operationSubmitParams = lastOperationResult.getSubmitParams();
            operationSubmitParams.remove("isremark");
            submitParams.putAll(operationSubmitParams);
            submitParams.put(userid + "_" + requestid + "_request_submit_token", System.currentTimeMillis());

            int requestType = Util.getIntValue(Util.null2String(resultDatas.get("requestType")), -1);
            Map<String, Object> remindInfo = this.getRemindInfo(intervenorright, isaffirmance, Util.null2String(this.workflowid), Util.null2String(nodeid), requestType);
            apidatas.put("remindInfo", remindInfo);
            submitParams.put("remindTypes", Util.null2String(remindInfo.get("value")));
            apidatas.put("promptInfo", promptInfo);
            apidatas.put("promptInfos", promptInfos);

            this.appendParamsBeforeReturn(resultDatas);

            RequestInfoEntity reqEntity = new RequestInfoEntity();
            reqEntity.setWorkflowId(this.workflowid);
            reqEntity.setRequestId(String.valueOf(requestid));

            WfWaterMarkEntity waterMarkEntity = WaterMarkBiz.getReqWaterMarkInfo(user, reqEntity, isprint);
            if (waterMarkEntity != null) {
                resultDatas.put("waterMarkInfo", waterMarkEntity);
            }

            //是否开启相关交流
            int isOpenCommunication = Util.getIntValue(wfManager.getIsOpenCommunication(), 0);
            //不是流程参与者，能查看签字意见才显示相关交流
            if (!isurger && isOpenCommunication == 1 && "".equals(isremarkForRM)) {
                Map<String, Object> communicationRightParams = new HashMap<>();
                communicationRightParams.put("requestid", requestid);
                communicationRightParams.put("workflowid", this.workflowid);
                communicationRightParams.put(RequestConstant.SIGNATURE_ATTRIBUTES_STR, attrSignatureUtil.getAttributeStr());
                communicationRightParams.put(RequestConstant.SIGNATURE_SECRET_KEY, attrSignatureUtil.getAttributeSignture());
                isOpenCommunication = WorkflowCommunicationBiz.hasCommunicationRight(communicationRightParams, user) ? 1 : 0;
            }
            if (isOpenCommunication == 1) {
                //是否有新的未读消息
                resultDatas.put("hasNewCommunication", WorkflowCommunicationBiz.hasNewCommunication(requestid, user.getUID()));
            }
            resultDatas.put("isOpenCommunication", isOpenCommunication);

        } catch (Exception e) {
            e.printStackTrace();
        }
        return apidatas;
    }

    //直接由后端返回tab页标签翻译好的名称,防止前端翻译的延迟问题
    private Map getTabName() {
        Map tabNameMap = new HashMap();
        tabNameMap.put("formTab",SystemEnv.getHtmlLabelName(34130, user.getLanguage()));
        tabNameMap.put("picTab",SystemEnv.getHtmlLabelName(18912, user.getLanguage()));
        tabNameMap.put("statusTab",SystemEnv.getHtmlLabelName(386192, user.getLanguage()));
        tabNameMap.put("odocTab",SystemEnv.getHtmlLabelName(1265, user.getLanguage()));
        tabNameMap.put("resourceTab",SystemEnv.getHtmlLabelName(386426, user.getLanguage()));
        tabNameMap.put("shareTab",SystemEnv.getHtmlLabelName(386153, user.getLanguage()));
        tabNameMap.put("communicationTab",SystemEnv.getHtmlLabelName(15153, user.getLanguage()));
        return tabNameMap;
    }

    private Map<String, Object> loadCreateCompetence(Map<String, Object> resultDatas) throws Exception {
        Map<String, Object> apidatas = new HashMap<String, Object>();
        apidatas.put("params", resultDatas);
        RecordSet rs = new RecordSet();
        // 获得工作流的基本信息
        this.workflowid = Util.getIntValue(WorkflowVersion.getActiveVersionWFID(Util.null2String(request.getParameter("workflowid"))), 0);
        resultDatas.put("workflowid", workflowid);

        CptWfUtil cptwfutil = new CptWfUtil();
        // 资产自定义流程类型
        String cptwftype = cptwfutil.getAllCptWftype("" + workflowid);
        boolean isCptwf = false;
        boolean ismodeCptwf = false;
        if (!"".equals(cptwftype)) {
            isCptwf = "fetch".equalsIgnoreCase(cptwftype) || "move".equalsIgnoreCase(cptwftype) || "lend".equalsIgnoreCase(cptwftype) || "discard".equalsIgnoreCase(cptwftype)
                    || "back".equalsIgnoreCase(cptwftype) || "loss".equalsIgnoreCase(cptwftype) || "mend".equalsIgnoreCase(cptwftype) || "mode_fetch".equalsIgnoreCase(cptwftype)
                    || "mode_move".equalsIgnoreCase(cptwftype) || "mode_lend".equalsIgnoreCase(cptwftype) || "mode_discard".equalsIgnoreCase(cptwftype) || "mode_back".equalsIgnoreCase(cptwftype)
                    || "mode_loss".equalsIgnoreCase(cptwftype) || "mode_mend".equalsIgnoreCase(cptwftype);
            ismodeCptwf = cptwftype.startsWith("mode_");
        }
        resultDatas.put("ismodeCptwf", ismodeCptwf);
        resultDatas.put("isCptwf", isCptwf);

        WorkflowComInfo wfComInfo = new WorkflowComInfo();
        String workflowname = wfComInfo.getWorkflowname(workflowid + "");
        workflowname = Util.processBody(workflowname, user.getLanguage() + "");
        String workflowtype = wfComInfo.getWorkflowtype(workflowid + ""); // 工作流种类

        resultDatas.put("workflowname", workflowname);
        resultDatas.put("workflowtype", workflowtype);

        int helpdocid = 0;
        int messageType = 0;
        int chatsType = 0;// 微信提醒(QC:98106)
        int defaultName = 0;
        String smsAlertsType = "0";
        String chatsAlertType = "0";// 微信提醒(QC:98106)
        String docCategory = "";
        String isannexupload = "";
        String annexdocCategory = "";
        String needconfirm = ""; // 是否需要提交确认
        String newdocpath = ""; //限制文档字段新建目录
        String isFree = "";
        int freewftype = 2;
        String isValid = ""; // 是否有效

        int userid = user.getUID();
        String logintype = user.getLogintype();
        String username = "";
        if (logintype.equals("1")) {
            ResourceComInfo resComInfo = new ResourceComInfo();
            username = Util.toScreen(resComInfo.getResourcename("" + userid), user.getLanguage());
        }
        if (logintype.equals("2")) {
            CustomerInfoComInfo cusComInfo = new CustomerInfoComInfo();
            username = Util.toScreen(cusComInfo.getCustomerInfoname("" + userid), user.getLanguage());
        }
        resultDatas.put("username", username);

        int islockworkflow = 0;

        // 查询该工作流的表单id，是否是单据（0否，1是），帮助文档id
        rs.executeProc("workflow_Workflowbase_SByID", workflowid + "");
        if (rs.next()) {
            this.formid = Util.getIntValue(rs.getString("formid"), 0);
            this.isbill = "" + Util.getIntValue(rs.getString("isbill"), 0);
            //获取自由流程自定义表单
            if (isnewFreeLayout) {
                DoSaveFreeExcelDesignBiz doSaveFreeExcelDesignBiz = new DoSaveFreeExcelDesignBiz(this.user);
                doSaveFreeExcelDesignBiz.getFreeNodeFormConfig(Util.null2String(this.configId));
                this.formid = doSaveFreeExcelDesignBiz.getFormid();
                this.isbill = Util.null2String(doSaveFreeExcelDesignBiz.getIsbill());
            }
            helpdocid = Util.getIntValue(rs.getString("helpdocid"), 0);
            // modify by xhheng @20050318 for TD1689,
            // 顺便将messageType、docCategory的获取统一至此
            messageType = rs.getInt("messageType");
            smsAlertsType = rs.getString("smsAlertsType");
            // 微信提醒START(QC:98106)
            chatsType = rs.getInt("chatsType");
            chatsAlertType = rs.getString("chatsAlertType");
            // 微信提醒END(QC:98106)
            defaultName = rs.getInt("defaultName");
            docCategory = rs.getString("docCategory");
            isannexupload = Util.null2String(rs.getString("isannexUpload"));
            annexdocCategory = Util.null2String(rs.getString("annexdoccategory"));
            needconfirm = Util.null2o(rs.getString("needAffirmance"));
            newdocpath = Util.null2String(rs.getString("newdocpath"));
            islockworkflow = Util.getIntValue(rs.getString("islockworkflow"), 0);
            isFree = rs.getString("isFree");
            isValid = rs.getString("isvalid");
            freewftype = Util.getIntValue(rs.getString("freewftype"), 2);
        }

        // 查询该工作流的当前节点id （即改工作流的创建节点 ）

        rs.executeProc("workflow_CreateNode_Select", workflowid + "");
        if (rs.next())
            nodeid = Util.getIntValue(rs.getString(1));

        resultDatas.put("nodeid", nodeid);
        resultDatas.put("formid", formid);
        resultDatas.put("isbill", isbill);
        resultDatas.put("billid", 0);
        resultDatas.put("nodeid", nodeid);
        resultDatas.put("helpdocid", helpdocid);
        resultDatas.put("messageType", messageType);
        resultDatas.put("smsAlertsType", smsAlertsType);
        resultDatas.put("chatsType", chatsType);
        resultDatas.put("chatsAlertType", chatsAlertType);
        resultDatas.put("defaultName", defaultName);
        resultDatas.put("docCategory", docCategory);
        resultDatas.put("isannexupload", isannexupload);
        resultDatas.put("annexdocCategory", annexdocCategory);
        resultDatas.put("needconfirm", needconfirm);
        resultDatas.put("newdocpath", newdocpath);
        resultDatas.put("isFree", isFree);

        getSelectNextFlowParams(workflowid, nodeid, resultDatas);//获取指定下一节点流转信息


        // 检查用户是否有创建权限
        RequestCheckUser requestCheckUser = new RequestCheckUser();
        // 2021.11.03 修改agent验权逻辑，封装agentBiz相关方法 -zhhsh2021
        int isagent = Util.getIntValue(request.getParameter("isagent"), 0);
        int beagenter = Util.getIntValue(request.getParameter("beagenter"), 0);
        int veryid=userid;
        if (isagent == 1 && beagenter != 0) {
            if (AgentBiz.hasAgentCreatRight(userid,workflowid,beagenter)){
                veryid = beagenter;
            }
        }
        requestCheckUser.setUserid(veryid);
        requestCheckUser.setWorkflowid(workflowid);
        requestCheckUser.setLogintype(logintype);
        requestCheckUser.checkUser();
        boolean verifyRight = requestCheckUser.getHasright() == 1;

        if (islockworkflow == 1 && !"true".equals(Util.null2String(request.getParameter("belongTest"))))
            verifyRight = false;    //流程锁定并且不是测试状态
        if (("2".equals(isValid) || "0".equals(isValid)) && !"true".equals(Util.null2String(request.getParameter("belongTest")))) {
            verifyRight = false;//当前流程版本是否是测试状态流程
        }
        resultDatas.put("isagent", isagent);
        resultDatas.put("beagenter", beagenter);
        resultDatas.put("verifyRight", verifyRight);
        boolean onlyVerifyRight = "true".equals(Util.null2String(request.getParameter("onlyVerifyRight")));
        if (!verifyRight || onlyVerifyRight) {
            if (onlyVerifyRight && "true".equals(Util.null2String(request.getParameter("belongTest"))))
                resultDatas.putAll(new TestWorkflowCheckBiz().judgeSupportSpaTest(workflowid));
            return apidatas;
        }
        attrSignatureUtil.setAttribute("isagent", "" + isagent);
        attrSignatureUtil.setAttribute("beagenter", "" + beagenter);
        attrSignatureUtil.setAttribute("configid", "" + configId);

        // 判断是否有流程创建文档，并且在该节点是有正文字段
        OfficalConditionInfo docConditionInfo = new OfficalConditionInfo();
        docConditionInfo.setWorkflowId(workflowid);
        docConditionInfo.setNodeId(nodeid);
        OfficalResultInfo resultInfo = WorkflowCreateDocPublicUtil.getWorkflowCreateDocData(docConditionInfo);

        resultDatas.put("isWorkflowDoc", resultInfo.isWorkflowDoc());
        resultDatas.put("flowDocFieldId", resultInfo.getFlowDocFieldId());
        submitParams.put("isWorkflowDoc", resultInfo.isWorkflowDoc());

        //RequestDoc flowDoc = new RequestDoc();
        //boolean docFlag = flowDoc.haveDocFiled(workflowid, nodeid);
        //String docFlagss = docFlag ? "1" : "0";
        //session.setAttribute("requestAdd" + user.getUID(), docFlagss);
        //resultDatas.put("docFlagss", docFlagss);

        // 判断正文字段是否显示选择按钮
        //ArrayList newTextList = flowDoc.getDocFiled(workflowid);
        //if (newTextList != null && newTextList.size() > 0) {
        //	String newTextNodes = "" + newTextList.get(5);
        //	String flowDocField = "" + newTextList.get(1);
        //	session.setAttribute("requestFlowDocField" + user.getUID(), flowDocField);
        //	session.setAttribute("requestAddNewNodes" + user.getUID(), newTextNodes);
        //}

        // 对不同的模块来说,可以定义自己相关的内容，作为请求默认值，比如将 docid 赋值，作为该请求的默认文档
        // 默认的值可以赋多个，中间用逗号格开
        String prjid = Util.null2String(request.getParameter("prjid"));
        String docid = Util.null2String(request.getParameter("docid"));
        String crmid = Util.null2String(request.getParameter("crmid"));
        String hrmid = Util.null2String(request.getParameter("hrmid"));
        String reqid = Util.null2String(request.getParameter("reqid"));
        if (hrmid.equals("") && logintype.equals("1"))
            hrmid = "" + userid;
        if (crmid.equals("") && logintype.equals("2"))
            crmid = "" + userid;

        resultDatas.put("prjid", prjid);
        resultDatas.put("docid", docid);
        resultDatas.put("crmid", crmid);
        resultDatas.put("hrmid", hrmid);
        resultDatas.put("reqid", reqid);

        // 工作流建立完成后将返回的页面
        String topage = Util.null2String(request.getParameter("topage"));
        if (isbill.equals("1")) {
            session.setAttribute("topage_ForAllBill", topage);
        }

        Map fieldMap = request.getParameterMap();
        Set keySet = fieldMap.keySet();
        Iterator it = keySet.iterator();
        String fieldUrl = "";
        while (it.hasNext()) {
            String key = Util.null2String((String) it.next());
            if (key.startsWith("field")) {
                String[] valueArr = (String[]) fieldMap.get(key);
                for (int i = 0; i < valueArr.length; i++) {
                    String value = valueArr[i];
                    fieldUrl += "&" + key + "=" + URLEncoder.encode(value);
                }
            }
        }
        if (!"".equals(fieldUrl)) {
            fieldUrl = fieldUrl.substring(1, fieldUrl.length());
            fieldUrl = URLEncoder.encode(fieldUrl);
        }
        resultDatas.put("fieldUrl", fieldUrl);

        // 请求提交的时候需要检查必输的字段名，多个必输项用逗号格开，requestname为新建请求中第一行的请求说明，是每一个请求都必须有的
        // TopTitle.jsp 页面参数
        String titlename = SystemEnv.getHtmlLabelName(18015, user.getLanguage()) + ":" + SystemEnv.getHtmlLabelName(125, user.getLanguage()) + " - " + Util.toScreen(workflowname, user.getLanguage())
                + " - " + SystemEnv.getHtmlLabelName(125, user.getLanguage());

        String requestid = "-1";
        String ismode = "";
        int showdes = 0, printdes = 0;
        String isHideArea = "0";
        String isHideInput = "0";
        int selectNextFlowPattern = 0;
        rs.executeSql("select ismode,showdes,ishidearea,ishideinput,selectnextflowpattern from workflow_flownode where workflowid=" + workflowid + " and nodeid=" + nodeid);
        if (rs.next()) {
            ismode = Util.null2String(rs.getString("ismode"));
            if (isnewFreeLayout) {
                ismode = "2";
            }
            showdes = Util.getIntValue(Util.null2String(rs.getString("showdes")), 0);
            printdes = Util.getIntValue(Util.null2String(rs.getString("printdes")), 0);
            isHideArea = Util.null2String(rs.getString("ishidearea"), "0");
            isHideInput = Util.null2String(rs.getString("ishideinput"), "0");
            selectNextFlowPattern = Util.getIntValue(Util.null2String(rs.getString("selectnextflowpattern")), 0);
        }

        if ("1".equals(isFree)) selectNextFlowPattern = (freewftype == 1) ? 0 : 1;
        resultDatas.put("isHideArea", isHideArea);
        resultDatas.put("isHideInput", isHideInput);
        resultDatas.put("requestid", requestid);
        resultDatas.put("titlename", titlename);
        resultDatas.put("btnLabelName", getTabName());
        resultDatas.put("requestType", RequestType.CREATE_REQ.getId());
        resultDatas.put("isviewonly", "0");
        resultDatas.put("iscreate", "1");
        resultDatas.put("creater", userid);
        resultDatas.put("creatertype", usertype);
        resultDatas.put("nodetype", 0);
        resultDatas.put("selectNextFlowPattern", selectNextFlowPattern + "");
        resultDatas.put("openNodeCheck", new NodeFieldCheckBiz().isOpenNodeFieldCheckInfo(workflowid, nodeid));

        //权限添加时“所有人”可选项受控于组织机构应用分权
        boolean appDetachDisableAll = new ManageDetachComInfo().appDetachDisableAll(user);
        resultDatas.put("appDetachDisableAll", appDetachDisableAll);

        //如果可以流转并且是简易模式 显示流转设置div

        boolean isAllowNodeFreeFlow = FreeNodeBiz.isAllowNodeFreeFlow(0, nodeid);
        resultDatas.put("showFreeWfSimpleCom", (isAllowNodeFreeFlow && selectNextFlowPattern == 0) ? 1 : 0);
        resultDatas.putAll(appendLayoutInfo(ismode, showdes, printdes, nodeid));
        resultDatas.put("isSelfAuth", 1);

        submitParams.put("workflowid", workflowid);
        submitParams.put("workflowtype", workflowtype);
        submitParams.put("nodeid", nodeid);
        submitParams.put("nodetype", "0");
        submitParams.put("src", "");
        submitParams.put("iscreate", "1");
        submitParams.put("formid", formid);
        submitParams.put("topage", "");
        submitParams.put("isbill", isbill);
        submitParams.put("method", "");
        submitParams.put("isMultiDoc", "");
        submitParams.put("requestid", "-1");
        submitParams.put("rand", "");
        submitParams.put("needoutprint", "");
        submitParams.put("htmlfieldids", "");
        submitParams.put("needwfback", "");
//		submitParams.put("docFlags", docFlagss);
        submitParams.put(userid + "_" + workflowid + "_addrequest_submit_token", System.currentTimeMillis());
        submitParams.put("lastloginuserid", user.getUID());
        Map<String, Object> remindInfo = this.getRemindInfo(0, "", Util.null2String(workflowid), Util.null2String(nodeid), RequestType.CREATE_REQ.getId());
        submitParams.put("remindTypes", Util.null2String(remindInfo.get("value")));
        apidatas.put("submitParams", submitParams);
        this.appendParamsBeforeReturn(resultDatas);
        apidatas.put("remindInfo", remindInfo);

        RequestInfoEntity reqEntity = new RequestInfoEntity();
        reqEntity.setWorkflowId(workflowid);
        reqEntity.setRequestId("-1");
        WfWaterMarkEntity waterMarkEntity = WaterMarkBiz.getReqWaterMarkInfo(user, reqEntity, isprint);
        if (waterMarkEntity != null) {
            resultDatas.put("waterMarkInfo", waterMarkEntity);
        }
        return apidatas;
    }

    private Map<String, Object> appendLayoutInfo(String ismodeStr, int showdes, int printdes, int nodeid) {
        Map<String, Object> layout = new HashMap<String, Object>();
        int ismode = 0;
        int modeid = -1;
        int layouttype = Util.getIntValue(request.getParameter("layouttype"), 0);
        int layoutversion = 2;
        if (isprint) {    //打印从request获取，模板已算好
            ismode = Util.getIntValue(request.getParameter("ismode"), 0);
            modeid = Util.getIntValue(request.getParameter("modeid"));
            layouttype = 1;
            if (ismode == 2) {
                layoutversion = new LayoutInfoBiz().getLayoutVersion(modeid);
                layout.put("printLogListFlag", new PrintInfoBiz().getPrintLogListFlag(modeid, true));
            } else
                layout.put("printLogListFlag", (new PrintInfoBiz().getDefaultPrintLogListFlag(nodeid)) == 0 ? 0 : 1);//模板模式不走这里
        } else {
            ismode = Util.getIntValue(ismodeStr, 0);
            boolean isMobileForm = "1".equals(request.getParameter("isMobileForm"));    //移动端
            if (isMobileForm) {
                int showLayoutSwitch = 0;    //是否显示模板切换按钮
                String layoutAnalysisType = Util.null2String(request.getParameter("layoutAnalysisType"));        //是否读取PC模板
                RecordSet rs = new RecordSet();
                rs.executeProc("SystemSet_Select", "");    //读后台配置
                rs.next();
                showLayoutSwitch = Util.getIntValue(rs.getString("mobilechangemode"), 0);
                if (showLayoutSwitch == 1 && "".equals(layoutAnalysisType)) {    //计算默认模板解析模式
                    layoutAnalysisType = "1";
                    int mobilemode = Util.getIntValue(rs.getString("mobilemode"), 0);
                    if (mobilemode == 1) {
                        int mobileapplyworkflow = Util.getIntValue(rs.getString("mobileapplyworkflow"), 0);
                        String mobileapplyworkflowids = Util.null2String(rs.getString("mobileapplyworkflowids"));
                        String versionsIds = "," + WorkflowVersion.getAllVersionStringByWFIDs(mobileapplyworkflowids) + ",";
                        String wfStr = "," + this.workflowid + ",";
                        if (mobileapplyworkflow == 0 || (mobileapplyworkflow == 1 && versionsIds.indexOf(wfStr) > -1) || (mobileapplyworkflow == 2 && versionsIds.indexOf(wfStr) == -1)) {
                            layoutAnalysisType = "2";        //默认使用PC解析模式
                        }
                    }
                }
                layouttype = "2".equals(layoutAnalysisType) ? 0 : 2;
                layout.put("showLayoutSwitch", showLayoutSwitch);
                layout.put("layoutAnalysisType", layoutAnalysisType);
            }
            if (ismode == 2) {    //html模式取活动模板、表单模板等
                weaver.workflow.exceldesign.HtmlLayoutOperate htmlLayoutOperate = new weaver.workflow.exceldesign.HtmlLayoutOperate();
                if (this.isnewFreeLayout) {
                    DoSaveFreeExcelDesignBiz doSaveFreeExcelDesignBiz = new DoSaveFreeExcelDesignBiz(user);
                    boolean isSimpleFreeFlow = FreeNodeBiz.judgeNodeSimpleFreeFlow(workflowid, this.nodeid);
                    if (isSimpleFreeFlow) {
                        modeid = doSaveFreeExcelDesignBiz.getLayoutIdByConfig(configId, nodeid);
                    } else {
                        modeid = doSaveFreeExcelDesignBiz.getLayoutIdByConfig(configId, this.nodeid);
                    }
                } else {
                    modeid = htmlLayoutOperate.getActiveHtmlLayout(workflowid, nodeid, layouttype);
                }
                if (modeid > 0) {    //为html模板
                    layoutversion = isnewFreeLayout ? 2 : new LayoutInfoBiz().getLayoutVersion(modeid);
                } else {    //无html模板默认为普通模板
                    ismode = 0;
                }
            } else {    //取普通模式模板
                ismode = 0;
            }
        }
        layout.put("ismode", ismode);
        layout.put("modeid", modeid);
        layout.put("layouttype", layouttype);
        layout.put("layoutversion", layoutversion);
        return layout;
    }

    private int loadShowAiParams(RecordSet recordSet, String workflowid) {
        String showAiSwitch = "";
        String workflowRange = "";
        String workflowIds = "";
        recordSet.executeQuery("select value from workflow_config where name = 'Intelligent_analysis_switch' and type='form'");
        if (recordSet.next()) {
            showAiSwitch = recordSet.getString(1);
        }
        recordSet.executeQuery("select value from workflow_config where name = 'Intelligent_analysis_range' and type='form'");
        if (recordSet.next()) {
            workflowRange = recordSet.getString(1);
        }
        recordSet.executeQuery("select value from workflow_config where name = 'Intelligent_analysis_workflow_path' and type='form'");
        if (recordSet.next()) {
            workflowIds = recordSet.getString(1);
        }
        if ("1".equals(showAiSwitch)) {
            String[] wfids = workflowIds.split(",");
            switch (workflowRange) {
                case "0":
                    return 1;
                case "1":
                    return (Util.contains(wfids, workflowid)) ? 1 : 0;
                case "2":
                    return (!Util.contains(wfids, workflowid)) ? 1 : 0;
                default:
                    return 0;
            }
        } else {
            return 0;
        }
    }


    /**
     * 由于新建与编辑走的不同方法，再return前调用此方法用于扩充(新建、编辑)都需要的params
     */
    private void appendParamsBeforeReturn(Map<String, Object> resultDatas) {
        RecordSet rs = new RecordSet();
        int workflowid = Util.getIntValue(resultDatas.get("workflowid") + "", 0);
        int iscreate = Util.getIntValue(resultDatas.get("iscreate") + "", 0);
        int formid = Util.getIntValue(resultDatas.get("formid") + "", 0);
        int isbill = Util.getIntValue(resultDatas.get("isbill") + "", 0);
        int nodeid = Util.getIntValue(resultDatas.get("nodeid") + "", 0);
        boolean isMobileForm = "1".equals(request.getParameter("isMobileForm"));
        boolean isFormMsg = "1".equals(request.getParameter("isFormMsg"));

        resultDatas.put("nodename", new WorkflowNodeComInfo().getNodename(nodeid + ""));
        resultDatas.put("apiResultCacheKey", (new Date()).getTime());
        resultDatas.put("f_weaver_belongto_userid", f_weaver_belongto_userid);
        resultDatas.put("f_weaver_belongto_usertype", f_weaver_belongto_usertype);
        resultDatas.put("languageid", user.getLanguage());
        resultDatas.put("lastname", user.getLastname());
        resultDatas.put("useInvoiceCloud", weaver.fna.invoice.utils.InvoiceCloudUtil.isExistInvoiceCloudInterface(user));
        if (isMobileForm) {
            DocCommonServiceImpl docService = new DocCommonServiceImpl();
            resultDatas.put("docViewUrl", docService.getMobileDocViewLink("${docid}"));
            resultDatas.put("fileViewUrl", docService.getMobileFileViewLink("${fileid}"));
        } else {
            resultDatas.put("docViewUrl", ServiceUtil.docViewUrl);
            resultDatas.put("fileViewUrl", ServiceUtil.fileViewUrl);
        }
        if (isFormMsg) {
            if (isMobileForm) {
                rs.executeQuery("select value from workflow_config where type= 'msgForm' and name ='mobile_msg_form' ");
            } else {
                rs.executeQuery("select value from workflow_config where type= 'msgForm' and name ='pc_msg_form' ");
            }
            rs.next();
            resultDatas.put("msgSubmitFormAction", Util.null2String(rs.getString(1)));
        }
        PortalCommonServiceImpl portalService = new PortalCommonServiceImpl();
        resultDatas.put("existSynergy", portalService.getPortalSynergyIsUse(iscreate, workflowid, requestid));
        if (isMobileForm)
            resultDatas.put("mobileSupportViewFileType", new DocDetailUtil().getAttachViewFileType());
        //custompage自定义页面信息


        String oldcustompage = "";
        rs.executeQuery("select custompage from workflow_base where id=?", workflowid);
        if (rs.next()) {
            oldcustompage = Util.null2String(rs.getString("custompage")).trim();
        }
        Map<String, List<String>> custompage = new HashMap<>();
        List<String> cssPage = new ArrayList();
        List<String> jsPage = new ArrayList();
        List<String> jspPage = new ArrayList();
        if (!"".equals(oldcustompage))
            jspPage.add(oldcustompage);
        rs.executeQuery("select workflowid,url from workflow_custompageconfig where enable=1 and (workflowid=-999 or workflowid=" + workflowid + ") order by workflowid,orderid");
        while (rs.next()) {
            String url = Util.null2String(rs.getString("url"));
            if (Pattern.compile("\\.css", Pattern.CASE_INSENSITIVE).matcher(url).find()) {
                cssPage.add(url);
            } else if (Pattern.compile("\\.jsp", Pattern.CASE_INSENSITIVE).matcher(url).find()) {
                jspPage.add(url);
            } else if (Pattern.compile("\\.js", Pattern.CASE_INSENSITIVE).matcher(url).find()) {
                jsPage.add(url);
            }
        }
        custompage.put("cssPage", cssPage);
        custompage.put("jsPage", jsPage);
        custompage.put("jspPage", jspPage);
        CustomPageRangeCache.appendPage(jspPage);
        resultDatas.put("custompage", custompage);
        //流程测试信息
        String wfTestStr = new TestWorkflowCheckBiz().encodeTestStr(request);
        resultDatas.put("belongTest", !"".equals(wfTestStr));
        resultDatas.put("wfTestStr", wfTestStr);
        //签名串属性存储
        resultDatas.put(RequestConstant.SIGNATURE_ATTRIBUTES_STR, attrSignatureUtil.getAttributeStr());
        resultDatas.put(RequestConstant.SIGNATURE_SECRET_KEY, attrSignatureUtil.getAttributeSignture());
        //单据信息
        if (isbill == 1) {
            SystemBillManagerBiz billManager = new SystemBillManagerBiz(formid);
            String billIncludePage = billManager.getIncludePagePath();
            CustomPageRangeCache.appendPage(billIncludePage);
            resultDatas.put("billIncludePage", billIncludePage);
            resultDatas.put("billIncludePage4mobile", billManager.getIncludePagePath4Mobile());
        }
        if (nodeid > 0 || FreeNodeBiz.isFreeNode(nodeid))
            resultDatas.put("margin", RequestFormBiz.generateLayoutMargin(FreeNodeBiz.getExtendNodeId(nodeid)));

        //是否开启showAI智能分析
        resultDatas.put("showAI", loadShowAiParams(rs, String.valueOf(workflowid)));
        resultDatas.put("wfFormFieldChangeCfg", getWorkflowFormFieldChangeCfg(nodeid));
        resultDatas.put("openDataVerify", getDataVerifyCfg());
    }

    /**
     * 获取是否开启数据校验开关
     *
     * @return
     */
    private Object getDataVerifyCfg() {
        String openDataVerify = "0";
        RecordSet rs = new RecordSet();
        String sql = "select value from workflow_config where name = 'form_open_dataverify' and type = 'form'";
        rs.executeQuery(sql);
        while (rs.next()) {
            openDataVerify = rs.getString(1);
        }
        return openDataVerify;
    }

    /**
     * 兼容异常情况下workflow_form表同一requestid多条记录问题
     * 改为直接从物理表计算billid，计算失败再从workflow_form表计算
     */
    private int calculateBillid(int formid, int isbill, int requestid) {
        int billid = 0;
        RecordSet rs = new RecordSet();
        if (isbill == 1) {
            rs.executeQuery("select tablename from workflow_bill where id=?", formid);
            if (rs.next()) {
                String tablename = rs.getString("tablename");
                boolean flag = rs.executeQuery("select id from " + tablename + " where requestid=?", requestid);
                if (flag && rs.getCounts() == 1 && rs.next()) {
                    billid = Util.getIntValue(rs.getString("id"));
                }
            }
            if (billid <= 0) {
                rs.executeQuery("select billformid,billid from workflow_form where requestid=?", requestid);
                if (rs.next()) {
                    billid = Util.getIntValue(rs.getString("billid"));
                    //物理表查不到情况formid以workflow_form表为准
                    int billformid = Util.getIntValue(rs.getString("billformid"), 0);
                    if (this.formid < 0 && billformid < 0 && this.formid != billformid)
                        this.formid = billformid;
                }
            }
        }
        return billid;
    }

    protected void getSelectNextFlowParams(int workflowid, int nodeid, Map<String, Object> params) {
        RecordSet rs = new RecordSet();
        String canChangeNextFlow = "";
        rs.executeQuery("select selectNextFlow from workflow_flownode where nodeid = ? and workflowid = ?", nodeid, workflowid);
        if (rs.next()) {
            canChangeNextFlow = rs.getString("selectNextFlow");
        }
        params.put("selectNextFlow", "1".equals(canChangeNextFlow) ? "1" : "0");
    }

    /**
     * 获取提醒类型设置信息
     *
     * @param intervenorright 2：干预；其他 非干预
     * @param isaffirmance    流程确认
     * @param wfId            路径ID
     * @param currentnodeid   当前节点ID
     * @param requestType
     * @return
     */
    private Map<String, Object> getRemindInfo(int intervenorright, String isaffirmance, String wfId, String currentnodeid, int requestType) {

        Map<String, Object> results = new HashMap<>();
        List<Map<String, Object>> options = new ArrayList<>();
        results.put("options", options);
        results.put("isShow", false);
        results.put("process", SystemEnv.getHtmlLabelName(533759, user.getLanguage()));
        RecordSet rs = new RecordSet();
        rs.executeQuery("select 1 from workflow_base where id = ? and remindScope = '1' ", wfId);
        if (rs.next()) {
            //em...如果路径开启节点自定义提醒，统一返回一种提醒方式，最后在RequestRemindBiz中，根据节点上设置的提醒方式做提醒
            Map<String, Object> email = new HashMap<>();
            email.put("key", RemindTypeEnum.EMAIL.getCode());
            email.put("showname", SystemEnv.getHtmlLabelName(18845, user.getLanguage()));
            options.add(email);
            results.put("options", options);
            results.put("value", RemindTypeEnum.EMAIL.getCode());
            results.put("isShow", false);
            results.put("viewAttr", 2);
            return results;
        }

        rs.executeQuery("select 1 from workflow_currentoperator where requestid =? and islasttimes =1 and userid = ? and ((isremark =1 and takisremark = 2) or isremark =0)  ", requestid, userid);
        //流程审批、意见征询回复或者流程创建时，才显示提醒方式
        if ((requestType == RequestType.CREATE_REQ.getId()) || rs.next() || intervenorright == 2) {
            String value = null;
            WFManager wfManager = new WFManager();
            wfManager.setWfid(Util.getIntValue(wfId));
            try {
                wfManager.getWfInfo();
                //1、没有开启提醒
                if (!RequestRemindBiz.isOpenRemind(wfManager)) return results;
                //2、E8设置中的提醒方式
                int messageType = Util.getIntValue(wfManager.getMessageType(), -1); //短信
                int smsAlertsType = Util.getIntValue(wfManager.getSmsAlertsType(),0);

                String mailMessageType = wfManager.getMailMessageType(); //邮件
//                if (messageType >= 1) {
//                    Map<String, Object> sms = new HashMap<>();
//                    sms.put("key", RemindTypeEnum.SMS.getCode());
//                    sms.put("showname", SystemEnv.getHtmlLabelName(17586, user.getLanguage()));
//                    options.add(sms);
//                    results.put("options", options);
//                    results.put("value", RemindTypeEnum.SMS.getCode());
//                    results.put("isShow", false);
//                    results.put("viewAttr", 2);
//                    return results;
//                } else if ("1".equals(mailMessageType)) {
//                    Map<String, Object> email = new HashMap<>();
//                    email.put("key", RemindTypeEnum.EMAIL.getCode());
//                    email.put("showname", SystemEnv.getHtmlLabelName(18845, user.getLanguage()));
//                    options.add(email);
//                    results.put("options", options);
//                    results.put("value", RemindTypeEnum.EMAIL.getCode());
//                    results.put("isShow", requestType == RequestType.VIEW_REQ.getId() ? false : true);
//                    results.put("viewAttr", 2);
//                    return results;
//                }

                //3、E9提醒
                Set<String> defaultValue = new HashSet<>();
                boolean isAlterRemindType = true;
                //3.1、开启节点单独设置，当前节点没有单独设置
                String isDefaultSmsRemind = wfManager.getIsDefaultSmsRemind();
                String isDefaultEmailRemind = wfManager.getIsDefaultEmailRemind();
                if ("1".equals(isDefaultSmsRemind) || (messageType >= 1 && smsAlertsType>0)) defaultValue.add(RemindTypeEnum.SMS.getCode());
                if ("1".equals(isDefaultEmailRemind) || "1".equals(mailMessageType)) defaultValue.add(RemindTypeEnum.EMAIL.getCode());

                String alterRemindNodesType = wfManager.getAlterRemindNodesType();
                if ("1".equals(alterRemindNodesType)) {
                    String alterRemindNodes = Util.null2String(wfManager.getAlterRemindNodes());
                    String[] alterRemindNodesArr = alterRemindNodes.split(",");
                    List<String> templast = Arrays.asList(alterRemindNodesArr);
                    isAlterRemindType = templast.contains(FreeNodeBiz.getExtendNodeId(Util.getIntValue(currentnodeid)) + "");
                }

                if (requestType == RequestType.CREATE_REQ.getId()) {
                    value = String.join(",", defaultValue); //流程创建时取默认
                } else { //其他情况先统一取数据库中的值
                    rs.executeQuery("select remindTypes from workflow_requestbase where requestid=?", this.requestid);
                    if (rs.next()) value = Util.null2String(rs.getString("remindTypes"));

                    if (!"1".equals(isaffirmance)) {

                        //3、流程刚流转到当前节点，节点操作者查看时，要取默认值
                        rs.executeQuery("select receivedate,receivetime from workflow_currentoperator where requestid =?  and nodeId = ? and viewtype <> 0", requestid, currentnodeid);
                        if (!rs.next()) {
                            value = String.join(",", defaultValue); //当前节点操作者都未查看改流程
                        } else {
                            String receivedate = rs.getString("receivedate");
                            String receivetime = rs.getString("receivetime");
                            rs.executeQuery("select operatedate,operatetime from workflow_requestLog where  requestid =? and nodeId = ? and logtype = '1'", requestid, currentnodeid);
                            if (!rs.next()) {
                                value = String.join(",", defaultValue); //查看过，但是没执行过保存
                            } else {
                                String operatedate = rs.getString("operatedate");
                                String operatetime = rs.getString("operatetime");
                                int compDate = DateUtil.compDate(String.format("%s %s", receivedate, receivetime), String.format("%s %s", operatedate, operatetime));
                                if (compDate < 0) {
                                    value = String.join(",", defaultValue);
                                }
                                //强制收回后，取默认值
                                rs.executeQuery("select 1 from workflow_requestoperatelog where requestid = ? and isinvalid = 1 and operatorId = ? and nodeid = ?", requestid, user.getUID(), currentnodeid);
                                if (rs.next()) {
                                    value = String.join(",", defaultValue);
                                }
                            }
                        }
                    }
                }

                String isSmsRemind = wfManager.getIsSmsRemind();
                String isEmailRemind = wfManager.getIsEmailRemind();
                boolean disabled = "1".equals(isaffirmance) ? true : (!isAlterRemindType);
                if ("1".equals(isSmsRemind) || messageType >= 1) {    //短信提醒
                    Map<String, Object> sms = new HashMap<>();
                    sms.put("key", RemindTypeEnum.SMS.getCode());
                    sms.put("showname", SystemEnv.getHtmlLabelName(17586, user.getLanguage()));
                    sms.put("disabled", disabled);
                    options.add(sms);
                }
                if ("1".equals(isEmailRemind) || "1".equals(mailMessageType)) {//邮件提醒
                    Map<String, Object> email = new HashMap<>();
                    email.put("key", RemindTypeEnum.EMAIL.getCode());
                    email.put("showname", SystemEnv.getHtmlLabelName(18845, user.getLanguage()));
                    email.put("disabled", disabled);
                    options.add(email);
                }

                boolean showRemindtype = true;
                if (intervenorright != 2 && requestType == RequestType.VIEW_REQ.getId()) {
                    showRemindtype = false;
                }
                results.put("options", options);
                results.put("value", value);
                results.put("isShow", showRemindtype && isAlterRemindType);
                results.put("viewAttr", isAlterRemindType ? 2 : 1);

            } catch (Exception e) {
                writeLog(e);
            }
        }
        return results;
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    public int getRequestid() {
        return requestid;
    }

    public int getWorkflowid() {
        return workflowid;
    }

    public int getFormid() {
        return formid;
    }

    public String getIsbill() {
        return isbill;
    }

    public Map<String, Object> getReqParams() {
        return reqParams;
    }

    private void wcCopy(int requestid, int userid, int usertype) {
        String nodetype = "",
                cids = "",
                endCid = "";
        RecordSet rs = new RecordSet(),
                rs1 = new RecordSet();
        String sql = "select co.id,nodetype from workflow_flownode nb inner join workflow_currentoperator co on co.nodeid = nb.nodeid where co.requestid = ? and "
                + "userid = ? and usertype = ? and isremark in ('1','7','8')";
        rs.executeQuery(sql, requestid, userid, usertype);
        while (rs.next()) {
            nodetype = Util.null2String(rs.getString("nodetype"));
            if (nodetype.equals("3")) {
                endCid = Util.null2String(rs.getString("id"));
            } else {
                cids += "," + Util.null2String(rs.getString("id"));
            }
        }
        if (!Strings.isNullOrEmpty(cids)) {
            String sql1 = "UPDATE workflow_currentoperator SET isremark = 2, operatedate = ?, operatetime = ?  WHERE requestid = "+requestid+" and " + Util.getSubINClause(cids.substring(1), "id", "in");
            rs1.executeUpdate(sql1, currentdate, currenttime);
        }
        if (!Strings.isNullOrEmpty(endCid)) {
            rs1.executeUpdate("UPDATE workflow_currentoperator SET isremark = 4, operatedate = ?, operatetime = ?  WHERE requestid = "+requestid+" and id =  ?", currentdate, currenttime, endCid);
        }
    }

    /**
     * 获取流程表单字段变更记录配置表信息
     */
    private List<Map<String, String>> getWorkflowFormFieldChangeCfg(int nodeId) {
        RecordSet rs = new RecordSet();
        ArrayList<Map<String, String>> lists = new ArrayList<>();
        String sql = "select nodeid,fieldid,type,maxmun,permaxmun from workflow_fieldchangecfg where nodeid = " + nodeId;
        rs.executeQuery(sql);
        while (rs.next()) {
            HashMap<String, String> map = new HashMap<>();
            map.put("nodeid", rs.getString("nodeid"));
            map.put("fieldid", rs.getString("fieldid"));
            map.put("type", rs.getString("type"));
            map.put("maxmun", rs.getString("maxmun"));
            map.put("permaxmun", rs.getString("permaxmun"));
            lists.add(map);
        }
        return lists;
    }
}