package weaver.workflow.request;
import com.alibaba.fastjson.JSON;
import com.api.doc.detail.util.ImageConvertUtil;
import com.api.odoc.service.OdocPrintMergePDFService;
import com.api.odoc.util.OdocPrintMergePDFUtil;
import com.api.odoc.util.OdocThreadPoolUtil;
import com.api.odoc.util.WorkflowCreateDocUtil;
import com.api.workflow.util.ServiceUtil;
import com.cloudstore.dev.api.util.Util_TableMap;
import com.engine.hrm.biz.HrmClassifiedProtectionBiz;
import com.engine.kq.biz.KQEditFieldInWorkflowBiz;
import com.engine.kq.biz.KQFlowActiontBiz;
import com.engine.odoc.biz.haoqian.HqGenerateSealDocBiz;
import com.engine.odoc.cmd.OdocFileSendDoc.PreFileDoc;
import com.engine.odoc.util.OdocPortalElementUtil;
import com.engine.odoc.util.OdocRequestdocUtil;
import com.engine.workflow.biz.*;
import com.engine.workflow.biz.RobotNode.RobotNodeBiz;
import com.engine.workflow.biz.RobotNode.RobotNodeFlowBiz;
import com.engine.workflow.biz.RobotNode.RobotNodeServiceBiz;
import com.engine.workflow.biz.excelDesign.DoSaveFreeExcelDesignBiz;
import com.engine.workflow.biz.freeNode.FreeNodeBiz;
import com.engine.workflow.biz.freeNode.RequestFreeNodeFlowBiz;
import com.engine.workflow.biz.freeNode.SimpleModeFreeNodeBiz;
import com.engine.workflow.biz.requestFlow.SaveDetailFormDatasBiz;
import com.engine.workflow.biz.requestFlow.SaveFieldAuthClearLogBiz;
import com.engine.workflow.biz.requestFlow.SaveMainFormDatasBiz;
import com.engine.workflow.biz.requestForm.*;
import com.engine.workflow.biz.requestSubmit.RequestOperationBiz;
import com.engine.workflow.biz.workflowCore.RequestBaseBiz;
import com.engine.workflow.biz.workflowCore.RequestLogSaveBiz;
import com.engine.workflow.biz.workflowOvertime.OvertimeBiz;
import com.engine.workflow.constant.ReqFlowFailMsgType;
import com.engine.workflow.constant.SelectNextFlowMode;
import com.engine.workflow.constant.newRule.RuleSource;
import com.engine.workflow.constant.node.NodeType;
import com.engine.workflow.constant.requestForm.RequestExecuteType;
import com.engine.workflow.entity.RequestFlowLogEntity;
import com.engine.workflow.entity.core.MainTableInfoEntity;
import com.engine.workflow.entity.core.RequestFlowInfoEntity;
import com.engine.workflow.entity.core.RequestInfoEntity;
import com.engine.workflow.entity.core.WorkflowBaseInfoEntity;
import com.engine.workflow.entity.freeNode.FreeNodeEntity;
import com.engine.workflow.entity.freeNode.FreeNodeGroupEntity;
import com.engine.workflow.entity.newRule.RuleCompareResult;
import com.engine.workflow.entity.requestForm.ReqFlowFailMsgEntity;
import com.engine.workflow.entity.requestForm.RequestOperationResultBean;
import com.engine.workflow.util.ChuanyueUtil;
import com.engine.workflow.util.CollectionUtil;
import com.engine.workflow.util.WorkflowOvertimeSettingsUtil;
import com.engine.workflowDesign.biz.AutoForecastBiz;
import org.apache.commons.lang3.StringUtils;
import org.codehaus.xfire.aegis.type.java5.IgnoreProperty;
import org.json.JSONException;
import org.json.JSONObject;
import weaver.WorkPlan.CreateWorkplanByWorkflow;
import weaver.common.StringUtil;
import weaver.conn.ConnStatement;
import weaver.conn.RecordSet;
import weaver.conn.RecordSetTrans;
import weaver.conn.constant.DBConstant;
import weaver.crm.Maint.CustomerInfoComInfo;
import weaver.dateformat.DateTransformer;
import weaver.docs.docs.DocExtUtil;
import weaver.docs.docs.util.DocImagefileToPdf;
import weaver.docs.docs.util.DocImagefileToPdfUseWps;
import weaver.docs.share.DocShareUtil;
import weaver.email.EmailWorkRunnable;
import weaver.file.FileUpload;
import weaver.filter.WeaverRequest;
import weaver.fna.general.FnaCommon;
import weaver.fna.maintenance.FnaAdvanceAmountControl;
import weaver.fna.maintenance.FnaBorrowAmountControl;
import weaver.general.*;
import weaver.hrm.User;
import weaver.hrm.resource.ResourceComInfo;
import weaver.interfaces.workflow.action.Action;
import weaver.interfaces.workflow.action.RollBackAction;
import weaver.mobile.webservices.workflow.soa.RequestPreProcessing;
import weaver.odoc.docs.ChangeDocName;
import weaver.odoc.docs.MaintextToPDF;
import weaver.odoc.docs.SecretDocService;
import weaver.odoc.ofd.util.OFDCommonUtil;
import weaver.soa.workflow.request.RequestService;
import weaver.system.ThreadForAllForNew;
import weaver.system.code.CodeBuild;
import weaver.systeminfo.SystemEnv;
import weaver.workflow.exceldesign.ExcelLayoutManager;
import weaver.workflow.form.FormFieldlabelMainManager;
import weaver.workflow.logging.Logger;
import weaver.workflow.logging.LoggerFactory;
import weaver.workflow.mode.FieldInfo;
import weaver.workflow.report.RequestDeleteLog;
import weaver.workflow.request.WFAutoApproveUtils.AutoApproveParams;
import weaver.workflow.request.entity.RequestOperateTypeEnum;
import weaver.workflow.ruleDesign.RuleInterface;
import weaver.workflow.workflow.WFSubDataAggregation;
import weaver.workflow.workflow.WfFunctionManageUtil;
import weaver.workflow.workflow.WorkflowAllComInfo;
import weaver.workflow.workflow.WorkflowRequestComInfo;
import weaver.worktask.request.RequestCreateByWF;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.concurrent.ConcurrentLinkedQueue;
import java.util.concurrent.ExecutorService;
import java.util.regex.Pattern;
import java.util.stream.Collectors;

/*
 * Created on 2006-05-18
 * Copyright (c) 2001-2006 泛微软件
 * 泛微协同商务系统，版权所有。
 *
 */


/**

 * Description: 流程处理基本类
 * @author ben
 * @version 1.0
 */

public class RequestManager extends BaseBean {

    private final static Logger log = LoggerFactory.getLogger(RequestManager.class);
    private RequestIdUpdate requestIdUpdate = new RequestIdUpdate();
    //同步的方法产生ID必须声明成STATIC对象

    private HttpServletRequest request;
    private FileUpload fu;			//modify by xhheng @20050315 for 附件上传,通过 FileUpload 获取原request参数
    private boolean isRequest=true;		//记录是否是HttpServletRequest对象,用以判断是从request还是fu中获取参数值
    private User user;

    private String isRobotNode;

    private String isMultiDoc = "";//多文档新建

    private String src = "";               // 操作类型
    private String iscreate = "";          // 是否为创建节点 是:1 否 0
    private int requestid = 0;            // 请求id
    private int workflowid = 0;           // 工作流id
    private String workflowtype = "";      // 工作流类型
    private int isremark = 0;             // 是否是批注提交 1: 是
    private int formid = 0;               // 表单或者单据的id
    private int isbill = 0;               // 是否单据 0:否 1:是
    private int billid = 0;               // 如果是单据,对应的单据表的id
    private int nodeid = 0;               // 节点id
    private String nodetype = "";          // 节点类型  0:创建 1:审批 2:实现 3:归档
    private String requestname = "";       // 请求名称
    private String requestmark = "";       // 请求的编号
    private String requestlevel = "";      // 请求重要级别 0:正常 1:重要 2:紧急
    private String remark = "";            // 签字批注
    private String clientType = "";        // 客户端类型(空为PC，1为WebClient，2为iPhone，3为iPad，4为Android)
    private String handWrittenSign;           // 手写签章对写附件ID号。
    private int speechAttachment;          // 语音附件上传附件ID号。
    private String remarkLocation;         // 签字意见添加位置信息
    private String signatureAppendfix;    // 签字意见上传附件
    private String signdocids="";           //相关文档
    private String signworkflowids="";      //相关流程
    private String messageType="";			// 短信提醒类型
    private String chatsType="";			// 微信提醒类型 (QC:98106)
    private String needwfback="";			//操作人是否需要流程反馈		TD9144

    private int nextnodeid = 0;           // 下一个节点的id
    private String nextnodetype = "";      // 下一个节点的类型
    private int lastnodeid = 0;           // 前一个节点的id
    private String lastnodetype = "";      // 前一个节点的类型
    private String status = "";            // 出口名称
    private int passedgroups = 0;         // 当前节点已经通过的组
    private int totalgroups = 0;          // 当前节点总的组
    private int creater = 0;              // 请求创建者
    private int creatertype = 0;         // 创建者类型 0:内部 1:外部
    private String createdate = "";        // 请求创建日期
    private String createtime = "";        // 请求创建时间
    private int lastoperator = 0;         // 前一个节点的操作者
    private int lastoperatortype = 0;    // 前一个节点的操作者类型 0:内部 1:外部
    private String lastoperatedate = "";   // 前一个节点的操作日期
    private String lastoperatetime = "";   // 前一个节点的操作时间
    private float nodepasstime = -1;      // 节点超时的时间 (小时)
    private float nodelefttime = -1;      // 节点剩下的时间 (小时)
    private int deleted = 0;              // 是否删除 0: 否 1: 是
    private int userid = 0;
    private int usertype = 0;
    private int userlanguage = 0;
    private int operatorgroup = 0;        // 操作者组 id
    private int typeid=0;          //判断是否为抄送
    private int groupdetailid=0;          //操作组实际id
    private String docids = "";             // 相关文档的id  (用作共享)
    private String crmids = "";             // 相关客户的id  (用作共享)
    private String hrmids = "";             // 相关人力资源的id  (用作共享)
    private String prjids = "";             // 相关项目的id  (用作共享)
    private String cptids = "";             // 相关资产的id  (用作共享)
    private String flowFrom = "";           //判断流程是否为自动为用户创建，如果是，则不用保存明细和基本信息
    private String currentdate = "";       // 当前日期
    private String currenttime = "";       // 当前时间
    private String logdate = "";       // 流转日志日期
    private String logtime = "";       // 流转日志时间
    private String billtablename = "";     // 当为单据的时候, 单据的主表的表名
    private String submitNodeId="";           //干预后流转至的节点及节点类型
    private String Intervenorid="";        //干预流转至的人
    private String IntervenoridType="";    //干预流转至的人类型
    private boolean isoracle = false;
    private Hashtable operatorsht = null;
    private char flag = Util.getSeparator();
    private String Procpara = "";
    private String sql = "";
    private int secLevel=0;
    private boolean isStart = true;	//流程是否已开始流转 by cyril
    private boolean isTrack = true; //功能开关,是否记录修改日志 by cyril
    private boolean isAgent = false; //是否代理的流程
    private int agentId = -1;
    private int sn = 0;//修改的序列
    private boolean executesuccess = true;
    private boolean islogsuccess = false;
    private ResourceComInfo resourceComInfo=null;
    private CustomerInfoComInfo customerInfoComInfo=null;
    private SendMsgAndMail sendMsgAndMail = null;
    private int selectvalue = -1;//文件上传关联的下拉框选择的值
    //	private String selectfieldid = "";//文件上传关联的下拉框字段id
    private int uploadType = 0;//附件上传目录类型
    private String selectedfieldid = "";//选中的字段id
    private String selectvaluesql = "";
    private String hasTriggeredSubwf="";//已触发子流程，防止死循环  add by fanggsh 20060706 for TD4531
    private  final String ifchangstatus= WorkflowOvertimeSettingsUtil.getOverTimeSettingsEntity().getChangestatus() +"";//不从配置文件读，该从数据库读取文件
    private String message="";
    private String isFromEditDocument="false"; //是否点击正文触发  true:是   false或其他：否
    private int isagentCreater=0;
    private int beagenter=0;
    private boolean CanModify=false;
    private int IsPending=-1;
    private int RequestKey=0;
    private int currentopratorInsFirstid=0;
    private String coadsigntype="2";
    private String IsBeForwardPending="";
    private String IsSubmitedOpinion="";
    private String IsBeForwardModify="";
    private String IsBeForwardSubmit="";
    private String coadispending="";
    private String coadismodify="";
    private String isrejectremind="";
    private String rejectremindnodes="";
    private String docrowindex;
    private int temprowindex = 0;
    private String tempsrc = "";
    private Map operator89mp = new HashMap();
    private Map operatortype89mp = new HashMap();
    private Map agentoperator89mp = new HashMap();
    private ArrayList operator89List = new ArrayList();//放当前找到的抄送人
    private ArrayList operatortype89List = new ArrayList();//放当前找到的抄送人的类型，0，人力资源；1，客户
    private ArrayList agentoperator89List = new ArrayList();//如果有代理，放的代理人的ID
    private Map htmlfieldMap = new HashMap();//by alan for 15769
    /**  异常流转相关参数 liuzy QC146873**/
    private boolean isNeedChooseOperator = false;	//是否允许手动选择操作者提交
    private Map<String,Object> eh_operatorMap = new HashMap<String,Object>();
    private ArrayList requestexceptiontypes = new ArrayList();
    private Iterator autoApproveIterator;
    private Queue <AutoApproveParams> autoApproveQueue = new ConcurrentLinkedQueue<>();
    private AutoApproveParams autoApproveParams;

    private boolean isBatchSubmit = false;
    private boolean isLastSubRequest = true;

    public void setBatchSubmit(boolean batchSubmit) {
        isBatchSubmit = batchSubmit;
    }
    private boolean needConformCheck = true;
    public void setNeedConformCheck(boolean NeedConformCheck) {
        this.needConformCheck = NeedConformCheck;
    }
    // added by pony on 2006-05-09 for TD4264 begin
    /**  签字意见字段类型map  **/
    //private static final Map OpinionTypeMap = new HashMap(9);
    private static final Map OpinionTypeMap = new java.util.concurrent.ConcurrentHashMap(9);

    private Map<String, String> locationPreValueMap = new HashMap<>();//记录位置字段保存之前的值，用于流程提交失败后的恢复
    private int takisremark;//用来判断意见征询的状态
    private List<Map<String, Object>> pushMsgDocIds = new ArrayList<>();//节点前后附加操作需要推送消息的文档id，放到流程提交最后推送
    private Map<String, Object> conflictFieldInfo = new HashMap<>();//字段编辑冲突信息
    private Map<String,Object> saveParams = new HashMap<>();    //保存参数

    static {
        OpinionTypeMap.put(OpinionFieldConstant.DOCUMENT_TYPE,
                OpinionFieldConstant.DOC_NAME);
        OpinionTypeMap.put(OpinionFieldConstant.MUTI_DOCUMENT_TYPE,
                OpinionFieldConstant.MUTI_DOC_NAME);
        OpinionTypeMap.put(OpinionFieldConstant.PROJECT_TYPE,
                OpinionFieldConstant.PROJECT_NAME);
        OpinionTypeMap.put(OpinionFieldConstant.MUTI_PROJECT_TYPE,
                OpinionFieldConstant.MUTI_PROJECT_NAME);
        OpinionTypeMap.put(OpinionFieldConstant.CUSTOMER_TYPE,
                OpinionFieldConstant.CUSTOMER_NAME);
        OpinionTypeMap.put(OpinionFieldConstant.MUTI_CUSTOMER_TYPE,
                OpinionFieldConstant.MUTI_CUSTOMER_NAME);
        OpinionTypeMap.put(OpinionFieldConstant.RESOURCES_TYPE,
                OpinionFieldConstant.RESOURCES_NAME);
        OpinionTypeMap.put(OpinionFieldConstant.WORKFLOW_TYPE,
                OpinionFieldConstant.WORKFLOW_NAME);
        OpinionTypeMap.put(OpinionFieldConstant.ACCESSORIES_TYPE,
                OpinionFieldConstant.ACCESSORIES_NAME);
    }
    //added end.
    private ArrayList nextnodeids;
    private ArrayList nextlinkids;
    private ArrayList nextlinknames;
    private ArrayList nextnodetypes;
    private ArrayList operatorshts;
    private ArrayList nextnodeattrs;
    private ArrayList nextnodepassnums;
    private ArrayList linkismustpasss;
    private int nextnodeattr=0;
    private WFLinkInfo wflinkinfo;
    private boolean canflowtonextnode=false;
    private String innodeids="";
    private int SignType=0;
    private int enableIntervenor=1;//是否启用节点及出口附加操作
    private RecordSetTrans rstrans = null;//是用来将流程用的事物(rst)传到外部接口中供action调用
    boolean coadcansubmit=true;
    boolean showcoadjutant=false;
    boolean isWorkFlowToDoc=false;  //节点后附加操作是否为流程存为文档
    private int RejectToNodeid=0;//退回到指定节点  td30785
    private int RejectToType = 0 ;//退回到指定节点的类型，主要针对分叉，1：重新分叉，2：取消合并
    private String isSubmitDirect = "";//退回后再提交是否直达当前节点
    private int SubmitToNodeid=0; // 提交至退回节点
    private String messageid = "";//提醒信息id
    private String messagecontent = "";//提醒信息内容
    private String isFirstSubmit = "";
    private boolean isFlowNextNoid = false; //流程提交是否流转到下一节点，依次逐个处理、会签时该值为false

    private List requestCheckAddinRulesList=null;//节点后附加操作或出口附加规则记录表
    private Map requestCheckAddinRulesMap=null;//节点后附加操作或出口附加规则记录

    private String isAutoApprove ="0";//允许自动批准
    private String isAutoCommit = "0";//允许处理节点自动提交
    private String isAutoRemark = "1";//自动填写用户最后一次手动操作的意见
    private int istest = 0;
    private int istestwf = 0;//是否是测试的流程
    private boolean hasEflowToAssignNode = false;
    private Map<Integer,AutoApproveParams> nodeInfoCache = new HashMap<Integer,AutoApproveParams>(); //可以自动提交节点的信息 key nodeid
    private int nodeattribute; //当前节点节点属性

    private String docView;//保存操作是否来自 点击正文（如果点击正文保存表单，不需要解锁）

    private boolean isFromWebservice = false;//是否从webservice调用进来
    private boolean doAutoApprove = false;

    private boolean isSelectNextFlow = false;//是否用户指定下一节点流转提交
    private SelectNextFlowMode selectNextFlowMode;//指定流转模式
    private String selectNodeFlowNodeIds = "";//指定下一节点
    private boolean selectNodeFlowNodeCanFlowNextNode = true;  //开启指定流转,并且此节点是会前状态，是否可以流转到下个节点
//    private String selectNodeFlowOperator = "";//指定操作者
//    private String selectNodeFlowCCOperator = "";//指定抄送者
//    private String selectNodeCanSubmit = "";//指定抄送者是否可提交签字意见

    //提交一票通过，流程立即向下流转，不再等待其他会签人的意见。
    private boolean isOneVoteApprove = false;
    //流程流转信息
    private RequestFlowInfoEntity requestFlowInfoEntity;
    private RequestFreeNodeFlowBiz freeNodeFlowBiz;
    private boolean conformCheckExecuted = false;//节点校验是否已执行过
    private boolean conformCheckResult = true;//节点字段校验结果

    public void setConformCheckExecuted(boolean conformCheckExecuted) {
        this.conformCheckExecuted = conformCheckExecuted;
    }

    public boolean isConformCheckExecuted() {
        return conformCheckExecuted;
    }

    public void setConformCheckResult(boolean conformCheckResult) {
        this.conformCheckResult = conformCheckResult;
    }

    public boolean getConformCheckResult() {
        return conformCheckResult;
    }

    public boolean isSelectNodeFlowNodeCanFlowNextNode() {
        return selectNodeFlowNodeCanFlowNextNode;
    }

    public void setSelectNodeFlowNodeCanFlowNextNode(boolean selectNodeFlowNodeCanFlowNextNode) {
        this.selectNodeFlowNodeCanFlowNextNode = selectNodeFlowNodeCanFlowNextNode;
    }

    //Action回滚数据
    private ActionRollBackBiz actionRollBackBiz = new ActionRollBackBiz();

    @IgnoreProperty
    public List getRequestCheckAddinRulesList() {
        return requestCheckAddinRulesList;
    }

    public boolean isWorkFlowToDoc() {
        return isWorkFlowToDoc;
    }

    public void setWorkFlowToDoc(boolean workFlowToDoc) {
        isWorkFlowToDoc = workFlowToDoc;
    }

    private static boolean isExeOldFlowlogic = false;

    static {
        init();
    }
    public static final String ERROR_NOTFOUND_G = ""+weaver.systeminfo.SystemEnv.getHtmlLabelName(10004308,weaver.general.ThreadVarLanguage.getLang())+"workflow_base"+weaver.systeminfo.SystemEnv.getHtmlLabelName(10004309,weaver.general.ThreadVarLanguage.getLang())+"";
    public static final String ERROR_NOTFOUND_NNL = ""+weaver.systeminfo.SystemEnv.getHtmlLabelName(10004310,weaver.general.ThreadVarLanguage.getLang())+"";
    public static final String ERROR_NOTFOUND_SUBMITERROR = ""+weaver.systeminfo.SystemEnv.getHtmlLabelName(10004311,weaver.general.ThreadVarLanguage.getLang())+"submitNodeId"+weaver.systeminfo.SystemEnv.getHtmlLabelName(10004312,weaver.general.ThreadVarLanguage.getLang())+"";
    public static final String ERROR_NOTFOUND_NNNO = ""+weaver.systeminfo.SystemEnv.getHtmlLabelName(10004313,weaver.general.ThreadVarLanguage.getLang())+"";

    private String oldformsignaturemd5 = "";

    private boolean isMakeOperateLog = true;

    private Map<String, Integer> newAddDetailRowPerInfo = new HashMap<String, Integer>();

    private boolean hasCoadjutant = false;
    private boolean comeE9 = false;  //true 请求来自E9
    private String isremark4CY = "";//批量提交时用来标志过来的身份是转发还是传阅，因为传阅批量提交的时候set进来的isremark暂时也是1
    private int currid4CY = 0;//传阅流程批量提交时用来算接收人
	private ReqFlowFailMsgEntity reqFailMsg;
	private RequestFlowLogEntity requestFlowLogEntity = new RequestFlowLogEntity();  //流程流转日志对象

    private Map<String,Object> otherParams;//rest接口参数
     /**
     * 构造函数，初始化日期，得到人力资源，客户缓存
     */
    public RequestManager() {
        Calendar today = Calendar.getInstance();
        currentdate = Util.add0(today.get(Calendar.YEAR), 4) + "-" +
                Util.add0(today.get(Calendar.MONTH) + 1, 2) + "-" +
                Util.add0(today.get(Calendar.DAY_OF_MONTH), 2);


        currenttime = Util.add0(today.get(Calendar.HOUR_OF_DAY), 2) + ":" +
                Util.add0(today.get(Calendar.MINUTE), 2) + ":" +
                Util.add0(today.get(Calendar.SECOND), 2);
        //logdate=currentdate;
        //logtime=currenttime;
        RecordSet rs = new RecordSet();


        //取数据库服务器的当前时间
        rs.executeProc("GetDBDateAndTime","");
        if(rs.next()){
            currentdate = rs.getString("dbdate");
            currenttime = rs.getString("dbtime");
        }
        logdate=currentdate;
        logtime=currenttime;
        //取数据库服务器的当前时间

        this.nextlinkids=new ArrayList();
        this.nextlinknames=new ArrayList();
        this.nextnodeids=new ArrayList();
        this.nextnodetypes=new ArrayList();
        this.operatorshts=new ArrayList();
        this.nextnodeattrs=new ArrayList();
        this.nextnodepassnums=new ArrayList();
        this.linkismustpasss=new ArrayList();
        isoracle = rs.getDBType().equals("oracle") && Util.null2String(rs.getOrgindbtype()).equals("oracle");
        nextnodeattr=0;
        SignType=0;
        isagentCreater=0;
        beagenter=0;
        CanModify=false;
        IsPending=-1;
        RequestKey=0;
        coadsigntype="2";
        showcoadjutant=false;
        this.operator89List = new ArrayList();
        this.agentoperator89List = new ArrayList();
        this.operatortype89List = new ArrayList();
        try {
            sendMsgAndMail = new SendMsgAndMail();
            resourceComInfo = new ResourceComInfo();
            customerInfoComInfo = new CustomerInfoComInfo();
            wflinkinfo=new WFLinkInfo();
        } catch (Exception ex) {
        }
        requestCheckAddinRulesList=new ArrayList();
        this.requestFlowInfoEntity = new RequestFlowInfoEntity(currentdate,currenttime);
        if(reqFailMsg == null) reqFailMsg = new ReqFlowFailMsgEntity();
    }

    public void setLastSubRequest(boolean lastSubRequest) {
        this.isLastSubRequest = lastSubRequest;
    }

    public ReqFlowFailMsgEntity getReqFailMsg() {
        return reqFailMsg;
    }

    public void setReqFailMsg(ReqFlowFailMsgEntity reqFailMsg) {
        this.reqFailMsg = reqFailMsg;
    }

    public int getTakisremark() {
        return takisremark;
    }

    public void setTakisremark(int takisremark) {
        this.takisremark = takisremark;
    }

    public String getDocView() {
        return docView;
    }

    public boolean isFlowNextNoid() {
        return isFlowNextNoid;
    }

    public void setDocView(String docView) {
        this.docView = docView;
    }


    public Iterator getAutoApproveIterator() {
        return autoApproveIterator;
    }

    public void setAutoApproveIterator(Iterator autoApproveIterator) {
        this.autoApproveIterator = autoApproveIterator;
    }

    public Queue<AutoApproveParams> getAutoApproveQueue() {
        return autoApproveQueue;
    }

    public void setAutoApproveQueue(Queue<AutoApproveParams> autoApproveQueue) {
        this.autoApproveQueue = autoApproveQueue;
    }

    public Map<String, Object> getConflictFieldInfo() {
        return conflictFieldInfo;
    }

    public void setConflictFieldInfo(Map<String, Object> conflictFieldInfo) {
        this.conflictFieldInfo = conflictFieldInfo;
    }

    public ActionRollBackBiz getActionRollBackBiz() {
        return actionRollBackBiz;
    }

    public void setActionRollBackBiz(ActionRollBackBiz actionRollBackBiz) {
        this.actionRollBackBiz = actionRollBackBiz;
    }

    /**
     * 获得提醒信息的id
     * @return
     */
    public String getMessageid() {
        return messageid;
    }

    /**
     * 设置提醒信息的id
     * @param messageid
     */
    public void setMessageid(String messageid) {
        this.messageid = messageid;
    }

    /**
     * 获得提醒信息的内容
     * @return
     */
    public String getMessagecontent() {
        return messagecontent;
    }


    /**
     * 设置提醒信息的内容
     * @param messagecontent
     */
    public void setMessagecontent(String messagecontent) {
        if(!isRequest){
            request=fu.getRequest();
        }
        if(request != null && !(request instanceof WeaverRequest)){
            HttpSession session = request.getSession(false);
            if(session != null) {
                session.setAttribute("errormsg_" + user.getUID() + "_" + requestid, messagecontent);
            }
    }
        this.messagecontent = messagecontent;
    }

    public boolean isFromWebservice() {
        return isFromWebservice;
    }

    public void setFromWebservice(boolean fromWebservice) {
        isFromWebservice = fromWebservice;
    }

    /**
     * 获得协办人会签关系
     * @return
     */
    public String getCoadsigntype() {
        return coadsigntype;
    }

    /**
     * 设置协办人会签关系
     * @param coadsigntype
     */
    public void setCoadsigntype(String coadsigntype) {
        this.coadsigntype = coadsigntype;
    }

    /**
     * 获得请求主键
     * @return
     */
    public int getRequestKey() {
        return RequestKey;
    }

    /**
     * 设置请求主键
     * @param requestKey
     */
    public void setRequestKey(int requestKey) {
        RequestKey = requestKey;
    }

    /**
     * 获得转发人(协办人)提交后被转发人未查看仍停留在待办
     * @return
     */
    public int getIsPending() {
        return IsPending;
    }

    /**
     * 设置转发人（协办人）提交后被转发人未查看仍停留在待办
     * @param isPending
     */
    public void setIsPending(int isPending) {
        IsPending = isPending;
    }

    /**
     * 获得是否能修改表单
     * @return
     */
    public boolean getCanModify() {
        return CanModify;
    }

    /**
     * 设置是否可修改表单
     * @param isModify
     */
    public void setCanModify(boolean isModify) {
        CanModify = isModify;
    }

    /**
     * 获得图形化主表计算公式关联的字段
     * @return
     */
    private ArrayList getCalfields() {
        ArrayList calfieldlist=new ArrayList();
        if(isRequest){
            if(request!=null) calfieldlist=Util.TokenizerString(Util.null2String(request.getParameter("calfields")),",");
        }else{
            if(fu!=null) calfieldlist=Util.TokenizerString(Util.null2String(fu.getParameter("calfields")),",");
        }
        return calfieldlist;
    }

    /**
     * 获得图形化明细表计算公式关联的字段
     * @return
     */
    private ArrayList getCaldetfields() {
        ArrayList caldetfieldlist=new ArrayList();
        if(isRequest){
            if(request!=null) caldetfieldlist=Util.TokenizerString(Util.null2String(request.getParameter("caldetfields")),",");
        }else{
            if(fu!=null) caldetfieldlist=Util.TokenizerString(Util.null2String(fu.getParameter("caldetfields")),",");
        }
        return caldetfieldlist;
    }

    /**
     * 获得流程中使用的事物
     * return RecordSetTrans rst
     */
    public RecordSetTrans getRsTrans() {
        return rstrans;
    }
    public void SetRsTrans(RecordSetTrans rst){
        this.rstrans = rst;
    }
    /**
     * 获得是否为代理人创建的流程
     * @return  1：代理人创建 0：本人创建
     */
    public int getIsagentCreater() {
        return isagentCreater;
    }

    /**
     * 设置是否为代理人创建的流程
     * @param isagentCreater 1：代理人创建 0：本人创建
     */
    public void setIsagentCreater(int isagentCreater) {
        this.isagentCreater = isagentCreater;
    }

    //退回后再提交是否直达当前节点
    public void setIsSubmitDirect(String isSubmitDirect) {
        this.isSubmitDirect = isSubmitDirect;
    }

    /**
     * 获得被代理人
     * @return
     */
    public int getBeAgenter() {
        return beagenter;
    }

    /**
     * 设置被代理人
     * @param beagenterid
     */
    public void setBeAgenter(int beagenterid) {
        this.beagenter = beagenterid;
    }

    /**
     * 设置流程干预会签关系
     * @param signType
     */
    public void setSignType(int signType) {
        SignType = signType;
    }

    /**
     * 获得返回错误消息号
     * @return
     */
    public String getMessage() {
        return message;
    }

    /**
     * 设置返回错误消息号
     * @param message
     */
    public void setMessage(String message) {
        if(!isRequest){
            request=fu.getRequest();
        }
        if(request != null && !(request instanceof WeaverRequest)){
            HttpSession session = request.getSession(false);
            if(session != null) {
                session.setAttribute("errormsgid_" + user.getUID() + "_" + requestid, message);
            }
        }
        this.message = message;
    }

    /**
     * 得到已触发子流程
     * @return 已触发子流程
     */
    public String getHasTriggeredSubwf() {
        return hasTriggeredSubwf;
    }
    /**
     * 设置已触发子流程
     * @param hasTriggeredSubwf 已触发子流程
     */
    public void setHasTriggeredSubwf(String hasTriggeredSubwf) {
        this.hasTriggeredSubwf = hasTriggeredSubwf;
    }

    /**
     * 得到 是否来自于维护正文
     * @return 是否来自于维护正文
     */
    public String getIsFromEditDocument() {
        return isFromEditDocument;
    }
    /**
     * 设置 是否来自于维护正文
     * @param isFromEditDocument 是否来自于维护正文
     */
    public void setIsFromEditDocument(String isFromEditDocument) {
        this.isFromEditDocument = isFromEditDocument;
    }

    /**
     * 得到用户id
     * @return 用户id
     */
    public int getUserId() {
        return userid;
    }

    /**
     * 得到用户登录类型   0：内部用户，1：外部用户
     * @return 用户登录类型
     *
     */
    public int getUserType() {
        return usertype;
    }
    /**
     * 得到用户对象
     * @return 用户对象
     */
    public User getUser() {
        return user;
    }

    /**
     * 得到单据表名
     * @return 单据表名
     */
    public String getBillTableName() {
        return billtablename;
    }

    /**
     * 得到请求当前日期
     * @return 当前日期
     */
    public String getCurrentDate() {
        return this.currentdate;
    }
    /**
     * 得到请求当前时间
     * @return 当前时间
     */
    public String getCurrentTime() {
        return this.currenttime;
    }

    /**
     * 设置是否是HttpServletRequest对象
     * @param isRequest 是否是HttpServletRequest对象
     */
    public void setIsRequest(boolean isRequest) {
        this.isRequest = isRequest;
    }

    /**
     * 得到递交的节点ID
     * @return 节点ID
     */
    public String getSubmitNodeId() {
        return submitNodeId;
    }
    /**
     * 设置递交的节点ID
     * @param submitNodeId 递交的节点ID
     */
    public void setSubmitNodeId(String submitNodeId) {
        this.submitNodeId = submitNodeId;
    }
    /**
     * 得到流程干预人
     * @return 流程干预人
     */
    public String getIntervenorid() {
        return Intervenorid;
    }
    /**
     * 设置流程干预人
     * @param intervenorid 流程干预人
     */
    public void setIntervenorid(String intervenorid) {
        Intervenorid = intervenorid;
    }
    /**
     * 得到流程干预人类型
     * @return 流程干预人类型
     */
    public String getIntervenoridType() {
        return IntervenoridType;
    }
    /**
     * 设置流程干预人类型
     * @param intervenoridType 流程干预人类型
     */
    public void setIntervenoridType(String intervenoridType) {
        IntervenoridType = intervenoridType;
    }
    /**
     * 设置操作类型（递交，保存，退回等）
     * @param src 操作类型
     */
    public void setSrc(String src) {
        this.src = src;
    }
    /**
     * 设置多文档新建字段
     * @param isMultiDoc
     */
    public void setIsMultiDoc(String isMultiDoc) {
        if(!isMultiDoc.equals(""))
            this.isMultiDoc = isMultiDoc;
    }
    /**
     * 设置流程从何而来（是新建流程还是其他模块触发的流程）
     * @param flowFrom 流程从何而来
     */
    public void setFlowFrom(String flowFrom) {
        this.flowFrom = flowFrom;
    }
    /**
     * 设置是否为创建节点
     * @param iscreate 否为创建节点
     */
    public void setIscreate(String iscreate) {
        this.iscreate = iscreate;
    }

    /**
     * 设置请求ID
     * @param requestid 请求ID
     */
    public void setRequestid(int requestid) {
        this.requestid = requestid;
    }
    /**
     * 设置工作流ID
     * @param workflowid 工作流ID
     */
    public void setWorkflowid(int workflowid) {
        this.workflowid = workflowid;
    }
    /**
     * 设置流程类型
     * @param workflowtype 流程类型
     */
    public void setWorkflowtype(String workflowtype) {
        this.workflowtype = workflowtype;
    }
    /**
     * 设置是否是批注提交 1: 是
     * @param isremark 是否是批注提交 1: 是
     */
    public void setIsremark(int isremark) {
        this.isremark = isremark;
    }
    /**
     * 设置表单ID
     * @param formid 表单ID
     */
    public void setFormid(int formid) {
        this.formid = formid;
    }
    /**
     * 设置是否为单据
     * @param isbill 是否为单据（0/1）
     */
    public void setIsbill(int isbill) {
        this.isbill = isbill;
    }
    /**
     * 设置单据ID
     * @param billid 单据ID
     */
    public void setBillid(int billid) {
        this.billid = billid;
    }
    /**
     * 设置节点ID
     * @param nodeid 节点ID
     */
    public void setNodeid(int nodeid) {
        this.nodeid = nodeid;
    }
    /**
     * 设置节点类型
     * @param nodetype 节点类型
     */
    public void setNodetype(String nodetype) {
        this.nodetype = nodetype;
    }
    /**
     * 设置请求标题
     * @param requestname 请求标题
     */
    public void setRequestname(String requestname) {
        this.requestname = Util.StringReplace(Util.htmlFilter4UTF8(requestname),",","，");
    }
    /**
     * 设置请求紧急程度
     * @param requestlevel 紧急程度
     */
    public void setRequestlevel(String requestlevel) {
        this.requestlevel = requestlevel;
    }
    /**
     * 设置节点的当前状态
     * @param remark 当前状态
     */
    public void setRemark(String remark) {
        this.remark = remark;
    }

    /**
     * 获得签字意见相关流程id
     * @return
     */
    public String getSignworkflowids() {
        return signworkflowids;
    }

    /**
     * 设置签字意见相关流程id
     * @param signworkflowids
     */
    public void setSignworkflowids(String signworkflowids) {
        this.signworkflowids = signworkflowids;
    }

    /**
     * 获得签字意见相关文档id
     * @return
     */
    public String getSigndocids() {
        return signdocids;
    }

    /**
     * 设置签字意见相关文档id
     * @param signdocids
     */
    public void setSigndocids(String signdocids) {
        this.signdocids = signdocids;
    }

    /**
     * 设置下一个节点
     * @param nextnodeid 下一个节点
     */
    public void setNextNodeid(int nextnodeid) {
        this.nextnodeid = nextnodeid;
    }
    /**
     * 设置下一个节点类型
     * @param nextnodetype 下一个节点类型
     */
    public void setNextNodetype(String nextnodetype) {
        this.nextnodetype = nextnodetype;
    }
    /**
     * 设置最后一个一个节点
     * @param lastnodeid 最后一个节点ID
     */
    public void setLastNodeid(int lastnodeid) {
        this.lastnodeid = lastnodeid;
    }
    /**
     * 设置最后一个一个节点类型
     * @param lastnodetype 后一个一个节点类型
     */
    public void setLastnodetype(String lastnodetype) {
        this.lastnodetype = lastnodetype;
    }
    /**
     * 设置请求当前状态
     * @param status 当前状态
     */
    public void setStatus(String status) {
        this.status = status;
    }
    /**
     * 设置请求当前节点已经提交的操作组数目
     * @param passedgroups 提交的操作组数目
     */
    public void setPassedGroups(int passedgroups) {
        this.passedgroups = passedgroups;
    }
    /**
     * 设置请求当前节点总共需要提交的操作组数目
     * @param totalgroups 总共需要提交的操作组数目
     */
    public void setTotalGroups(int totalgroups) {
        this.totalgroups = totalgroups;
    }
    /**
     * 设置请求创建人
     * @param creater 请求创建人
     */
    public void setCreater(int creater) {
        this.creater = creater;
    }
    /**
     * 设置请求创建人类型
     * @param creatertype 请求创建人类型
     */
    public void setCreatertype(int creatertype) {
        this.creatertype = creatertype;
    }
    /**
     * 设置请求创建日期
     * @param createdate 创建日期
     */
    public void setCreatedate(String createdate) {
        this.createdate = createdate;
    }
    /**
     * 设置请求创建时间
     * @param createtime 创建时间
     */
    public void setCreatetime(String createtime) {
        this.createtime = createtime;
    }
    /**
     * 设置最后一次操作者
     * @param lastoperator 最后一次操作者
     */
    public void setLastoperator(int lastoperator) {
        this.lastoperator = lastoperator;
    }
    /**
     * 设置当前最后一次操作者类型
     * @param lastoperatortype 操作者类型
     */
    public void setLastoperatortype(int lastoperatortype) {
        this.lastoperatortype = lastoperatortype;
    }
    /**
     * 设置当前最后一次操作请求的日期
     * @param lastoperatedate 最后一次操作请求的日期
     */
    public void setLastoperatedate(String lastoperatedate) {
        this.lastoperatedate = lastoperatedate;
    }
    /**
     * 设置当前最后一次操作请求的时间
     * @param lastoperatetime 最后一次操作请求的时间
     */
    public void setLastoperatetime(String lastoperatetime) {
        this.lastoperatetime = lastoperatetime;
    }
    /**
     * 设置节点超时时间
     * @param nodepasstime 节点超时时间
     */
    public void setNodepasstime(float nodepasstime) {
        this.nodepasstime = nodepasstime;
    }
    /**
     * 设置操作人是否需要流程反馈
     * @param needwfback 0：不需要；1：需要
     */
    public void setNeedwfback(String needwfback){
        this.needwfback = needwfback;
    }
    /**
     * 设置节点还有多少时间超时
     * @param nodelefttime 还有多少时间超时
     */
    public void setNodelefttime(float nodelefttime) {
        this.nodelefttime = nodelefttime;
    }
    /**
     * 设置从页面获取的请求
     * @param request 从页面获取的请求
     */
    public void setRequest(HttpServletRequest request) {
        this.request=request;
        this.isRequest=true;
    }

    public HttpServletRequest getRequest() {
        return request;
    }

    /**
     * 设置从页面获取的请求（含附件上传）
     * @param request 从页面获取的请求
     */
    public void setRequest(FileUpload request) {
        this.fu=request;
        this.isRequest=false;
    }
    /**
     * 设置请求当前操作用户
     * @param user 当前操作用户  @see User
     */
    public void setUser(User user) {
        this.user = user;
        this.userid = user.getUID();
        //下面这条语句造成流程模块的usertype与文档模块的usertype不一致！影响了功能开发，应该在单独的TD中去掉。
        this.usertype = (user.getLogintype()).equals("1") ? 0 : 1;
        this.usertype = (user.getLogintype()).equals("3") ? 2 : this.usertype;
        this.userlanguage = user.getLanguage();
    }
    /**
     * 设置应用到的单据表名 （如果流程用的是单据）
     * @param billtablename 单据表名
     */
    public void setBilltablename(String billtablename) {
        this.billtablename = billtablename;
    }
    /**
     * 设置请求相关文挡
     * @param Docids 相关文挡
     */
    public void setDocids(String Docids) {
        this.docids = Docids;
    }
    /**
     * 设置请求相关客户
     * @param Crmids 相关客户
     */
    public void setCrmids(String Crmids) {
        this.crmids = Crmids;
    }
    /**
     * 设置请求相关项目
     * @param Prjids 相关项目
     */
    public void setPrjids(String Prjids) {
        this.prjids = Prjids;
    }

    public String getHrmids() {
        return hrmids;
    }

    /**
     * 设置请求相关人力资源
     * @param hrmids 相关人力资源
     */
    public void setHrmids(String hrmids) {
        this.hrmids = hrmids;
    }
    /**
     * 设置请求相关资产
     * @param cptids 相关资产
     */
    public void setCptids(String cptids) {
        this.cptids = cptids;
    }
    /**
     * 得到页面请求类型（提交，保存，退回等等）
     * @return 页面请求类型（提交，保存，退回等等）
     */
    public String getSrc() {
        return this.src;
    }
    /**
     * 得到请求的当前节点是否创建节点
     * @return 请求的当前节点是否创建节点
     */
    public String getIscreate() {
        return this.iscreate;
    }

    /**
     * 得到请求ID
     * @return 请求ID
     */
    public int getRequestid() {
        return this.requestid;
    }
    /**
     * 得到流程ID
     * @return 流程ID
     */
    public int getWorkflowid() {
        return this.workflowid;
    }
    /**
     * 得到流程类型ID
     * @return 流程类型ID
     */
    public String getWorkflowtype() {
        return this.workflowtype;
    }
    /**
     * 得到请求批注
     * @return 请求批注
     */
    public int getIsremark() {
        return this.isremark;
    }
    /**
     * 得到流程关联的表单ID
     * @return 表单ID
     */
    public int getFormid() {
        return this.formid;
    }
    /**
     * 得到流程关联的是是否是单据
     * @return 是否是单据（0/1）
     */
    public int getIsbill() {
        return this.isbill;
    }
    /**
     * 得到流程关联的单据ID（如果流程关联的是单据）
     * @return 单据ID
     */
    public int getBillid() {
        return this.billid;
    }
    /**
     * 得到请求当前的节点ID
     * @return 节点ID
     */
    public int getNodeid() {
        return this.nodeid;
    }
    /**
     * 得到请求当前节点类型
     * @return 当前节点类型
     */
    public String getNodetype() {
        return this.nodetype;
    }
    /**
     * 得到请求标题
     * @return 请求标题
     */
    public String getRequestname() {
        return this.requestname;
    }
    /**
     * 得到请求的紧急程度
     * @return 紧急程度
     */
    public String getRequestlevel() {
        return this.requestlevel;
    }
    /**
     * 得到请求的当前节点的状态（已提交，已归档等）
     * @return 节点的状态（已提交，已归档等）
     */
    public String getRemark() {
        return this.remark;
    }
    /**
     * 得到请求的下一个节点
     * @return 下一个节点
     */
    public int getNextNodeid() {
        return this.nextnodeid;
    }
    /**
     * 得到请求的下一个节点类型
     * @return 下一个节点类型
     */
    public String getNextNodetype() {
        return this.nextnodetype;
    }
    /**
     * 得到请求的当前最后一次操作的节点ID
     * @return 节点ID
     */
    public int getLastNodeid() {
        return this.lastnodeid;
    }
    /**
     * 得到请求的当前最后一次操作的节点类型
     * @return 节点类型
     */
    public String getLastnodetype() {
        return this.lastnodetype;
    }
    /**
     * 得到请求当前状态
     * @return 当前状态
     */
    public String getStatus() {
        return this.status;
    }
    /**
     * 得到请求当前节点已提交的操作组数量
     * @return 操作组数量
     */
    public int getPassedGroups() {
        return this.passedgroups;
    }
    /**
     * 得到请求当前节点总共需要提交的操作组数量
     * @return 操作组数量
     */
    public int getTotalGroups() {
        return this.totalgroups;
    }
    /**
     * 得到请求的创建者
     * @return 创建者
     */
    public int getCreater() {
        return this.creater;
    }
    /**
     * 得到请求的创建者类型
     * @return 创建者类型
     */
    public int getCreatertype() {
        return this.creatertype;
    }
    /**
     * 得到请求的创建日期
     * @return 创建日期
     */
    public String getCreatedate() {
        return this.createdate;
    }
    /**
     * 得到请求的创建时间
     * @return 创建时间
     */
    public String getCreatetime() {
        return this.createtime;
    }
    /**
     * 得到请求当前最后一次操作的操作者
     * @return 操作者
     */
    public int getLastoperator() {
        return this.lastoperator;
    }
    /**
     * 得到请求当前最后一次操作的操作者类型
     * @return 操作者类型
     */
    public int getLastoperatortype() {
        return this.lastoperatortype;
    }
    /**
     * 得到请求当前最后一次操作日期
     * @return 操作日期
     */
    public String getLastoperatedate() {
        return this.lastoperatedate;
    }
    /**
     * 得到请求当前最后一次操作时间
     * @return 操作时间
     */
    public String getLastoperatetime() {
        return this.lastoperatetime;
    }
    /**
     * 得到请求当前节点的超时时间
     * @return 超时时间
     */
    public float getNodepasstime() {
        return this.nodepasstime;
    }
    /**
     * 得到操作人是否需要流程反馈
     */
    public String getNeedwfback(){
        return this.needwfback;
    }
    /**
     * 得到请求当前节点的通过还剩下的时间（不超时）
     * @return 剩下的时间
     */
    public float getNodelefttime() {
        return this.nodelefttime;
    }
    /**
     * 得到下一节点的操作者
     * @return 下一节点的操作者
     */
    public Hashtable getCurrentOperator() {
        return operatorsht;
    }

    /**
     * 设置下一节点的操作者
     */
    public void setCurrentOperator(Hashtable operatorsht) {
        this.operatorsht = operatorsht;
    }

    /**
     * 得到是否需要前台选择操作者提交
     */
    public boolean isNeedChooseOperator() {
        return isNeedChooseOperator;
    }

    /**
     * added by cyrll on 2008-06-25
     * 处理SQL语句的NULL问题
     * @param s
     * @return
     */
    public String disposeSqlNull(String s) {
        if(s==null)
            s = "NULL";
        else
            s = "'"+s+"'";
        return s;
    }

    /**
     * 允许自动批准
     * @return
     */
    public String getIsAutoApprove() {
        return isAutoApprove;
    }

    public void setIsAutoApprove(String isAutoApprove) {
        this.isAutoApprove = isAutoApprove;
    }

    /**
     * 允许处理节点自动提交
     * @return
     */
    public String getIsAutoCommit() {
        return isAutoCommit;
    }

    public void setAgent(boolean agent) {
        isAgent = agent;
    }

    public void setAgentId(int agentId) {
        this.agentId = agentId;
    }

    public int getAgentId() {
        return agentId;
    }

    public void setIsAutoCommit(String isAutoCommit) {
        this.isAutoCommit = isAutoCommit;
    }

    /**
     * 自动填写用户最后一次手动操作的意见
     * @return
     */
    public String getIsAutoRemark() {
        return isAutoRemark;
    }
    public void setIsAutoRemark(String isAutoRemark) {
        this.isAutoRemark = isAutoRemark;
    }

    public int getIstest() {
        return istest;
    }

    public boolean isHasEflowToAssignNode() {
        return hasEflowToAssignNode;
    }

    public String getLogdate() {
        return logdate;
    }

    public String getLogtime() {
        return logtime;
    }

    public int getNodeattribute() {
        return nodeattribute;
    }

    public void setNodeattribute(int nodeattribute) {
        this.nodeattribute = nodeattribute;
    }

    public boolean isComeE9() {
        return comeE9;
    }

    public void setComeE9(boolean comeE9) {
        this.comeE9 = comeE9;
    }

    public boolean isDoAutoApprove() {
        return doAutoApprove;
    }

    public void setDoAutoApprove(boolean doAutoApprove) {
        this.doAutoApprove = doAutoApprove;
    }

    public boolean isSelectNextFlow() {
        return isSelectNextFlow;
    }

    public void setSelectNextFlow(boolean selectNextFlow) {
        isSelectNextFlow = selectNextFlow;
    }

    public SelectNextFlowMode getSelectNextFlowMode() {
        return selectNextFlowMode;
    }

    public void setSelectNextFlowMode(SelectNextFlowMode selectNextFlowMode) {
        this.selectNextFlowMode = selectNextFlowMode;
    }

    public String getSelectNodeFlowNodeIds() {
        return selectNodeFlowNodeIds;
    }

    public void setSelectNodeFlowNodeIds(String selectNodeFlowNodeIds) {
        this.selectNodeFlowNodeIds = selectNodeFlowNodeIds;
    }

//    public String getSelectNodeFlowOperator() {
//        return selectNodeFlowOperator;
//    }
//
//    public void setSelectNodeFlowOperator(String selectNodeFlowOperator) {
//        this.selectNodeFlowOperator = selectNodeFlowOperator;
//    }
//
//    public String getSelectNodeFlowCCOperator() {
//        return selectNodeFlowCCOperator;
//    }
//
//    public void setSelectNodeFlowCCOperator(String selectNodeFlowCCOperator) {
//        this.selectNodeFlowCCOperator = selectNodeFlowCCOperator;
//    }
//
//    public String getSelectNodeCanSubmit() {
//        return selectNodeCanSubmit;
//    }
//
//    public void setSelectNodeCanSubmit(String selectNodeCanSubmit) {
//        this.selectNodeCanSubmit = selectNodeCanSubmit;
//    }

    public String getIsremark4CY() {
        return isremark4CY;
    }

    public void setIsremark4CY(String isremark4CY) {
        this.isremark4CY = isremark4CY;
    }

    public void setAutoApproveParams(AutoApproveParams autoApproveParams) {
        this.autoApproveParams = autoApproveParams;
    }

	public void addRollBackAction(RollBackAction action) {
        this.actionRollBackBiz.addAction(action);
    }

    public void rollBackAction() {
        this.actionRollBackBiz.executeActionRollBack(this);
    }

    public RequestFlowLogEntity getRequestFlowLogEntity() {
        return requestFlowLogEntity;
    }

    public void setRequestFlowLogEntity(RequestFlowLogEntity requestFlowLogEntity) {
        this.requestFlowLogEntity = requestFlowLogEntity;
    }

    public Map <String, Object> getOtherParams() {
        return otherParams;
    }

    public void setOtherParams(Map <String, Object> otherParams) {
        this.otherParams = otherParams;
    }

    /**
     * 保存请求的相关信息
     * description:第一步：存储基本信息（具体单据或workflow_form）,
     * 第二步：处理文档（附件）
     * 第三步：处理节点前（后）附加操作，
     * 第四步：处理明细信息
     * @return 是否保存成功
     */
    public boolean saveRequestInfo() {
        removeErrorMsg();
        WfFunctionManageUtil WfFunctionManageUtil = new WfFunctionManageUtil();
        boolean fnaWfValidatorFlag = true;
        RecordSet rs=new RecordSet();
        RecordSet rs2=new RecordSet();
        RecordSet rs4=new RecordSet();
        RecordSet rs1=new RecordSet();
        DateTransformer dft = new DateTransformer();

        try{
            rs.execute("select isvalid from workflow_base where id="+workflowid);
            if(rs.next()){
                int isvalid_t = Util.getIntValue(rs.getString("isvalid"), 0);
                if(isvalid_t == 2){
                    istest = 1;
                }
            }
            rs.executeQuery("select deleted from workflow_requestbase where requestid = " + requestid);
            if(rs.next()){
                istestwf = Util.getIntValue(rs.getString("deleted"));
            }
        }catch(Exception e){}
        if(!iscreate.equals("1")) {
            //校验锁定
            String needcheckLock = "";
            String timestamp = "";
            LockUtil lockUtil = new LockUtil();
            if(isRequest){
                needcheckLock = Util.null2String(request.getParameter("needcheckLock"));
                timestamp = Util.null2String(request.getParameter("timestamp"));
            }else{
                needcheckLock = Util.null2String(fu.getParameter("needcheckLock"));
                timestamp = Util.null2String(fu.getParameter("timestamp"));
            }
            if(!"true".equals(needcheckLock)){//如果页面传入不需要校验，则再去判断一次是否需要校验（考虑加载页面后开启锁定开关的情况）
                rs.execute("select isremark,takisremark from workflow_currentoperator where requestid = " + requestid + " and userid = " + userid + " and islasttimes = 1");
                if(rs.next()){
                    int temp_isremark = Util.getIntValue(Util.null2String(rs.getString(1)),0);
                    int temp_takisremark = Util.getIntValue(Util.null2String(rs.getString(2)),0);
                    boolean flag = lockUtil.isNeedCheckLock(requestid, workflowid, nodeid, temp_isremark, temp_takisremark, userid);
                    if(flag)
                        needcheckLock = "true";
                }
            }

            if("true".equals(needcheckLock) && !"1".equals(docView) && !"intervenor".equals(src) && !"supervise".equals(src)){//点击正文触发的保存，不解锁流程
                boolean checkEffictive = lockUtil.checkEffictive(requestid+"", nodeid+"", userid+"", timestamp);
                if(checkEffictive ){
                    lockUtil.unlockRequest(requestid+"", nodeid+"");
                }else{
                    setMessagecontent(SystemEnv.getHtmlLabelName(128922,user.getLanguage()));
                    saveRequestLog("1");
                    return false;
                }
            }
        }

        if (isbill == 1) {
            rs.executeSql("select tablename from workflow_bill where id = " + formid); // 查询工作流单据表的信息
            if (rs.next())
                billtablename = rs.getString("tablename");          // 获得单据的主表
            else
                return false;
        }

        if(!WfFunctionManageUtil.haveOtherOperationRight(requestid))
        {
            return false;
        }
        if (src.equals("delete")){
            if(!WfFunctionManageUtil.IsShowDelButtonByReject(requestid,workflowid)){
                setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_04);
                return false;
            }
        }

        WFCoadjutantManager wfcm=new WFCoadjutantManager();
        boolean isCoadjutantCanSubmit = false;
        rs.executeSql("select groupdetailid,agentorbyagentid from workflow_currentoperator where id="+RequestKey);
        if(rs.next()){
            wfcm.getCoadjutantRights(rs.getInt("groupdetailid"));
            isCoadjutantCanSubmit = wfcm.getCoadjutantCanNextNode(requestid, Util.getIntValue(wfcm.getSigntype(),2), RequestKey, isremark);
        }

        /*判断当前节点是否启用子流程归档后才能提交，如果启用并且存在未归档请求则不允许向下流转*/
        boolean isAllSubWorkflowEnded = SubWorkflowTriggerService.isAllSubWorkflowEnded(this, "" + nodeid);
        if(src.equals("submit")
                && !isAllSubWorkflowEnded
                && (isremark == 0 || (isremark == 7 && isCoadjutantCanSubmit))){
            setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_05);
            JSONObject subwfinfo = new JSONObject();
            try {
                subwfinfo.put("details",SubWorkflowTriggerService.getAllSubWorkflowEndedMessage(this, "" + nodeid));
            } catch (JSONException e) {
                e.printStackTrace();
            }
            setMessagecontent(subwfinfo.toString());
            return false;
        }

        String result = getUpLoadTypeForSelect(workflowid);//当前工作流附件上传类型
        if (result.indexOf(",") != -1) {
            selectedfieldid = result.substring(0,result.indexOf(","));//附件上传目录所选字段id
            uploadType = Integer.valueOf(result.substring(result.indexOf(",")+1)).intValue();//附件上传目录类型
        }

        //added by cyril on 2008-07-18 for td:8835
        Map typemap1 = new HashMap();
        //end added by cyril on 2008-07-18 for td:8835
        //qc:76256 xwz
        //背景:流程提交(创建、审批)均偶发性出现丢失的情况。原因：后台偶发性获取不到标题数据导致数据丢失。故此加强处理。
        //优点:只要创建节点提交，标题不丢失，那么直到归档也不会再丢失，如果创建丢失，那么就会生成一个系统默认的标题。
        //缺点:如果创建节点提交丢失标题，这样生成的默认标题和客户的自定义标题不符，可能引发质疑。
        requestname = requestname.trim();
        if(null == requestname || "".equals(requestname)){
            String createdate_temp = "";
            if(requestid > 0){
                rs2.executeSql("select requestname from workflow_requestbase where requestid  = "+ requestid);
                if(rs2.next()) requestname = Util.null2String(rs2.getString("requestname"));
            }else{
                //创建提交未开默认标题也生成固定格式标题，防止requestname值为空
                //开启了默认标题，有自定义格式，流程创建，清空标题再保存，应该取自定义格式
                DateUtil DateUtil = new DateUtil();
                String deftitle = DateUtil.getWFTitleNew(""+workflowid, userid+"", user.getLastname(), user.getLogintype());
                deftitle = Util.toScreenToEdit(deftitle, user.getLanguage());
                if ("".equals(deftitle)){
                    createdate_temp = logdate;
                    rs2.executeSql("select workflowname from workflow_base where id = "+ workflowid);
                    if(rs2.next()) deftitle=Util.null2String(rs2.getString("workflowname"))+"-"+user.getUsername()+"-"+createdate_temp;
                }
                requestname = Util.formatMultiLang(deftitle,user.getLanguage()+"");
            }
        }
        // 当操作类型为干预时，需要判断下干预的节点是否为当前节点，如果不是说明流程在打开干预表单后已有流转
        if("intervenor".equals(src)){
            String nodeid = Util.null2String(request.getParameter("nodeid"));
            rs.executeQuery("select currentnodeid from workflow_requestbase where requestid = ?", requestid);
            if(rs.next()){
                String currentnodeid = rs.getString("currentnodeid");
                if(!currentnodeid.equals(nodeid)){
                    this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_02);
                    return false;
                }
            }
        }
        // 当操作类型为删除，退回，重新打开，激活（将删除的恢复） 和批注提交时， 不修改表单和单据信息
        if (src.equals("delete") || src.equals("reopen") || src.equals("active") || ((isremark == 1||isremark==7||isremark==11)&&!CanModify) || src.equals("supervise") || isremark == 9 || src.equals("intervenor"))
            return true;

        // 当为创建节点新建请求的时候,获得新的 requestid , 并初始化请求,如果是单据,需要先得到单据的 billid
        if (iscreate.equals("1") && requestid <= 0) {
            // 获得新的请求id , 单据id(如果是单据) 并更新请求表和单据表(如果是单据)
            //			---------- xwj for td1940 on 2005-06-02 begin -------------------
//            if(isbill == 1){
//                requestIdUpdate.setBilltablename(billtablename);
//            }
            //requestid 和 billid 一起返回，避免同一时间提交的流程，billid出错
            int rvalue[] = requestIdUpdate.getRequestNewId(billtablename);
            requestid = rvalue[0];
            if (requestid == -1) {
                return false;
            }
					  /*
					  rs.executeProc("workflow_RequestID_Update", "");
					  if (rs.next())
						  requestid = Util.getIntValue(rs.getString(1), 0);
					  else
						  return false;
					  */
            //---------- xwj for td1940 on 2005-06-02 end -------------------

            if (isbill == 1) {
                //rs.executeSql("insert into " + billtablename + "(requestid) values( " + requestid + " ) "); // 初始化主表, 每一个主表必须有requestid 字段
                //rs.executeSql("select max(id) from " + billtablename); // 获得billid , 即最大的主表id,每一个主表必须有自增长的id作为主键
                //上述方式在并发时数据不正确改为以下方式
                //billid = requestIdUpdate.getBillid();
                billid = rvalue[1];
                if (billid==-1)
                    return false;
            }
            //流程新建计数
            RequestOperationBiz.addWorkflowCount(workflowid,user);
            executesuccess = rs.executeSql("insert into workflow_form (requestid,billformid,billid) values(" + requestid + "," + formid + "," + billid + ")"); // 初始化请求信息表
            if (!executesuccess) {
                this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_06);
                return false;
            }

            // 初始化请求基本信息和操作者基本信息
            createdate = currentdate;
            createtime = currenttime;
            lastnodeid = nodeid;
            lastnodetype = nodetype;
            status = "";
            passedgroups = 0;
            totalgroups = 0;
            lastoperator = 0;
            lastoperatortype = 0;
            lastoperatedate = "";
            lastoperatetime = "";
            deleted = 0;
            nodepasstime = -1;
            nodelefttime = -1;
            isremark = 0;          // 当前操作者
            operatorgroup = 0;
            groupdetailid=0;   //创建节点设为0，不用取得实际id
            creater = userid;
            creatertype = usertype;
            if(isagentCreater==1){
                if(beagenter<1){
                    rs.executeSql("select bagentuid from workflow_agentConditionSet where iscreateagenter=1 and agentuid="+userid+" and workflowid="+workflowid+" order by agentbatch desc  ,id desc");
                    if(rs.next()){
                        creater=rs.getInt(1);
                        creatertype=0;
                    }
                }else{
                    creater=beagenter;
                    creatertype=0;
                }
            }

            // 加入请求基本信息
            //modify by xhheng @ 2005/01/24 for 消息提醒 Request06
            /********/
            if(isoracle){
                Procpara = "" + requestid + flag + workflowid + flag + lastnodeid + flag + lastnodetype + flag
                        + nodeid + flag + nodetype + flag + status + flag + passedgroups + flag + totalgroups
                        + flag + requestname + flag + creater + flag + createdate + flag + createtime + flag
                        + lastoperator + flag + lastoperatedate + flag + lastoperatetime + flag + deleted + flag
                        + creatertype + flag + lastoperatortype + flag + nodepasstime + flag + nodelefttime + flag
                        + docids + flag + crmids + flag + "empty_clob()" + flag + prjids + flag + cptids + flag + messageType + flag + chatsType;//微信提醒(QC:98106)
            }
            else if(rs.getDBType().equalsIgnoreCase("postgresql")){
                if(chatsType.trim().equalsIgnoreCase(""))chatsType=null;
                if(messageType.trim().equalsIgnoreCase(""))messageType=null;
                if(prjids.trim().equalsIgnoreCase(""))prjids=null;
                Procpara = "" +requestid + flag + workflowid + flag + lastnodeid + flag + lastnodetype + flag
                        + nodeid + flag + nodetype + flag + status + flag + passedgroups + flag + totalgroups
                        + flag + requestname + flag + creater + flag + createdate + flag + createtime + flag
                        + lastoperator + flag + lastoperatedate + flag + lastoperatetime + flag + deleted + flag
                        + creatertype + flag + lastoperatortype + flag + nodepasstime + flag + nodelefttime + flag
                        + docids + flag + crmids + flag + hrmids + flag + prjids + flag + cptids + flag + messageType + flag + chatsType;//微信提醒(QC:98106)
            }
            else{
                Procpara = "" +requestid + flag + workflowid + flag + lastnodeid + flag + lastnodetype + flag
                        + nodeid + flag + nodetype + flag + status + flag + passedgroups + flag + totalgroups
                        + flag + requestname + flag + creater + flag + createdate + flag + createtime + flag
                        + lastoperator + flag + lastoperatedate + flag + lastoperatetime + flag + deleted + flag
                        + creatertype + flag + lastoperatortype + flag + nodepasstime + flag + nodelefttime + flag
                        + docids + flag + crmids + flag + hrmids + flag + prjids + flag + cptids + flag + messageType + flag + chatsType;//微信提醒(QC:98106)
            }
            /********/
            executesuccess = rs.executeProc("workflow_requestbase_insertnew", Procpara);

            //为何insett和update要分2步做？add by ben 2006-03-30
            rs.executeProc("workflow_Rbase_UpdateLevel", "" + requestid + flag + requestlevel);
            if (!executesuccess) {
                this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_06);
                return false;
            }

            /* ---- xwj for td2104 on 20050802 begin---- */
            if(isOldOrNewFlag(requestid)){//老数据 相对td2104之前
                Procpara = "" + requestid + flag + userid + flag + operatorgroup + flag + workflowid + flag
                        + workflowtype + flag + creatertype + flag + isremark + flag + -1 +
                        flag + -1 + flag + "0" + flag + -1+flag + groupdetailid+flag+this.currentdate+flag+this.currenttime;
                executesuccess = rs.executeProc("workflow_CurrentOperator_I2", Procpara);
            }
            else{
                if(isagentCreater==1&&beagenter>0){
                    Procpara = "" + requestid + flag + userid + flag + operatorgroup + flag + workflowid + flag
                            + workflowtype + flag + creatertype + flag + isremark + flag + lastnodeid + flag + beagenter
                            + flag + "2" + flag + -1 + flag + groupdetailid+flag+this.currentdate+flag+this.currenttime;
                    executesuccess = rs.executeProc("workflow_CurrentOperator_I2", Procpara);
                    Procpara = "" + requestid + flag + beagenter + flag + operatorgroup + flag + workflowid + flag
                            + workflowtype + flag + creatertype + flag + "2" + flag + lastnodeid + flag + userid
                            + flag + "1" + flag + -1 + flag + groupdetailid+flag+this.currentdate+flag+this.currenttime;
                    executesuccess = rs.executeProc("workflow_CurrentOperator_I2", Procpara);
                }else{
                    Procpara = "" + requestid + flag + userid + flag + operatorgroup + flag + workflowid + flag
                            + workflowtype + flag + creatertype + flag + isremark + flag + lastnodeid + flag + -1
                            + flag + "0" + flag + -1 + flag + groupdetailid+flag+this.currentdate+flag+this.currenttime;
                    executesuccess = rs.executeProc("workflow_CurrentOperator_I2", Procpara);
                }
            }
            /* ---- xwj for td2104 on 20050802 end---- */

            if (!executesuccess) return false;
            rs.executeSql("delete from workflow_nownode where requestid="+requestid);
            rs.executeSql("insert into workflow_nownode(requestid,nownodeid,nownodetype,nownodeattribute) values("+requestid+","+lastnodeid+",0,0)");
        }else{
            // 查询当前请求的一些基本信息
            rs.executeProc("workflow_Requestbase_SByID", requestid + "");
            if (rs.next()) {
                lastnodeid = Util.getIntValue(rs.getString("lastnodeid"), 0);
                lastnodetype = Util.null2String(rs.getString("lastnodetype"));
                passedgroups = Util.getIntValue(rs.getString("passedgroups"), 0);
                totalgroups = Util.getIntValue(rs.getString("totalgroups"), 0);
                creater = Util.getIntValue(rs.getString("creater"), 0);
                creatertype = Util.getIntValue(rs.getString("creatertype"), 0);
                requestmark = Util.null2String(rs.getString("requestmark"));
            }
            if(isbill==1 && billid<=0){
                getBillId();
            }
        }

        if(request != null && this.iscreate.equals("1")) {
            int configid = Util.getIntValue(request.getParameter("configid"));//更新自由流程自定义表单requestid
            DoSaveFreeExcelDesignBiz.updateConfigRequestId(requestid,configid);
        }

        if(!"1".equals(this.iscreate)){//其它节点也可以修改紧急程度和是否短信提醒，同一节点以最后一个有效操作者的修改提交到下一个节点。创建节点不重复更新。
            //add by mackjoe at 2008-02-21 for TD8232
            //检查是否是当前节点操作人 避免同一节点操作人重复提交
            boolean isFilterNode = false;
            rs.executeQuery("select value from workflow_config where name = 'filter_submit_nodes'");
            if (rs.next()) {
                String filterNodes = Util.null2String(rs.getString(1));
                String[] nodeIdArr = filterNodes.split(",");
                String currentNodeId = nodeid+"";
                for (String nodeId : nodeIdArr) {
                    if (nodeId.equals(currentNodeId)){
                        isFilterNode = true;
                        break;
                    }
                }
            }
            int sleepsum=0;
            while(true){
                if(GCONST.WFProcessing.indexOf(requestid+"_"+nodeid)==-1||isFilterNode){
                    break;
                }else{
                    try{
                        Thread.sleep(1000);   //等待1秒钟
                        sleepsum++;
                        if(sleepsum>1000){
                            GCONST.WFProcessing.remove(requestid+"_"+nodeid);
                            this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_03);  //等待1000秒后流程流转失败,提示：流程流转超时，请重试。
                            return false;
                        }
                    }catch(Exception e) {e.printStackTrace();}
                }
            }

            if(!verifySubmit()) return false;

            //end by mackjoe

            if(!"true".equals(isFromEditDocument) && !isSelectNextFlow){
                RequestSaveCheckManager requestSaveCheckManager=new RequestSaveCheckManager();
                String returnMessage=requestSaveCheckManager.getReturnMessage(this,this.isRequest,this.fu,this.request);
                if(!returnMessage.equals("")){
                    setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_04);
                    saveRequestLog("1");
                    return false;
                }
            }

            rs.execute("select requestname,requestlevel,messageType,seclevel,secvalidity from workflow_requestbase where requestid="+requestid);
            if(rs.next()){
                saveParams.put("oldRequestName", rs.getString("requestname"));
                saveParams.put("oldRequestLevel", rs.getString("requestlevel"));
                saveParams.put("oldMessageType", rs.getString("messageType"));
				saveParams.put("oldSeclevel", rs.getString("seclevel"));
				saveParams.put("oldSecvalidity", rs.getString("secvalidity"));
            }

            //更新requsetbase表
            StringBuffer updateInfo  = new StringBuffer();
            if(!"".equals(this.requestlevel)) {
                updateInfo.append(",requestLevel="+Util.getIntValue(this.requestlevel,-1));
            }
            if(!"".equals(this.messageType)) {
                updateInfo.append(",messageType="+Util.getIntValue(this.messageType,-1));
            }
            if(!"".equals(this.requestname) && this.requestname !=null){
                updateInfo.append(",requestname='" + Util.fromScreen2(requestname, userlanguage)+"'");
            }
            if(!"".equals(this.chatsType)){
                updateInfo.append(",chatsType="+Util.getIntValue(this.chatsType,-1));
            }
            if(updateInfo.length() > 0) {
                String sql = "update workflow_requestbase set " + updateInfo.substring(1) + " where requestid= " + this.requestid;
                rs.executeUpdate(sql);
            }
        }

		//更新流程密级
        if (HrmClassifiedProtectionBiz.isOpenClassification() && !"4".equals(nodetype)) {
            String secLevel = "";
            String secNewDocid = "";
            if (request != null) {
                secLevel = this.getRequestParamValue("field-10");
                secNewDocid = this.getRequestParamValue("secNewDocid");
            }
            RequestSecLevelBiz secLevelBiz = new RequestSecLevelBiz();
            if("0".equals(nodetype))    //创建节点才允许修改密级
                secLevelBiz.updateSecLevelByRequestId(this.requestid+"", secLevel, user);
            String newSeclevel = "";
            String newSecvalidity = "";
            if(secLevel.indexOf("#") > -1){
                newSeclevel = secLevel.substring(0, secLevel.indexOf("#"));
                newSecvalidity = secLevel.substring(secLevel.indexOf("#")+1);
            }else{
                newSeclevel = secLevel;
            }
            saveParams.put("newSeclevel", newSeclevel);
            saveParams.put("newSecvalidity", newSecvalidity);
        }

        //查询当前流程是否跟随文档关联人赋权
        int docRightByOperator=0;
        rs.execute("select docRightByOperator from workflow_base where id="+workflowid);
        if(rs.next()){
            docRightByOperator=Util.getIntValue(rs.getString("docRightByOperator"),0);
        }
        //检查操作人是否为被代理人
        agentId = RequestOperationBiz.judgeAgentOperation(requestid,nodeid,userid,usertype);
        isAgent = agentId > 0;
        if (flowFrom.equals("")) //如果流程不是由流程计划自动创建进行以下步骤
        {
            String nowtime = this.currentdate + " " + this.currenttime;
            //检查流程是否是在流转过程中,是否记录表单修改日志
            rs.executeQuery("select t1.ismodifylog, t2.status from workflow_base t1, workflow_requestbase t2 where t1.id=t2.workflowid and t2.requestid=?", requestid);
            if (rs.next()) {
                isTrack = (rs.getString("ismodifylog") != null && "1".equals(rs.getString("ismodifylog")));
                isStart = (rs.getString("status") != null && !"".equals(rs.getString("status")));
            }

            int extendnodeid  = nodeid;
            if(FreeNodeBiz.isFreeNode(nodeid)) {
                FreeNodeEntity nodeEntity = FreeNodeBiz.getCurrentFreeNodeEntity(requestid,nodeid);
                //查阅类型禁止编辑表单即使allowmodify=true
                if(nodeEntity != null && nodeEntity.isAllowModify() && nodeEntity.getNodetype() != 4) {
                    extendnodeid = nodeEntity.getExtendnodeid();
                }
            }
            //初始化ReqInfo对象
            RequestInfoEntity reqEntity = new RequestInfoEntity();
            reqEntity.setCreate("1".equals(iscreate));
            reqEntity.setRequestId(requestid+"");
            reqEntity.setWorkflowId(workflowid);
            reqEntity.setCurrentNodeId(nodeid+"");
            reqEntity.setCurrentNodeType(nodetype);
            reqEntity.setExtendNodeId(extendnodeid+"");
            reqEntity.setLanguageid(user.getLanguage());
            reqEntity.setClientip(this.getIp());
            reqEntity.setRequestName(this.requestname);
            reqEntity.setRequestLevel(this.requestlevel);
            MainTableInfoEntity mtableEntity = new MainTableInfoEntity();
            mtableEntity.setBillid(billid);
            mtableEntity.setTableDbName(isbill == 0 ? "workflow_form" :billtablename);
            reqEntity.setMainTableInfoEntity(mtableEntity);
            WorkflowBaseInfoEntity baseEntity = new WorkflowBaseInfoEntity();
            baseEntity.setFormId(formid + "");
            baseEntity.setIsBill(isbill + "");
            reqEntity.setWorkflowBaseInfo(baseEntity);
            //计算允许入库的字段范围
            FieldInfo fieldinfo = new FieldInfo();
            fieldinfo.setRequestid(requestid);
            ArrayList maineditfields = new ArrayList();
            ArrayList detaileditfields = new ArrayList();

            if (!"1".equals(iscreate)) {
                maineditfields = fieldinfo.getSaveMainFields(formid, isbill, workflowid, extendnodeid, getCalfields());
                detaileditfields = fieldinfo.getSaveDetailFields(formid, isbill, workflowid, extendnodeid, getCaldetfields());
                //Html模式-新表单设计器-公式赋值字段添加
                new ExcelLayoutManager().manageFormulaDestFile(workflowid, extendnodeid, 0, maineditfields, detaileditfields);
                //人力-考勤流程中只读也允许入库字段
                Map<String,Object> kqparams = new HashMap<>();
                kqparams.put("workflowid", this.workflowid);
                kqparams.put("nodeid", this.nodeid);
                List<String> kqEditFields = new KQEditFieldInWorkflowBiz().getEditFieldInWorkflow(kqparams);
                maineditfields.addAll(kqEditFields);
                detaileditfields.addAll(kqEditFields);
            }
            reqEntity.setMaineditfields(maineditfields);
            reqEntity.setDetaileditfields(detaileditfields);
            //部分参数传递到保存Cmd
            saveParams.put("src", src);
            saveParams.put("takisremark", takisremark);
            saveParams.put("needModifyLog", isTrack);
            saveParams.put("nowtime", nowtime);
            saveParams.put("agentId", agentId);
            saveParams.put("nodetype", this.nodetype);
            saveParams.put("checkParamsStr", request.getParameter("checkParamsStr"));
            saveParams.put("checkSecret", request.getParameter("checkSecret"));
            saveParams.put("ismobile", request.getParameter("isMobile"));
            saveParams.put("modeid", request.getParameter("modeId"));
            saveParams.put("openDataVerify", request.getParameter("openDataVerify"));
            //表单最后修改时间
            String loadFormTime = "";
            String currentdate = this.getRequestParamValue("currentdate");
            String currenttime = this.getRequestParamValue("currenttime");
            if(!"".equals(currentdate) && !"".equals(currenttime)) {
                loadFormTime = currentdate + " " + currenttime;
            }
            //表单字段修改范围
            //String existChangeRange = this.getRequestParamValue("existChangeRange");
            //保存主表数据逻辑重构 liuzy
            try{
                SaveMainFormDatasBiz saveMainManager = new SaveMainFormDatasBiz(reqEntity, saveParams, user, isRequest, request, fu);
                saveMainManager.setRequestManager(this);
                Map<String,Object> injectResult = saveMainManager.doInject();
                if(!(Boolean)injectResult.get("status")){
                    saveRequestLog("1");
                    this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_06);
                    this.setMessagecontent(Util.null2String(injectResult.get("errormsg")));
                    reqFailMsg.setMsgType(ReqFlowFailMsgType.SAVE_MAIN_TABLE_FAIL);
                    return false;
                }
                saveMainManager.setRequestFlowLogEntity(requestFlowLogEntity);                //记录修改冲突字段
                //this.conflictFieldInfo.putAll(saveMainManager.compareMainDatas(reqEntity, loadFormTime, existChangeRange));
                Map<String,Object> saveMainResult = saveMainManager.doSave();
                if (saveMainResult != null && !(Boolean) saveMainResult.get("status")) {
                    saveRequestLog("1");
                    this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_06);
                    this.setMessagecontent(Util.null2String(saveMainResult.get("errormsg")));
                    reqFailMsg.setMsgType(ReqFlowFailMsgType.SAVE_MAIN_TABLE_FAIL);
                    return false;
                }
            }catch(Exception e){
                saveRequestLog("1");
                reqFailMsg.setMsgType(ReqFlowFailMsgType.SAVE_MAIN_TABLE_FAIL);
                this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_06);
                e.printStackTrace();
                return false;
            }

            //lz add 20190603 -- start --
			boolean openOdocFlow = false;
			rs.executeQuery("select status from workflow_createdoc where workflowId=? ",workflowid);
			if(rs.next()){
				openOdocFlow = Util.getIntValue(rs.getString(1),-1) == 1;
			}
            boolean openyozo = false;
            boolean openWps = false;
            int useyozo = 0;
            int useWps = 0;
            rs.executeQuery("select useyozo,useWps from workflow_yozotopdfconfig");
            if(rs.next()) {
                useyozo = rs.getInt("useyozo");
                useWps = rs.getInt("useWps");
            }
            if(useWps == 1){
                openWps = true;
            }else{
                ImageConvertUtil ic = new ImageConvertUtil();
                boolean openConverForClient = ic.convertForClient();
                String _clientAddress = ic.getConvertIp();
                writeLog("======useyozo:"+useyozo+"=====src:"+src+"======openConverForClient:"+openConverForClient+"=======_clientAddress:"+_clientAddress+"=====openyozo:"+openyozo);
                if(openConverForClient && !_clientAddress.isEmpty()&&useyozo==1) { //开启单独服务转换
                    openyozo = true;
                }
            }
            if(!openyozo&&useyozo==1) {
                writeLog("================请检查配置文件：doc_custom_for_weaver.properties是否正常配置启用yozo服务！");
            }
            if((src.equals("save") || src.equals("submit")) && (openyozo || openWps) && openOdocFlow){
                int pdfDocId = -1;
                //流程保存，或提交时
                MaintextToPDF maintextToPDF = new MaintextToPDF();
                String opType = "";
                if(src.equals("save")){
                    opType = "0";
                }else{
                    opType = "1";
                }
                pdfDocId = maintextToPDF.textToPDF(user, requestid, workflowid,opType,(openyozo ? new DocImagefileToPdf() : new DocImagefileToPdfUseWps()));
                if(pdfDocId > 0) {
                    docids += ","+pdfDocId;
                }
            }
            //lz add 20190603 --  end  --

            if((src.equals("reject") || src.equals("save") || src.equals("submit")) && openOdocFlow){
                //流程退回，保存，或提交时，正文标题随设置的标题内容改变
                ChangeDocName changeDocName = new ChangeDocName();
                changeDocName.changeMainDocName(requestid,nodeid);
                OdocPortalElementUtil portalElementUtil = new OdocPortalElementUtil();
                portalElementUtil.convertThumbnailByThread(requestid);
            }
            //正文预归档
            if(src.equals("submit")){
                PreFileDoc preFileDoc=new PreFileDoc();
                preFileDoc.preFileMainDoc(requestid,nodeid);
            }
            //保存明细数据逻辑重构 liuzy
            if ((src.equals("save") || src.equals("submit") || src.equals("reject")) && (!(isSelectNextFlow && !"".equals(selectNodeFlowNodeIds)) && selectNodeFlowNodeCanFlowNextNode)) {
                try {
                    SaveDetailFormDatasBiz saveDetailManager = new SaveDetailFormDatasBiz(reqEntity, saveParams, user, isRequest, request, fu);
                    saveDetailManager.setRequestManager(this);
                    Map<String,Object> injectResult = saveDetailManager.doInject();
                    if(!(Boolean)injectResult.get("status")){
                        saveRequestLog("1");
                        this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_06);
                        reqFailMsg.setMsgType(ReqFlowFailMsgType.SAVE_DETAIL_TABLE_FAIL);
                        this.setMessagecontent(Util.null2String(injectResult.get("errormsg")));
                        return false;
                    }
					saveDetailManager.setRequestFlowLogEntity(requestFlowLogEntity);
                    //记录修改冲突字段
                    //this.conflictFieldInfo.putAll(saveDetailManager.compareDetailDatas(reqEntity, loadFormTime, existChangeRange));
                    Map<String,Object> saveDetailResult = saveDetailManager.doSave();
                } catch (Exception e) {
                    //保存明细错误提示
                    saveRequestLog("1");
                    reqFailMsg.setMsgType(ReqFlowFailMsgType.SAVE_DETAIL_TABLE_FAIL);
                    this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_06);
                    e.printStackTrace();
                    return false;
                }
            }
            String linkageUUID = this.getRequestParamValue("linkageUUID");
            if (!"".equals(linkageUUID)){
                //联动信息回写
                RecordSet rsObj = new RecordSet();
                rsObj.executeUpdate("update workflow_linkagelog set requestid=? where linkageUUID =?",requestid,linkageUUID);
            }
//            if (this.conflictFieldInfo.size() > 0) {//存在字段冲突，前台提示
//                saveRequestLog("1");
//                this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_11);
//                return false;
//            }

            //相关资源信息拼接
            hrmids += Util.null2String(reqEntity.getHrmids());
            crmids += Util.null2String(reqEntity.getCrmids());
            prjids += Util.null2String(reqEntity.getPrjids());
            docids += Util.null2String(reqEntity.getDocids());
            cptids += Util.null2String(reqEntity.getCptids());
            if (!hrmids.equals("")) hrmids = hrmids.substring(1);
            if (!crmids.equals("")) crmids = crmids.substring(1);
            if (!prjids.equals("")) prjids = prjids.substring(1);
            if (!docids.equals("")) docids = docids.substring(1);
            if (!cptids.equals("")) cptids = cptids.substring(1);
            //处理附件相关内容
            String fileDocids = Util.null2String(reqEntity.getFileDocids()).trim();
            if(fileDocids.startsWith(","))
                fileDocids = fileDocids.substring(1);
            if(!"".equals(fileDocids) && !"1".equals(WorkflowCreateDocUtil.queryByWorkflowId(workflowid).getIsworkflowdraft()))
                new DocExtUtil().updateDoc(fileDocids, user, "1");//更新文档状态为正常

            if(fnaWfValidatorFlag){
                // 开始节点自动赋值操作(用在处理节点前，节点后等的赋值操作)
                String rejectbackflag = "";//退回时，当前节点的节点后附加操作是否触发。rejectbackflag=1，表示触发。
                RecordSet tempRecordSet = new RecordSet();
                tempRecordSet.executeSql("select rejectbackflag from workflow_flownode where workflowid="+workflowid+" and nodeid="+nodeid);
                if(tempRecordSet.next()){
                    rejectbackflag = Util.null2String(tempRecordSet.getString("rejectbackflag"));
                }

                //if((!src.equals("save")&&(!src.equals("reject")||(src.equals("reject")&&!rejectbackflag.equals("1"))))&& enableIntervenor==1){//用于修改，保存也会执行节点后附加操作
                if((!src.equals("save"))&& enableIntervenor==1){//用于修改，保存也会执行节点后附加操作
                    //判断当前节点是否为流程存为文档

                    if((!src.equals("reject")||(src.equals("reject")&&!rejectbackflag.equals("1")))){
                        //rs.executeSql("select * from workflow_addinoperate  where workflowid="+workflowid+" and objid="+nodeid+" and ispreadd=0 and type=2  and customervalue='action.WorkflowToDoc' ");
                        rs.executeSql("select * from workflowactionview  where workflowid="+workflowid+" and nodeid="+nodeid+" and ispreoperator='0' and (id='action.WorkflowToDoc' or id='WorkflowToDoc') and isused = 1");
                        if(rs.next())
                        {
                            isWorkFlowToDoc=true;
                        }
                    }
                    if(RequestBaseBiz.judgeNodeAction(requestid,formid,isbill,src,workflowid,0,1,nodeid)) {
                        try {
                            //由于objtype为"1: 节点自动赋值",不为"0 :出口自动赋值"，不用改变除状态外的文档相关信息，故可不用给user、clienIp、src赋值  fanggsh TD5121
                            RequestCheckAddinRules requestCheckAddinRules = new RequestCheckAddinRules();
                            requestCheckAddinRules.resetParameter();
                            //add by cyril on 2008-07-28 for td:8835 事务无法开启查询,只能传入
                            requestCheckAddinRules.setTrack(isTrack);
                            requestCheckAddinRules.setStart(isStart);
                            requestCheckAddinRules.setNodeid(nodeid);
                            //end by cyril on 2008-07-28 for td:8835
                            requestCheckAddinRules.setRequestid(requestid);
                            requestCheckAddinRules.setWorkflowid(workflowid);
                            requestCheckAddinRules.setObjid(nodeid);
                            requestCheckAddinRules.setObjtype(1);               // 1: 节点自动赋值 0 :出口自动赋值
                            requestCheckAddinRules.setIsbill(isbill);
                            requestCheckAddinRules.setFormid(formid);
                            requestCheckAddinRules.setIspreadd("0");//xwj for td3130 20051123
                            requestCheckAddinRules.setRequestManager(this);
                            requestCheckAddinRules.setUser(user);
                            String clientIp = "";
                            if(isRequest){
                                if (request != null)
                                    clientIp = Util.null2String(Util.getIpAddr(request));
                            }else{
                                if (fu != null)
                                    clientIp = Util.null2String(fu.getRemoteAddr());
                            }
                            requestCheckAddinRules.setClientIp(clientIp);//add by fanggsh 20061016 fot TD5121
                            requestCheckAddinRules.setSrc(src);

                            WFCoadjutantManager checkAddInWfCm=new WFCoadjutantManager();
                            rs.executeSql("select groupdetailid,agentorbyagentid from workflow_currentoperator where id="+RequestKey);
                            if(rs.next()){
                                checkAddInWfCm.getCoadjutantRights(rs.getInt("groupdetailid"));
                            }
                            requestCheckAddinRules.setWfcm(checkAddInWfCm);
                            requestCheckAddinRules.setPushMsgDocIds(this.pushMsgDocIds);
                            requestCheckAddinRules.setRequestFlowLogEntity(requestFlowLogEntity);
                            requestCheckAddinRules.checkAddinRules();
                            if(requestCheckAddinRules.getDoDmlResult().startsWith("-1")){
                                if("-1".equals(requestCheckAddinRules.getDoDmlResult())){
                                    if("".equals(this.getMessage())){
                                        this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_07);
                                    }
                                    if("".equals(this.getMessagecontent())){
                                        this.setMessagecontent(WorkflowRequestMessage.resolveDetailInfo(SystemEnv.getHtmlLabelName(10000171,weaver.general.Util.getIntValue(user.getLanguage()))));
                                    }
                                    requestFlowLogEntity.getActionlog().put("operation after the node",SystemEnv.getHtmlLabelName(10000171,weaver.general.Util.getIntValue(user.getLanguage())));
                                }else{
                                    this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_07);
                                    this.setMessagecontent(WorkflowRequestMessage.resolveDetailInfo(SystemEnv.getHtmlLabelName(10000192,weaver.general.Util.getIntValue(user.getLanguage()))+":"+requestCheckAddinRules.getDoDmlResult().replace("-1,", "")));
                                    requestFlowLogEntity.getActionlog().put("operation after the node",SystemEnv.getHtmlLabelName(10000192,weaver.general.Util.getIntValue(user.getLanguage()))+":"+requestCheckAddinRules.getDoDmlResult().replace("-1,", ""));
                                }
                                reqFailMsg.setMsgType(ReqFlowFailMsgType.AFTER_NODE_OPERATE_EX_FAIL);
                                return false;
                            }

                            requestCheckAddinRulesMap=new HashMap();
                            requestCheckAddinRulesMap.put("objId",""+nodeid);
                            requestCheckAddinRulesMap.put("objType","1");// 1: 节点自动赋值 0 :出口自动赋值
                            requestCheckAddinRulesMap.put("isPreAdd","0");
                            requestCheckAddinRulesList.add(requestCheckAddinRulesMap);
                        } catch (Exception erca) {
                            if(!conformCheckResult){
                                return false;
                            }
                            writeLog(erca);
                            saveRequestLog("1");
                            if(erca.getMessage().indexOf("workflow interface action error")>-1){
                                writeLog(erca);
                            }
                            if("".equals(this.getMessage())){
                                this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_07);
                            }
                            if("".equals(this.getMessagecontent())){
                                this.setMessagecontent(WorkflowRequestMessage.resolveDetailInfo(SystemEnv.getHtmlLabelName(10000171,weaver.general.Util.getIntValue(user.getLanguage()))));
                            }
                            reqFailMsg.setMsgType(ReqFlowFailMsgType.AFTER_NODE_OPERATE_EX_FAIL);
                            return false;
                        }
                    }
                }
            }
        }
        //###################Save the detailed form data END// #############
        //added by mackjoe at 2007-01-11 TD5731 将流程编号从option页面移到这里处理,解决一些使用特殊option的单据无法使用流程编号功能
        //生成编号放在流向下一节点的时候  fanggsh 20070719 for TD6963
//        if(iscreate.equals("1")){
//            CodeBuild cbuild = new CodeBuild(formid);
//            String  codeFields=cbuild.haveCode();
//            if (!codeFields.equals("")){
//                cbuild.getFlowCodeStr(requestid,isbill);
//            }
//        }

        //当表单内容保存时，根据请求id插入督办权限表
        if(!src.equals("submit")){
        	/* e8流程督办注释 luosy 2018/8/13
            WFUrgerManager WFUrgerManager = new WFUrgerManager();
            WFUrgerManager.setLogintype(Util.getIntValue(user.getLogintype()));
            WFUrgerManager.setUserid(user.getUID());
            WFUrgerManager.insertUrgerByRequestid(requestid);
            WFUrgerManager.insertUrgerByRequestid4e9(requestid, user);
            */
            SuperviseManagerBiz superviseBiz = new SuperviseManagerBiz();//e9
            superviseBiz.setReceivedate(currentdate);
            superviseBiz.setReceivetime(currenttime);
            superviseBiz.findOperatorByRequestid(user, requestid);
        }

        if(!isRequest){
            request=fu.getRequest();
        }
        if(request != null && !(request instanceof WeaverRequest)){
            HttpSession session = (HttpSession) request.getSession(false);
            if(session != null) {
                session.setAttribute("requestidForAllBill", String.valueOf(requestid));
            }
        }
        try{
            WorkflowRequestComInfo workflowRequestComInfo = new WorkflowRequestComInfo();
            workflowRequestComInfo.deleteRequestInfoCache(""+this.requestid);
        }catch(Exception e){

        }
        //从requet取自由流程设置信息保存
        try {
            if(isremark == 0) {
                SimpleModeFreeNodeBiz.saveSimpleFreeAddSignAttr(loadAddSignParams(false));
            }
        } catch (Exception e) {
            this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_06);
            log.error("加签失败requestid:" + requestid + ",userid:"+ userid,e);
        }
        try{
            //更新流程请求标题字段Start
            new SetNewRequestTitle().getAllRequestName(rs,requestid+"",requestname,workflowid+"",nodeid+"",formid,isbill,userlanguage);
            //更新流程请求标题字段End
        }catch(Exception e){
        }

        try{
            if(fnaWfValidatorFlag){
                int userId = 0;
                if(user!=null){
                    userId = user.getUID();
                }
                //插入 借款、还款（冲销借款）、报销（冲销借款）流程的借款（冲销）金额 调整记录
                new FnaBorrowAmountControl().saveFnaAmountAdjustLogs(workflowid, formid, nodeid, src, requestid, userId);
            }
        }catch(Exception e){
            new BaseBean().writeLog(e);
        }

        try{
            int userId = 0;
            if(user!=null){
                userId = user.getUID();
            }
            //插入 借款、还款（冲销借款）、报销（冲销借款）流程的借款（冲销）金额 调整记录
            new FnaAdvanceAmountControl().saveFnaAmountAdjustLogs(workflowid, formid, nodeid, src, requestid, userId);
        }catch(Exception e){
            new BaseBean().writeLog(e);
        }
        //更新公文相关信息
		if(!"delete".equals(src)){
			try{
				//获取流程创建文档设置的正文字段
				int flowdocfield = -1;
				rs1.executeQuery("select flowdocfield from workflow_createdoc where workflowid = ? and status = 1 ",workflowid);
				if(rs1.next()){
					flowdocfield = rs1.getInt("flowdocfield");
				}
				if(flowdocfield > 0) {
					OdocRequestdocUtil OdocRequestdocUtil = new OdocRequestdocUtil();
					//根据设置更新公文相关信息
					try {
						OdocRequestdocUtil.OdocRequestdocInitByReqId(requestid);
					} catch (Exception e) {
						writeLog("RequestManager.OdocRequestdocInitByReqId exception:",e);
					}

					//根据设置更新公文内部交换相关信息
					try {
						OdocRequestdocUtil.updateInnerChangeData(requestid);
					} catch (Exception e) {
						writeLog("RequestManager.updateInnerChangeData exception:",e);
					}


				}
			}catch(Exception e){
				new BaseBean().writeLog(e);
			}
		}
        if(src.equals("save") || src.equals("submit")){
            //是否开启分级保护
            boolean isOpenClassification = HrmClassifiedProtectionBiz.isOpenClassification();
            if(isOpenClassification){
                //请求数据绑定公文正文
                SecretDocService secretDocService = new SecretDocService();
                secretDocService.bindRequestAndDoc(requestid);

                //根据流程绑定关系，更新正文的密级
                //secretDocService.updateDocSecretLevel(workflowid,requestid, user);
            }

        }
        //提交流程时，进行正文转OFD
        if (src.equals("submit")){
            boolean isConvertNode= OFDCommonUtil.isConvertNode(workflowid,nodeid);
            if(isConvertNode){
                OdocThreadPoolUtil odocThreadPoolUtil = new OdocThreadPoolUtil();
                odocThreadPoolUtil.convertOFDByThread(requestid,user);
            }
        }

        //退回流程时，进行正文转OFD
        if (src.equals("reject")){
            boolean isConvertNode= OFDCommonUtil.isConvertNode(workflowid,nodeid);
            boolean isRejectConvertNode= OFDCommonUtil.isRejectConvertNode(workflowid,nodeid);
            if(isConvertNode && isRejectConvertNode){
                OdocThreadPoolUtil odocThreadPoolUtil = new OdocThreadPoolUtil();
                odocThreadPoolUtil.convertOFDByThread(requestid,user);
            }
        }

        //提交流程时，进行附件转OFD
        if (src.equals("submit")){
            boolean isConvertNode= OFDCommonUtil.isAttachConvertNode(workflowid,nodeid);
            if(isConvertNode){
                OdocThreadPoolUtil odocThreadPoolUtil = new OdocThreadPoolUtil();
                odocThreadPoolUtil.convertAttachOFDByThread(requestid,user);
            }
        }

        //退回流程时，进行附件转OFD
        if (src.equals("reject")){
            boolean isConvertNode= OFDCommonUtil.isAttachConvertNode(workflowid,nodeid);
            boolean isAttachRejectConvertNode= OFDCommonUtil.isAttachRejectConvertNode(workflowid,nodeid);
            if(isConvertNode && isAttachRejectConvertNode){
                OdocThreadPoolUtil odocThreadPoolUtil = new OdocThreadPoolUtil();
                odocThreadPoolUtil.convertAttachOFDByThread(requestid,user);
            }
        }

        return true;
    }


    private void addLenMsg(String fieldid,int len) {
        String fieldname = "";
        if(isbill == 1){
            RecordSet temprs = new RecordSet();
            temprs.executeQuery("select b.indexdesc from workflow_billfield a,htmllabelindex b where a.fieldlabel = b.id and a.id = ?", fieldid);
            if(temprs.next()){
                fieldname = Util.null2String(temprs.getString(1));
            }
        }else{
            FormFieldlabelMainManager ffmm = new FormFieldlabelMainManager();
            ffmm.resetParameter();
            ffmm.setFormid(formid);
            ffmm.setFieldid(Util.getIntValue(fieldid,0));
            ffmm.setLanguageid(userlanguage);
            try {
                ffmm.selectSingleFormField();
            } catch (Exception e) {
                e.printStackTrace();
            }
            fieldname = ffmm.getFieldlabel();
        }

        JSONObject msgobj = new JSONObject();
        try {
            msgobj.put("details", WorkflowRequestMessage.assemMsgInfo(SystemEnv.getHtmlLabelName(126571,userlanguage), fieldname,String.valueOf(len)));
        } catch (JSONException e) {
            e.printStackTrace();
        }
        this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_06);
        this.setMessagecontent(msgobj.toString());
    }

    /**
     * 将request中的参数转化为map
     * @return
     */
    private Map<String, String> convertRequestToMap(FileUpload fu){
        Map<String, String> params = new HashMap<String, String>();
        if(fu == null) return params;
        try{
            Enumeration<String> paramNames = fu.getParameterNames();
            while( paramNames.hasMoreElements() ) {
                String paramName = paramNames.nextElement();
                String[] paramValues = fu.getParameterValues(paramName);
                if (paramValues.length >= 1) {
                    String paramValue = paramValues[0];
                    //处理中文乱码
                    //paramValue = new String(paramValue.getBytes("ISO8859_1") ,"UTF-8");
                    if (paramValue.length() != 0) {
                        params.put(paramName, paramValue);
                    }
                }
            }
        }catch(Exception e){
            return params;
        }
        return params;
    }

    /**
     * 保存自由节点
     */
    private void saveFreeNode(Map<String,Object> saveFreeNodeParams) throws Exception{
        String operatorids = Util.null2String(saveFreeNodeParams.get("operatorids")).trim();
        int  SubmitToNodeid = Util.getIntValue(Util.null2String(getRequestParamValue("SubmitToNodeid")),0);
        int isToNewAddSign = Util.getIntValue(Util.null2String(saveFreeNodeParams.get("isToNewAddSign")),-1);
        /**
         * isToNewAddSign ： 2 流转下一节点 0 ： 重走上一次加签路径 1：新建加签校验必填 3：默认值无需校验必填
         */
        boolean isSubmit = "submit".equals(src) &&  SubmitToNodeid== 0;
        if (isSubmit && FreeNodeBiz.judgeNodeSimpleFreeFlow(workflowid,nodeid) && !"".equals(operatorids) && (isToNewAddSign == 1 || isToNewAddSign == 3)) {
            //新建加签路径但是设置变化过
            int attrFlag = SimpleModeFreeNodeBiz.attrChanged(saveFreeNodeParams);
            String destnodeids = SimpleModeFreeNodeBiz.freenodeids(requestid, nodeid);
            boolean delFreeNode = SimpleModeFreeNodeBiz.isPassed(requestid, nodeid, destnodeids) || attrFlag == 2;
            if (attrFlag == 0 || delFreeNode) {
                String result = SimpleModeFreeNodeBiz.saveFreeNodeSetting(saveFreeNodeParams, user,delFreeNode);
                if (result != null) {
                    setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_07);
                    setMessagecontent(result);
                    throw new Exception("生成自由节点失败");
                }
            }
        } else if (!"".equals(operatorids)) {
            String msg = new StringBuilder().append(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(10004314,weaver.general.ThreadVarLanguage.getLang())+"requestid:").append(requestid).append(",userid:").append(userid).append(",src:")
                    .append(src).append(",SubmitToNodeid:").append(SubmitToNodeid).append(",isToNewAddSign:").append(isToNewAddSign).toString();
            log.error(msg);
        }

        if((isToNewAddSign == 0 || isToNewAddSign == 2 || "".equals(operatorids)) && isremark == 0) {
            RecordSet rs = new RecordSet();
            rs.executeUpdate("delete from workflow_simpleaddsignlog where requestid  = ? and nodeid  = ? and isvalild = '0'", requestid, nodeid);
        }
    }

    private Map<String,Object> loadAddSignParams(boolean loadConfig){
        Map<String,Object> freeNodeParams = new HashMap <>();
        freeNodeParams.put("nodetype",nodetype);
        freeNodeParams.put("requestid",requestid);
        freeNodeParams.put("workflowid",workflowid);
        freeNodeParams.put("nodeid",nodeid);
        freeNodeParams.put("userid",userid);
        freeNodeParams.put("src",src);
        if(loadConfig) {
            RecordSet rs = new RecordSet();
            rs.executeQuery("select operatorids,signType,isFlowToNext,isToNewAddSign,approvalSettings from workflow_simpleaddsignlog where requestid  = ? and nodeid =? and isvalild = '0'",requestid,nodeid);
            if(rs.next()) {
                freeNodeParams.put("isToNewAddSign", Util.getIntValue(rs.getString("isToNewAddSign"), -1));
                freeNodeParams.put("isFlowToNext", rs.getString("isFlowToNext"));
                freeNodeParams.put("operatorids", Util.null2String(rs.getString("operatorids")));
                freeNodeParams.put("signType", Util.null2String(rs.getString("signType")));
                freeNodeParams.put("approvalSettings", Util.null2String(rs.getString("approvalSettings")));
            }
        } else {
            freeNodeParams.put("isToNewAddSign", Util.getIntValue(getRequestParamValue("isToNewAddSign"), -1));
            String isFlowToNext = getRequestParamValue("isFlowToNext");
            if (FreeNodeBiz.isFreeNode(nodeid) || FreeNodeBiz.isFreeFlow(workflowid)) {
                isFlowToNext = "1";
            }
            freeNodeParams.put("isFlowToNext", isFlowToNext);
            freeNodeParams.put("operatorids", getRequestParamValue("operatorids"));
            freeNodeParams.put("signType", getRequestParamValue("countersignAttribute"));
            freeNodeParams.put("approvalSettings", getRequestParamValue("approvalSettings"));
        }
        return freeNodeParams;
    }


    /**
     * 检查ID是否被删除
     * @param delIds	已删除列表
     * @param id		检查的ID
     * @return
     */
    private boolean checkIdDel(String delIds, String id) {
        if(delIds!=null && !delIds.equals("")) {
            List list = Util.TokenizerString(delIds, ",");
            for(int i=0; i<list.size(); i++) {
                if(list.get(i).toString().equals(id)) {
                    return false;
                }
            }
        }
        return true;
    }
    /**
     * 请求流到下一个节点
     * @return 是否流到下一个节点
     */
    public boolean  flowNextNode() {
        // 节点字段校验
        if(!conformCheck()){
            return false;
        }

        boolean needAddOvertimeTask = false;//是否需要添加超时处理任务
        //防止流程创建文档不进行赋权。
        if(requestCheckAddinRulesList.size() == 0){
            requestCheckAddinRulesMap=new HashMap();
            requestCheckAddinRulesMap.put("objId",""+nodeid);
            requestCheckAddinRulesMap.put("objType","1");// 1: 节点自动赋值 0 :出口自动赋值
            requestCheckAddinRulesMap.put("isPreAdd","0");
            requestCheckAddinRulesList.add(requestCheckAddinRulesMap);
        }

        //计算流转方式
        String flowToNextFreeNode = Util.null2String(getRequestParamValue("flowToNextFreeNode"));
        int extendnodeid  = FreeNodeBiz.getExtendNodeId(requestid,nodeid);
        RecordSet rs=new RecordSet();
        RecordSet rs1=new RecordSet();
        RecordSet rs2=new RecordSet();
        RecordSet rs3=new RecordSet();
        RecordSet rs4=new RecordSet();

        requestFlowInfoEntity.setRequestid(requestid);
        requestFlowInfoEntity.setWorkflowid(workflowid);
        requestFlowInfoEntity.setOperator(user.getUID());
        requestFlowInfoEntity.setLogType(src);
        requestFlowInfoEntity.setNodeid(nodeid);


        //---------------------------------------------------------------------------------------------------
        // 用于线程同步，防止同一节点操作人重复提交
        // 当方法：flownextnode开始执行时，会将当前节点的请求放入application变量(GCONST.WFProcessing)中
        // 当前节点的其他操作人，必须等待application变量(GCONST.WFProcessing)中没有当前请求时，才可以继续执行
        // application变量(GCONST.WFProcessing)中的当前请求会在方法：flownextnode执行完毕后清除
        // 此方法必须保证在执行完成后，从GCONST.WFProcessing中清除当前请求！
        //---------------------------------------------------------------------------------------------------
        //初始化操作日志对象
        RequestOperationLogManager rolm = null;
        try {
            removeErrorMsg();
            ConnStatement statement = null;
            ArrayList poppuplist=new ArrayList();
            //add by liaodong for qc76119,76120,54194,64652 start
            String penetrateFlag = "";
            String lastNodeId = "";
            int flowNextLinkId = -1;
            //end
            //add by liaodong for qc48451 in 2013年10月21日 start
            boolean isfixbill = false;
            //end
            WFForwardManager wffm=new WFForwardManager();
            WFCoadjutantManager wfcm=new WFCoadjutantManager();
            wffm.init();
            wffm.setWorkflowid(workflowid);
            wffm.setNodeid(nodeid);
            wffm.setIsremark(""+isremark);
            wffm.setRequestid(requestid);
            wffm.setBeForwardid(RequestKey);
            wffm.getWFNodeInfo();
            IsBeForwardPending=wffm.getIsBeForwardPending();
            IsSubmitedOpinion=wffm.getIsSubmitedOpinion();
            IsBeForwardModify=wffm.getIsBeForwardModify();
            IsBeForwardSubmit = wffm.getIsBeForwardSubmit();
            rs.executeSql("select groupdetailid,agentorbyagentid from workflow_currentoperator where id="+RequestKey);
            if(rs.next()){
                wfcm.getCoadjutantRights(rs.getInt("groupdetailid"));
                coadispending=wfcm.getIspending();
                coadismodify=wfcm.getIsmodify();
                coadsigntype = wfcm.getSigntype();
                this.setBeAgenter(rs.getInt("agentorbyagentid"));
            }
            // add by liaodong for qc48451 in 2013年10月21日 start
            String  fixbillSql = "select * from workflow_bill  where id >0 and id= "+formid;
            rs.executeSql(fixbillSql);
            if(rs.next()){
                isfixbill = true;
            }
            //end
            try{
                rs.execute("select isvalid from workflow_base where id="+workflowid);
                if(rs.next()){
                    int isvalid_t = Util.getIntValue(rs.getString("isvalid"), 0);
                    if(isvalid_t == 2){
                        istest = 1;
                    }
                }
            }catch(Exception e){}

            //协办人条件 65537 yl
            String sqlll = "select  distinct wp.ispending,wp.ismodify,wp.issubmitdesc,wp.isforward,wc.userid,wp.signtype from workflow_groupdetail wp,workflow_currentoperator wc where wp.id = wc.groupdetailid and wc.requestid = "+requestid+" and IsCoadjutant='1' and wc.isremark ='7'";

            rs.executeSql(sqlll);
            ArrayList<String> isforwards = new ArrayList();//协办人是否可以转发
            ArrayList<String> coadispendings = new ArrayList(); //协办人是否一直待办
            ArrayList<String> coadismodifys = new ArrayList();//协办人是否可以修改
            ArrayList<String> isSubmitedOpinions = new ArrayList();//协办人是否可以提交
            ArrayList<String> userids = new ArrayList();//协办人组
            ArrayList<String> coadsigntypes = new ArrayList();//协办人会签条件
            while(rs.next()){
                if("2".equals(rs.getString(6)) && "0".equals(rs.getString(3))){//如果协办人关系是不影响流程流转且没有勾选仅能在主办人提交前提交，则默认它为为查看始终停留在待办
                    coadispendings.add("1");
                }else{
                    coadispendings.add(rs.getString(1));
                }
                coadismodifys.add(rs.getString(2));
                isSubmitedOpinions.add(rs.getString(3));
                isforwards.add(rs.getString(4));
                userids.add(rs.getString(5));
                coadsigntypes.add(rs.getString(6));
            }

            String isfeedback="";
            String isnullnotfeedback="";
            rs.executeSql("select t.isfeedback,t.isnullnotfeedback,t1.nodeattribute from workflow_flownode t, workflow_nodebase t1  where t.nodeid = t1.id and t.workflowid="+workflowid+" and t.nodeid="+extendnodeid);
            if(rs.next()){
                isfeedback=Util.null2String(rs.getString("isfeedback"));
                isnullnotfeedback=Util.null2String(rs.getString("isnullnotfeedback"));
                nodeattribute = Util.getIntValue(rs.getString("nodeattribute"), 0);
                if(FreeNodeBiz.isFreeNode(nodeid)) nodeattribute = 0;
            }
            boolean needFeedBack = RequestBaseBiz.needFeedBack(workflowid,extendnodeid,remark);
            if(isremark==7&&"2".equals(coadsigntype)){
                tempsrc = src;
                src="save";
            }
            //重新对billid赋值
            getBillId();

            //由request或fu获得needwfback的值。如没有，则默认为1（需反馈）TD9144
            if(needwfback==null || "".equals(needwfback)){
                if(isRequest){
                    if(request!=null){
                        needwfback = ""+Util.getIntValue(request.getParameter("needwfback"), 1);
                    }
                }else{
                    if(fu!=null){
                        needwfback = ""+Util.getIntValue(fu.getParameter("needwfback"), 1);
                    }
                }
            }
            String cnodetype="";
            ArrayList operatorsWfEnd = new ArrayList(); //xwj for td3450 20060111
            boolean haspassthisnode = false;

            //提交节点, 记录已经完成的操作组ID集合，当流程不可以流向下一节点时，更新该操作组的其他人员
            String finishndgpids = "";

            ArrayList tempusers=new ArrayList();
            ArrayList tempusersType=new ArrayList();
            String groupdetailids="";
            String groupdetailid4sql = "";
            ArrayList submituserids=new ArrayList();
            ArrayList submitusertypes=new ArrayList();
            canflowtonextnode=true;
            coadcansubmit=true;
            showcoadjutant=false;
            /**
             * added by cyril on 2008-07-29 for td:8835
             * 检查流程状态
             */
            StringBuffer s = new StringBuffer();
            s.append("select t1.ismodifylog, t2.status, t2.currentnodetype,t1.isAutoApprove,t1.isAutoCommit,t1.isAutoRemark from workflow_base t1, workflow_requestbase t2 where t1.id=t2.workflowid and t2.requestid="+requestid);
            executesuccess = rs.executeSql(s.toString());
            if (!executesuccess) {
                writeLog(s.toString());
                saveRequestLog("1");
                return false;
            }
            String tempcurrentnodetype = "";
            if(rs.next()) {
                isTrack = (rs.getString("ismodifylog")!=null && "1".equals(rs.getString("ismodifylog")));
                isStart = (rs.getString("status")!=null && !"".equals(rs.getString("status")));
                tempcurrentnodetype = Util.null2String(rs.getString("currentnodetype"));
                //System.out.println("isStart="+isStart);

                this.setIsAutoApprove(Util.null2s(rs.getString("isAutoApprove"), "0"));
                this.setIsAutoCommit(Util.null2s(rs.getString("isAutoCommit"), "0"));
                this.setIsAutoRemark(Util.null2s(rs.getString("isAutoRemark"), "1"));
            }
            /**
             * end by cyril on 2008-07-29 for td:8835
             */
            //add by xhheng @20050303 for TD 1545
            //批量提交时将不调用saveRequestInfo()函数，故需要再此重新获取billtablename值，以便单据节点的正确寻找
            if (isbill == 1) {
                rs.executeSql("select tablename from workflow_bill where id = " + formid); // 查询工作流单据表的信息
                if (rs.next())
                    billtablename = rs.getString("tablename");          // 获得单据的主表
                else {
                    WriteSubmitErrorLog();
                    return false;
                }
            }

            if(!"1".equals(this.iscreate)) {
                boolean isFilterNode = false;
                rs.executeQuery("select value from workflow_config where name = 'filter_submit_nodes'");
                if (rs.next()) {
                    String filterNodes = Util.null2String(rs.getString(1));
                    String[] nodeIdArr = filterNodes.split(",");
                    String currentNodeId = nodeid+"";
                    for (String nodeId : nodeIdArr) {
                        if (nodeId.equals(currentNodeId)){
                            isFilterNode = true;
                            break;
                        }
                    }
                }
                int sleepsum = 0;
                while (true) {
                    if (GCONST.WFProcessing.indexOf(requestid + "_" + nodeid) == -1||isFilterNode) {
                        break;
                    } else {
                        try {
                            Thread.sleep(1000);   //等待1秒钟
                            sleepsum++;
                            if (sleepsum > 1000) {
                                GCONST.WFProcessing.remove(requestid + "_" + nodeid);
                                this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_03);  //等待1000秒后流程流转失败,提示：流程流转超时，请重试。
                                return false;
                            }
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }
                }
            }
            GCONST.WFProcessing.add(requestid+"_"+nodeid);
            //writeLog("isremark:"+isremark);
            // 查询下一个节点
            RecordSetTrans rst=new RecordSetTrans();
            rst.setAutoCommit(false);
            SetRsTrans(rst);
            //出发子流程
            ArrayList nodeidList_sub = new ArrayList();
            ArrayList triggerTimeList_sub = new ArrayList();
            //触发日程
            ArrayList nodeidList_wp = new ArrayList();
            ArrayList createTimeList_wp = new ArrayList();

            //是否重新计算相关资源的共享权限，只有流程流转至下一节点时，才进行计算
            boolean isReCalculatePermission = false;;
            try{
                // 查询当前请求的一些基本信息
                rst.executeProc("workflow_Requestbase_SByID", requestid + "");
                if (rst.next()) {
                    lastnodeid = Util.getIntValue(rst.getString("lastnodeid"), 0);
                    lastnodetype = Util.null2String(rst.getString("lastnodetype"));
                    passedgroups = Util.getIntValue(rst.getString("passedgroups"), 0);
                    totalgroups = Util.getIntValue(rst.getString("totalgroups"), 0);
                    creater = Util.getIntValue(rst.getString("creater"), 0);
                    creatertype = Util.getIntValue(rst.getString("creatertype"), 0);
                    requestmark = Util.null2String(rst.getString("requestmark"));
                    cnodetype=Util.null2String(rst.getString("currentnodetype"));
                    oldformsignaturemd5 = Util.null2String(rst.getString("formsignaturemd5"));
                    //防止开启出口提示信息文档等丢失
                    if("1".equals(isFirstSubmit)){
                        docids = Util.null2String(rst.getString("docids"));
                        crmids = Util.null2String(rst.getString("crmids"));
                        hrmids = Util.null2String(rst.getString("hrmids"));
                        prjids = Util.null2String(rst.getString("prjids"));
                        cptids = Util.null2String(rst.getString("cptids"));
                    }
                } else {
                    WriteSubmitErrorLog();
                    saveRequestLog("1");
                    if(rst!=null){
                        new Exception(RequestManager.ERROR_NOTFOUND_G).printStackTrace();
                        rst.rollback();
                    }
                    this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_01);
                    return false;
                }
                if (isMakeOperateLog) {
                    //初始化日志对象， 记录初始数据
                    rolm = new RequestOperationLogManager(this);
                    rolm.setLastNodetype(Util.getIntValue(tempcurrentnodetype,-1));
                    if(this.takisremark == 2){
                        rolm.setSrc(RequestOperateTypeEnum.TAKEREPLY.getId());
                    }else if(this.isremark == 1){
                        rolm.setSrc(RequestOperateTypeEnum.FORWARDREPLY.getId());
                    }
                    rolm.flowTransStartBefore();
                }

                if(!isAgent) {
                    agentId = RequestOperationBiz.judgeAgentOperation(requestid, nodeid, userid, usertype);
                    isAgent = agentId > 0;
                }

                if (src.equals("submit") || src.equals("reject") || src.equals("reopen") || src.equals("intervenor")) {
                    // 如果是提交节点, 查询通过了的组数
                    int copnodeid=nodeid;
                    int submitgroups=0;
                    int totalunsubmitgroups=0;

                    if (src.equals("submit")) {

                        if (!isOneVoteApprove) {


                            //6 自动批准
                            String tempisremark = " (isremark = '0' or isremark = '6') ";
                            if (coadsigntype.equals("0")) {
                                tempisremark = "(isremark = '0' or isremark = '6' or isremark = '7')";
                            } else if (coadsigntype.equals("1")) {
                                int signorder = 0;
                                tempisremark = "(isremark = '0' or isremark = '6' or isremark = '7')";
                                rs.executeSql("select signorder from workflow_groupdetail where id=" + wfcm.getGroupdetailid());
                                if (rs.next()) signorder = Util.getIntValue(rs.getString("signorder"), 0);
                                if (isremark == 0) {   //未操作者
                                    //查询协办人是否已提交
                                    rs.executeSql("select 1 from workflow_currentoperator where isremark = '7' and requestid=" + requestid + " and nodeid=" + nodeid + " and exists(select 1 from workflow_coadjutant where coadjutantid=workflow_currentoperator.id and organizedid=" + RequestKey + " and requestid=" + requestid + ")");
                                    if (rs.next()) coadcansubmit = false;
                                    if (wfcm.getSignorder() == 2 && coadcansubmit == false)
                                        coadcansubmit = true; //如果是依次处理并且协办人没有提交
                                } else if (isremark == 7) {  //协办人
                                    //查询主办人是否存在未提交
                                    rs.executeSql("select 1 from workflow_currentoperator where isremark = '0' and requestid=" + requestid + " and nodeid=" + nodeid + " and exists(select 1 from workflow_coadjutant where organizedid=workflow_currentoperator.id and coadjutantid=" + RequestKey + " and requestid=" + requestid + ")");
                                    if (rs.next()) coadcansubmit = false;
                                    if (signorder == 0) {
                                        rs.executeSql("select 1 from workflow_currentoperator where isremark = '2' and preisremark='0' and (isreject is null or isreject=0) and requestid='" + requestid + "' and nodeid='" + nodeid + "' and groupdetailid ='" + wfcm.getGroupdetailid() + "'");
                                        if (rs.next()) coadcansubmit = true;
                                    }
                                }
                            }
                            if (coadcansubmit) {


                                //为了兼容部分老客户，此处做了分支处理，可以通过修改配置文件来配置程序流转的逻辑
                                //else部分的逻辑不再维护，修改此处逻辑时，请注意！
                                if (!isExeOldFlowlogic) {
                                    Map<String, Object> flownodeInfo = isFlowNextNode(this.requestid, nodeid, isremark, userid, usertype, rst, tempisremark, wfcm);

                                    copnodeid = (Integer) flownodeInfo.get("copnodeid");
                                    finishndgpids = (String) flownodeInfo.get("finishndgpids");
                                    groupdetailids = (String) flownodeInfo.get("groupdetailids");
                                    groupdetailid4sql = (String) flownodeInfo.get("groupdetailid4sql");
                                    passedgroups = (Integer) flownodeInfo.get("passedgroups");
                                    submitgroups = (Integer) flownodeInfo.get("submitgroups");
                                    totalunsubmitgroups = (Integer) flownodeInfo.get("totalunsubmitgroups");
                                } else {
                                    //-----------------------------------------------------
                                    // 注意：此case中为老的逻辑不再维护 START
                                    //-----------------------------------------------------


                                    rst.executeSql("select count(distinct groupid) from workflow_currentoperator where " + tempisremark + " and requestid=" + requestid + " and userid=" + userid + " and usertype=" + usertype + " and nodeid=" + nodeid);
                                    if (rst.next()) {
                                        passedgroups += Util.getIntValue(rst.getString(1), 0);
                                        submitgroups = Util.getIntValue(rst.getString(1), 0);
                                    }
                                    // 如果是提交节点, 查询当前用户提交组数和总共的未提交组数
                                    rst.executeSql("select nodeid from workflow_currentoperator where " + tempisremark + " and requestid=" + requestid + " and userid=" + userid + " and usertype=" + usertype + " and nodeid=" + nodeid + " order by id desc");
                                    if (rst.next()) {
                                        copnodeid = Util.getIntValue(rst.getString(1), 0);
                                    } else {
                                        rst.executeSql("select nodeid from workflow_currentoperator where " + tempisremark + " and requestid=" + requestid + " and userid=" + userid + " and usertype=" + usertype + " order by id desc");
                                        if (rst.next()) copnodeid = Util.getIntValue(rst.getString(1), 0);
                                    }

                                    //rst.executeSql("select count(distinct groupid) from workflow_currentoperator where "+tempisremark+" and requestid=" + requestid +" and nodeid="+nodeid);
                                    //if (rst.next()) totalunsubmitgroups = Util.getIntValue(rst.getString(1), 0);

                                    //查询当前节点是否存在协办人，如果存在则按协办人条件进行判断（当存在协办人时，主办人不再局限于部门的人员而是整个节点操作组都将是主办人）
                                    rst.executeSql("select groupdetailid from workflow_currentoperator where (isremark='7' or preisremark='7') and requestid='" + requestid + "' and nodeid='" + nodeid + "' and groupdetailid='" + wfcm.getGroupdetailid() + "'");
                                    if (rst.next() && (isremark == 0 || isremark == 7)) {
                                        totalunsubmitgroups = wfcm.getTotalnumSubmitGroups(isremark, nodeid, requestid, userid, rst);
                                    } else {
                                        rst.executeSql("select count(distinct groupid) from workflow_currentoperator where " + tempisremark + " and requestid=" + requestid + " and nodeid=" + nodeid);
                                        if (rst.next()) {
                                            totalunsubmitgroups = Util.getIntValue(rst.getString(1), 0);
                                        }
                                    }
                                    //		    				if(coadsigntype.equals("0")){
                                    //		        				rst.executeSql("select count(distinct groupid) from workflow_currentoperator where "+tempisremark+" and requestid=" + requestid +" and nodeid="+nodeid+" and not exists(select * from workflow_currentoperator b where b.groupid=workflow_currentoperator.groupid and (b.preisremark = '0' or b.preisremark = '7')  and b.isremark='2'and b.requestid=" + requestid +" and b.nodeid="+nodeid+")");
                                    //		        				if (rst.next()){
                                    //		        					totalunsubmitgroups = Util.getIntValue(rst.getString(1), 0);
                                    //		        				}
                                    //		    				}else{
                                    //		        				rst.executeSql("select count(distinct groupid) from workflow_currentoperator where "+tempisremark+" and requestid=" + requestid +" and nodeid="+nodeid);
                                    //		        				if (rst.next()){
                                    //		        					totalunsubmitgroups = Util.getIntValue(rst.getString(1), 0);
                                    //		        				}
                                    //		    				}


                                    //判断该人所在组是否含有依次逐个递交的组，如果有一个，则passedgroups-1，并且进入得到下个操作者的方法
                                    rst.execute("select distinct groupdetailid,groupid from workflow_currentoperator where " + tempisremark + " and requestid=" + requestid + " and userid=" + userid + " and usertype=" + usertype + " and nodeid=" + nodeid);

                                    while (rst.next()) {
                                        rs2.execute("select * from workflow_groupdetail where id=" + rst.getInt("groupdetailid"));
                                        if (rs2.next()) {
                                            int type = rs2.getInt("type");
                                            int signorder = rs2.getInt("signorder");
                                            if (WFPathUtil.isContinuousProcessing(type) && signorder == 2 && isremark != 7)
                                            //update by 	84163
                                            {    //判断是否还有剩余节点
                                                rs3.execute("select * from workflow_agentpersons where requestid=" + requestid + " and (groupdetailid=" + rst.getInt("groupdetailid") + " or groupdetailid is null)");
                                                if (rs3.next() && !rs3.getString("receivedPersons").equals("")) {
                                                    passedgroups--;
                                                    submitgroups--;
                                                    groupdetailids = groupdetailids.equals("") ? rst.getString("groupdetailid") + "_" + rst.getString("groupid") : groupdetailids + "," + rst.getString("groupdetailid") + "_" + rst.getString("groupid");
                                                    groupdetailid4sql = groupdetailid4sql.equals("") ? rst.getString("groupdetailid") : groupdetailid4sql + "," + rst.getString("groupdetailid");
                                                }
                                            }

                                        }
                                    }

                                    //-----------------------------------------------------
                                    // 注意：此case中为老的逻辑不再维护 END
                                    //-----------------------------------------------------
                                }

                            }
                        }
                    }
                    //提交时是否可流转下一节点
                    boolean tempCanFlowToNextNode = src.equals("submit") && (nodeid > 0 && submitgroups >= totalunsubmitgroups && copnodeid==nodeid&&coadcansubmit);
                    if(FreeNodeBiz.isFreeNode(nodeid)) {
                        FreeNodeGroupEntity groupEntity = FreeNodeBiz.getCurrentNodeGroup(requestid,nodeid);
                        if(groupEntity != null && groupEntity.isNodeElement()) {
                            tempCanFlowToNextNode = !RequestFreeNodeFlowBiz.currentNodeHaveNoUnoperated(groupEntity, requestid, user);
                        } else {
                            tempCanFlowToNextNode = true;
                        }
                    }
                    if(tempCanFlowToNextNode && !(isSelectNextFlow && !"".equals(selectNodeFlowNodeIds))) {
                        Map<String,Object> saveFreeNodeParams = loadAddSignParams(true);
                        int isToNewAddSign = Util.getIntValue(Util.null2String(saveFreeNodeParams.get("isToNewAddSign")),-1);
                        //重新添加分支 、重走分叉 、第一次添加分叉
                        if (isToNewAddSign == 1 ||isToNewAddSign == 0) flowToNextFreeNode = "1";
                        if (isToNewAddSign == 2) flowToNextFreeNode ="2";
                        saveFreeNode(saveFreeNodeParams);
                    }
                    freeNodeFlowBiz = new RequestFreeNodeFlowBiz(user,requestid,nodeid);
                    freeNodeFlowBiz.setFlowToNextFreeNode("1".equals(Util.null2String(flowToNextFreeNode)));
                    // 只对可以通过的提交节点和拒绝节点查询下一个节点

                    boolean freeNodeCanFlowToNext = false;
                    if(FreeNodeBiz.isFreeNode(nodeid) && src.equals("submit")) {
                        try {
                            freeNodeCanFlowToNext = freeNodeFlowBiz.canFlowToNextNode();
                        }catch (Exception e) {
                            e.printStackTrace();
                            this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_07);
                            this.setMessagecontent(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(10004315,weaver.general.ThreadVarLanguage.getLang())+"");
                            if(rst!=null){
                                rst.rollback();
                            }
                            return false;
                        }
                    }
                    if ((src.equals("submit") && ((nodeid > 0 && submitgroups >= totalunsubmitgroups && copnodeid==nodeid&&coadcansubmit) || freeNodeCanFlowToNext )) || src.equals("reject") || src.equals("reopen") || isremark==5|| src.equals("intervenor") || (src.equals("submit") && isOneVoteApprove)) {
                        showcoadjutant=true;
                        int isreject = 0;
                        int isreopen = 0;
                        int linkid = 0;
                        String newRejectNodeIds = "";
                        if (src.equals("reject")){
                            isreject = 1;

                            if(RejectToType <= 0 && !(this.RejectToNodeid > 0 || FreeNodeBiz.isFreeNode(this.RejectToNodeid))) {
                                RejectToNodeid = Util.getIntValue(getRequestParamValue("RejectToNodeid"));
                                RejectToType = Util.getIntValue(getRequestParamValue("RejectToType"));
                                newRejectNodeIds = Util.null2String(getRequestParamValue("newRejectNodeIds"));
                            }
                        }else if("submit".equals(src)) {
                            if(!(this.SubmitToNodeid > 0 ||FreeNodeBiz.isFreeNode(this.SubmitToNodeid))&&!doAutoApprove) {
                                this.SubmitToNodeid = Util.getIntValue(getRequestParamValue("SubmitToNodeid"),0);

                                if (isFromWebservice) {
                                    this.SubmitToNodeid = new SubmitToNodeBiz().getSubmitToNodeId(requestid, workflowid, nodeid);
                                }
                            }
                        }
                        else if (src.equals("reopen")) isreopen = 1;
                        requestFlowInfoEntity.setSubmitToRejectNode(SubmitToNodeid > 0  || FreeNodeBiz.isFreeNode(SubmitToNodeid));
                        if(isremark!=5 && !src.equals("intervenor")){
                            //注意：requestNodeFlow.getNextNodes()方法之前不能通过rst修改workflow_currentoperator表的数据，不然会死锁。
                            // 查询下一个节点的操作者
                            RequestNodeFlow requestNodeFlow = new RequestNodeFlow();
                            requestNodeFlow.setRequestid(requestid);
                            requestNodeFlow.setNodeid(nodeid);
                            requestNodeFlow.setNodetype(nodetype);
                            requestNodeFlow.setWorkflowid(workflowid);
                            requestNodeFlow.setUserid(userid);
                            requestNodeFlow.setUsertype(usertype);
                            requestNodeFlow.setLanguageid(this.userlanguage);
                            requestNodeFlow.setCreaterid(creater);
                            requestNodeFlow.setCreatertype(creatertype);
                            requestNodeFlow.setFormid(formid);
                            requestNodeFlow.setIsbill(isbill);
                            requestNodeFlow.setBillid(billid);
                            requestNodeFlow.setBilltablename(billtablename);
                            requestNodeFlow.setIsreject(isreject);
                            requestNodeFlow.setIsreopen(isreopen);
                            requestNodeFlow.setRejectToNodeid(RejectToNodeid);
                            requestNodeFlow.setRejectToType(RejectToType);
                            requestNodeFlow.setSubmitToNodeid(this.SubmitToNodeid);
                            requestNodeFlow.setNewRejectNodeids(newRejectNodeIds);
                            requestNodeFlow.setRecordSet(rs);
                            requestNodeFlow.setUser(user);
                            requestNodeFlow.setRecordSetTrans(rst);
                            requestNodeFlow.setIsFromRequestManager(1);
                            //add by liaodong for qc48451 in 2013年10月21日 start
                            requestNodeFlow.setIsfixbill(isfixbill);
                            //end
                            // add by liaodong for qc86096 in 2013-11-19 start
                            requestNodeFlow.setCurrentdate(currentdate);
                            requestNodeFlow.setCurrenttime(currenttime);
                            //end
                            requestNodeFlow.setEh_operatorMap(eh_operatorMap);
                            requestNodeFlow.setTonextnode(true);
                            requestNodeFlow.setFreeNodeFlowBiz(freeNodeFlowBiz);
                            requestNodeFlow.setSelectNextFlow(isSelectNextFlow);
                            requestNodeFlow.setSelectNextFlowMode(selectNextFlowMode);
                            requestNodeFlow.setReqFailMsg(reqFailMsg);
                            //指定流转前台用户选择节点模式，传入选择的节点列表
                            //if (selectNextFlowMode == SelectNextFlowMode.NODE_ONLY) {
                                requestNodeFlow.setSelectNextFlowNodeList(this.generateSelectFlowNodeList(selectNodeFlowNodeIds));
                            //}
                            //计算节点操作者

							String clientIp = "";
                            if(isRequest){
                                if (request != null)
                                    clientIp = Util.null2String(request.getRemoteAddr());
                            }else{
                                if (fu != null)
                                    clientIp = Util.null2String(fu.getRemoteAddr());
                            }
                            requestNodeFlow.setClientIp(clientIp);
                            requestNodeFlow.setRequestFlowLogEntity(requestFlowLogEntity);

                            requestNodeFlow.getNextNodes();
                            this.nextnodeids=requestNodeFlow.getNextnodeids();
                            this.nextnodetypes=requestNodeFlow.getNextnodetypes();
                            this.nextlinkids=requestNodeFlow.getNextlinkids();
                            this.nextlinknames=requestNodeFlow.getNextlinknames();
                            this.operatorshts=requestNodeFlow.getOperatorshts();
                            this.nextnodeattrs=requestNodeFlow.getNextnodeattrs();
                            this.nextnodepassnums=requestNodeFlow.getNextnodepassnums();
                            this.linkismustpasss=requestNodeFlow.getLinkismustpasss();
                            this.requestexceptiontypes = requestNodeFlow.getRequestexceptiontypes();
                            this.hasEflowToAssignNode = requestNodeFlow.isHasEflowToAssignNode();
                            this.hasCoadjutant = requestNodeFlow.isHasCoadjutant();
                            //System.out.println("nextnodeidsize:"+nextnodeids.size());
                            //add by liaodong for qc76119,76120,54194,64652 start
                            penetrateFlag = requestNodeFlow.getPenetrateId();
                            lastNodeId = requestNodeFlow.getLastNodeId();
                            flowNextLinkId = requestNodeFlow.getNextLinkid();

                            //前台用户指定下一节点流转
                            //if (isSelectNextFlow && selectNextFlowMode == SelectNextFlowMode.NODE_AND_OPERATOR && !"".equals(this.selectNodeFlowNodeIds)) {
                            //    this.setSelectNextFlowInfo(requestNodeFlow);
                            //}

                            //end
                            if (nextnodeids.size()<1) {
                                if(reqFailMsg.getMsgType() == null) reqFailMsg.setMsgType(ReqFlowFailMsgType.NODE_NODE_FOUND_OPERATOR);
                                WriteSubmitErrorLog();
                                saveRequestLog("1");
                                if(rst!=null){
                                    new Exception(RequestManager.ERROR_NOTFOUND_NNL).printStackTrace();
                                    rst.rollback();
                                }
                                this.isNeedChooseOperator = requestNodeFlow.isNeedChooseOperator();
                                if(!this.isNeedChooseOperator){
                                    this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_07);
                                }else{
                                    this.nextnodeid = requestNodeFlow.getNextNodeid();
                                }
                                this.setMessagecontent(requestNodeFlow.getMessagecontent());
                                return false;
                            }else{
                                //异步提交流程
                                if(request!=null) {
                                    boolean isAsynchronousSubmit = "1".equals(getRequestParamValue("isAsynchronousSubmit"));
                                    if ("0".equals(isFirstSubmit) && !isAsynchronousSubmit) {
                                        String returnvalue = "";
                                        for (int i = 0; i < nextlinkids.size(); i++) {
                                            String viewNodeIdSQL = "select tipsinfo from workflow_nodelink where id=" + nextlinkids.get(i);
                                            if (RejectToNodeid > 0) {
                                                viewNodeIdSQL += " and  destnodeid=" + RejectToNodeid;
                                            }
                                            rst.executeSql(viewNodeIdSQL);
                                            if (rst.next()) {
                                                String tipsinfo = Util.null2String(rst.getString("tipsinfo"));
                                                if ("".equals(tipsinfo.trim()))
                                                    continue;
                                                if (!"".equals(returnvalue))
                                                    returnvalue += "\\n";
                                                returnvalue += tipsinfo;
                                            }
                                        }

                                        if (!"".equals(returnvalue)) {
                                            this.setMessage(WorkflowRequestMessage.WF_CUSTOM_LINK_TIP);
                                            this.setMessagecontent(returnvalue);
                                            WriteSubmitErrorLog();
                                            rst.rollback();
                                            return false;
                                        }
                                    }
                                }
                            }
                            wflinkinfo.setSrc(src);
                            wflinkinfo.setSubmitToNodeid(this.SubmitToNodeid);
							wflinkinfo.setSelectNextFlow(isSelectNextFlow);
                            for(int i=0;i<nextnodeids.size();i++){
                                nextnodeid = Util.getIntValue((String)nextnodeids.get(i));
                                nextnodetype = (String)nextnodetypes.get(i);
                                linkid = Util.getIntValue((String)nextlinkids.get(i));
                                status = (String)nextlinknames.get(i);
                                operatorsht = (Hashtable)operatorshts.get(i);
                                nextnodeattr=Util.getIntValue((String)nextnodeattrs.get(i));
                                totalgroups = operatorsht.size();
                                if(nextnodeattr==3||nextnodeattr==4||nextnodeattr==5) {
                                    canflowtonextnode=wflinkinfo.FlowToNextNode(requestid,nodeid,nextnodeid,nextnodeattr+"",Util.getIntValue((String)nextnodepassnums.get(i)),Util.getIntValue((String)linkismustpasss.get(i)));
                                    //自动批准时当所有分支都满足自动审批时，并且 已经满足了合并。将自动流转遍历器游标拉倒最后，并且更新数据为2
                                    if(canflowtonextnode && !this.autoApproveQueue.isEmpty()) {
                                        AutoApproveParams autoApproveParams1;
                                        while (!this.autoApproveQueue.isEmpty()) {
                                            autoApproveParams1 = (AutoApproveParams) autoApproveQueue.poll();
                                            rst.executeUpdate("update workflow_currentoperator set isremark='2',viewtype = '-2',operatedate='"+this.currentdate+"', operatetime='"+this.currenttime+"' where isremark='6' and requestid=? and userid=? and nodeid=?",requestid,autoApproveParams1.getUserid(), autoApproveParams1.getNodeid());
                                        }

                                    }
                                }
                                //System.out.println("nextnodeid="+nextnodeid+" nextnodeattr="+nextnodeattr+" canflowtonextnode:"+canflowtonextnode);
                                haspassthisnode = true;

                                // 查询当前请求的一些基本信息
                                rst.executeProc("workflow_Requestbase_SByID", requestid + "");
                                if (rst.next()) {
                                    requestmark = Util.null2String(rst.getString("requestmark"));
                                } else {
                                    WriteSubmitErrorLog();
                                    saveRequestLog("1");
                                    if(rst!=null){
                                        new Exception(RequestManager.ERROR_NOTFOUND_G).printStackTrace();
                                        rst.rollback();
                                    }
                                    return false;
                                }


                                // 查询下一个节点的超时设置
                                rst.executeProc("workflow_NodeLink_SPasstime", "" + nextnodeid + flag + "0");
                                if (rst.next()){
                                    nodepasstime = Util.getFloatValue(rst.getString("nodepasstime"), -1);
                                }
                            }

                            if(nextnodeids.size() > 1 && FreeNodeBiz.isFreeNode(nextnodeid)) {
                                //status =  SystemEnv.getHtmlLabelName(83284,userlanguage);
                                status = LabelUtil.getMultiLangLabel("83284");
                            }
                        }
                        else{
                            if("".equals(this.submitNodeId)) {
                                submitNodeId = Util.null2String(getRequestParamValue("submitNodeId"));
                                Intervenorid=Util.null2String(getRequestParamValue("Intervenorid"));
                                IntervenoridType=Util.null2String(getRequestParamValue("IntervenoridType"));
                                SignType=Util.getIntValue(getRequestParamValue("SignType"),0);
                            }

                            ArrayList tempnodes=Util.TokenizerString(submitNodeId,"_");
                            tempusers=Util.TokenizerString(Intervenorid,",");
                            tempusersType=Util.TokenizerString(IntervenoridType,",");
                            if(tempnodes.size()>=2){
                                nextnodeid=Util.getIntValue((String)tempnodes.get(0));
                                nextnodetype=(String)tempnodes.get(1);
                                //流程干预
                                int tempnodeid  = nodeid;
                                if(FreeNodeBiz.isFreeNode(nodeid)) {
                                    List <Integer> intervenorRangeNodeIds = freeNodeFlowBiz.getIntervenorRange(requestid, nextnodeid);
                                    if(intervenorRangeNodeIds.contains(nextnodeid)) {
                                        tempnodeid = nextnodeid;
                                    } else {
                                        if(intervenorRangeNodeIds.size() > 0) {
                                            tempnodeid = intervenorRangeNodeIds.get(0);
                                        }
                                    }
                                    innodeids = CollectionUtil.list2String(intervenorRangeNodeIds,",");
                                }

                                nextnodeattr=wflinkinfo.getNodeAttribute(nextnodeid);
                                nextnodeids.add(""+nextnodeid);
                                nextnodetypes.add(nextnodetype);
                                nextnodeattrs.add(""+nextnodeattr);
                                totalgroups=tempusers.size();
                                String tmpnodeids=wflinkinfo.getBrancheNode(nextnodeid,workflowid,"",requestid);
                                if(!tmpnodeids.equals("")){
                                    rst.executeSql("select a.nodeid,b.nodetype from workflow_currentoperator a,workflow_flownode b where a.workflowid=b.workflowid and a.nodeid=b.nodeid and a.isremark='0' and a.requestid="+requestid+" and a.nodeid in("+tmpnodeids+")");
                                    if(rst.next()){
                                        nodeid=rst.getInt(1);
                                        nodetype=Util.null2String(rst.getString(2));
                                    }
                                }
                                status = WorkflowBaseBiz.getWorkflowNodeName(tempnodeid);
                                status += LabelUtil.getMultiLangLabel("516518")+WorkflowBaseBiz.getWorkflowNodeName(nextnodeid);;
                                //status += SystemEnv.getHtmlLabelName(516518,userlanguage)+WorkflowBaseBiz.getWorkflowNodeName(nextnodeid);

                                try {//记录下会签关系，以便转办多人时可以取到会签关系
                                    String insertsql = "insert into workflow_requestselectnextflow(requestid,nodeid,destnodeid,signtype,flowoperator)values(?,?,?,?,?)";
                                    rst.executeUpdate(insertsql, requestid, nodeid, nextnodeid, SignType, Intervenorid);
                                }catch(Exception e){
                                    e.printStackTrace();
                                }
                            }else{
                                WriteSubmitErrorLog();
                                if(rst!=null){
                                    new Exception(RequestManager.ERROR_NOTFOUND_SUBMITERROR).printStackTrace();
                                    rst.rollback();
                                }
                                this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_07);
                                this.setMessagecontent(WorkflowRequestMessage.resolveDetailInfo(SystemEnv.getHtmlLabelName(528841,userlanguage)));
                                return false;
                            }
                            canflowtonextnode=true;
                        }
                        //处理超时流程提醒
                        String remindusers="";
                        String usertypes="";
                        rst.executeSql("select wfreminduser,wfusertypes from workflow_currentoperator where isremark='0' and requestid="+requestid);
                        if(rst.next()){
                            remindusers=rst.getString("wfreminduser");
                            usertypes=rst.getString("wfusertypes");
                        }
                        ArrayList wfremindusers=Util.TokenizerString(remindusers,",");
                        ArrayList wfusertypes=Util.TokenizerString(usertypes,",");
                        rst.executeSql("select userid,usertype,nodeid from workflow_currentoperator where requestid="+requestid +" group by userid,usertype,nodeid");
                        while(rst.next()){
                            String tempuserid=rst.getString("userid");
                            String tempusertype=rst.getString("usertype");
                            int tempnodeid=Util.getIntValue(rst.getString("nodeid"),0);
                            if(wfremindusers.indexOf(tempuserid)<0){
                                if(nodeid == tempnodeid){
                                    wfremindusers.add(tempuserid);
                                    wfusertypes.add(tempusertype);
                                }
                            }
                        }

                        //----------------------------------------------
                        // 获取表单数据签名 start
                        //----------------------------------------------
                        String formsignaturemd5 = "";
                        try {
                            if ("submit".equals(src)) {
                                formsignaturemd5 = WFPathUtil.getFormValMD5(workflowid, requestid, isbill, formid, requestname, nextnodeid);
                            }
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                        //----------------------------------------------
                        // 获取表单数据签名 end
                        //----------------------------------------------
                        // 更新 requestbase 表信息
                        if (src.equals("submit")&&!((isremark==1||isremark==7)&&!CanModify)) {

                            // 处理编号
                            if (lastnodetype.equals("0") && requestmark.equals("")) {
                                requestmark = doRequestMark();
                            }
                            sql = " update workflow_requestbase set " +
                                    " lastnodeid = " + nodeid +
                                    " ,lastnodetype = '" + nodetype;
                            if(canflowtonextnode){
                                if(nextnodeattr==1){
                                    sql+="' ,currentnodeid = " + nextnodeid +
                                            " ,currentnodetype = '" + nextnodetype;
                                    //status = SystemEnv.getHtmlLabelName(21394,userlanguage);
                                    status = LabelUtil.getMultiLangLabel("21394");
                                }else if(nextnodeattr==2){
                                    sql+="' ,currentnodeid = " + nextnodeid +
                                            " ,currentnodetype = '" + nextnodetype;
                                    //status = SystemEnv.getHtmlLabelName(21395,userlanguage);
                                    status = LabelUtil.getMultiLangLabel("21395");
                                }else{
                                    sql+="' ,currentnodeid = " + nextnodeid +
                                            " ,currentnodetype = '" + nextnodetype;
                                }
                            }else{
                                //status = SystemEnv.getHtmlLabelName(21395,userlanguage);
                                status = LabelUtil.getMultiLangLabel("21395");
                            }
                            if (isSelectNextFlow && "".equals(status)) {
                                //status = SystemEnv.getHtmlLabelName(505769, user.getLanguage());
                                status = LabelUtil.getMultiLangLabel("505769");
                            }
                            sql+="' ,status = '" + Util.fromScreen2(status, userlanguage) + "' "+
                                    " ,passedgroups = 0" +
                                    " ,totalgroups = " + totalgroups ;
                            String fromScreen2 = Util.fromScreen2(requestname, userlanguage);
                            if(!"".equals(fromScreen2)){
                                sql+=" ,requestname = '" + fromScreen2 + "' " ;
                            }
                            if(!"".equals(requestmark)){
                                sql+=   " ,requestmark = '" + requestmark + "' " +
                                        " ,lastoperator = " + userid ;
                            }else{
                                sql+=" ,lastoperator = " + userid ;
                            }
                            if(!tempcurrentnodetype.equals("3")){//归档流程不更新lastoperatedate和lastoperatetime
                                sql = sql+
                                        " ,lastoperatedate = '" + currentdate + "' " +
                                        " ,lastoperatetime = '" + currenttime + "' " ;
                            }
                            sql = sql+
                                    " ,lastoperatortype = " + usertype +
                                    " ,nodepasstime = " + nodepasstime +
                                    " ,nodelefttime = " + nodepasstime ;

                            if(!docids.equals("")){
                                sql+=  " ,docids = '" + docids + "' " ;
                            }
                            if(!crmids.equals("")){
                                sql+=  " ,crmids = '" + crmids + "' ";
                            }
                            if(isoracle&&!hrmids.equals("")){
                                sql+=" ,hrmids = ? ";
                            }else if(!hrmids.equals("")){
                                sql+=" ,hrmids = '" + hrmids + "' ";
                            }
                            //" ,hrmids = '" + hrmids + "' " +
                            if(!prjids.equals("")) {
                                sql += " ,prjids = '" + prjids + "'";
                            }
                            if(!cptids.equals("")) {
                                sql +=" ,cptids = '" + cptids + "' ";
                            }
                            //" ,cptids = '" + cptids + "' " +
                            //" where requestid = " + requestid;
                        } else{
                            sql = " update workflow_requestbase set " +
                                    " lastnodeid = " + nodeid +
                                    " ,lastnodetype = '" + nodetype;
                            if(canflowtonextnode){
                                if(nextnodeattr==1){
                                    sql+="' ,currentnodeid = " + nextnodeid +
                                            " ,currentnodetype = '" + nextnodetype;
                                    //status = SystemEnv.getHtmlLabelName(21394,userlanguage);
                                    status = LabelUtil.getMultiLangLabel("21394");
                                }else if(nextnodeattr==2){
                                    sql+="' ,currentnodeid = " + nextnodeid +
                                            " ,currentnodetype = '" + nextnodetype;
                                    //status = SystemEnv.getHtmlLabelName(21395,userlanguage);
                                    status = LabelUtil.getMultiLangLabel("21395");
                                }else{
                                    sql+="' ,currentnodeid = " + nextnodeid +
                                            " ,currentnodetype = '" + nextnodetype;
                                }
                            }else{
                                //status = SystemEnv.getHtmlLabelName(21395,userlanguage);
                                status = LabelUtil.getMultiLangLabel("21395");
                            }
                            if (!src.equals("save")) {
                                sql+="' ,status = '" + Util.fromScreen2(status, userlanguage) + "' "+
                                        " ,passedgroups = 0" +
                                        " ,totalgroups = " + totalgroups +
                                        " ,lastoperator = " + userid ;
                            }else{
                                sql+="' ,passedgroups = 0 "+
                                        " ,totalgroups = " + totalgroups +
                                        " ,lastoperator = " + userid ;
                            }
                            if(!tempcurrentnodetype.equals("3")){//归档流程不更新lastoperatedate和lastoperatetime
                                sql = sql+
                                        " ,lastoperatedate = '" + currentdate + "' " +
                                        " ,lastoperatetime = '" + currenttime + "' " ;
                            }
                            sql = sql+
                                    " ,lastoperatortype = " + usertype +
                                    " ,nodepasstime = " + nodepasstime +
                                    " ,nodelefttime = " + nodepasstime;
                            //" ,nodelefttime = " + nodepasstime +
                            //" where requestid = " + requestid;
                        }

                        //更新签名信息
                        if (!"".equals(formsignaturemd5)) {
                            sql += ", formsignaturemd5='" + formsignaturemd5 + "' ";
                        }
                        if(needFeedBack) {
                            sql += ",lastFeedBackDate = '"+currentdate+"',lastFeedBackTime = '"+currenttime+"',lastfeedbackoperator=" + userid;
                        }
                        sql+=" where requestid = " + requestid;
                        //writeLog(" update workflow_requestbase sql is " + sql);
                        if(isoracle&&src.equals("submit")&&!((isremark==1||isremark==7)&&!CanModify)&&!("0".equals(coadismodify)&&isremark==7)){
                            if(!hrmids.equals("")) {
                                executesuccess = rst.executeUpdate(sql, new Object[]{hrmids});
                            }else{
                                executesuccess = rst.executeUpdate(sql);
                            }
                        }else{
                            executesuccess = rst.executeSql(sql);
                        }

                        if (!executesuccess) {
                            WriteSubmitErrorLog();
                            saveRequestLog("1");
                            if(rst!=null){
                                rst.rollback();
                            }
                            this.writeLog(sql);
                            this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_06);
                            this.setMessagecontent(WorkflowRequestMessage.resolveDetailInfo("流程提交，更新RequestBase出错"));
                            return false;
                        }
                        /******/

					/*if(isoracle&&src.equals("submit")&&!((isremark==1||isremark==7)&&!CanModify)){
						ConnStatement statement1 = null;
						try {
							String sql1 = "select hrmids from workflow_requestbase where requestid="+requestid+" for update";
							statement1 = new ConnStatement();
							statement1.setStatementSql(sql1, false);
			                if(statement1.next()){
				                CLOB theclob = statement1.getClob(1);
				                char[] contentchar = hrmids.toCharArray();
				                Writer contentwrite = theclob.getCharacterOutputStream();
				                contentwrite.write(contentchar);
				                contentwrite.flush();
				                contentwrite.close();
			                }
						} catch (Exception e) {
							rs.writeLog(e);
							e.printStackTrace();
						} finally {
							if(statement1!=null) statement1.close();
						}
					}
					*/
                        /******/


                        //TD9427 获得所有下一个节点的nodeid，用于查询流程生成计划任务设置	add by chuj
                        String wf_nextnodeids = "";
                        for(int n=0;n<nextnodeids.size();n++){
                            nextnodeid=Util.getIntValue((String)nextnodeids.get(n));
                            wf_nextnodeids += (""+nextnodeid+", ");		//TD9427
                            if((isremark!=5&&!src.equals("intervenor")) && enableIntervenor==1){
                                // 出口自动赋值处理
                                try {
                                    linkid=Util.getIntValue((String)nextlinkids.get(n));
                                    RequestCheckAddinRules requestCheckAddinRules = new RequestCheckAddinRules();
                                    //add by cyril on 2008-07-28 for td:8835 事务无法开启查询,只能传入
                                    requestCheckAddinRules.resetParameter();
                                    requestCheckAddinRules.setTrack(isTrack);
                                    requestCheckAddinRules.setStart(isStart);
                                    requestCheckAddinRules.setNodeid(nodeid);
                                    //end by cyril on 2008-07-28 for td:8835
                                    requestCheckAddinRules.setRequestid(requestid);
                                    requestCheckAddinRules.setWorkflowid(workflowid);
                                    requestCheckAddinRules.setObjid(linkid);
                                    requestCheckAddinRules.setObjtype(0);               // 1: 节点自动赋值 0 :出口自动赋值
                                    requestCheckAddinRules.setIsbill(isbill);
                                    requestCheckAddinRules.setFormid(formid);
                                    requestCheckAddinRules.setIspreadd("0");//xwj for td3130 20051123
                                    requestCheckAddinRules.setUser(user);//add by fanggsh 20061016 fot TD5121
                                    String clientIp = "";
                                    if(isRequest){
                                        if (request != null)
                                            clientIp = Util.null2String(request.getRemoteAddr());
                                    }else{
                                        if (fu != null)
                                            clientIp = Util.null2String(fu.getRemoteAddr());
                                    }
                                    requestCheckAddinRules.setClientIp(clientIp);//add by fanggsh 20061016 fot TD5121
                                    requestCheckAddinRules.setSrc(src);//add by fanggsh 20061016 fot TD5121
                                    requestCheckAddinRules.setRequestManager(this);
                                    requestCheckAddinRules.setPushMsgDocIds(this.pushMsgDocIds);
                                    requestCheckAddinRules.checkAddinRules();

                                    if(requestCheckAddinRules.getDoDmlResult().startsWith("-1")){
                                        if("-1".equals(requestCheckAddinRules.getDoDmlResult())){
                                            if("".equals(this.getMessage())){
                                                this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_07);
                                            }
                                            if("".equals(this.getMessagecontent())){
                                                this.setMessagecontent(WorkflowRequestMessage.resolveDetailInfo(SystemEnv.getHtmlLabelName(10000193,weaver.general.Util.getIntValue(user.getLanguage()))));
                                            }
                                        }else{
                                            this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_07);
                                            this.setMessagecontent(WorkflowRequestMessage.resolveDetailInfo(SystemEnv.getHtmlLabelName(10000194,weaver.general.Util.getIntValue(user.getLanguage()))+":"+requestCheckAddinRules.getDoDmlResult().replace("-1,", "")));
                                        }
                                        if(rst!=null)
                                            rst.rollback();

                                        reqFailMsg.setMsgType(ReqFlowFailMsgType.LINK_OPERATE_EX_FAIL);
                                        return false;
                                    }

                                    requestCheckAddinRulesMap=new HashMap();
                                    requestCheckAddinRulesMap.put("objId",""+linkid);
                                    requestCheckAddinRulesMap.put("objType","0");// 1: 节点自动赋值 0 :出口自动赋值
                                    requestCheckAddinRulesMap.put("isPreAdd","0");
                                    requestCheckAddinRulesList.add(requestCheckAddinRulesMap);
                                } catch (Exception erca) {
                                    WriteSubmitErrorLog();
                                    //writeLog(erca);
                                    if(erca.getMessage().indexOf("workflow interface action error")>-1){
                                        writeLog(erca);
                                        if(rst!=null){
                                            rst.rollback();
                                        }
                                        if("".equals(this.getMessage())){
                                            this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_07);
                                        }
                                        if("".equals(this.getMessagecontent())){
                                            this.setMessagecontent(WorkflowRequestMessage.resolveDetailInfo(SystemEnv.getHtmlLabelName(10000193,weaver.general.Util.getIntValue(user.getLanguage()))));
                                        }
                                        reqFailMsg.setMsgType(ReqFlowFailMsgType.LINK_OPERATE_EX_FAIL);
                                        return false;}
                                }

                                //签批
                                try {
                                    HqGenerateSealDocBiz.generateSealFile(this);
                                } catch (Exception erca) {
                                    WriteSubmitErrorLog();
                                    if(rst!=null){
                                        rst.rollback();
                                    }
                                    if("".equals(this.getMessage())){
                                        this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_07);
                                    }
                                    if("".equals(this.getMessagecontent())){
                                        this.setMessagecontent(WorkflowRequestMessage.resolveDetailInfo(SystemEnv.getHtmlLabelName(522634,weaver.general.Util.getIntValue(user.getLanguage()))));
                                    }
                                    return false;
                                }
                            }

                            //出口自动赋值处理  xwj for td3130 20051123
                            String drawbackflag = "";//退回时，下一个节点的节点前附加操作是否触发。drawbackflag=1，表示触发。
                            RecordSet tempRecordSet = new RecordSet();
                            tempRecordSet.executeSql("select drawbackflag from workflow_flownode where workflowid="+workflowid+" and nodeid="+nextnodeid);
                            if(tempRecordSet.next()){
                                drawbackflag = Util.null2String(tempRecordSet.getString("drawbackflag"));
                            }

                            int nextnodeattr=Util.getIntValue((String)nextnodeattrs.get(n),0);

                            //当前节点类型是分之的合并节点(3.按通过分支数合并节点; 4.指定分支合并节点)
                            boolean isMergeNode = (nextnodeattr == 3 || nextnodeattr == 4|| nextnodeattr == 5);
                            boolean canflowtonextnode = false;
                            //如果是合并节点，对其进行判断是否可流转至下一节点。
                            if(isMergeNode && !src.equals("intervenor")){
                                canflowtonextnode = wflinkinfo.FlowToNextNode(requestid,nodeid,nextnodeid, String.valueOf(nextnodeattr), Util.getIntValue((String)nextnodepassnums.get(n)), Util.getIntValue((String)linkismustpasss.get(n)));
                            }


                            if( ((!src.equals("reject") && !isMergeNode) || (!src.equals("reject") && isMergeNode && canflowtonextnode)  || (src.equals("reject")) || (src.equals("intervenor") && isMergeNode)) &&  enableIntervenor==1){
                                try {
                                    //由于objtype为"1: 节点自动赋值",不为"0 :出口自动赋值"，不用改变除状态外的文档相关信息，故可不用给user、clienIp、src赋值   fanggsh TD5121
                                    RequestCheckAddinRules requestCheckAddinRules = new RequestCheckAddinRules();
                                    requestCheckAddinRules.resetParameter();
                                    //add by cyril on 2008-07-28 for td:8835 事务无法开启查询,只能传入
                                    requestCheckAddinRules.setTrack(isTrack);
                                    requestCheckAddinRules.setStart(isStart);
                                    requestCheckAddinRules.setNodeid(nodeid);
                                    //end by cyril on 2008-07-28 for td:8835
                                    requestCheckAddinRules.setRequestid(requestid);
                                    requestCheckAddinRules.setWorkflowid(workflowid);
                                    requestCheckAddinRules.setObjid(nextnodeid);
                                    requestCheckAddinRules.setObjtype(1);
                                    requestCheckAddinRules.setIsbill(isbill);
                                    requestCheckAddinRules.setFormid(formid);
                                    requestCheckAddinRules.setIspreadd("1");
                                    requestCheckAddinRules.setRequestManager(this);
                                    requestCheckAddinRules.setUser(user);
                                    String clientIp = "";
                                    if(isRequest){
                                        if (request != null)
                                            clientIp = Util.null2String(Util.getIpAddr(request));
                                    }else{
                                        if (fu != null)
                                            clientIp = Util.null2String(fu.getRemoteAddr());
                                    }
                                    requestCheckAddinRules.setClientIp(clientIp);//add by fanggsh 20061016 fot TD5121
                                    requestCheckAddinRules.setSrc(src);
                                    requestCheckAddinRules.setPushMsgDocIds(this.pushMsgDocIds);
                                    requestCheckAddinRules.checkAddinRules();

                                    if(requestCheckAddinRules.getDoDmlResult().startsWith("-1")){
                                        if("-1".equals(requestCheckAddinRules.getDoDmlResult())){
                                            if("".equals(this.getMessage())){
                                                this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_07);
                                            }
                                            if("".equals(this.getMessagecontent())){
                                                this.setMessagecontent(WorkflowRequestMessage.resolveDetailInfo(SystemEnv.getHtmlLabelName(10000195,weaver.general.Util.getIntValue(user.getLanguage()))));
                                            }
                                        }else{
                                            this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_07);
                                            this.setMessagecontent(WorkflowRequestMessage.resolveDetailInfo(SystemEnv.getHtmlLabelName(10000196,weaver.general.Util.getIntValue(user.getLanguage()))+":"+requestCheckAddinRules.getDoDmlResult().replace("-1,", "")));
                                        }
                                        if(rst!=null){
                                            rst.rollback();
                                        }
                                        reqFailMsg.setMsgType(ReqFlowFailMsgType.BEFORE_NODE_OPERATE_EX_FAIL);
                                        return false;
                                    }

                                    requestCheckAddinRulesMap=new HashMap();
                                    requestCheckAddinRulesMap.put("objId",""+nextnodeid);
                                    requestCheckAddinRulesMap.put("objType","1");// 1: 节点自动赋值 0 :出口自动赋值
                                    requestCheckAddinRulesMap.put("isPreAdd","1");
                                    requestCheckAddinRulesList.add(requestCheckAddinRulesMap);
                                } catch (Exception erca) {
                                    WriteSubmitErrorLog();
                                    //writeLog(erca);
                                    if(erca.getMessage().indexOf("workflow interface action error")>-1){
                                        writeLog(erca);
                                        if(rst!=null){
                                            rst.rollback();
                                        }
                                        if("".equals(this.getMessage())){
                                            this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_07);
                                        }
                                        if("".equals(this.getMessagecontent())){
                                            this.setMessagecontent(WorkflowRequestMessage.resolveDetailInfo(SystemEnv.getHtmlLabelName(10000195,weaver.general.Util.getIntValue(user.getLanguage()))));
                                        }
                                        reqFailMsg.setMsgType(ReqFlowFailMsgType.BEFORE_NODE_OPERATE_EX_FAIL);
                                        return false;}
                                }
                            }
                            //add  by liaodong for qc40998 in 20130918 start
                            //出口根据勾选的退回进行存档，节点后附加操作根据触发退回是否
                            String rejectbackflag = "";//退回时，下一个节点的节点后附加操作是否触发。rejectbackflag=0，表示触发。
                            RecordSet tempRejectRecordSet = new RecordSet();
                            tempRejectRecordSet.executeSql("select rejectbackflag from workflow_flownode where workflowid="+workflowid+" and nodeid="+nodeid);
                            if(tempRejectRecordSet.next()){
                                rejectbackflag = Util.null2String(tempRejectRecordSet.getString("rejectbackflag"));
                            }
                            String forkflag = "";//退回时，下一个节点的节点后附加操作是否触发。forkflag=1，表示触发。
                            RecordSet tempForkRecordSet = new RecordSet();
                            tempForkRecordSet.executeSql("select isreject from workflow_nodelink where workflowid="+workflowid+" and id="+linkid);
                            if(tempForkRecordSet.next()){
                                forkflag = Util.null2String(tempForkRecordSet.getString("isreject"));
                            }
                            if(src.equals("reject")){ //退回时处理
                                if("0".equals(rejectbackflag)){ //节点后操作判断是否另存文档
                                    //rs.executeSql("select * from workflow_addinoperate  where workflowid="+workflowid+" and isnode=1 and objid="+nodeid+" and ispreadd = 0  and type=2 and customervalue='action.WorkflowToDoc' ");
                                    rs.executeSql("select * from workflowactionview  where workflowid="+workflowid+" and nodeid="+nodeid+" and ispreoperator='0' and (id='action.WorkflowToDoc' or id='WorkflowToDoc') and isused = 1");
                                    if(rs.next()){
                                        isWorkFlowToDoc=true;
                                    }
                                }
                                if("1".equals(forkflag)){
                                    //rs.executeSql("select * from workflow_addinoperate  where workflowid="+workflowid+" and isnode=0 and objid="+linkid+" and ispreadd='0'  and type=2 and customervalue='action.WorkflowToDoc' ");
                                    rs.executeSql("select * from workflowactionview  where workflowid="+workflowid+" and nodelinkid="+linkid+" and (id='action.WorkflowToDoc' or id='WorkflowToDoc') and isused = 1");
                                    if(rs.next()){
                                        isWorkFlowToDoc=true;
                                    }
                                }
                                if("1".equals(drawbackflag)){
                                    rs.executeSql("select * from workflowactionview  where workflowid="+workflowid+" and nodeid="+nextnodeid+" and ispreoperator='1' and (id='action.WorkflowToDoc' or id='WorkflowToDoc') and isused = 1");
                                    //rs.executeSql("select * from workflow_addinoperate  where workflowid="+workflowid+" and isnode=1 and objid="+nextnodeid+" and ispreadd = 1  and type=2 and customervalue='action.WorkflowToDoc' ");
                                    if(rs.next()){
                                        isWorkFlowToDoc=true;
                                    }
                                }
                            }else{ //非退回时处理
                                String todocsql = "";
                                if(linkid == 0){
                                    linkid = -1;
                                }
                                if("intervenor".equals(src)){
                                    if(enableIntervenor == 1){   //执行节点前附加操作
                                        todocsql = "select * from workflowactionview  where workflowid="+workflowid+" and ((nodeid="+nextnodeid+" and ispreoperator='1') or nodelinkid="+linkid+" or (nodeid="+nodeid+" and ispreoperator='0')) and (id='action.WorkflowToDoc' or id='WorkflowToDoc') and isused = 1 ";
                                    }else{  //不执行节点前附加操作
                                        todocsql = "select * from workflowactionview  where workflowid="+workflowid+" and (nodelinkid="+linkid+" or (nodeid="+nodeid+" and ispreoperator='0')) and (id='action.WorkflowToDoc' or id='WorkflowToDoc') and isused = 1 ";
                                    }
                                }else{    //原有的逻辑
                                    todocsql = "select * from workflowactionview  where workflowid="+workflowid+" and ((nodeid="+nextnodeid+" and ispreoperator='1') or nodelinkid="+linkid+" or (nodeid="+nodeid+" and ispreoperator='0')) and (id='action.WorkflowToDoc' or id='WorkflowToDoc') and isused = 1 ";
                                }
                                rs.executeSql(todocsql);
                                if(rs.next()){
                                    isWorkFlowToDoc=true;
                                }
                            }

                            //end

                        }

                        //TD9472	2	Start	查询流程生成计划任务（总体）设置，取得到达nextnodeids时和离开nodeid时生成计划任务的情况，生成计划任务
                        int isusedworktask = Util.getIntValue(getPropValue("worktask","isusedworktask"), 0);
                        if(isusedworktask == 1){
                            sql = "select * from workflow_createtask where wfid="+this.workflowid+" and ((nodeid="+this.nodeid+" and changetime=2) or (changetime=1 and nodeid in ("+wf_nextnodeids+"0)))";
                            rst.execute(sql);
                            while(rst.next()){
                                int creatertype_tmp = Util.getIntValue(rst.getString("creatertype"), 0);
                                if(creatertype_tmp == 0){
                                    continue;
                                }
                                int createtaskid_tmp = Util.getIntValue(rst.getString("id"), 0);
                                int wffieldid_tmp = Util.getIntValue(rst.getString("wffieldid"), 0);
                                int taskid_tmp = Util.getIntValue(rst.getString("taskid"), 0);
                                int changemode_tmp = Util.getIntValue(rst.getString("changemode"), 0);
                                int changenodeid_tmp = Util.getIntValue(rst.getString("nodeid"), 0);
                                int changetime_tmp = Util.getIntValue(rst.getString("changetime"), 0);
                                if(changenodeid_tmp!=this.nodeid && (","+wf_nextnodeids+",").indexOf(","+changenodeid_tmp+",")>-1){//首先保证触发节点是操作后到达的节点，并且触发节点在到达的节点之中
                                    if(changetime_tmp==1 && (("submit".equals(src) && changemode_tmp==2) || ("reject".equals(src) && changemode_tmp==1))){
                                        //必须是达到触发的设置，如果勾选前一节点退回（changemode_tmp==2），那么如果是提交的，就不触发了；如果勾选前一节点提交（changemode_tmp==1），那么如果是退回，就不触发了
                                        continue;
                                    }
                                }
                                if(changenodeid_tmp==this.nodeid){//如果是离开节点
                                    if(changetime_tmp==2 && (("submit".equals(src) && changemode_tmp==2) || ("reject".equals(src) && changemode_tmp==1))){
                                        //必须是离开触发的设置，如果勾选退回（changemode_tmp==2），那么如果是提交的，就不触发了；如果勾选提交（changemode_tmp==1），那么如果是退回，就不触发了
                                        continue;
                                    }
                                }
                                RequestCreateByWF requestCreateByWF = new RequestCreateByWF();
                                requestCreateByWF.setWf_formid(this.formid);
                                requestCreateByWF.setWf_isbill(this.isbill);
                                requestCreateByWF.setWf_wfid(this.workflowid);
                                requestCreateByWF.setWf_requestid(this.requestid);
                                requestCreateByWF.setWt_creatertype(creatertype_tmp);
                                requestCreateByWF.setWt_creater(this.creater);
                                requestCreateByWF.setWf_fieldid(wffieldid_tmp);
                                requestCreateByWF.setWt_wtid(taskid_tmp);
                                requestCreateByWF.setCreatetaskid(createtaskid_tmp);
                                requestCreateByWF.createWT();
                            }
                        }
                        //TD9472	2	End

                        // 更新操作者信息 1,删除当前批注人 2, 将当前操作者根据组的追踪情况处理 3, 加入新的操作者
                        rs1 = new RecordSet();
                        //modify by mackjoe at 2005-09-29 td1772 不屏蔽删除转发人
                        rst.executeSql("update workflow_currentoperator set isremark='2', preisremark='5',operatedate='"+currentdate+"',operatetime='"+currenttime+"',processUser = "+userid+" where isremark ='5' and requestid=" + requestid+" and nodeid="+nodeid);
                        if(src.equals("reject")) {
                            rst.execute("update workflow_currentoperator set operatetype='3', isremark = '2', operatedate = '"+currentdate+"',operatetime='"+currenttime+"',processUser = "+userid+" where requestid = " + requestid + " and isremark = '0' and nodeid="+nodeid);
                            if(wflinkinfo.getNodeAttribute(extendnodeid)!=2){
                                rst.executeSql("update workflow_currentoperator set isreject='1' where (isreject is null or isreject!='1') and requestid="+requestid);
                            }else{
                                if(this.nextnodeattr!=2){
                                    sql = "update workflow_currentoperator set isremark='2',operatedate='"+currentdate+"',operatetime='"+currenttime+"',processUser = "+userid+" where userid != "+userid+" and nodeid in (select nownodeid from workflow_nownode where requestid="+requestid+") and isremark='0' and requestid=" + requestid;
                                    rst.executeSql(sql);
                                    sql = "update workflow_currentoperator set takisremark = '0' where nodeid in (select nownodeid from workflow_nownode where requestid="+requestid+") and isremark=2 and takisremark = '-2' and requestid=" + requestid;
                                    rst.executeSql(sql);
                                }
                            }
                            //TD17640 如果当前操作者同时被转发或传阅，如果是同节点或不是分叉中间节点，都设置为已操作
                            sql = "update workflow_currentoperator set isremark='2',operatedate='"+currentdate+"',operatetime='"+currenttime+"',processUser = "+userid+" where (isremark='1' or isremark='11') and (nodeid="+nodeid+" or nodeid in (select a.nodeid from workflow_flownode a,workflow_nodebase b where a.nodeid=b.id and b.nodeattribute in ('0','1','3','4','5')  and a.workflowid="+workflowid+")) and requestid=" + requestid+" and userid=" + userid + " and usertype=" + usertype;
                            rst.executeSql(sql);
                            //TD7382 解决协办人退回后 节点操作者依然含有协办人的问题
                            sql = "update workflow_currentoperator set isremark='2',operatedate='"+currentdate+"',operatetime='"+currenttime+"',processUser = "+userid+" where isremark='7' and nodeid="+nodeid+" and requestid=" + requestid;
                            rst.executeSql(sql);
                            //退回后，同节点其他操作者流程转为已办
                            sql = "update workflow_currentoperator set isremark='2',operatedate='"+currentdate+"',operatetime='"+currenttime+"',processUser = "+userid+" where userid != "+userid+" and nodeid="+nodeid+" and (isremark='0' or (isremark='1' and takisremark='2')) and requestid=" + requestid;
                            rst.executeSql(sql);

                            if(this.RejectToType == 1 || this.RejectToType == 2){
                                sql = "update workflow_currentoperator set isremark='2',operatedate='"+currentdate+"',operatetime='"+currenttime+"',processUser = "+userid+" where userid != "+userid+" and nodeid in (select nownodeid from workflow_nownode where requestid="+requestid+") and isremark='0' and requestid=" + requestid;
                                rst.executeSql(sql);
                            }

                            if("".equals(newRejectNodeIds)) newRejectNodeIds = RejectToNodeid + "";
                            String nowNodeIds =freeNodeFlowBiz.getRejectNodeIds(newRejectNodeIds);
                            if(!"".equals(nowNodeIds)) {
                                requestFlowInfoEntity.setRejectnodeids(nowNodeIds);
                                sql = "update workflow_currentoperator set isremark='2',operatedate='"+currentdate+"',operatetime='"+currenttime+"',processUser = "+userid+" where nodeid in ("+nowNodeIds+") and isremark='0' and requestid=" + requestid;
                                rst.executeSql(sql);
                                rst.executeSql("delete from workflow_nownode where requestid="+requestid + " and nownodeid in ("+nowNodeIds+")");//删掉所有的当前节点
                            }
                            //从自由节点退回
                            if(FreeNodeBiz.isFreeNode(nodeid) && "reject".equals(src)) {
                                List<Integer> rejectRanage = freeNodeFlowBiz.getRejectRangeNodes(RejectToNodeid,nodeid,"");
                                requestFlowInfoEntity.setRejectRangeNodes(CollectionUtil.list2String(rejectRanage,","));
                            }
                        }
                        else {
                            if(isremark==0||isremark==7){

                                //是否执行老的逻辑，即操作组同批次为非会签关系
                                if (!isExeOldFlowlogic || (isOneVoteApprove && isremark == 0)) {
                                    //当前流程可以流向下一节点，需要更新同一操作组（节点操作组）的其他人员（同一操作组的同批次之间为非会签关系）
                                    rst.executeSql("select distinct userid,usertype from workflow_currentoperator where isremark = '"+isremark+"' and requestid=" + requestid + " and nodeid="+nodeid+" and groupid in(select distinct groupid from workflow_currentoperator where isremark = '"+isremark+"' and requestid=" + requestid +" and nodeid="+nodeid+")");
                                } else {
                                    //当前流程可以留下下一节点，需要更新与当前人员同组（会签的组）的人员
                                    rst.executeSql("select distinct userid,usertype from workflow_currentoperator where isremark = '"+isremark+"' and requestid=" + requestid + " and nodeid="+nodeid+" and groupid in(select distinct groupid from workflow_currentoperator where isremark = '"+isremark+"' and requestid=" + requestid +" and userid=" + userid +" and usertype=" + usertype+" and nodeid="+nodeid+")");
                                }
                                while(rst.next()){
                                    submituserids.add(rst.getString("userid"));
                                    submitusertypes.add(rst.getString("usertype"));
                                }
                                List tmpgroupidList=new ArrayList();

                                //是否执行老的逻辑，即操作组同批次为非会签关系
                                if (!isExeOldFlowlogic || (isOneVoteApprove && isremark == 0)) {
                                    //当前流程可以流向下一节点，需要更新同一操作组（节点操作组）的其他人员（同一操作组的同批次之间为非会签关系）
                                    rst.executeSql("select distinct groupid from workflow_currentoperator where isremark = '"+isremark+"' and requestid=" + requestid + " and nodeid="+nodeid);
                                } else {
                                    //当前流程可以留下下一节点，需要更新与当前人员同组（会签的组）的人员
                                    rst.executeSql("select distinct groupid from workflow_currentoperator where isremark = '"+isremark+"' and requestid=" + requestid + " and userid=" + userid + " and usertype=" + usertype+" and nodeid="+nodeid);
                                }
                                while(rst.next()){
                                    tmpgroupidList.add(""+Util.getIntValue(rst.getString(1), 0));
                                }
                                for(int i=0;i<tmpgroupidList.size();i++) {
                                    int tmpgroupid = Util.getIntValue((String)tmpgroupidList.get(i), 0);

                                    if(!"0".equals(needwfback)){
                                        //rst.executeProc("workflow_CurOpe_UpdatebySubmit", "" +userid +flag + requestid + flag + tmpgroupid+flag+nodeid+flag+isremark + flag + this.currentdate + flag + this.currenttime);
                                        workflow_CurOpe_UpdatebySubmit(rst, requestid, nodeid, userid, usertype, currentdate, currenttime, tmpgroupid, isremark);
                                        if(isremark==7){
                                            rst.executeSql("update workflow_currentoperator set operatedate='"+this.currentdate+"',operatetime='"+this.currenttime+"' where  isremark='7' and requestid ="+requestid+" and userid="+userid+" and nodeid="+nodeid);
                                        }else{
                                            rst.executeSql("update workflow_currentoperator set operatedate='"+currentdate+"',operatetime='"+currenttime+"' where (isremark = '5' or isremark='0' or isremark='1' or isremark='8' or isremark='9' or isremark='7') and requestid ="+requestid+" and userid="+userid+" and nodeid="+nodeid+" and groupid="+tmpgroupid);
                                            rst.executeSql("update workflow_currentoperator set needwfback = '1' where preisremark='0' and requestid ="+requestid+" and userid="+userid+" and nodeid="+nodeid+" and groupid="+tmpgroupid);
                                            this.updateworkflowcurrenttakingopsoperator(rst,tmpgroupid);

                                        }
                                        if( (isremark==7 && wfcm.getSigntype().equals("0")) || (wfcm.getSignorder()==0 && wfcm.getSigntype().equals("1"))){//协办人非会签 协办人提交到下一节点后未提交的主办人和协办人流程都置为已办
                                            rst.executeSql("update workflow_currentoperator set isremark ='2',processUser = "+userid+" where ( isremark='0' or isremark='7') and requestid ="+requestid+" and nodeid="+nodeid);
                                        }
                                    }else{
                                        //boolean istrue=  rst.executeProc("workflow_CurOpe_UbySubmitNB", "" +userid +flag + requestid + flag + tmpgroupid+flag+nodeid+flag+isremark + flag + this.currentdate + flag + this.currenttime);
                                        workflow_CurOpe_UbySubmitNB(rst, requestid, nodeid, userid, usertype, currentdate, currenttime, tmpgroupid, isremark);
                                        rst.executeSql("update workflow_currentoperator set operatedate='"+this.currentdate+"',operatetime='"+this.currenttime+"' where (isremark = '5' or isremark='0' or isremark='1' or isremark='8' or isremark='9' or isremark='7') and requestid ="+requestid+" and userid="+userid+" and nodeid="+nodeid);
                                        this.updateworkflowcurrenttakingopsoperator(rst,tmpgroupid);
                                        if((isremark==7 && wfcm.getSigntype().equals("0")) || (wfcm.getSignorder()==0 && wfcm.getSigntype().equals("1"))){//部门非会签协办人会签 提交到下一节点后未提交的主办人和协办人流程都置为已办
                                            rst.executeSql("update workflow_currentoperator set isremark ='2',processUser = "+userid+" where ( isremark='0' or isremark='7') and requestid ="+requestid+" and nodeid="+nodeid);
                                        }
                                    }
                                }
                            }
                            if(isremark==5||src.equals("intervenor")){//流程干预者（超时）提交时更新节点操作者，被转发者及被抄送者信息。
                                if(FreeNodeBiz.isFreeNode(nodeid) && innodeids!=null && !"".equals(innodeids)) {
                                    rst.executeSql("update workflow_currentoperator set isremark='2',operatedate='" + currentdate + "',operatetime='" + currenttime + "',processUser = " + userid + " where (isremark = '5' or isremark='0' or isremark='1' or isremark='8' or isremark='9' or isremark='7') and requestid=" + requestid + " and nodeid in (" + innodeids + ")");
                                } else if(!FreeNodeBiz.isFreeNode(nodeid)) {
                                    rst.executeSql("update workflow_currentoperator set isremark='2',operatedate='" + currentdate + "',operatetime='" + currenttime + "',processUser = " + userid + " where (isremark = '5' or isremark='0' or isremark='1' or isremark='8' or isremark='9' or isremark='7') and requestid=" + requestid + " and nodeid=" + nodeid);
                                }
                                String curr_nodeattribute = "0";
                                String next_nodeattribute = "0";
                                rst.executeSql("select nodeattribute from workflow_nodebase where id="+nodeid);
                                if(rst.next()){
                                    curr_nodeattribute = rst.getString(1);
                                }
                                rst.executeSql("select nodeattribute from workflow_nodebase where id="+nextnodeid);
                                if(rst.next()){
                                    next_nodeattribute = rst.getString(1);
                                }
                                if(!next_nodeattribute.equals("2")&&curr_nodeattribute.equals("2")){
                                    rst.executeSql("update workflow_currentoperator set isremark='2',operatedate='"+currentdate+"',operatetime='"+currenttime+"',processUser = "+userid+" where (isremark = '5' or isremark='0' or isremark='1' or isremark='8' or isremark='9' or isremark='7') and requestid=" + requestid+" and nodeid!="+nextnodeid );
                                }
                                if(next_nodeattribute.equals("2")&&curr_nodeattribute.equals("2")){
                                    //中间节点干预到中间节点 不操作
                                    rst.executeSql("update workflow_currentoperator set takisremark=null where requestid=" + requestid+" and takisremark=-2 and nodeid="+nodeid);
                                }else{
                                    //更新意见征询标识 ,takisremark=null
                                    rst.executeSql("update workflow_currentoperator set takisremark=null where requestid=" + requestid+" and takisremark=-2 and nodeid!="+nextnodeid);
                                }
                            }else{
                                if(canflowtonextnode && (nextnodeattr==3 || nextnodeattr==4|| nextnodeattr==5)){
                                    innodeids= wflinkinfo.getSummaryNodes(nextnodeid,workflowid,"",requestid);
                                    if(innodeids.equals("")) innodeids="0";
                                    //System.out.println("innodeids:"+innodeids);
                                    List tmpgroupidList=new ArrayList();
                                    rst.executeSql("select distinct groupid from workflow_currentoperator where (isremark='0' or isremark = '5') and requestid=" + requestid + " and userid=" + userid + " and usertype=" + usertype+" and nodeid in("+innodeids+")");
                                    while (rst.next()) {
                                        tmpgroupidList.add(""+Util.getIntValue(rst.getString(1), 0));
                                    }
                                    for(int i=0;i<tmpgroupidList.size();i++){
                                        int tmpgroupid = Util.getIntValue((String)tmpgroupidList.get(i), 0);

                                        rst.executeSql("update workflow_currentoperator set operatedate='"+currentdate+"',operatetime='"+currenttime+"' where (isremark='0' or isremark = '5') and requestid=" + requestid+ " and nodeid in("+innodeids+") and groupid="+tmpgroupid);
                                        this.updateworkflowcurrenttakingopsoperator(rst,innodeids,tmpgroupid);
                                    }
                                    rst.executeSql("update workflow_currentoperator set isremark='2',processUser = "+userid+" where (isremark='0' or isremark = '5' or (isremark=1 and takisremark=2)) and requestid=" + requestid+" and nodeid in("+innodeids+")" );
                                }
                                //自由流程分支合并
                                if(freeNodeCanFlowToNext) {
                                    List<Integer> branchFreeNodeIds = freeNodeFlowBiz.getBranchNodeIds();
                                    if(branchFreeNodeIds != null && branchFreeNodeIds.size() > 0) {
                                        innodeids = CollectionUtil.list2String(branchFreeNodeIds, ",");
                                        rst.executeSql("update workflow_currentoperator set isremark='2',processUser = "+userid+",operatedate='"+currentdate+"',operatetime='"+currenttime+"' where (isremark='0' or isremark = '5' or (isremark=1 and takisremark=2)) and requestid=" + requestid+" and nodeid in("+innodeids+")" );
                                    }
                                }

                            }
                            if(isremark==0){
                                String isremarktmp = "";
                                //65537 yl 协办人模块
                                //isforwards //协办人是否可以转发
                                //coadispendings  //协办人是否一直待办
                                //coadismodifys//协办人是否可以修改
                                //isSubmitedOpinions//协办人是否可以提交
                                //userids //协办人组
                                //coadsigntypes //协办人会签条件
                                if(null!=userids && userids.size()>0){
                                    for(int i = 0;i<userids.size();i++){
                                        if(!coadispendings.get(i).equals("1")){  //没有勾选“未查看停留在待办”
                                            sql = "update workflow_currentoperator set isremark='2',processUser = "+userid+" where isremark='7' and requestid=" + requestid+" and nodeid="+nodeid + " and userid= "+userids.get(i);
                                            rst.executeSql(sql);
                                        }else if(coadispendings.get(i).equals("1")){ //如果勾选了并且查看过则改为已办
                                            sql = "select viewtype from  workflow_currentoperator where isremark='7' and requestid=" + requestid+" and nodeid="+nodeid + " and userid= "+userids.get(i);
                                            rs1.executeSql(sql);
                                            if(rs1.next() && (rs1.getString("viewtype").equals("-2") || rs1.getString("viewtype").equals("-1") )){
                                                sql = "update workflow_currentoperator set isremark='2',processUser = "+userid+" where isremark='7' and requestid=" + requestid+" and nodeid="+nodeid + " and userid= "+userids.get(i);
                                                rst.executeSql(sql);
                                            }
                                        }
                                        wffm.updateForwardRemark(rst, IsBeForwardPending, IsSubmitedOpinion, IsBeForwardSubmit, true, nodeid);
                                    }
                                }else{
                                    if(!coadsigntype.equals("1")&& !coadispending.equals("1")){  //会签关系为非会签或不影响流程流转 并且没有勾选“未查看停留在待办”
                                        sql = "update workflow_currentoperator set isremark='2',processUser = "+userid+" where isremark='7' and requestid=" + requestid+" and nodeid="+nodeid;
                                        rst.executeSql(sql);
                                    }
                                    wffm.updateForwardRemark(rst, IsBeForwardPending, IsSubmitedOpinion, IsBeForwardSubmit, true, nodeid);
                                }
                                //TD17640 如果当前操作者同时被转发，如果是同节点或不是分叉中间节点，都设置为已操作
                                sql = "update workflow_currentoperator set isremark='2',operatedate='"+currentdate+"',operatetime='"+currenttime+"',processUser = "+userid+" where isremark='1' and (nodeid="+nodeid+" or nodeid in (select a.nodeid from workflow_flownode a,workflow_nodebase b where a.nodeid=b.id and b.nodeattribute in ('0','1','3','4')  and a.workflowid="+workflowid+")) and requestid=" + requestid+" and userid=" + userid + " and usertype=" + usertype;
                                rst.executeSql(sql);
                                //如果当前操作者同时被传阅
                                sql = "update workflow_currentoperator set isremark=2,operatedate='"+currentdate+"',operatetime='"+currenttime+"',processUser = "+userid+" where isremark=11 and workflowid="+workflowid+" and requestid=" + requestid+" and userid=" + userid + " and usertype=" + usertype;
                                rst.executeSql(sql);
                            }else if(isremark==7&&coadsigntype.equals("0")){   //协办人提交 并且会签关系为非会签
                                String isremarktmp = "";
                                rst.executeSql("update workflow_currentoperator set isremark='2',processUser = "+userid+" where (isremark='0' or isremark='7') and requestid='"+requestid+"' and nodeid='"+nodeid+"' and groupdetailid in("+wfcm.getSameGroupdetailids()+")");
                                wffm.updateForwardRemark(rst, IsBeForwardPending, IsSubmitedOpinion, IsBeForwardSubmit, true, nodeid);
                            }
                        }

                        //指定流转插入操作者
                        if(isSelectNextFlow && selectNextFlowMode == SelectNextFlowMode.NODE_AND_OPERATOR && !"".equals(this.selectNodeFlowNodeIds)){
                            String[] selectNextNodeIds = Util.null2String(this.selectNodeFlowNodeIds).split(",");

                            List<List<String>> operatorsList = new ArrayList<>();
                            List<List<String>> operatorsTypeList = new ArrayList<>();
                            List<String> ccTypeList = new ArrayList<>();
                            List<List<Integer>> ccIndexList = new ArrayList<>();
                            List<Integer> signTypeList = new ArrayList<>();

                            for (int index = 0; index < selectNextNodeIds.length; index++) {

                                List<String> operatorsType = new ArrayList<>();

                                List<Integer> ccIndex = new ArrayList<>();
                                List<String> operators = otherParams!=null&&otherParams.containsKey("selectNodeFlow_operator_"+index)?Util.TokenizerString(Util.null2String(otherParams.get("selectNodeFlow_operator_"+index)),",")
                                        :Util.TokenizerString(getRequestParamValue("selectNodeFlow_operator_" + index),",");
                                List<String> ccOperator = Util.TokenizerString(getRequestParamValue("ccOperator_" + index),",");
                                int signType = otherParams!=null&&otherParams.containsKey("SignType_"+index)?Util.getIntValue(Util.null2String(otherParams.get("SignType_"+index)),0)
                                        :Util.getIntValue(getRequestParamValue("SignType_" + index));
                                String selectNodeCanSubmit = getRequestParamValue("canSubmit_" + index);

                                for (int i = 0; i < ccOperator.size(); i++) {
                                    operators.add(ccOperator.get(i));
                                    ccIndex.add(operators.size() - 1);
                                }
                                for (int i = 0; i < operators.size(); i++) {
                                    operatorsType.add("0");
                                }

                                operatorsList.add(operators);
                                operatorsTypeList.add(operatorsType);
                                ccTypeList.add(selectNodeCanSubmit);
                                ccIndexList.add(ccIndex);
                                signTypeList.add(signType);
                            }
                            setOperator4SelectNextFlow(operatorsList,operatorsTypeList,rst,ccTypeList,ccIndexList,signTypeList);
                        } else if(isremark==5||src.equals("intervenor")){
                            canflowtonextnode=true;
                            setOperatorByremark5(tempusers,tempusersType,rst);
                        }else{
                            setOperator(rst);
                        }

                        //将更新操作移到消息提醒前 td3608
                        if (canflowtonextnode&&nextnodetype.equals("3")) {
                            Procpara = "" + creater + flag + creatertype + flag + requestid;

                            //流转下一节点，清空节点签字意见权限控制
                            RequestRemarkRight reqRight = new RequestRemarkRight();
                            reqRight.setRequestid(requestid);
                            reqRight.setNodeid(nodeid);
                            reqRight.deleteAllRight();   //归档时，清除所有的签字意见权限控制
                            //modify by xhheng @20050520 for TD1725,添加条件 isremark='0' 使能区分历史操作人和归档人
                            // 2005-03-24 Guosheng for TD1725**************************************
                            rst.executeSql("update  workflow_currentoperator  set isremark='4',processUser = "+userid+"  where (isremark='0' or isremark='5') and requestid = " +  requestid);
                            //考虑到流程转发和抄送的接收人可能也是归档人，如果该人还没处理，在待办事宜里应该显示 by ben for td5020
                            //rst.executeSql("update workflow_currentoperator set islasttimes='1' where islasttimes='0' and (isremark='1' or isremark='8' or isremark='9') and requestid = " + requestid+" and exists (select 1 from workflow_currentoperator a where a.requestid=workflow_currentoperator.requestid and a.userid=workflow_currentoperator.userid and a.usertype=workflow_currentoperator.usertype and a.isremark='4')");

                            if("mysql".equals(rst.getDBType())){
                                String zsql="UPDATE workflow_currentoperator t INNER JOIN workflow_currentoperator a  " +
                                        "  ON a.requestid = t.requestid  AND a.userid = t.userid  AND a.usertype = t.usertype " +
                                        "  SET t.islasttimes = '0' " +
                                        "  WHERE a.isremark IN('1','8','9') " +
                                        "  AND t.islasttimes = '1' " +
                                        "  AND t.isremark = '4' " +
                                        "  AND t.requestid = ?";
                                rst.executeUpdate(zsql,requestid);

                            }else{
                                rst.executeSql("update workflow_currentoperator set islasttimes='0' where islasttimes='1' and isremark='4' and requestid = " + requestid+" " +
                                        "and exists (select 1 from (select * from workflow_currentoperator) a where a.requestid=workflow_currentoperator.requestid " +
                                        "and a.userid=workflow_currentoperator.userid and a.usertype=workflow_currentoperator.usertype and " +
                                        "(a.isremark='1' or a.isremark='8' or a.isremark='9'))");

                            }


                            rst.executeSql("update  workflow_currentoperator  set iscomplete=1  where isremark!='8' and isremark!='9' and isremark!='7' and requestid = " +  requestid );//抄送者未做操作不更新

                        }

                        //add by xhheng @20050125 for 消息提醒 request06 ,短信发送
                        //int rqMessageType=0;
                        //String mailrequestname = "";
                        //int level=0;
                        //rst.executeSql("select messageType,requestname,requestlevel from workflow_requestbase where requestid="+requestid);
                        //if (rst.next()) {
                        //  rqMessageType=rst.getInt("messageType");
                        //  mailrequestname=rst.getString("requestname");
                        //  level=Util.getIntValue(rst.getString("requestlevel"),0);
                        //}
//                        boolean isMode = false;
//                        rst.executeQuery("select ismode from workflow_flownode where nodeid = ? and ismode = '1'", nodeid);
//                        if(rst.next()){
//                            isMode = true;
//                        }
//                        for(int n=0;n<nextnodeids.size();n++){
//                            nextnodeid=Util.getIntValue((String)nextnodeids.get(n));
//
//                            if(istest != 1 && isMode && !isBatchSubmit){
//                                //发送短信、微信、邮件提醒
//                                sendMsgAndMail.sendMsg(rst,requestid,nextnodeid,user,src,nextnodetype);
//                                sendMsgAndMail.sendChats(rst,workflowid,requestid,nextnodeid,user,src,nextnodetype);//微信提醒(QC:98106)
//                                sendMsgAndMail.sendMail(rst,workflowid,requestid,nextnodeid,request,fu,isRequest,src,nextnodetype,user);
//                            }
//                        }

                        //离开节点触发子流程
                        if((nextnodeid>0 || FreeNodeBiz.isFreeNode(nextnodeid))){
                            nodeidList_sub.add(""+nodeid);
                            triggerTimeList_sub.add("2");
                        }
                        //离开节点
                        if(nextnodeids!=null && nextnodeids.size()>0 && !nextnodeids.contains(""+nodeid)){
                            nodeidList_wp.add(""+nodeid);
                            createTimeList_wp.add("2");
                        }

                        for(int n=0;n<nextnodeids.size();n++){

                            nextnodeid=Util.getIntValue((String)nextnodeids.get(n));

                            if( canflowtonextnode && (nextnodeid>0 || FreeNodeBiz.isFreeNode(nextnodeid))){
                                //到达节点触发子流程
                                nodeidList_sub.add(""+nextnodeid);
                                triggerTimeList_sub.add("1");

                                if(nextnodeid!=nodeid){
                                    //TD13304 在这里记录需要触发日程的节点和触发类型（到达节点或离开节点），到流程事务外处理
                                    nodeidList_wp.add(""+nextnodeid);
                                    createTimeList_wp.add("1");//到达节点
                                }
                            }
                        }
                        isReCalculatePermission = true;

                        //流转下一节点，清空节点签字意见权限控制
                        RequestRemarkRight reqRight = new RequestRemarkRight();
                        reqRight.setRequestid(requestid);
                        reqRight.setNodeid(nodeid);
                        reqRight.deleteRemarkRight();
                        needAddOvertimeTask = true;//提交成功需要重新计算超时任务
                        isFlowNextNoid = true;
                    } else {
                        if(submitgroups < 0 && totalunsubmitgroups <= 0) {
                            saveRequestLog("1");
                            log.info("已无流程提交权限："+requestid+",userid:"+userid+",nodeid:"+nodeid);
                            this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_02); //已经流转到下一节点，不可以再提交
                            reqFailMsg.setMsgType(ReqFlowFailMsgType.NO_REQUEST_PERMISSION);
                            return false;
                        }

                        //处理超时流程提醒
                        if (!groupdetailids.equals("")&&coadcansubmit){

                        }

                        // 更新操作者信息 1,删除当前组批注人 2, 将当前操作者根据组的追踪情况处理
                        rs1 = new RecordSet();
                        if(isremark==0||isremark==7){

                        }
                        //				如果是依次逐个递交
                        //节点是会签关系是否还有未操作者
                        boolean oneByOneHasUnoperated = false;
                        if(FreeNodeBiz.isFreeNode(nodeid)) {
                            oneByOneHasUnoperated = RequestFreeNodeFlowBiz.isOneByOneHasUnoperated(requestid,nodeid);
                        }

                        if ((!groupdetailids.equals("")&&coadcansubmit && isremark!=7) || oneByOneHasUnoperated)
                        {
                            int isreject = 0;
                            if (src.equals("reject"))
                                isreject = 1;
                            // 查询下一个操作者
                            if(oneByOneHasUnoperated) {
                                operatorsht = RequestFreeNodeFlowBiz.getFreeNodeOneByOneNextOperator(requestid,nodeid,rst,false);
                                //TODO 错误信息
                                if(operatorsht.size() == 0) {
                                    WriteSubmitErrorLog();
                                    saveRequestLog("1");
                                    if (rst != null) {
                                        new Exception(RequestManager.ERROR_NOTFOUND_NNNO).printStackTrace();
                                        rst.rollback();
                                    }
                                    this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_07);
                                    return false;
                                }
                            } else {
                                RequestNodeFlow requestNodeFlow = new RequestNodeFlow();
                                requestNodeFlow.setRequestid(requestid);
                                requestNodeFlow.setNodeid(nodeid);
                                requestNodeFlow.setNodetype(nodetype);
                                requestNodeFlow.setWorkflowid(workflowid);
                                requestNodeFlow.setUserid(userid);
                                requestNodeFlow.setUsertype(usertype);
                                requestNodeFlow.setCreaterid(creater);
                                requestNodeFlow.setCreatertype(creatertype);
                                requestNodeFlow.setFormid(formid);
                                requestNodeFlow.setIsbill(isbill);
                                requestNodeFlow.setBillid(billid);
                                requestNodeFlow.setBilltablename(billtablename);
                                requestNodeFlow.setRecordSet(rs);
                                requestNodeFlow.setRecordSetTrans(rst);
                                requestNodeFlow.setIsreject(isreject);
                                //add by liaodong for qc48451 in 2013年10月21日 start
                                requestNodeFlow.setIsfixbill(isfixbill);
                                requestNodeFlow.setLanguageid(this.userlanguage);
                                //end
                                // add by liaodong for qc86096 in 2013-11-19 start
                                requestNodeFlow.setCurrentdate(currentdate);
                                requestNodeFlow.setCurrenttime(currenttime);
                                requestNodeFlow.setReqFailMsg(reqFailMsg);
                                //end
                                boolean hasnextnodeoperator = requestNodeFlow.getNextOrderOperator(groupdetailids);
                                if (!hasnextnodeoperator) {
                                    WriteSubmitErrorLog();
                                    saveRequestLog("1");
                                    if (rst != null) {
                                        new Exception(RequestManager.ERROR_NOTFOUND_NNNO).printStackTrace();
                                        rst.rollback();
                                    }
                                    this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_07);
                                    this.reqFailMsg.setMsgType(ReqFlowFailMsgType.NODE_NODE_FOUND_OPERATOR);
                                    this.setMessagecontent(requestNodeFlow.getMessagecontent());
                                    return false;
                                }
                                operatorsht = requestNodeFlow.getOperators();
                                penetrateFlag = requestNodeFlow.getPenetrateId();
                                lastNodeId = requestNodeFlow.getLastNodeId();
                            }

                            nextnodeid=nodeid;
                            nextnodetype=nodetype;
                            nextnodeattr=wflinkinfo.getNodeAttribute(nextnodeid);
                            nextnodeids.add(""+nextnodeid);
                            nextnodetypes.add(nodetype);
                            nextnodeattrs.add(""+nextnodeattr);
                            operatorshts.add(operatorsht);
                            haspassthisnode = true;//added by pony for TD4485
                            //add by liaodong for qc76119,76120,54194,64652 start

                            //end
                            //处理超时流程提醒
                            this.updatePoppupRemindInfoThisJava(rst,this.requestid);

                            // 更新操作者信息 1,删除当前组批注人 2, 将当前操作者根据组的追踪情况处理
                            if(isremark==0||isremark==7){
                                this.updateworkflowcurrentoperator(rst,submituserids,submitusertypes, finishndgpids);
                            }

                            if(isremark==0){
                                wffm.updateForwardRemark(rst, IsBeForwardPending, IsSubmitedOpinion, IsBeForwardSubmit, false, nodeid);
                            }else if(isremark==7&&coadsigntype.equals("0")){   //协办人提交
                                String isremarktmp = "";
                                if (!coadispending.equals("1")) {   //协办人未查看停留在待办
                                    isremarktmp = " (isremark='0' and viewtype=0) ";
                                }
                                if (!isremarktmp.equals("")){
                                    sql = "update workflow_currentoperator set isremark='2',processUser = "+userid+" where (" + isremarktmp + ") and (exists (select 1 from workflow_currentoperator c where c.requestid="+requestid+" and c.nodeid=workflow_currentoperator.nodeid and c.groupdetailid=workflow_currentoperator.groupdetailid and c.id=" + RequestKey + " and exists(select id from workflow_groupdetail g where g.id=c.groupdetailid and g.signtype='0') and exists (select 1 from workflow_coadjutant a where a.requestid="+requestid+" and a.coadjutantid=" + RequestKey + ")) ";
                                    sql+=")";
                                    rst.executeSql(sql);
                                }
                                wffm.updateForwardRemark(rst, IsBeForwardPending, IsSubmitedOpinion, IsBeForwardSubmit, false, nodeid);
                            }
                            //新版自由流程
                            if(oneByOneHasUnoperated){
                                sql = "update workflow_currentoperator set isremark='2',processUser = " + userid + " where (isremark='0' or isremark='5') and requestid=" + requestid + " and nodeid=" + nodeid +" and userid = " +user.getUID();
                            } else {
                                sql = "update workflow_currentoperator set isremark='2',processUser = " + userid + " where (isremark='0' or isremark='5') and requestid=" + requestid + " and nodeid=" + nodeid + " and groupdetailid in (" + groupdetailid4sql + ")";
                            }
                            rst.executeSql(sql);

                            //如果当期操作者还有转发以及传阅未提交记录则也一起更新掉
                            sql = " update workflow_currentoperator set isremark  = '2',processUser = "+userid+",viewtype =-2,operatedate='"+this.currentdate+"',operatetime='"+this.currenttime+"' where isremark  in ('1', '11') and requestid = " + requestid + " and userid  = " + userid;
							rst.executeUpdate(sql);

                            setOperator(rst);
                            showcoadjutant=true;
//                            boolean isMode = false;
//                            rst.executeQuery("select ismode from workflow_flownode where nodeid = ? and ismode = 1", nodeid);
//                            if(rst.next()) isMode = true;
//                            if(istest != 1 && isMode && !isBatchSubmit){
//                                //依次逐个提交对下一个操作者短信提醒 ==start==
//                                sendMsgAndMail.sendMsg(rst,requestid,nextnodeid,user,src,nextnodetype);
//                                //依次逐个提交对下一个操作者短信提醒 ==end==
//                                sendMsgAndMail.sendChats(rst,workflowid,requestid,nextnodeid,user,src,nextnodetype);//微信提醒(QC:98106)
//                                //依次逐个提交对下一个操作者邮件提醒 ==start==
//                                sendMsgAndMail.sendMail(rst,workflowid,requestid,nextnodeid,request,fu,isRequest,src,nextnodetype,user);
//                                //依次逐个提交对下一个操作者邮件提醒 ==end==
//                            }
                            isReCalculatePermission = true;
                            needAddOvertimeTask = true;//提交成功需要重新计算超时任务
                        }else{
                            nextnodeid=nodeid;
                            nextnodetype=nodetype;
                            nextnodeattr=wflinkinfo.getNodeAttribute(nextnodeid);
                            nextnodeids.add(""+nextnodeid);
                            nextnodetypes.add(nodetype);
                            nextnodeattrs.add(""+nextnodeattr);
                            operatorshts.add(operatorsht);

                            ArrayList temppoppuplist=new ArrayList();
                            boolean isautoApprove = new WFAutoApproveUtils().isAutoApprove(this, rst, nodeInfoCache,temppoppuplist,nextnodeattr);

                            WFAutoApproveUtils.processApproveLog(rst,this);

                            // 更新操作者信息 1,删除当前组批注人 2, 将当前操作者根据组的追踪情况处理
                            if(isremark==0||isremark==7){
                                this.updateworkflowcurrentoperator(rst,submituserids,submitusertypes, finishndgpids);
                            }

                            if(isremark==0){
                                int coadjutantuser = 0;

                                coadjutantuser = wfcm.getCoadjutantUser(wfcm.getGroupdetailid(), nodeid, requestid,rst);
                                if("0".equals(wfcm.getSigntype())){ //协办人非会签
                                    boolean isupcoad = false;
                                    if(wfcm.getSignorder()==1 || wfcm.getSignorder()==2){
                                        rst.executeSql("select userid from workflow_currentoperator where isremark='0' and requestid='"+requestid+"' and nodeid='"+nodeid+"' and groupdetailid ='"+wfcm.getGroupdetailid()+"'");
                                        isupcoad = !rst.next();
                                        if(userid==coadjutantuser) isupcoad = true;
                                    }else if(wfcm.getSignorder()==0){
                                        rst.executeSql("select userid from workflow_currentoperator where isremark='2' and preisremark='0' and  (isreject is null or isreject=0) and requestid='"+requestid+"' and nodeid='"+nodeid+"' and groupdetailid ='"+wfcm.getGroupdetailid()+"'");
                                        isupcoad = rst.next();
                                    }
                                    if(isupcoad){
                                        if(!wfcm.getIspending().equals("1")){  //没有勾选“未查看停留在待办”
                                            sql = "update workflow_currentoperator set isremark='2',processUser = "+userid+" where isremark='7' and requestid=" + requestid+" and nodeid="+nodeid + " and userid= "+coadjutantuser;
                                            rst.executeSql(sql);
                                        }else if(wfcm.getIspending().equals("1")){ //如果勾选了并且查看过则改为已办
                                            sql = "select viewtype from  workflow_currentoperator where isremark='7' and requestid=" + requestid+" and nodeid="+nodeid + " and userid= "+coadjutantuser;
                                            rst.executeSql(sql);
                                            if(rst.next() && (rst.getString("viewtype").equals("-2") || rst.getString("viewtype").equals("-1") )){
                                                sql = "update workflow_currentoperator set isremark='2',processUser = "+userid+" where isremark='7' and requestid=" + requestid+" and nodeid="+nodeid + " and userid= "+coadjutantuser;
                                                rst.executeSql(sql);
                                            }
                                        }
                                    }
                                }else if("1".equals(wfcm.getSigntype())){ //协办人会签 主办人非会签，当协办人提交后，一个主办人提交后其他主办人不再提交（基于多操作组时）
                                    if(wfcm.getSignorder()==0){
                                        rs1.executeSql("select userid from workflow_currentoperator where isremark='2' and preisremark='7' and groupdetailid='"+wfcm.getGroupdetailid()+"' and requestid='"+requestid+"'");
                                        if(rs1.next()){
                                            rst.executeSql("update workflow_currentoperator set isremark='2',processUser = "+userid+" where isremark='0' and requestid='" + requestid+"' and nodeid='"+nodeid + "' and groupdetailid='"+wfcm.getGroupdetailid()+"'");
                                        }
                                    }else if(wfcm.getSignorder()==1 && isremark==0 && userid==coadjutantuser){
                                        rst.executeSql("update workflow_currentoperator set isremark='2',operatedate='"+this.currentdate+"',operatetime='"+this.currenttime+"',processUser = "+userid+" where isremark='7' and requestid='" + requestid+"' and nodeid='"+nodeid + "' and userid='"+userid+"' and groupdetailid='"+wfcm.getGroupdetailid()+"'");
                                    }
                                }else if("2".equals(wfcm.getSigntype())){
                                    if(!wfcm.getIspending().equals("1")){  //没有勾选“未查看停留在待办”
                                        rst.executeSql("select id from  workflow_currentoperator where isremark='0' and requestid=" + requestid+" and nodeid="+nodeid + " and groupdetailid= "+wfcm.getGroupdetailid());
                                        if(!rst.next()){
                                            sql = "update workflow_currentoperator set isremark='2',processUser = "+userid+" where isremark='7' and requestid=" + requestid+" and nodeid="+nodeid + " and userid= "+coadjutantuser;
                                            rst.executeSql(sql);
                                        }
                                    }else if(wfcm.getIspending().equals("1")){ //如果勾选了并且查看过则改为已办
                                        sql = "select viewtype from  workflow_currentoperator where isremark='7' and requestid=" + requestid+" and nodeid="+nodeid + " and userid= "+coadjutantuser;
                                        rst.executeSql(sql);
                                        if(rst.next() && (rst.getString("viewtype").equals("-2") || rst.getString("viewtype").equals("-1") )){
                                            rst.executeSql("select id from  workflow_currentoperator where isremark='0' and requestid=" + requestid+" and nodeid="+nodeid + " and groupdetailid= "+wfcm.getGroupdetailid());
                                            if(!rst.next()){
                                                sql = "update workflow_currentoperator set isremark='2',processUser = "+userid+" where isremark='7' and requestid=" + requestid+" and nodeid="+nodeid + " and userid= "+coadjutantuser;
                                                rst.executeSql(sql);
                                            }
                                        }
                                    }
                                    //如果当期操作者还有转发以及传阅未提交记录则也一起更新掉
                                    sql = " update workflow_currentoperator set isremark  = '2',processUser = "+userid+",viewtype =-2,operatedate='"+this.currentdate+"',operatetime='"+this.currenttime+"' where isremark  in ('1','11') and requestid = " + requestid + " and userid  = " + userid;
                                    rst.executeUpdate(sql);
                                }

                                wffm.updateForwardRemark(rst, IsBeForwardPending, IsSubmitedOpinion, IsBeForwardSubmit, false,nodeid);

                                //会签提交
                                //需要区分是会签还是，分支不符合合并条件
                                if(freeNodeFlowBiz.isBranchMerge()) {
                                    List<Integer> branchFreeNodeIds = freeNodeFlowBiz.getBranchNodeIds();
                                    if(branchFreeNodeIds.size() == 0) branchFreeNodeIds.add(nodeid);
                                    String tempinnodeids = CollectionUtil.list2String(branchFreeNodeIds, ",");
                                    rst.executeSql("delete from workflow_nownode where nownodeid in("+tempinnodeids+") and requestid="+requestid);
                                    rst.executeSql("update workflow_currentoperator set isremark='2',processUser = "+userid+",operatedate='"+currentdate+"',operatetime='"+currenttime+"' where (isremark='0' or isremark = '5' or (isremark=1 and takisremark=2)) and requestid=" + requestid+" and nodeid in("+tempinnodeids+")" );
                                    requestFlowInfoEntity.setMergeNodeIds(freeNodeFlowBiz.getMergeNodeIds());
                                    requestFlowInfoEntity.setDestnodeid(0);
                                } else {
                                    requestFlowInfoEntity.setDestnodeid(nodeid);
                                }
                                RequestBaseBiz.saveRequestFlowInfo(requestFlowInfoEntity,rst);
                            }else if(isremark==7&&coadsigntype.equals("0")){   //协办人提交 会签关系为非会签
                                String isremarktmp = "";
                                rst.executeSql("update workflow_currentoperator set isremark='2',processUser = "+userid+" where (isremark='0' or isremark='7') and requestid='"+requestid+"' and nodeid='"+nodeid+"' and groupdetailid in("+wfcm.getSameGroupdetailids()+")");

                                wffm.updateForwardRemark(rst, IsBeForwardPending, IsSubmitedOpinion, IsBeForwardSubmit, false,nodeid);

                            }else if(isremark==7&&coadsigntype.equals("1")){//协办人会签关系
                                if(wfcm.getSignorder()==0){
                                    rs1.executeSql("select userid from workflow_currentoperator where isremark='2' and preisremark='0' and (isreject is null or isreject='0') and groupdetailid='"+wfcm.getGroupdetailid()+"' and requestid='"+requestid+"'");
                                    if(rs1.next()){
                                        rst.executeSql("update workflow_currentoperator set isremark='2',processUser = "+userid+" where isremark='0' and requestid='" + requestid+"' and nodeid='"+nodeid + "' and groupdetailid='"+wfcm.getGroupdetailid()+"'");
                                    }
                                }
                            }
                        }

                        // 更新 requestbase 表信息
                        //因为强制收回后status更改了，所以此处要修改该节点的status add by ben 2006-3-29
                        //rst.execute("select *  from workflow_nodelink where destnodeid="+nodeid+" and (isreject='' or isreject is null)");
                        //if (rst.next())
                        status = new RequestNodeFlow().getLinkName(nodeid,billid,requestid,isbill,billtablename);
                        if(canflowtonextnode){
                            if(nextnodeattr==1){
                                //status = SystemEnv.getHtmlLabelName(21394,userlanguage);
                                status = LabelUtil.getMultiLangLabel("21394");
                            }else if(nextnodeattr==2){
                                //status = SystemEnv.getHtmlLabelName(21395,userlanguage);
                                status = LabelUtil.getMultiLangLabel("21395");
                            }
                        }else{
                            //status = SystemEnv.getHtmlLabelName(21395,userlanguage);
                            status = LabelUtil.getMultiLangLabel("21395");
                        }

                        //----------------------------------------------
                        // 获取表单数据签名 start
                        //----------------------------------------------
                        String formsignaturemd5 = "";
                        try {
                            if ("submit".equals(src)) {
                                formsignaturemd5 = WFPathUtil.getFormValMD5(workflowid, requestid, isbill, formid, requestname, this.nodeid);
                            }
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                        //----------------------------------------------
                        // 获取表单数据签名 end
                        //----------------------------------------------
                        if (status.equals(""))
                        {
                            sql = " update workflow_requestbase set " +
                                    " passedgroups = " + passedgroups +

                                    " ,requestname = '" + Util.fromScreen2(requestname, userlanguage) + "' " +
                                    " ,lastoperator = " + userid ;
                            if(!tempcurrentnodetype.equals("3")){//归档流程不更新lastoperatedate和lastoperatetime
                                sql = sql +
                                        " ,lastoperatedate = '" + currentdate + "' " +
                                        " ,lastoperatetime = '" + currenttime + "' " ;
                            }
                            sql = sql +
                                    " ,lastoperatortype = " + usertype ;
                            if(!((isremark==1||isremark==7)&&!CanModify)){
                                if(!"".equals(docids)){
                                    sql += " ,docids = '" + docids + "' ";
                                }
                                if(!"".equals(crmids)){
                                    sql += " ,crmids = '" + crmids + "' ";
                                }
                                if(!"".equals(hrmids)){
                                    if(isoracle){
                                        sql+=" ,hrmids = ? ";
                                    }else{
                                        sql+=" ,hrmids = '"+hrmids+"' ";
                                    }
                                }
                                if(!"".equals(prjids)){
                                    sql += " ,prjids = '" + prjids + "' ";
                                }
                                if(!"".equals(cptids)){
                                    sql += " ,cptids = '" + cptids + "' ";
                                }
                            }
                            //sql+=" where requestid = " + requestid;
                        }
                        else
                        {
                            if (!src.equals("save")) {
                                sql = " update workflow_requestbase set " +
                                        " passedgroups = " + passedgroups +
                                        " ,status = '" + Util.fromScreen2(status, userlanguage) + "' " +
                                        " ,requestname = '" + Util.fromScreen2(requestname, userlanguage) + "' " +
                                        " ,lastoperator = " + userid ;
                            }else{
                                sql = " update workflow_requestbase set " +
                                        " passedgroups = " + passedgroups +
                                        " ,requestname = '" + Util.fromScreen2(requestname, userlanguage) + "' " +
                                        " ,lastoperator = " + userid ;
                            }
                            if(!tempcurrentnodetype.equals("3")){//归档流程不更新lastoperatedate和lastoperatetime
                                sql = sql +
                                        " ,lastoperatedate = '" + currentdate + "' " +
                                        " ,lastoperatetime = '" + currenttime + "' " ;
                            }
                            sql = sql +
                                    " ,lastoperatortype = " + usertype;
                            if(!((isremark==1||isremark==7)&&!CanModify)){
                                if(!"".equals(docids)){
                                    sql += " ,docids = '" + docids + "' ";
                                }
                                if(!"".equals(crmids)){
                                    sql += " ,crmids = '" + crmids + "' ";
                                }
                                if(!"".equals(hrmids)){
                                    if(isoracle){
                                        sql+=" ,hrmids = ? ";
                                    }else{
                                        sql+=" ,hrmids = '"+hrmids+"' ";
                                    }
                                }
                                if(!"".equals(prjids)){
                                    sql += " ,prjids = '" + prjids + "' ";
                                }
                                if(!"".equals(cptids)){
                                    sql += " ,cptids = '" + cptids + "' ";
                                }
                            }
                            //sql+=" where requestid = " + requestid;
                        }

                        //更新签名信息
                        if (!"".equals(formsignaturemd5)) {
                            sql += ", formsignaturemd5='" + formsignaturemd5 + "' ";
                        }

                        if(needFeedBack) {
                            sql += ",lastFeedBackDate = '"+currentdate+"',lastFeedBackTime = '"+currenttime+"',lastfeedbackoperator=" + userid;
                        }
                        sql+=" where requestid = " + requestid;

                        //rs.executeSql(sql);

                        if(isoracle&&!("0".equals(coadismodify)&&isremark==7) && !"".equals(hrmids)){
                            rst.executeUpdate(sql, new Object[]{hrmids});
                        }else{
                            rst.executeSql(sql);
                        }

                        /******/
					/*
					if(isoracle){
						ConnStatement statement2 = null;
						try {
							String sql2 = "select hrmids from workflow_requestbase where requestid="+requestid+" for update";
							statement2 = new ConnStatement();
							statement2.setStatementSql(sql2, false);
							statement2.executeQuery();
			                if(statement2.next()){
				                CLOB theclob = statement2.getClob(1);
				                char[] contentchar = hrmids.toCharArray();
				                Writer contentwrite = theclob.getCharacterOutputStream();
				                contentwrite.write(contentchar);
				                contentwrite.flush();
				                contentwrite.close();
			                }
						} catch (Exception e) {
							rs.writeLog(e);
							e.printStackTrace();
						} finally {
							if(statement2!=null) statement2.close();
						}
					}*/
                        /******/
                        //依次逐个提交对下一个操作者短信提醒 ==start==
                        //sendMsgAndMail.sendMsg(rst,requestid,nextnodeid,user);
                        //依次逐个提交对下一个操作者短信提醒 ==end==

                        //依次逐个提交对下一个操作者邮件提醒 ==start==
                        //sendMsgAndMail.sendMail(rst,workflowid,requestid,nextnodeid,request,fu,isRequest,src,nextnodetype,user);
                        //依次逐个提交对下一个操作者邮件提醒 ==end==

                    }

                    //将已查看操作人的查看状态置为（-1：新提交未查看）
//                    if (!ifchangstatus.equals("")&&isfeedback.equals("1")&&((isnullnotfeedback.equals("1")&&!Util.replace(remark, "\\<script\\>initFlashVideo\\(\\)\\;\\<\\/script\\>", "", 0, false).equals(""))||!isnullnotfeedback.equals("1")))
//                    {
//                        rst.executeSql("update workflow_currentoperator set viewtype =-1  where needwfback='1' and requestid=" + requestid + " and userid<>" + userid + " and viewtype=-2");
//                    }
                    //将自己的查看状态置为（-2：已提交已查看）
                    //TD21155，要求把当前操作人的未查看记录（operatedate为空的）改为当前时间。oracle和sqlserver下的SQL好像是一样的
                    rst.executeSql("update workflow_currentoperator set viewtype =-2 where requestid=" + requestid + "  and userid=" + userid + " and usertype = "+usertype+" and viewtype<>-2" + (nextnodeids.size() == 0 ? "" : " and nodeid not in("+CollectionUtil.list2String(nextnodeids,",")+")"));//下一个节点的数据不做更新
                    rst.executeSql("update workflow_currentoperator set operatedate='"+this.currentdate+"', operatetime='"+this.currenttime+"' where (operatedate is null or operatedate='') and requestid=" + requestid + "  and userid=" + userid + " and usertype = "+usertype+" and viewtype=-2 and isremark in (0,1,8,9,5,6)" + (nextnodeids.size() == 0 ? "" : " and nodeid not in("+CollectionUtil.list2String(nextnodeids,",")+")"));//下一个节点的数据不做更新
                } else {                                        // save,active,delete等不流到下一个节点的
                    if (src.equals("save")) {
                        if (isremark == 1) {                   // 属于批注提交的节点----传阅批量提交也会走这里，暂时先不改，如果后面有问题再考虑把isremark=11单独抽出来
                            // 更新操作者信息 1,删除当前批注人
                            rs.executeQuery(ServiceUtil.calculateCurrentNodeSql(String.valueOf(requestid),userid,usertype));
                            if(rs.next()){
                                currid4CY = Util.getIntValue(rs.getString("id"));
                            }
                            if (cnodetype.equals("3"))
                            {
                                rs.executeSql("update workflow_currentoperator set islasttimes =0 where requestid=" + requestid + "  and userid=" + userid + " and usertype = "+usertype+"  " );
                                if("11".equals(isremark4CY)){
                                    rs.executeSql("update workflow_currentoperator set isremark ='2',operatedate = '"+ currentdate+"',operatetime='"+currenttime+"',islasttimes =1,iscomplete=1,processUser = "+userid+" where requestid=" + requestid + "  and userid=" + userid + " and usertype = "+usertype+"  and isremark='11'" );
                                }else{
                                    rs.executeSql("update workflow_currentoperator set isremark ='2',operatedate = '"+currentdate+"',operatetime='"+currenttime+"',islasttimes =1,iscomplete=1,processUser = "+userid+" where requestid=" + requestid + "  and userid=" + userid + " and usertype = "+usertype+"  and isremark='1'" );
                                }
                                //代理人从已办设置为办结
                                rs.executeSql("update workflow_currentoperator set iscomplete=1 where requestid=" + requestid + " and isremark='2' and  agenttype = '1' and agentorbyagentid="+userid+" ");
                            }
                            else
                            {
                                if(!"0".equals(needwfback)){
                                    //rst.executeProc("workflow_CurOpe_UbyForward", "" + requestid + flag + userid + flag + usertype);
                                    workflow_CurOpe_UbyForward(rst, requestid, userid, usertype, currentdate, currenttime);
                                }else{
                                    //rst.executeProc("workflow_CurOpe_UbyForwardNB", "" + requestid + flag + userid + flag + usertype);
                                    workflow_CurOpe_UbyForwardNB(rst, requestid, userid, usertype, currentdate, currenttime);
                                }
                            }
                            //将已查看操作人的查看状态置为（-1：新提交未查看）

                            //考虑到流程转发的接收人可能也是归档人，如果该人处理后，在归档事宜里应该显示 by ben for td5020
                            if("mysql".equals(rs.getDBType())){
                                rst.executeSql("UPDATE workflow_currentoperator a INNER JOIN workflow_currentoperator b ON (b.requestid = a.requestid) SET a.islasttimes='0' WHERE a.islasttimes = '1' AND a.isremark = '2' AND a.requestid = " + requestid + " AND a.userid = " + userid + " AND a.usertype = " + usertype + " AND b.userid = a.userid AND b.usertype = a.usertype AND b.isremark = '4'");
                                rst.executeSql("update workflow_currentoperator set islasttimes='1' where islasttimes='0' and isremark='4' and requestid="+requestid+" and userid="+userid+" and usertype="+usertype+"  order by id desc limit 1");
                            }else {
                                rst.executeSql("update workflow_currentoperator set islasttimes='0' where islasttimes='1' and isremark='2' and  requestid=" + requestid + " and userid=" + userid + " and usertype=" + usertype + "  and exists (select 1 from workflow_currentoperator a where a.requestid=workflow_currentoperator.requestid and a.userid=workflow_currentoperator.userid and a.usertype=workflow_currentoperator.usertype and a.isremark='4')");
                                rst.executeSql("update workflow_currentoperator set islasttimes='1' where islasttimes='0' and isremark='4' and requestid=" + requestid + " and userid=" + userid + " and usertype=" + usertype + "  and id=(select max(id) from workflow_currentoperator  a where a.islasttimes=workflow_currentoperator.islasttimes and a.isremark=workflow_currentoperator.isremark and a.requestid=workflow_currentoperator.requestid and a.userid=workflow_currentoperator.userid and a.usertype=workflow_currentoperator.usertype)");
                            }

                            //TD4294  删除workflow_currentoperator表中orderdate、ordertime列 fanggsh begin
//                            if (!ifchangstatus.equals("")&&isfeedback.equals("1")&&((isnullnotfeedback.equals("1")&&!Util.replace(remark, "\\<script\\>initFlashVideo\\(\\)\\;\\<\\/script\\>", "", 0, false).equals(""))||!isnullnotfeedback.equals("1"))) {
//                                rst.executeSql("update workflow_currentoperator set viewtype =-1  where needwfback='1' and requestid=" + requestid + " and userid<>" + userid + " and viewtype=-2");
//                            }
                            RequestBaseBiz.operateFeedBack(requestid,workflowid,nodeid,userid,remark,currentdate,currenttime);
                            haspassthisnode = true;//added by pony on 2006-06-09 for TD4463
                        } else {
                            ////因为强制收回后status更改了，所以此处要修改该节点的status add by ben 2006-3-29
                            //rst.execute("select * from  workflow_nodelink where destnodeid="+nodeid+" and (isreject='' or isreject is null)");
                            //if (rst.next())
                            if(isremark==7 && "2".endsWith(coadsigntype) && tempsrc.equals("submit")){ //当协办人会签关系是不影响流程流转且来自提交时提交后进入到已办而不是始终在待办可提交多次
                                rst.executeSql("select * from workflow_currentoperator where iscomplete='1' and requestid='"+requestid+"'");
                                if(rst.next()){
                                    rst.executeSql("update workflow_currentoperator set isremark='2',iscomplete='1',preisremark='7',operatedate='"+currentdate+"',operatetime='"+currenttime+"',processUser = "+userid+" where isremark ='7' and requestid=" + requestid+" and nodeid="+nodeid);
                                }else{
                                    rst.executeSql("update workflow_currentoperator set isremark='2',preisremark='7',operatedate='"+currentdate+"',operatetime='"+currenttime+"',processUser = "+userid+" where isremark ='7' and requestid=" + requestid+" and nodeid="+nodeid+" and userid='"+userid+"'");
                                }
                            }
                            status = new RequestNodeFlow().getLinkName(nodeid,billid,requestid,isbill,billtablename);
                            nextnodeattr=wflinkinfo.getNodeAttribute(nodeid);
                            if(canflowtonextnode){
                                if(nextnodeattr==1){
                                    //status = SystemEnv.getHtmlLabelName(21394,userlanguage);
                                    status = LabelUtil.getMultiLangLabel("21394");
                                }else if(nextnodeattr==2){
                                    //status = SystemEnv.getHtmlLabelName(21395,userlanguage);
                                    status = LabelUtil.getMultiLangLabel("21395");
                                }
                            }else{
                                //status = SystemEnv.getHtmlLabelName(21395,userlanguage);
                                status = LabelUtil.getMultiLangLabel("21395");
                            }

                            //----------------------------------------------
                            // 获取表单数据签名 start
                            //----------------------------------------------
                            String formsignaturemd5 = "";
                            try {
                                if ("save".equals(src)) {
                                    formsignaturemd5 = WFPathUtil.getFormValMD5(workflowid, requestid, isbill, formid, requestname, this.nodeid);
                                }
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                            //----------------------------------------------
                            // 获取表单数据签名 end
                            //----------------------------------------------

                            // 更新 requestbase 表信息
                            if (status.equals(""))
                            {
                                sql = " update workflow_requestbase set " +
                                        " requestname = '" + Util.fromScreen2(requestname, userlanguage) + "' " ;
                                if(!"true".equals(isFromEditDocument)){
                                    sql=sql+" ,lastoperator = " + userid ;
                                }


                                if(!tempcurrentnodetype.equals("3")&&!"true".equals(isFromEditDocument)){//归档流程不更新lastoperatedate和lastoperatetime
                                    sql = sql +
                                            " ,lastoperatedate = '" + currentdate + "' " +
                                            " ,lastoperatetime = '" + currenttime + "' " ;
                                }
                                sql = sql +
                                        " ,lastoperatortype = " + usertype ;
                                if(!((isremark==1||isremark==7)&&!CanModify)){
                                    if(!"".equals(docids)){
                                        sql += " ,docids = '" + docids + "' ";
                                    }
                                    if(!"".equals(crmids)){
                                        sql += " ,crmids = '" + crmids + "' ";
                                    }
                                    if(!"".equals(hrmids)){
                                        if(isoracle){
                                            sql+=" ,hrmids = ? ";
                                        }else{
                                            sql+=" ,hrmids = '"+hrmids+"' ";
                                        }
                                    }
                                    if(!"".equals(prjids)){
                                        sql += " ,prjids = '" + prjids + "' ";
                                    }
                                    if(!"".equals(cptids)){
                                        sql += " ,cptids = '" + cptids + "' ";
                                    }
                                }
                                //sql+=" where requestid = " + requestid;
                            }
                            else
                            {
                                if (!src.equals("save")) {
                                    sql = " update workflow_requestbase set " +
                                            " requestname = '" + Util.fromScreen2(requestname, userlanguage) + "' " +
                                            " ,status = '" + Util.fromScreen2(status, userlanguage) + "' " ;
                                }else{
                                    sql = " update workflow_requestbase set " +
                                            " requestname = '" + Util.fromScreen2(requestname, userlanguage) + "' " ;
                                }

                                if(!"true".equals(isFromEditDocument)){
                                    sql=sql+" ,lastoperator = " + userid ;
                                }
                                if(!tempcurrentnodetype.equals("3")&&!"true".equals(isFromEditDocument)){//归档流程不更新lastoperatedate和lastoperatetime
                                    sql = sql +
                                            " ,lastoperatedate = '" + currentdate + "' " +
                                            " ,lastoperatetime = '" + currenttime + "' " ;
                                }
                                sql = sql +
                                        " ,lastoperatortype = " + usertype ;
                                if(!((isremark==1||isremark==7)&&!CanModify)){
                                    if(!"".equals(docids)){
                                        sql += " ,docids = '" + docids + "' ";
                                    }
                                    if(!"".equals(crmids)){
                                        sql +=" ,crmids = '" + crmids + "' ";
                                    }
                                    if(!"".equals(hrmids)){
                                        if(isoracle){
                                            sql+=" ,hrmids = ? ";
                                        }else{
                                            sql+=" ,hrmids = '"+hrmids+"' ";
                                        }
                                    }
                                    if(!"".equals(prjids)){
                                        sql += " ,prjids = '" + prjids + "' ";
                                    }
                                    if(!"".equals(cptids)){
                                        sql += " ,cptids = '" + cptids + "' ";
                                    }
                                }
                                //sql+=" where requestid = " + requestid;
                            }

                            if (!"".equals(formsignaturemd5)) {
                                sql += ", formsignaturemd5='" + formsignaturemd5 + "' ";
                            }
                            sql+=" where requestid = " + requestid;
                            //rs.executeSql(sql);
                            if(isoracle&&!("0".equals(coadismodify)&&isremark==7) && !"".equals(hrmids)){
                                rst.executeUpdate(sql, new Object[]{hrmids});
                            }else{
                                rst.executeSql(sql);
                            }
                            /******/
						/*
						if(isoracle){
							ConnStatement statement3 = null;
							try {
								String sql3 = "select hrmids from workflow_requestbase where requestid="+requestid+" for update";
								statement3 = new ConnStatement();
								statement3.setStatementSql(sql3, false);
								statement3.executeQuery();
				                if(statement3.next()){
					                CLOB theclob = statement3.getClob(1);
					                char[] contentchar = hrmids.toCharArray();
					                Writer contentwrite = theclob.getCharacterOutputStream();
					                contentwrite.write(contentchar);
					                contentwrite.flush();
					                contentwrite.close();
				                }
							} catch (Exception e) {
								rs.writeLog(e);
								e.printStackTrace();
							} finally {
								if(statement3!=null) statement3.close();
							}
						}*/
                            /******/
                        }

                    }
                    if (src.equals("delete")) {
				    /*
					//删除流程中所带附件 QC46085
					Monitor monitor=new Monitor();
					monitor.delWfAcc(""+requestid);

	                //add by mackjoe at 2005-10-20 增加流程删除时，删除单据中的相关数据
	                SysWFLMonitor wflm=new SysWFLMonitor();
	                wflm.WorkflowDel(requestid+"");
	                //end by mackjoe
	                // 2005-03-24 Guosheng for TD1725**************************************
					poppupRemindInfoUtil.deletePoppupRemindInfo(requestid,0);
					poppupRemindInfoUtil.deletePoppupRemindInfo(requestid,1);
                    poppupRemindInfoUtil.deletePoppupRemindInfo(requestid,10);
					sql = "delete from workflow_logviewusers where exists (select 1 from workflow_requestLog where workflow_requestLog.requestid = " + requestid + " and workflow_requestLog.logid = workflow_logviewusers.logid)";  //删除签字意见权限控制的表中的数据
                    rst.executeSql(sql);
					sql = "delete workflow_currentoperator where requestid =" + requestid  ;
					rst.executeSql(sql);
					sql = "delete from  workflow_form where requestid=" + requestid  ;
					rst.executeSql(sql);
					sql = "delete from  workflow_requestLog where requestid=" + requestid  ;
					rst.executeSql(sql);
					sql = "delete from  workflow_requestViewLog where id=" + requestid ;

                    rst.executeSql(sql);
					sql = "delete from  workflow_requestbase where requestid=" + requestid ;
					rst.executeSql(sql);
					//删除流程对应共享
					sql = "delete from  Workflow_SharedScope where requestid=" + requestid ;
					rst.executeSql(sql);


					//特殊处理(费用流程，在流程删除时，同时，已经配置生效、释放冻结预算)
					try {
		        		FnaCommon fnaCommon = new FnaCommon();
		        		fnaCommon.doWfForceOver(requestid, 0, true);
		            }catch(Exception easi) {
		            	this.writeLog(easi);
					}

                    sql="delete from workflow_groupdetail where EXISTS(select 1 from workflow_nodegroup where workflow_groupdetail.groupid=workflow_nodegroup.id and EXISTS(select 1 from workflow_nodebase b where workflow_nodegroup.nodeid=b.id and b.IsFreeNode='1' and b.requestid="+requestid+"))";
                    rs.executeSql(sql);
                    sql="delete from workflow_nodegroup where EXISTS(select 1 from workflow_nodebase b where workflow_nodegroup.nodeid=b.id and b.IsFreeNode='1' and b.requestid="+requestid+")";
                    rs.executeSql(sql);
                    sql="delete from workflow_nodemode where EXISTS(select 1 from workflow_nodebase b where workflow_nodemode.nodeid=b.id and b.IsFreeNode='1' and b.requestid="+requestid+")";
                    rs.executeSql(sql);
                    sql="delete from workflow_nodeform where EXISTS(select 1 from workflow_nodebase b where workflow_nodeform.nodeid=b.id and b.IsFreeNode='1' and b.requestid="+requestid+")";
                    rs.executeSql(sql);
                    sql="delete from workflow_flownode where EXISTS(select 1 from workflow_nodebase b where workflow_flownode.nodeid=b.id and b.IsFreeNode='1' and b.requestid="+requestid+")";
                    rs.executeSql(sql);
                    sql="delete from workflow_nodelink where EXISTS(select 1 from workflow_nodebase b where workflow_nodelink.nodeid=b.id and b.IsFreeNode='1' and b.requestid="+requestid+") or EXISTS(select 1 from workflow_nodebase b where workflow_nodelink.destnodeid=b.id and b.IsFreeNode='1' and b.requestid="+requestid+") or wfrequestid="+requestid;
					rst.executeSql(sql);
                    sql="delete from workflow_nodebase where IsFreeNode='1' and requestid="+requestid;
					rst.executeSql(sql);
					// 2005-03-24 Guosheng for TD1725**************************************
                    // 2014-9-3 add delete log
                      */
                        RequestDeleteLog log = new RequestDeleteLog();
                        log.setRequestId(String.valueOf(requestid));
                        log.setRequestName(Util.fromScreen2(requestname, userlanguage));
                        log.setOperateUserId(String.valueOf(userid));
                        log.setOperateDate(currentdate);
                        log.setOperateTime(currenttime);
                        log.setWorkflowId(String.valueOf(workflowid));
                        String clientip = "";
                        if (isRequest) {
                            if (request != null)
                                clientip = Util.null2String(request.getRemoteAddr());
                        } else {
                            if (fu != null)
                                clientip = Util.null2String(fu.getRemoteAddr());
                        }
                        log.setClientAddress(clientip);
                        //由于并非实际删除流程，这里流程相关附件就不删除了
                        try{
                            RequestDeleteUtils rdu = new RequestDeleteUtils(requestid,rst,log,user);
                            rdu.executeDeleteRequest();
                        }catch(Exception exception){
                            WriteSubmitErrorLog();
                            exception.printStackTrace();
                            rst.rollback();
                            if(exception.getMessage().indexOf("workflow interface action error")>-1){
                                if("".equals(this.getMessage())){
                                    this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_10);
                                }
                                if("".equals(this.getMessagecontent())){
                                    this.setMessagecontent(WorkflowRequestMessage.resolveDetailInfo(SystemEnv.getHtmlLabelNames("522595,83071", user.getLanguage())));
                                }
                            }
                            return false;
                        }
                        //特殊处理(费用流程，在流程删除时，同时，已经配置生效、释放冻结预算)
                        try {
                            FnaCommon fnaCommon = new FnaCommon();
                            fnaCommon.doWfForceOver(requestid, 0, true);
                        }catch(Exception easi) {
                            this.writeLog(easi);
                        }
                      //E9 新考勤，删除流程后删除流程数据
                      try {
                        new KQFlowActiontBiz().delTest(requestid,workflowid+"","RequestManager delete");
                      }catch(Exception e) {
                        new BaseBean().writeLog(e);
                      }
                    }
                    if (src.equals("active")) {
                        // 更新 requestbase 表信息, 将 deleted 设置为0
                        sql = " update workflow_requestbase set " +
                                " lastoperator = " + userid ;
                        if(!tempcurrentnodetype.equals("3")){//归档流程不更新lastoperatedate和lastoperatetime
                            sql = sql +
                                    " ,lastoperatedate = '" + currentdate + "' " +
                                    " ,lastoperatetime = '" + currenttime + "' " ;
                        }
                        sql = sql +
                                " ,lastoperatortype = " + usertype +
                                " ,deleted = 0 " +
                                " where requestid = " + requestid;
                        rst.executeSql(sql);
                    }
                    //流程督办处理
                    if (src.equals("supervise")) {
                        // 更新查看过的人为有回复未查看，显示为黄色new
//                        if (!ifchangstatus.equals("")&&isfeedback.equals("1")&&((isnullnotfeedback.equals("1")&&!Util.replace(remark, "\\<script\\>initFlashVideo\\(\\)\\;\\<\\/script\\>", "", 0, false).equals(""))||!isnullnotfeedback.equals("1"))) {
//                            sql = " update workflow_currentoperator set viewtype = -1 where needwfback='1' and requestid = " + requestid+" and viewtype=-2 and userid <>"+userid;
//                            rst.executeSql(sql);
//                        }
                        // 更新 requestbase 表信息
                        sql = " update workflow_requestbase set " +
                                " lastoperator = " + userid ;
                        if(!tempcurrentnodetype.equals("3")){//归档流程不更新lastoperatedate和lastoperatetime
                            sql = sql +
                                    " ,lastoperatedate = '" + currentdate + "' " +
                                    " ,lastoperatetime = '" + currenttime + "' " ;
                        }
                        if(needFeedBack) {
                            sql += ",lastFeedBackDate = '"+currentdate+"',lastFeedBackTime = '"+currenttime+"',lastfeedbackoperator =" + userid;
                        }
                        sql = sql +
                                " ,lastoperatortype = " + usertype +
                                " where requestid = " + requestid;
                        rst.executeSql(sql);
                    }
                }
                //更新超时时间
                //OvertimeBiz.getInstance().updateOvertime(this,rst);
                // 请求的基本表信息和操作者信息结束

                //当前节点更新
                if(nextnodeattr>=3 && nextnodeattr <=5 && nodeid != nextnodeid) {//分叉合并节点
                    rst.executeQuery("select t.currentnodeid from workflow_requestbase t where t.requestid = "+requestid+" and EXISTS (select 1 from workflow_currentoperator t1 where t1.isremark = 0 and t1.requestid = "+requestid+" and t1.nodeid = t.currentnodeid)" );
                    if(!rst.next()){
                        rst.executeQuery("select nodeid,nodetype from workflow_flownode where nodeid = (select max(nodeid) from workflow_currentoperator  where isremark = 0 and requestid = "+requestid+")" );
                        if(rst.next()) {
                            rst.executeUpdate("update workflow_requestbase set currentnodeid = " + rst.getString("nodeid") + ",currentnodetype = " + rst.getString("nodetype") +"  where requestid = "+requestid);
                        }
                    }
                }

                rst.commit();
                try {
                    //提交流程， 重置预测
                    if (!"save".equals(this.src)) {
                        new AutoForecastBiz().resetForecast(requestid);
                    }


                    //如果提交时将意见征询的记录也更新为已办，则需要更新征询人的状态
                    if ("submit".equals(this.src)) {
                        new TakReplyBiz(requestid, workflowid, user).doTakingReply(false);
                    }

                    //自动批准
                    if(this.doAutoApprove) {
//                    String updateSql = "update workflow_currentoperator set isremark = '2',viewtype = '-2'  where requestid = ? and userid = ? and nodeid = ? and isremark = ? ";
//                    rs.executeUpdate(updateSql,requestid,userid,nodeid,"6");
                        String sql = "update workflow_currentoperator set isremark = '2',viewtype = '-2',operatedate='"+this.currentdate+"', operatetime='"+this.currenttime+"'  where requestid = "+requestid+" and userid = "+userid+" and nodeid = "+nodeid+" and isremark = '6' ";
                        rs.executeUpdate(sql);
                    }

                    //流程测试信息存入缓存
                    if(this.istest == 1) {
                        WorkflowTestBiz.setWorkflowTestInfo(this.src, this.requestid, this.nodeid, this.status, this.nextlinkids,this.getNextNodeid());
                    }

                    //推送处理start
                    WFPathUtil wfutil = new WFPathUtil();

                    //wfutil.getFixedThreadPool().execute(new RequestPreProcessing(iscreate, workflowid, isbill, formid, requestid, requestname, oldformsignaturemd5, nodeid, nextnodeid, haspassthisnode, finishndgpids, user, false));
                    //new Thread().start();
                    //推送处理end
                } catch (Exception e) {
                    log.info("requestid:" + requestid + "后续逻辑执行异常记录,e:" + e.getMessage());
                    e.printStackTrace();
                }
            }catch(Exception exception){
                WriteSubmitErrorLog();
                exception.printStackTrace();
                rst.rollback();
                return false;
            }
            if(src.equals("submit") || src.equals("reject") || src.equals("reopen") || src.equals("save") || src.equals("supervise") || src.equals("intervenor")){
                //处理退回提醒
                if(src.equals("reject")){
                    String ischangrejectnode="";
                    sql="select isrejectremind,ischangrejectnode from workflow_flownode where workflowid="+workflowid + " and nodeid=" + this.nodeid;
                    rs.executeSql(sql);
                    if(rs.next()){
                        isrejectremind=Util.null2String(rs.getString("isrejectremind"));
                        ischangrejectnode=Util.null2String(rs.getString("ischangrejectnode"));
                    }
                    if(isrejectremind.equals("1")){
                        if(ischangrejectnode.equals("1")){
                            if(isRequest){
                                if (request != null){
                                    rejectremindnodes = Util.null2String(request.getParameter("RejectNodes"));
                                }
                            } else {
                                if (fu != null){
                                    rejectremindnodes = Util.null2String(fu.getParameter("RejectNodes"));
                                }
                            }
                        }else{
                            rejectremindnodes="-1";
                        }
                        //System.out.println("rejectremindnodes:"+rejectremindnodes);
                        if(!rejectremindnodes.equals("")){
                            //获得提醒人
                            sql="select distinct userid,usertype from workflow_currentoperator where requestid="+requestid+" and not (userid="+userid+" and usertype="+usertype+") ";
                            if(!rejectremindnodes.equals("-1")){
                                if(rejectremindnodes.startsWith(",")){
                                    rejectremindnodes = rejectremindnodes.substring(1);
                                }
                                sql+=" and nodeid in("+rejectremindnodes+")";
                            }

                        }
                    }
                }
                //穿透再异常处理，显示异常，提前插入一份异常处理记录
                if(eh_operatorMap.size()>0 ){
                    //查阅类型不记录意见
                    if(!nodetype.equals("4")){
                        FlowExceptionHandle flowExceptionHandle = new FlowExceptionHandle();
                        ArrayList _alluserids = new ArrayList();
                        for (int n = 0; n < nextnodeids.size(); n++) {
                            nextnodeid = Util.getIntValue((String) nextnodeids.get(n), 0);
                            nextnodeattr = Util.getIntValue((String) nextnodeattrs.get(n), 0);
                            //异常处理信息存workflow_requestexceptionflow表
                            int requestexceptiontype = 0;
                            if(requestexceptiontypes.size() > n)
                                requestexceptiontype = Util.getIntValue((String)requestexceptiontypes.get(n));
                            flowExceptionHandle.saveRequestExceptionFlowInfo(requestid, nodeid, nextnodeid, requestexceptiontype, eh_operatorMap);
                        }
                    }
                }

                if(autoApproveParams == null || autoApproveParams.isLeaveMarks()) {
                    islogsuccess = saveRequestLog2();
                }
                if(autoApproveParams != null && !autoApproveParams.isLeaveMarks()){
                    if(nodeInfoCache != null && nodeInfoCache.size() > 0) {
                        for(Map.Entry<Integer,AutoApproveParams> item : nodeInfoCache.entrySet()) {
                            item.getValue().setStartLogId(autoApproveParams.getStartLogId());
                        }
                    }
                    setAutoApproveReceiveUser();
                }
                if(islogsuccess) {
                    if("reject".equals(src)) {
                        if(isRequest) {
                            if(request != null) {
                                this.isSubmitDirect = Util.null2String(request.getParameter("isSubmitDirect"));
                            }
                        }else {
                            if(fu != null) {
                                this.isSubmitDirect = Util.null2String(fu.getParameter("isSubmitDirect"));
                            }
                        }
                        if("1".equals(this.isSubmitDirect)) { // 退回后再提交直达本节点
                            rs.executeSql("select * from workflow_requestlog where logtype = '3' and requestid=" + requestid + " and nodeid=" + nodeid + " order by logid desc");
                            if(rs.next()) {
                                rs.executeSql("update workflow_requestlog set isSubmitDirect='" + this.isSubmitDirect + "' where logid=" + Util.getIntValue(rs.getString("logid"), 0));
                            }

                        }
                    }
                }

                //由于下面会进行islasttimes的更新动作，等更新完成后再记录修改日志
//            if (rolm != null) {
//                //流程提交完成， 记录最新数据， 并与之前数据做对比， 记录修改日志
//                rolm.flowTransSubmitAfter();
//            }

            }
            //add by liaodong for qc76119,76120,54194,64652 start
            //回写穿透时workflow_requestLog日志penetrateFlag lastNodeId
            if(!"".equals(penetrateFlag)){ //有穿透的功能时候
                //查询requestId下面的最新的流程
                if(penetrateFlag.indexOf(",")>=0){
                    penetrateFlag = penetrateFlag.substring(penetrateFlag.indexOf(",")+1,penetrateFlag.length());
                    updatePrenetrateLog(penetrateFlag, lastNodeId, flowNextLinkId);
                }else{
                    updatePrenetrateLog(penetrateFlag, lastNodeId, flowNextLinkId);
                }
            }
            //end

            //子流程归档设置，数据汇总主流程，插入明细相关信息，不考虑主流程明细是否只读qc:
            try{
                //是否开启子流程全部归档才能提交,子流程归档时调用
                if(WFSubDataAggregation.checkSubProcessSummary(this.requestid)){
                    String cmainRequestId = SubWorkflowTriggerService.getMainRequestId(this.requestid);
                    if (cmainRequestId != null && !(cmainRequestId.length()==0)) {
                        if (canflowtonextnode&&nextnodetype.equals("3")) {
                            WFSubDataAggregation.addMainRequestDetail(cmainRequestId,this.requestid+"",-1,user);
                        }
                    }
                }

                if(nextnodetype.equals("3") && isLastSubRequest){
                    WFSubDataAggregation.subWfFileReminMainWf(this.requestid,user,request,fu,this.isRequest);
                }


                //主流程到达汇总节点时判断子流程是否已归档，已归档则进行汇总
                List<String> subList = WFSubDataAggregation.getSubRequestIdByMain(this.requestid,workflowid,nextnodeid);
                if(subList.size()>0){
                    for(int r=0;r<subList.size();r++){
                        WFSubDataAggregation.addMainRequestDetail(this.requestid+"",subList.get(r),nextnodeid,user);
                    }
                }

            }catch(Exception e){
                e.printStackTrace();
            }

            /**
             * 触发子流程 为了防止死锁，移到事物结束后处理。子流程触发失败，不影响主流程流转
             * chujun
             * Start
             */
            try{
                if(istest != 1 ){
                    ExecutorService fixedThreadPool = new WFPathUtil().getSubRequestThreadPool();
                    for(int i=0; i<nodeidList_sub.size(); i++){
                        int nodeid_tmp = Util.getIntValue((String)nodeidList_sub.get(i), 0);
                        String triggerTime_tmp = Util.null2String((String)triggerTimeList_sub.get(i));
                        //
                        Util_TableMap.setVal(String.format("trisub_%s_%s",this.getRequestid(),nodeid_tmp ), "1");
                        SubWorkflowTriggerServiceThread triggerService = new SubWorkflowTriggerServiceThread(this, nodeid_tmp, hasTriggeredSubwf, user,triggerTime_tmp);
                        // 线程池执行子流程
                        fixedThreadPool.execute(triggerService);
                    }
                }
            }catch(Exception e){
                writeLog(e);
            }
            //触发子流程End

            /**
             * 流程触发日程 TD13304
             */
            try{
                String clientip = "";
                if(isRequest){
                    if (request != null){
                        clientip = Util.null2String(request.getRemoteAddr());
                    }
                }else{
                    if (fu != null){
                        clientip = Util.null2String(fu.getRemoteAddr());
                    }
                }
                String sqlExt = "";
                for(int i=0; i<nodeidList_wp.size(); i++){
                    String nodeid_tmp = Util.null2String((String)nodeidList_wp.get(i));
                    String createTime_tmp = Util.null2String((String)createTimeList_wp.get(i));
                    sqlExt += " (nodeid="+nodeid_tmp+" and changetime="+createTime_tmp+") or";
                }
                if(!"".equals(sqlExt) && (src.equals("submit") || src.equals("reject"))){
                    CreateWorkplanByWorkflow createWorkplanByWorkflow = null;
                    sqlExt = sqlExt.substring(0, sqlExt.length()-2);
                    RecordSet rs_wp = new RecordSet();
                    rs_wp.execute("select * from workflow_createplan where wfid="+this.workflowid+" and ("+sqlExt+") order by id");
                    while(rs_wp.next()){
                        int createplanid = Util.getIntValue(rs_wp.getString("id"), 0);
                        int plantypeid_tmp = Util.getIntValue(rs_wp.getString("plantypeid"), 0);
                        int creatertype_tmp = Util.getIntValue(rs_wp.getString("creatertype"), 0);
                        int wffieldid_tmp = Util.getIntValue(rs_wp.getString("wffieldid"), 0);
                        int changemode = Util.getIntValue(rs_wp.getString("changemode"));
                        if(changemode == 2 && src.equals("submit")) continue;
                        if(changemode == 1 && src.equals("reject")) continue;
                        createWorkplanByWorkflow = new CreateWorkplanByWorkflow();
                        createWorkplanByWorkflow.setCreateplanid(createplanid);
                        createWorkplanByWorkflow.setWorkplantypeid(plantypeid_tmp);
                        createWorkplanByWorkflow.setWp_creatertype(creatertype_tmp);
                        createWorkplanByWorkflow.setWf_fieldid(wffieldid_tmp);
                        createWorkplanByWorkflow.setWf_formid(this.formid);
                        createWorkplanByWorkflow.setWf_isbill(this.isbill);
                        createWorkplanByWorkflow.setWf_requestid(this.requestid);
                        createWorkplanByWorkflow.setWf_wfid(this.workflowid);
                        createWorkplanByWorkflow.setUser(this.user);
                        createWorkplanByWorkflow.setRemoteAddr(clientip);
                        createWorkplanByWorkflow.createWorkplan();
                    }
                }
            }catch(Exception e){
                writeLog(e);
            }

            // 处理共享信息
            //modify by xhheng @20050406 for TD 1758
            if ((src.equals("save") && isremark == 1) || src.equals("submit") || src.equals("reject") || src.equals("intervenor")) {

                //处理文档消息推送
                processDocPush();

                //流程归档，删除Workflow_DocSource数据
                if (canflowtonextnode&&nextnodetype.equals("3")) {
                    rs.execute("select docRightByOperator from workflow_base where id="+workflowid);
                    if(rs.next()){
                        if(Util.getIntValue(rs.getString("docRightByOperator"),0)==1){
                            rs.execute("delete from Workflow_DocSource where requestid =" + requestid );
                        }
                    }
                    rs.executeQuery("select distinct groupdetailid from workflow_currentoperator where groupid=-2 and requestid = ?",requestid);
                    List<Integer> groupdetailidList = new ArrayList<>();
                    while (rs.next()) {
                        groupdetailidList.add(rs.getInt("groupdetailid"));
                    }
                    if(groupdetailidList.size() > 0) {
                        rs.executeUpdate("delete from workflow_groupdetail where groupid=-2 and id in ("+ StringUtils.join(groupdetailidList,",") +")");
                    }
                    rs.execute("delete from workflow_agentpersons where requestid =" + requestid );
                }

                for(int i=0;i<submituserids.size();i++){
                    int tempworkflowcurrid=0;
                    int tempislasttimes=0;
                    rs.executeSql("select id,islasttimes from workflow_currentoperator where (isremark = 5 or isremark=0 or isremark=1 or isremark=8 or isremark=9 or isremark=7) and requestid=" + requestid + " and userid=" + submituserids.get(i) + " and usertype=" + submitusertypes.get(i) + " order by id");
                    while (rs.next()) {
                        int tislasttimes = rs.getInt("islasttimes");
                        if (tislasttimes != 1) {
                            tempworkflowcurrid = rs.getInt("id");
                        } else {
                            tempislasttimes = 1;
                            break;
                        }
                    }
                    if (tempislasttimes == 0 && tempworkflowcurrid > 0) {
                        rs.executeSql("update workflow_currentoperator set islasttimes=0 where requestid=" + requestid + " and userid=" + submituserids.get(i) + " and usertype=" + submitusertypes.get(i));
                        rs.executeSql("update workflow_currentoperator set islasttimes=1 where id=" + tempworkflowcurrid);
                    }
                }
            }
            try{
                fixIslastrimes();
                if(wflinkinfo.getNodeAttribute(nodeid)==2){
                    this.CheckUserIsLasttimes(requestid, nodeid, user);
                }
            }catch(Exception e){
                writeLog(e);
            }
            try{
                //更新流程标题
                new SetNewRequestTitle().getAllRequestName(rs,requestid+"",requestname,workflowid+"",nodeid+"",formid,isbill,userlanguage);
            }catch(Exception e){}

            if(src.equals("submit") || src.equals("reject") || src.equals("reopen") || src.equals("save") || src.equals("supervise") || src.equals("intervenor")){

                if (rolm != null) {
                    //流程提交完成， 记录最新数据， 并与之前数据做对比， 记录修改日志
                    rolm.setDoAutoApprove(this.isDoAutoApprove());
                    rolm.setNextNodeIsAutoApprove(nodeInfoCache.size() > 0);
                    rolm.flowTransSubmitAfter();

                    boolean isMode = false;
                    rs4.executeQuery("select ismode from workflow_flownode where nodeid = ? and ismode = 1", nodeid);
                    if(rs4.next()){
                        isMode = true;
                    }
                    if(istest != 1 && isMode && !isBatchSubmit){
                        RequestRemindBiz remindBiz = new RequestRemindBiz(user);
                        remindBiz.requestSubmitRemind4WebService(requestid,workflowid,-1,-1);
                    }
                }
                if(istest != 1 && ((src.equals("save") && isremark == 1) || src.equals("submit") || src.equals("reject") || src.equals("intervenor"))){
                    try {
                        if (src.equals("intervenor"))   haspassthisnode = true;
                        RequestAddShareInfo shareinfo = new RequestAddShareInfo();
                        for(int n=0;n<nextnodeids.size();n++){
                            nextnodeid=Util.getIntValue((String)nextnodeids.get(n),0);
                            shareinfo.setRequestid(requestid);
                            shareinfo.SetWorkFlowID(workflowid);
                            shareinfo.SetNowNodeID(nodeid);
                            if(nextnodeid==0)
                                shareinfo.SetNextNodeID(nodeid);
                            else
                                shareinfo.SetNextNodeID(nextnodeid);
                            shareinfo.setIsbill(isbill);
                            shareinfo.setUser(user);
                            shareinfo.SetIsWorkFlow(1);
                            shareinfo.setBillTableName(billtablename);
                            shareinfo.setHaspassnode(haspassthisnode);
                            shareinfo.setRequestCheckAddinRulesList(requestCheckAddinRulesList);
                            shareinfo.setSrc(src);

                            shareinfo.setReCalculatePermission(isReCalculatePermission);
                            shareinfo.addShareInfo();
                        }
                    }catch(Exception easi) {
                        easi.printStackTrace();
                    }
                }
                //下一节点自动批准 如何解决分叉流程
                if(nodeInfoCache.size() > 0){
                    WeaverRequest weaverRequest = null;
                    if(request != null) {
                        if(request instanceof WeaverRequest) {
                            weaverRequest = (WeaverRequest) request;
                        } else {
                            weaverRequest = new WeaverRequest(request);
                            weaverRequest.setSession(request.getSession());
                        }
                    }
                    if(autoApproveParams==null) {
                        WFAutoApproveUtils wfAutoApproveUtil = new WFAutoApproveUtils(this,nodeInfoCache);
                        wfAutoApproveUtil.setRequest(weaverRequest);
                        wfAutoApproveUtil.setFlowNextLinkId(flowNextLinkId);
                        if(istest == 1) {
                            GCONST.WFProcessing.remove(requestid + "_" + nodeid);//流程测试时先要移除，否则依次逐个处理时会卡住
                            wfAutoApproveUtil.excuteflownextnodeForTest();
                        }
                        else
                            WFAutoApproveThreadPoolUtil.getFixedThreadPool().execute(wfAutoApproveUtil);
                    }else{
                        for (Map.Entry <Integer, AutoApproveParams> item : nodeInfoCache.entrySet()) {
                            autoApproveQueue.offer(item.getValue());
                        }
                    }
                }

                if(nodeInfoCache.size() <= 0){//没有自动批准
                    //流程流转提醒
                    boolean isChangeNode = true;
                    //普通节点提交，如果workflow_nownode不包含当前节点，说明流程流转到了其他节点
                    if(!FreeNodeBiz.isFreeNode(nodeid)) {
                        rs.executeQuery("select 1 from workflow_nownode where requestid = ? and nownodeid = ?", requestid, nodeid);
                        if (rs.next()) isChangeNode = false;
                    }else{//自由节点提交，提交合并，会删除当前节点在workflow_nownode数据，需单独处理
                        if(nextnodeids.contains(nodeid+"") || nextnodeids.size() == 0) isChangeNode = false;
                    }

                    //批量提交，批注也会走requestmanager，当下一节点为空时，不做流转提醒
                    if(nextnodeids.size() == 0) isChangeNode = false;

                    if(canflowtonextnode && !"1".equals(iscreate) && isChangeNode){
                        RequestFlowRemindBiz rbz = new RequestFlowRemindBiz();
                        rbz.doRequestflowRemind(requestid,workflowid,nextnodeids,userid,currentdate, currenttime);
                    }

                    if (isBatchSubmit) {
                        RequestRemindBiz remindBiz = new RequestRemindBiz(user);
                        remindBiz.batchSubmitRemind(requestid,this.src);
                    }
                }
            }


            try{
                WFPathUtil wfutil = new WFPathUtil();
                wfutil.getFixedThreadPool().execute(new RequestPreProcessing(iscreate, workflowid, isbill, formid, requestid, requestname, oldformsignaturemd5, nodeid, nextnodeid, haspassthisnode, finishndgpids, user, false));
            }catch(Exception e){
            }
            if(nextnodetype.equals("3")){//归档时回写流程信息外部数据TD10797
                RequestManageWriteBackAction writebackaction = new RequestManageWriteBackAction();
                writebackaction.doWriteBack(this.requestid);
            }
            //TD 24650 ——xyz 如果节点后附加操作为流程存为文档，那么等所有操作执行之后，来执行存为文档操作
            if(isWorkFlowToDoc&&nodeid!=nextnodeid)
            {
                Action action= (Action)StaticObj.getServiceByFullname("action.WorkflowToDoc", Action.class);
                RequestService requestService=new  RequestService();
                //String msg=action.execute(requestService.getRequest(requestid));
                String msg=action.execute(requestService.getRequest(this));
            }
            //主流程自动流转
            SubWorkflowTriggerService.judgeMainWfAutoFlowNextNode(this.requestid);


            if(src.equals("reject")){
                /*
                 * 不知道哪里会修改操作者时间，导致退回的时候操作时间和后面接受人员的时间不一致
                 * 在这做一次修改 进行同步
                 *
                 */
                int currentid = 0 ;
                rs.executeSql("select id from workflow_currentoperator where requestid="+requestid+" and nodeid="+nodeid+" and userid="+user.getUID()+" and usertype="+this.usertype+" and preisremark=0 and isremark=2 and islasttimes=1 order by id desc");
                if(rs.next()){
                    currentid = rs.getInt(1);
                }
                rs.executeSql("update workflow_currentoperator set operatetime='"+this.currenttime+"' where id="+currentid);
            }

            if(src.equals("intervenor")&&!nextnodetype.equals("3")){
                //归档节点流程干预到非归档节点 要修改该状态。
                rs.executeSql("update workflow_currentoperator set iscomplete=0 where requestid="+requestid);
                rs.executeSql("update workflow_currentoperator set isremark='2',processUser = "+userid+" where isremark='4' and requestid="+requestid);
                //子流程归档汇总标记撤销
                rs.executeSql(" update workflow_requestbase set dataaggregated = '' where requestid = " + requestid);
            }
            if(nextnodetype.equals("3")){
                rs.executeSql("update workflow_currentoperator set isremark='4',processUser = "+userid+" where (isremark='2' and preisremark not in ('8','9')) and nodeId="+nextnodeid+" and requestid="+requestid);
            }

            if(nextnodetype.equals("0")){
                //流程以任意状态流转到创建节点，则清除预算费用数据
                try {
                    FnaCommon fnaCommon = new FnaCommon();
                    fnaCommon.doWfForceOver(requestid, 0, true);
                }catch(Exception easi) {
                    new BaseBean().writeLog(easi);
                }
                //E9 新考勤，删除流程后删除流程数据
                try {
                  new KQFlowActiontBiz().delTest(requestid,workflowid+"","RequestManager nextnodetype 0");
                }catch(Exception e) {
                  new BaseBean().writeLog(e);
                }
            }

            //当表单内容保存时，根据请求id插入督办权限表
            /* e8流程督办注释 luosy 2018/8/13
            WFUrgerManager WFUrgerManager = new WFUrgerManager();
            WFUrgerManager.setLogintype(Util.getIntValue(user.getLogintype()));
            WFUrgerManager.setUserid(user.getUID());
            WFUrgerManager.insertUrgerByRequestid(requestid);
            WFUrgerManager.insertUrgerByRequestid4e9(requestid, user);
            */

            SuperviseManagerBiz superviseBiz = new SuperviseManagerBiz();//e9
            superviseBiz.setReceivedate(currentdate);
            superviseBiz.setReceivetime(currenttime);
            superviseBiz.findOperatorByRequestid(user, requestid);

            String isnew = new BaseBean().getPropValue("WorkflowOvertimeIsNew" , "isNew");
            try {
                if ("1".equals(isnew) && needAddOvertimeTask && nodeInfoCache.size()<=0) {
                    //需要重新计算超时任务
                    if (nextnodeids.size() > 1)
                        OvertimeBiz.getInstance().addOvertimeTaskThread(requestid, workflowid, 0);//添加超时任务
                    else
                        OvertimeBiz.getInstance().addOvertimeTaskThread(requestid, workflowid, nextnodeid);//添加超时任务
                }else{
                    if (nextnodeids.size() > 1){
                        for(Object nodeidTemp : nextnodeids){
                            int nodeidTemp_int = Util.getIntValue((String) nodeidTemp, -1);
                            if(nodeInfoCache.get(nodeidTemp_int) == null && nodeidTemp_int != -1){
                                OvertimeBiz.getInstance().addOvertimeTaskThread(requestid, workflowid, nodeidTemp_int);//添加超时任务
                            }
                        }
                    }
                }
            }catch (Exception e){
                writeLog("添加超时信息失败：requestid："+requestid + "===nodeid:"+nodeid +"====msg:"+e.getMessage());
            }

            //if (src.equals("submit")) {
            //    SmartProcessBiz.doSmartProcess(requestid, workflowid);
            //}

            //机器人节点
            try {
                if (needAddOvertimeTask && (nextnodetypes.contains(NodeType.WAIT.getValue()) || nextnodetypes.contains(NodeType.AUTOPROCESS.getValue()))) {
                    if(istest == 1) {
                        for(int i=0; i<nextnodeids.size(); i++) {
                            if(nextnodetypes.get(i).equals(NodeType.AUTOPROCESS.getValue())) {
                                int nodeid_temp = Util.getIntValue(nextnodeids.get(i)+"");
                                GCONST.WFProcessing.remove(requestid + "_" + nodeid);//流程测试时先要移除，否则依次逐个处理时会卡住
                                new RobotNodeFlowBiz().robotNodeFlow(new RobotNodeServiceBiz().getRobotNodeSet(nodeid_temp),requestid, workflowid, nodeid_temp, true);
                            }
                        }
                    }else {
                        if (nextnodeids.size() > 1)
                            RobotNodeBiz.getInstance().addRobotNodeTaskThread(requestid, workflowid, 0);//添加任务
                        else
                            RobotNodeBiz.getInstance().addRobotNodeTaskThread(requestid, workflowid, 0);//添加任务
                    }
                    rs.executeUpdate("update workflow_currentoperator set viewtype = '-2',firstviewdate = ?, firstviewtime = ?, viewdate = ?, viewtime = ?, operatedate = ?, operatetime = ? where requestid = ? and userid = '0' and usertype = '2' and viewtype = '0'", currentdate, currenttime, currentdate, currenttime, currentdate, currenttime, requestid);
                }
            }catch (Exception e){
                writeLog("添加机器人节点：requestid："+requestid + "===nodeid:"+nodeid +"====msg:"+e.getMessage());
            }

            //处理工作流外部接口的代码
            return doOutWork(this.workflowid, this.requestid);


            //清除GCONST.WFProcessing中的值，保证当前节点的其他操作人能够正常提交
        } finally {
			writeLog("==========合并文档=========workflowid=="+workflowid+"===nodeid=="+nodeid+"====requestid=="+requestid+"==user=="+user.getUID()+"==src=="+src);
			//提交流程时，合并文档
			if (src.equals("submit")){
				boolean isConvertNode= OdocPrintMergePDFUtil.isMergePDFNode(workflowid,nodeid);
				if(isConvertNode){
					OdocPrintMergePDFService odocPrintMergePDFService = new OdocPrintMergePDFService();
					odocPrintMergePDFService.odocPrintMergePDF(requestid,workflowid,nodeid,user);
				}
			}
            if("intervenor".equals(src)){//流程干预的，将流程解锁
                rs.execute("update workflow_requestlock set islock = 0 where requestid = " + requestid);
            }
            GCONST.WFProcessing.remove(requestid+"_"+nodeid);
            //更新公文相关信息
			if(!"delete".equals(src)){
				try{
					rs.executeQuery("select 1 from odoc_requestdoc where requestid = ?",requestid);
					if (rs.next()){
						OdocRequestdocUtil OdocRequestdocUtil = new OdocRequestdocUtil();
						//根据设置更新公文相关信息
						try {
							OdocRequestdocUtil.OdocRequestdocInitByReqId(requestid);
						} catch (Exception e) {
							writeLog("RequestManager.OdocRequestdocInitByReqId exception:",e);
						}
						//根据设置更新公文内部交换相关信息
						try {
							OdocRequestdocUtil.updateInnerChangeData(requestid);
						} catch (Exception e) {
							writeLog("RequestManager.updateInnerChangeData exception:",e);
						}
					}
				}catch(Exception e){
					new BaseBean().writeLog(e);
				}
			}
        }
    }

    public boolean fixIslastrimes(){
        boolean flag1 = fixIslasttimesByuserType("0");
        boolean flag2 = fixIslasttimesByuserType("1");
        return flag1 && flag2;
    }

    private boolean fixIslasttimesByuserType(String usertype){
        try{
            //把这个流程的所有操作者都找一遍，只要islasttimes有2个为1，就要清掉。不管客户的
            RecordSet rs001 = new RecordSet();
            RecordSet rs002 = new RecordSet();
            String sqltmp = "select userid, islasttimes, id, isremark from workflow_currentoperator where usertype='"+usertype+"' and requestid="+this.requestid+" order by userid, case isremark when 11 then 1.6 when 4 then 1.5 when 8 then 1.4 when 9 then 1.3 when 5 then 1.2 when 6 then 0 else isremark end desc, islasttimes asc, id asc";

            rs001.execute(sqltmp);
            Map<Integer,List<Integer[]>> userDataMap = new HashMap<>();
            while(rs001.next()){
                int userid_tmp = Util.getIntValue(rs001.getString("userid"), 0);
                int islasttimes_tmp = Util.getIntValue(rs001.getString("islasttimes"), 0);
                int id_tmp = Util.getIntValue(rs001.getString("id"), 0);
                List<Integer[]> userDataInfos = userDataMap.get(userid_tmp);
                if(userDataInfos == null) {
                    userDataInfos = new ArrayList<>();
                    userDataMap.put(userid_tmp,userDataInfos);
                }
                Integer[] item = new Integer[]{id_tmp,islasttimes_tmp};
                userDataInfos.add(item);
            }
            List<List> updateParam = new ArrayList<>();
            Iterator<Integer> it = userDataMap.keySet().iterator();
            while (it.hasNext()) {
                int userId_temp = it.next();
                List<Integer[]> userDataInfos = userDataMap.get(userId_temp);
                if(userDataInfos == null || userDataInfos.size() == 0) {
                    continue;
                }

                //只有一条islasttimes=1的记录，无需修改直接跳出循环
                List<Integer[]> filterResult = userDataInfos.stream().filter(item -> item[1] == 1).collect(Collectors.toList());
                int islasttimes_temp = userDataInfos.get(userDataInfos.size()-1)[1];
                if(filterResult.size() == 1 && islasttimes_temp == 1) {
                    continue;
                }

                //蒋最后一条记录的islasttimes 修改为1 ，其余记录均修改为0
                int userRecordSize = userDataInfos.size();
                for(int index = 0;index < userRecordSize;index++) {
                    //最后一条记录
                    List updateItem = new ArrayList();
                    Integer[] item = userDataInfos.get(index);
                    int recordId = item[0];
                    if(index == userRecordSize-1 && item[1] != 1) {
                        // 最后一条记录的islasttimes 修改为1
                        updateItem.add("1");
                    } else if(index < userRecordSize-1 && item[1] != 0){
                        // 其余记录均修改为0
                        updateItem.add("0");
                    }
                    if(updateItem.size() > 0){
                        updateItem.add(this.requestid);
                    updateItem.add(recordId);
                    updateParam.add(updateItem);
                }
            }
            }

            if(updateParam.size() > 0) {
                String updateSql = " update workflow_currentoperator set islasttimes= ? where requestid = ? and id= ? ";
                boolean flag = rs002.executeBatchSql(updateSql, updateParam);
                log.info("~~~~~~fixIslasttimesByuserType~~~requestId:" + requestid+",user:"+ user.getUsername() + ",flag:" + flag+",param:"+ JSON.toJSONString(updateParam));
            }
        }catch (Exception e){
            writeLog(e);
            return false;
        }
        return true;
    }

    /**
     * 用于穿透的时候回写日志记录表信息
     * @param penetrateFlag
     *
     * @param lastNodeId
     */
    private void updatePrenetrateLog(String penetrateFlag, String lastNodeId, int flowNextLinkId) {
        String maxRequestLogSql = " select MAX(LOGID) logid from workflow_requestLog where requestid = "+requestid+" and logtype <> 't'";
        RecordSet rs=new RecordSet();
        RecordSet rs1=new RecordSet();
        rs.executeSql(maxRequestLogSql);



        if(rs.next()){
            String maxRequestLogId = rs.getString("logid");
            String requestLogSql=" select logtype,operatedate,operatetime,remark,clientip,receivedPersons,showorder,agentorbyagentid," +
                    "agenttype,LOGID,annexdocids,requestLogId,operatorDept," +
                    "signdocids,signworkflowids,isMobile,HandWrittenSign,SpeechAttachment,remarkLocation " +
                    "from workflow_requestLog where LOGID = '"+maxRequestLogId+"'";
            rs.executeSql(requestLogSql);


            if(rs.next()){
                String penetrateremark = Util.null2String(rs.getString("remark"));
                if(penetrateFlag.indexOf(",")>=0){
                    String updatePenSql = "update workflow_penetrateLog set logtype = '"+rs.getString("logtype")+"'," +
                            "operatedate = '"+rs.getString("operatedate")+"',operatetime = '"+rs.getString("operatetime")+"',remark=''," +
                            "clientip='"+rs.getString("clientip")+"',receivedPersons='',showorder='"+rs.getString("showorder")+"'," +
                            "agentorbyagentid='"+rs.getString("agentorbyagentid")+"',agenttype='"+rs.getString("agenttype")+"',LOGID='"+rs.getString("LOGID")+"'," +
                            "annexdocids='"+rs.getString("annexdocids")+"',requestLogId='"+rs.getString("requestLogId")+"',operatorDept='"+rs.getString("operatorDept")+"'," +
                            "signdocids='"+rs.getString("signdocids")+"',signworkflowids='"+rs.getString("signworkflowids")+"',isMobile='"+rs.getString("isMobile")+"',HandWrittenSign="+rs.getString("HandWrittenSign")+"," +
                            "SpeechAttachment = '"+rs.getString("SpeechAttachment")+"',"+ "remarkLocation = "+rs.getString("remarkLocation") +"  where id in ("+penetrateFlag+")";

                    rs.executeSql(updatePenSql);
                    ////////////////
                    try {
                        String fdsql = " update workflow_penetrateLog set receivedPersons = ?,remark = ? where id in ("+penetrateFlag+")";
                        ConnStatement fdst = null;
                        try {
                            fdst = new ConnStatement();
                            fdst.setStatementSql(fdsql);
                            fdst.setString(1, rs.getString("receivedPersons"));
                            fdst.setString(2, penetrateremark);
                            fdst.executeUpdate();
                        } catch (Exception e) {
                            writeLog(e);
                        } finally {
                            if(fdst!=null) fdst.close();
                        }

                    }catch(Exception e){
                        writeLog(e);
                    }
                    ////////////////
                }else{
                    String updatePenSql = "update workflow_penetrateLog set logtype = '"+rs.getString("logtype")+"'," +
                            "operatedate = '"+rs.getString("operatedate")+"',operatetime = '"+rs.getString("operatetime")+"',remark=''," +
                            "clientip='"+rs.getString("clientip")+"',receivedPersons='',showorder='"+rs.getString("showorder")+"'," +
                            "agentorbyagentid='"+rs.getString("agentorbyagentid")+"',agenttype='"+rs.getString("agenttype")+"',LOGID='"+rs.getString("LOGID")+"'," +
                            "annexdocids='"+rs.getString("annexdocids")+"',requestLogId='"+rs.getString("requestLogId")+"',operatorDept='"+rs.getString("operatorDept")+"'," +
                            "signdocids='"+rs.getString("signdocids")+"',signworkflowids='"+rs.getString("signworkflowids")+"',isMobile='"+rs.getString("isMobile")+"',HandWrittenSign="+rs.getString("HandWrittenSign")+"," +
                            "SpeechAttachment = '"+rs.getString("SpeechAttachment")+"',"+ "remarkLocation = "+rs.getString("remarkLocation") + "  where id= '"+penetrateFlag+"'";
                    rs.executeSql(updatePenSql);
                    ////////////////
                    try {
                        String fdsql = " update workflow_penetrateLog set receivedPersons = ?,remark = ? where id = '"+penetrateFlag+"'";
                        ConnStatement fdst = null;
                        try {
                            fdst = new ConnStatement();
                            fdst.setStatementSql(fdsql);
                            fdst.setString(1, rs.getString("receivedPersons"));
                            fdst.setString(2, penetrateremark);
                            fdst.executeUpdate();
                        } catch (Exception e) {
                            writeLog(e);
                        } finally {
                            if(fdst!=null) fdst.close();
                        }
                    }catch(Exception e){
                        writeLog(e);
                    }
                    ////////////////
                }
            }
            if(!"".equals(lastNodeId)){
                String updateRequestSql ="select requestid,workflowid,nodeid,logtype," +
                        "operatedate,operatetime,operator,remark,clientip," +
                        "operatortype,destnodeid,receivedPersons,showorder," +
                        "agentorbyagentid,agenttype,LOGID,annexdocids,requestLogId," +
                        "operatorDept,signdocids,signworkflowids,isMobile,HandWrittenSign," +
                        "SpeechAttachment,remarkLocation from  workflow_requestLog where LOGID = '"+maxRequestLogId+"'";
                rs.executeSql(updateRequestSql);


                if(rs.next()){
                    try{
                        //取数据库服务器的当前时间 start
                        String penetrateSql = "insert into workflow_penetrateLog(requestid,workflowid,nodeid,logtype,operatedate," +
                                "operatetime,operator,remark,clientip,operatortype,destnodeid,receivedPersons,showorder," +
                                "agentorbyagentid,agenttype,LOGID,annexdocids,requestLogId,operatorDept," +
                                "signdocids,signworkflowids,isMobile,HandWrittenSign,SpeechAttachment,remarkLocation, linkid) values("+
                                "'"+rs.getString("requestid")+"','"+rs.getString("workflowid")+"','"+lastNodeId+"','z'," +
                                "'"+rs.getString("operatedate")+"','"+rs.getString("operatetime")+"','"+rs.getString("operator")+"',''," +
                                "'"+rs.getString("clientip")+"','"+rs.getString("operatortype")+"','"+rs.getString("destnodeid")+"','"+rs.getString("receivedPersons")+"'," +
                                "'"+rs.getString("showorder")+"','"+rs.getString("agentorbyagentid")+"','"+rs.getString("agenttype")+"','"+rs.getString("LOGID")+"'," +
                                "'"+rs.getString("annexdocids")+"','"+rs.getString("requestLogId")+"','"+rs.getString("operatorDept")+"','"+rs.getString("signdocids")+"'," +
                                "'"+rs.getString("signworkflowids")+"','"+rs.getString("isMobile")+"','"+rs.getString("HandWrittenSign")+"','"+rs.getString("SpeechAttachment")+"','"+rs.getString("remarkLocation")+"', "+flowNextLinkId+")";
                        if("oracle".equals(rs.getDBType())){
                            penetrateSql = "insert into workflow_penetrateLog(id,requestid,workflowid,nodeid,logtype,operatedate," +
                                    "operatetime,operator,remark,clientip,operatortype,destnodeid,receivedPersons,showorder," +
                                    "agentorbyagentid,agenttype,LOGID,annexdocids,requestLogId,operatorDept," +
                                    "signdocids,signworkflowids,isMobile,HandWrittenSign,SpeechAttachment,remarkLocation, linkid) values("+
                                    "workflowpenetratelog_Id.nextval,'"+rs.getString("requestid")+"','"+rs.getString("workflowid")+"','"+lastNodeId+"','z'," +
                                    "'"+rs.getString("operatedate")+"','"+rs.getString("operatetime")+"','"+rs.getString("operator")+"',''," +
                                    "'"+rs.getString("clientip")+"','"+rs.getString("operatortype")+"','"+rs.getString("destnodeid")+"',''," +
                                    "'"+rs.getString("showorder")+"','"+rs.getString("agentorbyagentid")+"','"+rs.getString("agenttype")+"','"+rs.getString("LOGID")+"'," +
                                    "'"+rs.getString("annexdocids")+"','"+rs.getString("requestLogId")+"','"+rs.getString("operatorDept")+"','"+rs.getString("signdocids")+"'," +
                                    "'"+rs.getString("signworkflowids")+"','"+rs.getString("isMobile")+"','"+rs.getString("HandWrittenSign")+"','"+rs.getString("SpeechAttachment")+"','"+rs.getString("remarkLocation")+"', "+flowNextLinkId+")";
                        }
                        String penetrateremark = Util.null2String(rs.getString("remark"));
                        rs.executeSql(penetrateSql);
                        ////////////////
                        if("oracle".equals(rs.getDBType())){
                            try {
                                String sqllog = "select max(id) rid from workflow_penetrateLog where requestid = "+rs.getString("requestid")+" and workflowid = " + rs.getString("workflowid") ;
                                rs1.executeSql(sqllog);
                                if(rs1.next()){
                                    String receivedPersonids = Util.null2String(rs1.getString("rid"));
                                    if(!"".equals(receivedPersonids)){
                                        String fdsql = " update workflow_penetrateLog set receivedPersons = ?,remark = ? where id = '"+receivedPersonids+"'";
                                        ConnStatement fdst = null;
                                        try {
                                            fdst = new ConnStatement();
                                            fdst.setStatementSql(fdsql);
                                            fdst.setString(1, rs.getString("receivedPersons"));
                                            fdst.setString(2, penetrateremark);
                                            fdst.executeUpdate();
                                        } catch (Exception e) {
                                            writeLog(e);
                                        } finally {
                                            if(fdst!=null) fdst.close();
                                        }
                                    }
                                }
                            }catch(Exception e){
                                writeLog(e);
                            }
                        }else{
                            try {
                                String sqllog = "select max(id) rid from workflow_penetrateLog where requestid = "+rs.getString("requestid")+" and workflowid = " + rs.getString("workflowid") ;
                                rs1.executeSql(sqllog);
                                if(rs1.next()){
                                    String receivedPersonids = Util.null2String(rs1.getString("rid"));
                                    if(!"".equals(receivedPersonids)){
                                        String fdsql = " update workflow_penetrateLog set remark = ? where id = '"+receivedPersonids+"'";
                                        ConnStatement fdst = null;
                                        try {
                                            fdst = new ConnStatement();
                                            fdst.setStatementSql(fdsql);
                                            fdst.setString(1, penetrateremark);
                                            fdst.executeUpdate();
                                        } catch (Exception e) {
                                            writeLog(e);
                                        } finally {
                                            if(fdst!=null) fdst.close();
                                        }
                                    }
                                }
                            }catch(Exception e){
                                writeLog(e);
                            }
                        }
                        ////////////////
                    }catch(Exception e){
                        writeLog(e);
                    }

                }
            }
        }
    }




    /**
     * 读取配置信息，由workflowid得到对应的处理类的名称，然后执行其处理方法.<br>
     * @param workflowid 工作流id
     * @param requestid 工组流一个请求地id
     * @return 读取是否成功
     */
    private boolean doOutWork(int workflowid, int requestid) {
        //得到配置文件的全路径名称
        String outWorkFileName = "requestmapping";
        String className = "";
        RequestOutWork work = null;
        try {
            String hasOutWork = getPropValue(GCONST.getConfigFile(), "hasOutWork");
            if (hasOutWork != null && hasOutWork.equals("true")) {
                className = getPropValue(outWorkFileName, "" + workflowid);
                if (className != null) {
                    Class cl = Class.forName(className);
                    //实例化处理类
                    work = (RequestOutWork) cl.newInstance();
                    HashMap dataInfo = new HashMap();
                    dataInfo.put("workflowid",this.workflowid+"");
                    dataInfo.put("userid",this.userid+"");
                    dataInfo.put("usertype",this.usertype+"");
                    dataInfo.put("src",this.src);
                    dataInfo.put("iscreate",this.iscreate);
                    dataInfo.put("requestlevel",this.requestlevel);
                    dataInfo.put("requestmark",this.requestmark);
                    dataInfo.put("nextnodetype",this.getNextNodetype());
                    return work.execute(requestid,dataInfo);
                }

            }

        } catch (ClassNotFoundException e) {
            this.writeLog("get class instance error!");
        } catch (InstantiationException e) {
            this.writeLog("get class instance error!");
        } catch (IllegalAccessException e) {
            this.writeLog("get class instance error!");
        } catch (RequestOutWorkException e) {
            this.writeLog(e.getMessage());
        }
        return true;
    }

    /**
     * 外部jsp文件调用，由于必须再判断之前就保存日志，所以这个函数屏蔽掉，仅仅返回之前saveRequestLog2() 的返回结果
     */
    public boolean saveRequestLog() {
        return islogsuccess;
    }

    /**
     * 代替saveRequestLog()保存日志信息
     *
     * @return 保存是否成功
     */
    public boolean saveRequestLog2() {
        if (src.equals("save")) {
            if (isremark == 1 || isremark == 9 ||(isremark==7 && "submit".equals(tempsrc))) {
                if("11".equals(isremark4CY)){
                    saveRequestLog("y"); // 传阅批示为y，传阅为c
                }else{
                    saveRequestLog("9"); // 批注日志类型为9
                }
            } else {
                saveRequestLog("1"); // 保存日志类型为1
            }
        } else if (src.equals("submit")) {
            //查阅类型不记录意见
            if(nodetype.equals("4")) return true;
            FlowExceptionHandle flowExceptionHandle = new FlowExceptionHandle();
            ArrayList _alluserids = new ArrayList();
            for (int n = 0; n < nextnodeids.size(); n++) {
                nextnodeid = Util.getIntValue((String) nextnodeids.get(n), 0);
                nextnodeattr = Util.getIntValue((String) nextnodeattrs.get(n), 0);
                //异常处理信息存workflow_requestexceptionflow表
                int requestexceptiontype = 0;
                if(requestexceptiontypes.size() > n)
                    requestexceptiontype = Util.getIntValue((String)requestexceptiontypes.get(n));
                flowExceptionHandle.saveRequestExceptionFlowInfo(requestid, nodeid, nextnodeid, requestexceptiontype, eh_operatorMap);
                //指定流转信息存入workflow_requestselectnextflow表
                if (isSelectNextFlow && !"".equals(selectNodeFlowNodeIds)) {
					SelectNextFlowBiz.saveRequestSelectNextFlowInfo(requestid, nodeid, nextnodeid, Util.getIntValue(getRequestParamValue("SignType_" + n)), getRequestParamValue("selectNodeFlow_operator_" + n));
                }
            }

            if (isremark == 7 && coadsigntype.equals("2")) {
                saveRequestLog("9");
            } else {
                if (nodetype.equals("1")) {
                    saveRequestLog("0");
                } else if (nodetype.equals(NodeType.WAIT.getValue()) || nodetype.equals(NodeType.AUTOPROCESS.getValue())){
                    String operateType = new RobotNodeServiceBiz().getRobotNodeSet(nodeid).getOperateType();
                    saveRequestLog("0".equals(operateType) ? "2" : "0");
                }else{
                    saveRequestLog("2");
                }
            }
        } else if (src.equals("reject")){
            //saveRequestLog("3");
            ArrayList _alluserids = new ArrayList();
            for (int n = 0; n < nextnodeids.size(); n++) {
                nextnodeid = Util.getIntValue((String) nextnodeids.get(n), 0);
                nextnodeattr = Util.getIntValue((String) nextnodeattrs.get(n), 0);
                try{
                    Hashtable _operatorsht = (Hashtable)operatorshts.get(n);
                    Enumeration tempKeys = operatorsht.keys();
                    while (tempKeys.hasMoreElements()) {
                        String tempKey = (String) tempKeys.nextElement();
                        ArrayList tempoperators = (ArrayList) operatorsht.get(tempKey);
                        _alluserids.addAll(tempoperators);
                    }
                }catch(Exception e){

                }
            }
            saveRequestLog("3");
        }else if (src.equals("reopen"))
            saveRequestLog("4");
        else if (src.equals("delete"))
            saveRequestLog("5");
        else if (src.equals("active"))
            saveRequestLog("6");
        else if (src.equals("supervise")) {
            ArrayList nownodelist = Util.TokenizerString(wflinkinfo.getNowNodeids(requestid), ",");
            for (int n = 0; n < nownodelist.size(); n++) {
                int nownodeid = Util.getIntValue((String) nownodelist.get(n), 0);
                if (nownodeid > 0 || FreeNodeBiz.isFreeNode(nownodeid))
                    saveRequestLog("s", nownodeid, nownodeid);
            }
        } else if (src.equals("intervenor")) {
            saveRequestLog("i");
        }

        return true;
    }

    /**
     * 流程新建且签字意见中包含相关文档时，需要调用此方法进行处理其中的链接
     * 将-1替换为当前请求的id
     * @param remarkstr
     * @return
     */
    private String remarkBeforeSaveHandle(String remarkstr) {
        remarkstr = Util.null2String(remarkstr);
        String result = "";
        if(!"".equals(remarkstr)&& remarkstr!=null){
            StringBuffer rksb = new StringBuffer();
            Pattern ptrn = Pattern.compile("requestid=\\{#\\[currentRequestid\\]#\\}");
            result = ptrn.matcher(remarkstr).replaceAll("requestid=" + requestid);
        }

        return result;
    }

    private void  saveRequestLog(String logtype) {
        // 图形化表单类型的流程创建文档，点击“正文”，并且签字意见为空的时候不记录签字意见。
        RecordSet rs=new RecordSet();
        if ("true".equals(isFromEditDocument) && "".equals(this.remark) && "".equals(signdocids) && "".equals(signworkflowids)) {
            return;
        }
        //创建节点处理链接中的requestid
        if ("1".equals(iscreate)) {
            this.remark = remarkBeforeSaveHandle(this.remark);
        }
        // added by mackjoe at 20080415 TD8580 增加流程签字上传附件功能
        String ismode = "";
        rs.executeSql("select ismode from workflow_flownode where workflowid=" + workflowid + " and nodeid=" + nodeid);
        if (rs.next()) {
            ismode = Util.null2String(rs.getString("ismode"));
        }

        int currentid = 0 ;
        rs.executeSql("select id from workflow_currentoperator where requestid="+requestid+" and userid="+userid+" and usertype="+usertype+" and islasttimes=1 ");
        if(rs.next()){
            currentid = Util.getIntValue(rs.getString("id"),0);
        }
        String annexdocids = "";
        //如果从手机版提交流程，则从 signatureAppendfix 字段获取相当附件值。
        if(WorkflowSpeechAppend.isFromMobile(clientType)){
            annexdocids = signatureAppendfix;
        }else{
            if (!ismode.equals("1") || src.equals("supervise") || src.equals("intervenor")) {
                RequestAnnexUpload rau = new RequestAnnexUpload();
                if(isRequest) {
                    rau.setRequest(request);
                } else {
                    rau.setRequest(fu);
                }
                rau.setUser(user);
                annexdocids = rau.AnnexUpload();
            } else {
                String hasSign = "0";// 模板中是否设置了签字
                rs.executeSql("select * from workflow_modeview where formid=" + formid + " and nodeid=" + nodeid + " and fieldid=-4");
                if (rs.next())
                    hasSign = "1";
                if ("1".equals(hasSign)) {// 模板中设置了签字
                    if (isRequest) {
                        if (request != null)
                            annexdocids = Util.null2String(request.getParameter("qianzi"));
                    } else {
                        if (fu != null)
                            annexdocids = Util.null2String(fu.getParameter("qianzi"));
                    }
                } else {// 模板中没有设置签字，按普通方式上传签字意见的附件
                    RequestAnnexUpload rau = new RequestAnnexUpload();
                    if(isRequest) {
                        rau.setRequest(request);
                    } else {
                        rau.setRequest(fu);
                    }
                    rau.setUser(user);
                    annexdocids = rau.AnnexUpload();
                }
            }
        }


        // 获取签字意见相关文档，相关流程
        if (isRequest) {
            if (request != null) {
                signdocids = Util.null2String(request.getParameter("signdocids"));
                signworkflowids = Util.null2String(request.getParameter("signworkflowids"));
            }
        } else {
            if (fu != null) {
                signdocids = Util.null2String(fu.getParameter("signdocids"));
                signworkflowids = Util.null2String(fu.getParameter("signworkflowids"));
            }
        }
        if(doAutoApprove){
            annexdocids = "";
            signdocids = "";
            signworkflowids = "";
        }
        //保存时，过滤高于密级的资源
        if("1".equals(logtype) && "0".equals(this.nodetype)){
            signworkflowids = RequestSecLevelBiz.changeSecLevelFilterValue(this.requestid+"", "3-16", signworkflowids, this.saveParams);
            signdocids = RequestSecLevelBiz.changeSecLevelFilterValue(this.requestid+"", "3-9", signdocids, this.saveParams);
            annexdocids = RequestSecLevelBiz.changeSecLevelFilterValue(this.requestid+"", "6-1", annexdocids, this.saveParams);
        }

        String clientip = "";
        if (isRequest) {
            if (request != null)
                clientip = Util.null2String(request.getRemoteAddr());
        } else {
            if (fu != null)
                clientip = Util.null2String(fu.getRemoteAddr());
        }

        int requestLogId = 0;
        if (isRequest) {
            if (request != null)
                requestLogId = Util.getIntValue(request.getParameter("workflowRequestLogId"), 0);
        } else {
            if (fu != null)
                requestLogId = Util.getIntValue(fu.getParameter("workflowRequestLogId"), 0);
        }

        String remarkquote = "";
        if(isRequest) {
            if(request != null) remarkquote = Util.null2String(request.getParameter("remarkquote"));
        } else {
            if(fu != null) remarkquote = Util.null2String(fu.getParameter("remarkquote"));
        }

        String fulltextannotation = "";
        if (isRequest) {
            if (request != null)
                fulltextannotation = Util.null2String(request.getParameter("fulltextannotation"));
        } else {
            if (fu != null)
                fulltextannotation = Util.null2String(fu.getParameter("fulltextannotation"));
        }

        String speechAttachmente9 = "";
        if (isRequest) {
            if (request != null)
                speechAttachmente9 = Util.null2String(request.getParameter("speechAttachmente9"));
        } else {
            if (fu != null)
                speechAttachmente9 = Util.null2String(fu.getParameter("speechAttachmente9"));
        }

        if (nextnodeid == 0)
            nextnodeid = nodeid;
        String personStr = "";
        String receivedPersonids = "";
        String personStr1 = "";
        String receivedPersonids1 = "";
        String isremarkStr_t = "";// 如果是提交、批准或者退回，为了防止当前操作人A，现在虽然是代理人，但是下一节点就是正常操作人，那么如果不限制isremark，找出来的就是非代理情况
        if ("0".equals(logtype) || "2".equals(logtype) || "3".equals(logtype)) {
            isremarkStr_t = " and isremark in ('2','6') ";
        }
        /* ---------------- xwj for td2104 on 20050802 B E G I N ------------------ */
        if (isOldOrNewFlag(requestid)) {// 老数据, 相对 td2104 之前
            rs.executeSql("select userid,usertype from workflow_currentoperator where isremark = 0 and requestid = " + requestid);
            while (rs.next()) {
                if ("0".equals(rs.getString("usertype"))) {
                    personStr += Util.toScreen(resourceComInfo.getResourcename(rs.getString("userid")), user.getLanguage()) + ",";
                    receivedPersonids += Util.null2String(rs.getString("userid")) +",";
                } else {
                    personStr += Util.toScreen(customerInfoComInfo.getCustomerInfoname(rs.getString("userid")), user.getLanguage()) + ",";
                    receivedPersonids += Util.null2String(rs.getString("userid")) +",";
                }
            }
            //System.out.println(" personStr = "+personStr);
            Procpara = "" + requestid + flag + workflowid + flag + nodeid + flag + logtype + flag + logdate + flag + logtime + flag + userid + flag + clientip + flag + usertype + flag + nextnodeid + flag + personStr.trim() + flag + -1 + flag + "0" + flag + -1 + flag + annexdocids + flag + requestLogId + flag + signdocids + flag + signworkflowids + flag + clientType + flag + speechAttachment + flag + handWrittenSign + flag + receivedPersonids + flag + remarkLocation;
            //Procpara = "" + requestid + flag + workflowid + flag + nodeid + flag + logtype + flag + logdate + flag + logtime + flag + userid + flag + remark + flag + clientip + flag + usertype + flag + nextnodeid + flag + personStr.trim() + flag + -1 + flag + "0" + flag + -1 + flag + annexdocids + flag + requestLogId + flag + signdocids + flag + signworkflowids + flag + clientType + flag + speechAttachment + flag + handWrittenSign + flag + receivedPersonids;
            if (logdate.equals("")) {
                String currentString = execRequestlog(Procpara,rs,flag,remark);
                if(!"".equals(currentString) && currentString.indexOf("~~current~~") > -1){
                    String [] arraycurrent = Util.TokenizerString2(currentString, "~~current~~");
                    logdate = arraycurrent[0];
                    logtime = arraycurrent[1];
                }
                //rs.executeProc("workflow_RequestLog_Insert_New", Procpara);
                //if (rs.next()) {
                //	logdate = Util.null2String(rs.getString(1));
                //	logtime = Util.null2String(rs.getString(2));
                //}
            }else{
                //rs.executeProc("workflow_RequestLogCurDate_New", Procpara);
                execRequestlog(Procpara,rs,flag,remark);
            }
        } else {
            String tempSQL = "";
            int agentorbyagentid = -1;
            int agenttype = 0;
            int showorder = 1;

            ResourceComInfo resourceComInfo = null;
            try {
                resourceComInfo = new ResourceComInfo();
            } catch (Exception ex) {
                // writeLog(ex.toString());
            }
            String tempisremark = "isremark in ('0','4','6')";  //f 自动提交 或 自动批准
            //如果当前节点存在协办人并且协办人关系为会签或者非会签 主办人关系为会签或依次处理 则接收人应包含协办人
            rs.executeSql("select signorder,signtype from workflow_groupdetail where type=42 and groupid in (select id from workflow_nodegroup where nodeid="+nodeid+")");
            if(rs.next()){
                int signorder = rs.getInt("signorder");
                int signtype = rs.getInt("signtype");
                if(signtype!=2 && (signorder==0 || signorder==1 || signorder==2 ||(signorder==0 && src.equals("reject")))){
                    tempisremark = "isremark in ('0','4','7','6')";
                }
            }
            if("i".equals(logtype) && "3".equals(nextnodetype)){    // 归档节点干预时接收人取干预操作接受人，防止归档节点多次干预接收人获取出错
                tempisremark = tempisremark + " and " + Util.getSubINClause(this.Intervenorid, "userid", "in");
            }
            //TODO JHY 签字意见保存改造
            Map<String,Object> receivePersonInfo = RequestLogSaveBiz.getReceivePersons(showcoadjutant,currentopratorInsFirstid,user,operator89mp,operator89List,
                    operatortype89List,agentoperator89List,operatortype89mp,agentoperator89mp,nextnodeids,workflowid,requestid,logtype,tempisremark,src,nodeid);
            personStr = Util.null2String(receivePersonInfo.get("receivePersonNames"));
            receivedPersonids = Util.null2String(receivePersonInfo.get("receivePersonids"));
            personStr1 = Util.null2String(receivePersonInfo.get("ccPersonNames"));
            receivedPersonids1 = Util.null2String(receivePersonInfo.get("ccPersonids"));

            //等待合并
            if ((freeNodeFlowBiz != null && freeNodeFlowBiz.isBranchMerge() && "".equals(receivedPersonids.trim())) ||(!canflowtonextnode && (nextnodeattr == 3 || nextnodeattr == 4|| nextnodeattr==5))) {
                personStr = SystemEnv.getHtmlLabelName(21399, user.getLanguage()) + ",";
            }
            tempSQL = "select agentorbyagentid, agenttype, showorder from workflow_currentoperator where nodeid = " + nodeid + " and requestid = " + requestid + " and userid = " + userid + isremarkStr_t + " order by  operatedate desc,operatetime desc, id asc";
            rs.executeSql(tempSQL);
            if (rs.next()) {
                if(isAgent) {
                    agentorbyagentid = agentId;
                    agenttype = 2;
                }
                showorder = rs.getInt("showorder");
            }
            if (logtype.equals("9") || logtype.equals("7") || logtype.equals("y")) { // logtype=9时 , "被转发人" 在
                // "操作人"后显示
                rs.executeSql("select max(showorder) as maxshow from workflow_requestlog where requestid = " + requestid + " and nodeid = " + nodeid + " and (logtype = '9' or logtype = '7')");
                rs.next();
                if (rs.getInt("maxshow") != -1) {
                    showorder = rs.getInt("maxshow") + 1;
                } else {
                    showorder = 10000;
                }
                String sql = "select receivedpersons,receivedpersonids from workflow_requestlog where requestid = " + requestid + " and nodeid = " + nodeid + " and (logtype = '2' or logtype = '0' or logtype = '3') order by operatedate desc,operatetime desc";
                if(DBConstant.DB_TYPE_MYSQL.equals(rs.getDBType())) {
                    sql += " limit 0,1 ";
                }
                else if(DBConstant.DB_TYPE_POSTGRESQL.equals(rs.getDBType())) {
                    sql += " limit 1 offset 0 ";
                }
                else if(DBConstant.DB_TYPE_SQLSERVER.equals(rs.getDBType())) {
                    sql = " select top 1 receivedpersons,receivedpersonids from workflow_requestlog where requestid = " + requestid + " and nodeid = " + nodeid + " and (logtype = '2' or logtype = '0' or logtype = '3') order by operatedate desc,operatetime desc";
                } else if(DBConstant.DB_TYPE_ORACLE.equals(rs.getDBType())) {
                    sql = new StringBuilder("select t.* from (").append(sql).append(") t where rownum = 1 ").toString();
                }
                rs.executeSql(sql);// logtype在数据库中是char(1)字段
                if (rs.next() && !"y".equals(logtype)) {
                    personStr = Util.null2String(rs.getString(1));
                    receivedPersonids = Util.null2String(rs.getString(2));
                }else if("y".equals(logtype)){//传阅批注
                    Map<String,String> receivedPersons = ChuanyueUtil.getCYReceivedPersons(requestid,nodeid,user,currid4CY);
                    personStr = Util.null2String(receivedPersons.get("personStr"));
                    receivedPersonids = Util.null2String(receivedPersons.get("receivedPersonids"));
                    showorder = Util.getIntValue(receivedPersons.get("showorder"),1);
                }
            }
            Procpara = "" + requestid + flag + workflowid + flag + nodeid + flag + logtype + flag + logdate + flag + logtime + flag + userid + flag + clientip + flag + usertype + flag + nextnodeid + flag + personStr.trim() + flag + agentorbyagentid + flag + agenttype + flag + showorder + flag + annexdocids + flag + requestLogId + flag + signdocids + flag + signworkflowids + flag + clientType + flag + speechAttachment + flag + handWrittenSign + flag + receivedPersonids +flag+ remarkLocation + flag+fulltextannotation+flag+speechAttachmente9+flag + remarkquote;
            //Procpara = "" + requestid + flag + workflowid + flag + nodeid + flag + logtype + flag + logdate + flag + logtime + flag + userid + flag + remark + flag + clientip + flag + usertype + flag + nextnodeid + flag + personStr.trim() + flag + agentorbyagentid + flag + agenttype + flag + showorder + flag + annexdocids + flag + requestLogId + flag + signdocids + flag + signworkflowids + flag + clientType + flag + speechAttachment + flag + handWrittenSign + flag + receivedPersonids;
            if (logdate.equals("")) {
                //rs.executeProc("workflow_RequestLog_Insert_New", Procpara);
                //if (rs.next()) {
                //	logdate = Util.null2String(rs.getString(1));
                //	logtime = Util.null2String(rs.getString(2));
                //}
                String currentString = execRequestlog(Procpara,rs,flag,remark);
                if(!"".equals(currentString) && currentString.indexOf("~~current~~") > -1){
                    String [] arraycurrent = Util.TokenizerString2(currentString, "~~current~~");
                    logdate = arraycurrent[0];
                    logtime = arraycurrent[1];
                }
            } else {
                //rs.executeProc("workflow_RequestLogCurDate_New", Procpara);
                execRequestlog(Procpara,rs,flag,remark);
            }
            // 抄送另外保存
            if (!personStr1.trim().equals("")) {
                // 解决抄送人也把签字意见显示出来问题，把remark置为空，同时，相关附件、流程、文档也要空
                // userid + flag + remark + flag，其中，remark在抄送中为空
                Procpara = "" + requestid + flag + workflowid + flag + nodeid + flag + "t" + flag + logdate + flag + logtime + flag + userid + flag + clientip + flag + usertype + flag + nextnodeid + flag + personStr1.trim() + flag + agentorbyagentid + flag + agenttype + flag + showorder + flag + "" + flag + requestLogId + flag + "" + flag + "" + flag + clientType + flag + 0 + flag + "" + flag + receivedPersonids1 +flag+ remarkLocation+flag+""+flag+0;
                if (logdate.equals("")) {
                    //rs.executeProc("workflow_RequestLog_Insert_New", Procpara);
                    //if (rs.next()) {
                    //	logdate = Util.null2String(rs.getString(1));
                    //	logtime = Util.null2String(rs.getString(2));
                    //}
                    String currentString = execRequestlog(Procpara,rs,flag,"");
                    if(!"".equals(currentString) && currentString.indexOf("~~current~~") > -1){
                        String [] arraycurrent = Util.TokenizerString2(currentString, "~~current~~");
                        logdate = arraycurrent[0];
                        logtime = arraycurrent[1];
                    }
                } else {
                    //rs.executeProc("workflow_RequestLogCurDate_New", Procpara);
                    execRequestlog(Procpara,rs,flag,"");
                }
            }
        }

    }

    /**
     * 根据节点写日志
     *
     * @param logtype
     * @param nownodeid
     * @param nownextnodeid
     */
    private void saveRequestLog(String logtype, int nownodeid, int nownextnodeid) {
        String ismode = "";
        RecordSet rs=new RecordSet();
        rs.executeSql("select ismode from workflow_flownode where workflowid=" + workflowid + " and nodeid=" + nownodeid);
        if (rs.next()) {
            ismode = Util.null2String(rs.getString("ismode"));
        }

        //相关附件
        String annexdocids = "";
        //如果从手机版提交流程，则从 signatureAppendfix 字段获取相当附件值。
        if(WorkflowSpeechAppend.isFromMobile(clientType)){
            annexdocids = signatureAppendfix;
        }else{
            if (!ismode.equals("1") || src.equals("supervise") || src.equals("intervenor")) {
                RequestAnnexUpload rau = new RequestAnnexUpload();
                if(isRequest) {
                    rau.setRequest(request);
                } else {
                    rau.setRequest(fu);
                }
                rau.setUser(user);
                annexdocids = rau.AnnexUpload();
            } else {
                if (isRequest) {
                    if (request != null)
                        annexdocids = Util.null2String(request.getParameter("qianzi"));
                } else {
                    if (fu != null)
                        annexdocids = Util.null2String(fu.getParameter("qianzi"));
                }
            }
        }

        String fulltextannotation = "";
        String speechAttachmente9 = "";
        // 获取签字意见相关文档，相关流程
        if (isRequest) {
            if (request != null) {
                signdocids = Util.null2String(request.getParameter("signdocids"));
                signworkflowids = Util.null2String(request.getParameter("signworkflowids"));
                fulltextannotation = Util.null2String(request.getParameter("fulltextannotation"));
                speechAttachmente9 = Util.null2String(request.getParameter("speechAttachmente9"));
            }
        } else {
            if (fu != null) {
                signdocids = Util.null2String(fu.getParameter("signdocids"));
                signworkflowids = Util.null2String(fu.getParameter("signworkflowids"));
                fulltextannotation = Util.null2String(fu.getParameter("fulltextannotation"));
                speechAttachmente9 = Util.null2String(fu.getParameter("speechAttachmente9"));
            }
        }

        String clientip = "";
        if (isRequest) {
            if (request != null)
                clientip = Util.null2String(request.getRemoteAddr());
        } else {
            if (fu != null)
                clientip = Util.null2String(fu.getRemoteAddr());
        }

        int requestLogId = 0;
        if (isRequest) {
            if (request != null)
                requestLogId = Util.getIntValue(request.getParameter("workflowRequestLogId"), 0);
        } else {
            if (fu != null)
                requestLogId = Util.getIntValue(fu.getParameter("workflowRequestLogId"), 0);
        }

        if (nownextnodeid == 0)
            nownextnodeid = nownodeid;
        String personStr = "";
        String personStr1 = "";
        String receivedPersonids = "";
        String receivedPersonids1 = "";
        String isremarkStr_t = "";// 如果是提交、批准或者退回，为了防止当前操作人A，现在虽然是代理人，但是下一节点就是正常操作人，那么如果不限制isremark，找出来的就是非代理情况
        if ("0".equals(logtype) || "2".equals(logtype) || "3".equals(logtype) || "h".equals(logtype)) {
            isremarkStr_t = " and isremark in ('2','6') ";
        }
        /* ---------------- xwj for td2104 on 20050802 B E G I N ------------------ */
        if (isOldOrNewFlag(requestid)) {// 老数据, 相对 td2104 之前
            rs.executeSql("select userid,usertype from workflow_currentoperator where isremark = 0 and requestid = " + requestid);
            while (rs.next()) {
                if ("0".equals(rs.getString("usertype"))) {
                    personStr += Util.toScreen(resourceComInfo.getResourcename(rs.getString("userid")), user.getLanguage()) + ",";
                    receivedPersonids += Util.null2String(rs.getString("userid")) + ",";
                } else {
                    personStr += Util.toScreen(customerInfoComInfo.getCustomerInfoname(rs.getString("userid")), user.getLanguage()) + ",";
                    receivedPersonids += Util.null2String(rs.getString("userid")) + ",";
                }
            }

            Procpara = "" + requestid + flag + workflowid + flag + nownodeid + flag + logtype + flag + logdate + flag + logtime + flag + userid + flag + clientip + flag + usertype + flag + nownextnodeid + flag + personStr.trim() + flag + -1 + flag + "0" + flag + -1 + flag + annexdocids + flag + requestLogId + flag + signdocids + flag + signworkflowids + flag + clientType + flag + speechAttachment + flag + handWrittenSign + flag + receivedPersonids +flag + remarkLocation;
            //Procpara = "" + requestid + flag + workflowid + flag + nownodeid + flag + logtype + flag + logdate + flag + logtime + flag + userid + flag + remark + flag + clientip + flag + usertype + flag + nownextnodeid + flag + personStr.trim() + flag + -1 + flag + "0" + flag + -1 + flag + annexdocids + flag + requestLogId + flag + signdocids + flag + signworkflowids + flag + clientType + flag + speechAttachment + flag + handWrittenSign + flag + receivedPersonids;
            if (logdate.equals("")) {
                String currentString = execRequestlog(Procpara,rs,flag,remark);
                if(!"".equals(currentString) && currentString.indexOf("~~current~~") > -1){
                    String [] arraycurrent = Util.TokenizerString2(currentString, "~~current~~");
                    logdate = arraycurrent[0];
                    logtime = arraycurrent[1];
                }
                //rs.executeProc("workflow_RequestLog_Insert_New", Procpara);
                //if (rs.next()) {
                //  logdate = Util.null2String(rs.getString(1));
                //  logtime = Util.null2String(rs.getString(2));
                //}
            } else {
                //rs.executeProc("workflow_RequestLogCurDate_New", Procpara);
                execRequestlog(Procpara,rs,flag,remark);
            }
        } else {
            String tempSQL = "";
            int agentorbyagentid = -1;
            int agenttype = 0;
            int showorder = 1;

            ResourceComInfo resourceComInfo = null;
            try {
                resourceComInfo = new ResourceComInfo();
            } catch (Exception ex) {
            }

            String sql = "";
            if("s".equals(logtype)){//督办
                sql = "select userid,usertype,agentorbyagentid, agenttype,nodeid from workflow_currentoperator where (isremark in ('0','4','6') or (isremark = '1' and takisremark = '2')) and requestid = " + requestid + " and nodeid in(" + wflinkinfo.getBrancheNode(nownextnodeid, workflowid, "" + nownextnodeid, requestid) + ") order by showorder asc,id asc";
            }else{
                sql = "select userid,usertype,agentorbyagentid, agenttype,nodeid from workflow_currentoperator where isremark in ('0','4') and requestid = " + requestid + " and nodeid in(" + wflinkinfo.getBrancheNode(nownextnodeid, workflowid, "" + nownextnodeid, requestid) + ") order by showorder asc,id asc";
            }
            rs.execute(sql);
            String _useridStr = "";
            RobotNodeServiceBiz robotNodeServiceBiz = new RobotNodeServiceBiz(userlanguage);
            while (rs.next()) {
                int nodeidTemp = rs.getInt("nodeid");
                if ("0".equals(rs.getString("usertype"))) {
                    if (rs.getInt("agenttype") == 0) {
                        String tempPersonStr = Util.toScreen(resourceComInfo.getResourcename(rs.getString("userid")), user.getLanguage());
                        String tempUseridStr = Util.null2String(rs.getString("userid"));
                        if ((personStr.indexOf("," + tempPersonStr + ",") == -1 && personStr.indexOf(tempPersonStr + ",") == -1) || (_useridStr.indexOf("," + tempUseridStr + ",") == -1 && _useridStr.indexOf(tempUseridStr + ",") == -1)) {
                            personStr += tempPersonStr + ",";
                            _useridStr += tempUseridStr + ",";
                            receivedPersonids += tempUseridStr + ",";
                        }
                    } else if (rs.getInt("agenttype") == 2) {
                        String tempPersonStr = Util.toScreen(resourceComInfo.getResourcename(rs.getString("agentorbyagentid")), user.getLanguage()) + "->" + Util.toScreen(resourceComInfo.getResourcename(rs.getString("userid")), user.getLanguage());
                        String tempUseridStr = Util.null2String(rs.getString("agentorbyagentid"));
                        if ((personStr.indexOf("," + tempPersonStr + ",") == -1 && personStr.indexOf(tempPersonStr + ",") == -1) || (_useridStr.indexOf("," + tempUseridStr + ",") == -1 && _useridStr.indexOf(tempUseridStr + ",") == -1)) {
                            personStr += tempPersonStr + ",";
                            _useridStr += tempUseridStr + ",";
                            receivedPersonids += tempUseridStr + ",";
                        }
                    } else {
                    }
                } else {
                    String tempPersonStr = "2".equals(rs.getString("usertype")) ? robotNodeServiceBiz.getRobotNodeSet(nodeidTemp).getOperatorName() : Util.toScreen(customerInfoComInfo.getCustomerInfoname(rs.getString("userid")), user.getLanguage());
                    String tempUseridStr = Util.null2String(rs.getString("userid"));
                    if ((personStr.indexOf("," + tempPersonStr + ",") == -1 && personStr.indexOf(tempPersonStr + ",") == -1) || (_useridStr.indexOf("," + tempUseridStr + ",") == -1 && _useridStr.indexOf(tempUseridStr + ",") == -1)) {
                        personStr += tempPersonStr + ",";
                        _useridStr += tempUseridStr + ",";
                        receivedPersonids += tempUseridStr + ",";
                    }
                }
            }

            if (logtype.equals("0") || logtype.equals("2")) {// 提交到下一节点时，下一节点的抄送另外保存
                // 抄送协办人
                sql = "select userid,usertype,agentorbyagentid, agenttype from workflow_currentoperator where isremark ='7' and nodeid = " + nownextnodeid + " and requestid = " + requestid;
                sql += " and id>=" + currentopratorInsFirstid;
                sql += " order by id desc";
                rs.executeSql(sql);

                if (rs.next()) {
                    if ("0".equals(rs.getString("usertype"))) {
                        if (rs.getInt("agenttype") == 0) {
                            String tempPersonStr = Util.toScreen(resourceComInfo.getResourcename(rs.getString("userid")), user.getLanguage());
                            if (personStr1.indexOf("," + tempPersonStr + ",") == -1 && personStr1.indexOf(tempPersonStr + ",") == -1) {
                                personStr1 += tempPersonStr + ",";
                                receivedPersonids1 += Util.null2String(rs.getString("userid")) + ",";
                            }
                        } else if (rs.getInt("agenttype") == 2) {
                            String tempPersonStr = Util.toScreen(resourceComInfo.getResourcename(rs.getString("agentorbyagentid")), user.getLanguage()) + "->" + Util.toScreen(resourceComInfo.getResourcename(rs.getString("userid")), user.getLanguage());
                            if (personStr1.indexOf("," + tempPersonStr + ",") == -1 && personStr1.indexOf(tempPersonStr + ",") == -1) {
                                personStr1 += tempPersonStr + ",";
                                receivedPersonids1 += Util.null2String(rs.getString("userid")) + ",";
                            }
                        } else {
                        }
                    } else {
                        String tempPersonStr = Util.toScreen(customerInfoComInfo.getCustomerInfoname(rs.getString("userid")), user.getLanguage());
                        if (personStr1.indexOf("," + tempPersonStr + ",") == -1 && personStr1.indexOf(tempPersonStr + ",") == -1) {
                            personStr1 += tempPersonStr + ",";
                            receivedPersonids1 += Util.null2String(rs.getString("userid")) + ",";
                        }
                    }
                }
                // 抄送
                // TD23439，根据之前operator89List的值来分析是否有被炒送人
                if (operator89mp != null && !operator89mp.isEmpty()) {
                    operator89List = (ArrayList)operator89mp.get(String.valueOf(nextnodeid));
                    operatortype89List = (ArrayList)operatortype89mp.get(String.valueOf(nextnodeid));
                    agentoperator89List = (ArrayList)agentoperator89mp.get(String.valueOf(nextnodeid));

                    if (operator89List == null) operator89List = new ArrayList();
                    if (operatortype89List == null) operatortype89List = new ArrayList();
                    if (agentoperator89List == null) agentoperator89List = new ArrayList();
                }

                for (int cc = 0; cc < operator89List.size(); cc++) {
                    int operatortype_tmp = Util.getIntValue((String) operatortype89List.get(cc), 0);
                    int operator_tmp = Util.getIntValue((String) operator89List.get(cc), 0);
                    int agentoperator_tmp = Util.getIntValue((String) agentoperator89List.get(cc), 0);
                    if (operatortype_tmp == 0) {
                        if (agentoperator_tmp == 0) {
                            String tempPersonStr = Util.toScreen(resourceComInfo.getResourcename("" + operator_tmp), user.getLanguage());
                            if (personStr1.indexOf("," + tempPersonStr + ",") == -1 && personStr1.indexOf(tempPersonStr + ",") == -1) {
                                personStr1 += tempPersonStr + ",";
                                receivedPersonids1 += Util.null2String(operator89List.get(cc)) + ",";
                            }
                        } else if (agentoperator_tmp > 0) {
                            String tempPersonStr = Util.toScreen(resourceComInfo.getResourcename("" + operator_tmp), user.getLanguage()) + "->" + Util.toScreen(resourceComInfo.getResourcename("" + agentoperator_tmp), user.getLanguage());
                            if (personStr1.indexOf("," + tempPersonStr + ",") == -1 && personStr1.indexOf(tempPersonStr + ",") == -1) {
                                personStr1 += tempPersonStr + ",";
                                receivedPersonids1 += Util.null2String(operator89List.get(cc)) + ",";
                            }
                        } else {
                        }
                    } else {
                        String tempPersonStr = Util.toScreen(customerInfoComInfo.getCustomerInfoname("" + operator_tmp), user.getLanguage());
                        if (personStr1.indexOf("," + tempPersonStr + ",") == -1 && personStr1.indexOf(tempPersonStr + ",") == -1) {
                            personStr1 += tempPersonStr + ",";
                            receivedPersonids1 += Util.null2String(operator89List.get(cc)) + ",";
                        }
                    }
                }
            }
            if (!canflowtonextnode && (nextnodeattr == 3 || nextnodeattr == 4|| nextnodeattr==5)) {
                personStr = SystemEnv.getHtmlLabelName(21399, user.getLanguage()) + ",";
            }
            tempSQL = "select agentorbyagentid, agenttype, showorder from workflow_currentoperator where nodeid = " + nownodeid + " and requestid = " + requestid + " and userid = " + userid + isremarkStr_t + " order by operatedate desc,operatetime desc, id desc";
            rs.executeSql(tempSQL);
            if (rs.next()) {
                agentorbyagentid = rs.getInt("agentorbyagentid");
                agenttype = rs.getInt("agenttype");
                showorder = rs.getInt("showorder");
            }
            if (logtype.equals("9") || logtype.equals("7")) { // logtype=9时 , "被转发人" 在
                // "操作人"后显示
                rs.executeSql("select max(showorder) as maxshow from workflow_requestlog where requestid = " + requestid + " and nodeid = " + nownodeid + " and (logtype = '9' or logtype = '7')");
                rs.next();
                if (rs.getInt("maxshow") != -1) {
                    showorder = rs.getInt("maxshow") + 1;
                } else {
                    showorder = 10000;
                }
                rs.executeSql("select receivedpersons,receivedPersonids from workflow_requestlog where requestid = " + requestid + " and nodeid = " + nownodeid + " and (logtype = '2' or logtype = '0' or logtype = '3') order by operatedate desc,operatetime desc");// logtype在数据库中是char(1)字段
                if (rs.next()) {
                    personStr = Util.null2String(rs.getString(1));
                    receivedPersonids = Util.null2String(rs.getString(2));
                }
            }

            Procpara = "" + requestid + flag + workflowid + flag + nownodeid + flag + logtype + flag + logdate + flag + logtime + flag + userid + flag + clientip + flag + usertype + flag + nownextnodeid + flag + personStr.trim() + flag + agentorbyagentid + flag + agenttype + flag + showorder + flag + annexdocids + flag + requestLogId + flag + signdocids + flag + signworkflowids + flag + clientType + flag + speechAttachment + flag + handWrittenSign + flag + receivedPersonids + flag + remarkLocation + flag + fulltextannotation + flag + speechAttachmente9;
            //Procpara = "" + requestid + flag + workflowid + flag + nownodeid + flag + logtype + flag + logdate + flag + logtime + flag + userid + flag + remark + flag + clientip + flag + usertype + flag + nownextnodeid + flag + personStr.trim() + flag + agentorbyagentid + flag + agenttype + flag + showorder + flag + annexdocids + flag + requestLogId + flag + signdocids + flag + signworkflowids + flag + clientType + flag + speechAttachment + flag + handWrittenSign + flag + receivedPersonids;
            if (logdate.equals("")) {
                //rs.executeProc("workflow_RequestLog_Insert_New", Procpara);
                //if (rs.next()) {
                //  logdate = Util.null2String(rs.getString(1));
                //  logtime = Util.null2String(rs.getString(2));
                //}
                String currentString = execRequestlog(Procpara,rs,flag,remark);
                if(!"".equals(currentString) && currentString.indexOf("~~current~~") > -1){
                    String [] arraycurrent = Util.TokenizerString2(currentString, "~~current~~");
                    logdate = arraycurrent[0];
                    logtime = arraycurrent[1];
                }
            } else {
                //rs.executeProc("workflow_RequestLogCurDate_New", Procpara);
                execRequestlog(Procpara,rs,flag,remark);
            }
            // 抄送另外保存
            if (!personStr1.trim().equals("")) {
                // 解决抄送人也把签字意见显示出来问题，把remark置为空，同时，相关附件、流程、文档也要空
                // userid + flag + remark + flag，其中，remark在抄送中为空
                Procpara = "" + requestid + flag + workflowid + flag + nownodeid + flag + "t" + flag + logdate + flag + logtime + flag + userid + flag + clientip + flag + usertype + flag + nownextnodeid + flag + personStr1.trim() + flag + agentorbyagentid + flag + agenttype + flag + showorder + flag + "" + flag + requestLogId + flag + "" + flag + "" + flag + clientType + flag + speechAttachment + flag + handWrittenSign + flag + receivedPersonids1 +flag + remarkLocation;
                //Procpara = "" + requestid + flag + workflowid + flag + nownodeid + flag + "t" + flag + logdate + flag + logtime + flag + userid + flag + "" + flag + clientip + flag + usertype + flag + nownextnodeid + flag + personStr1.trim() + flag + agentorbyagentid + flag + agenttype + flag + showorder + flag + "" + flag + requestLogId + flag + "" + flag + "" + flag + clientType + flag + speechAttachment + flag + handWrittenSign + flag + receivedPersonids1;
                if (logdate.equals("")) {
                    //rs.executeProc("workflow_RequestLog_Insert_New", Procpara);
                    //if (rs.next()) {
                    //  logdate = Util.null2String(rs.getString(1));
                    //  logtime = Util.null2String(rs.getString(2));
                    //}
                    String currentString = execRequestlog(Procpara,rs,flag,"");
                    if(!"".equals(currentString) && currentString.indexOf("~~current~~") > -1){
                        String [] arraycurrent = Util.TokenizerString2(currentString, "~~current~~");
                        logdate = arraycurrent[0];
                        logtime = arraycurrent[1];
                    }
                } else {
                    //rs.executeProc("workflow_RequestLogCurDate_New", Procpara);
                    execRequestlog(Procpara,rs,flag,"");
                }
            }
        }
    }

    private String doRequestMark() {
        RecordSetTrans rst1=new RecordSetTrans();
        rst1.setAutoCommit(false);
        RecordSet rs=new RecordSet();
        try{
            String needmark = "";
            rst1.executeSql(" select needmark from workflow_base where id = " + workflowid);
            if (rst1.next()) needmark = Util.null2String(rst1.getString("needmark"));

            if (needmark.equals("1")) {
                String newcurrentdate = Util.StringReplace(currentdate, "-", "");
                rst1.executeSql("select requestmark from workflow_requestmark where markdate = '" + currentdate + "' ");
                if (rst1.next()) {
                    int requestmark = Util.getIntValue(rst1.getString("requestmark"), 0);
                    rst1.executeSql("update workflow_requestmark set requestmark = requestmark+1 where markdate = '" + currentdate + "' ");
                    return newcurrentdate + Util.add0(requestmark + 1, 4);
                } else {
                    rst1.executeSql("insert into workflow_requestmark(markdate, requestmark) values('" + currentdate + "',1) ");
                    return newcurrentdate + Util.add0(1, 4);
                }
            }
            rst1.commit();
        }catch(Exception exception){
            exception.printStackTrace();
            rst1.rollback();
            return "";
        }
        return "";
    }

    public String getMessageType() {
        return messageType;
    }

    public void setMessageType(String messageType) {
        if(messageType==null || messageType.equals("")){
            messageType="0";
        }
        this.messageType = messageType;
    }

    /**
     * @author xwj  20050802
     *判断当前流程是否为老数据(相对于 td2104 以前)
     * @param requestid 请求ID
     * @return 是否是老数据
     */
    public boolean isOldOrNewFlagTrans(int requestid,RecordSetTrans rst)throws Exception{
        //boolean isOldWf = false;
        //try{
        //  rst.executeSql("select nodeid from workflow_currentoperator where requestid = " + requestid);
        //  while(rst.next()){
        //    if(rst.getString("nodeid") == null || "".equals(rst.getString("nodeid")) || "-1".equals(rst.getString("nodeid"))){
        //     isOldWf = true;
        //    }
        //  }
        //}catch(Exception exception){
        //  throw exception;
        //}
        return false;

    }
    /**
     * @author xwj  20050802
     *判断当前流程是否为老数据(相对于 td2104 以前)
     * @param requestid 请求ID
     * @return 是否是老数据
     */
    public boolean isOldOrNewFlag(int requestid){
        RecordSet  rs = new RecordSet();
        rs.executeQuery("select 1 from workflow_currentoperator where requestid = ? and (nodeid is null or nodeid = -1) ",requestid);
        return rs.next();
    }

    /**
     * 流程下一节点操作者的插入,并触发提醒信息
     *
     */
    public void setOperator(RecordSetTrans rst)throws Exception{
        //记录日志
        WFAutoApproveUtils.processApproveLog(rst,this);
        RecordSet rs=new RecordSet();
        wfAgentCondition wfAgentCondition=new wfAgentCondition();
        ArrayList poppuplist=new ArrayList();
        WFCoadjutantManager coadjutantmanager=new WFCoadjutantManager();
        WFAutoApproveUtils wfautoApproveUtil = new WFAutoApproveUtils();
        //流程密级相关
        HrmClassifiedProtectionBiz hrmSecBiz = new HrmClassifiedProtectionBiz();
        boolean isOpenSec = HrmClassifiedProtectionBiz.isOpenClassification();//是否开启涉密系统
        RequestSecLevelBiz requestSecBiz = new RequestSecLevelBiz();
        int requestSecLevel = 0;
        if (isOpenSec) {
            requestSecLevel = requestSecBiz.getSecLevelByRequestId(this.requestid+"");//当前流程密级
        }

        int organizedid=0;
        rst.executeSql("select nodeattribute from workflow_nodebase where id="+this.nodeid);
        rst.next();
        int nodeattr = rst.getInt(1);
        //-----------------------------------------------------------------
        //操作者循环过程中，可能需要用到，上一个操作者的信息，
        //为了优化性能，不再每次都将查询结果保存下来，而是将原始的操作者信息保存下来
        //待需要用到结果信息时，再使用保存下来 信息进行查询
        // start
        //-----------------------------------------------------------------
        String prevOperatorid = "";
        int prevOperatortype = 0;
        int prevOperatorisremark = 0;
        int prevOperatornodeid = 0;
        int prevgroupdetailid = 0;
        //-----------------------------------------------------------------
        // end
        //-----------------------------------------------------------------
        ArrayList operatorsWfNew = new ArrayList();
        ArrayList operatorsWfEnd = new ArrayList();
        for(int n=0;n<nextnodeids.size();n++){
            nextnodeid=Util.getIntValue((String)nextnodeids.get(n),0);
            operatorsht=(Hashtable)operatorshts.get(n);
            nextnodetype=Util.null2String((String)nextnodetypes.get(n));
            nextnodeattr=Util.getIntValue((String)nextnodeattrs.get(n),0);
            int linkid= 0;
            if (nextlinkids.size() > n) {
                linkid = Util.getIntValue((String)nextlinkids.get(n), 0);
            }

            //各节点抄送人初始化
            operator89List = new ArrayList();
            operatortype89List = new ArrayList();
            agentoperator89List = new ArrayList();
            //操作人更新结束
            int showorder = 0;
            TreeMap map = new TreeMap(new ComparatorUtilBean());
            Enumeration tempKeys = operatorsht.keys();
            while (tempKeys.hasMoreElements()) {
                String tempKey = (String) tempKeys.nextElement();
                ArrayList tempoperators = (ArrayList) operatorsht.get(tempKey);
                map.put(tempKey,tempoperators);
            }
            try{

                int verSuccussPerson = 0;
                //获取当前请求操作者的代理情况
                //在插入操作者迭代过程中在单独查询
                Map<String, String> operatorAgentInfo = wfAgentCondition.getAgentInfoByResouce(
                        String.valueOf(workflowid)
                        , wfAgentCondition.getAlloperator(operatorsht, map)
                        , String.valueOf(requestid));

                Iterator iterator = map.keySet().iterator();
                //Date d1 = new Date();
                //System.out.println("人员计算插入开始...");
                List<List<Object>> insertOperatorParamsList = new ArrayList<List<Object>>();
                String operatornames = "";
                while(iterator.hasNext()) {
                    String operatorgroup = (String) iterator.next();
                    ArrayList operators = (ArrayList) operatorsht.get(operatorgroup);

                    for (int i = 0; i < operators.size(); i++) {
                        showorder++;
                        String operatorandtype = (String) operators.get(i);
                        String[] operatorandtypes = Util.TokenizerString2(operatorandtype, "_");
                        String opertor = operatorandtypes[0];
                        String opertortype = operatorandtypes[1];
                        groupdetailid = Util.getIntValue(operatorandtypes[2],-1);
                        typeid= Util.getIntValue(operatorandtypes[3],0);
                        if(!canflowtonextnode&&typeid!=-3&&typeid!=-4&&typeid!=-5) continue;
                        //代理数据检索
                        boolean isbeAgent=false;
                        String agenterId="";

                        if (opertortype.equals("0")){   //客户不用考虑代理 by ben 2008-1-10
                            //agenterId=wfAgentCondition.getAgentid(""+workflowid,""+opertor,""+requestid);
                            agenterId = operatorAgentInfo.get(opertor);
                            if(agenterId != null && !agenterId.equals("")){
                                isbeAgent=true;
                            }

                            if (isbeAgent && isOpenSec) {//开启涉密系统后，代理需根据人员密级来判断，代理人密级不够，则不发生代理
                                int agenterSecLevel = Util.getIntValue(hrmSecBiz.getMaxResourceSecLevelById2(agenterId));
                                if (requestSecLevel < agenterSecLevel) {//被代理人不满足条件，则不发生代理
                                    isbeAgent = false;
                                }
                            }

                        }
                        String hrmstatusSql = "";
                        String tempStatus = "";
                        String operatorname = "";
                        if (!isbeAgent) {
                            //在非归档节点，如果下一节点操作者为离职人员，且没有代理，则流程不流转（针对type为：3， 8， 17，18的情况）
                            if (!"3".equals(nextnodetype)) {
                                //根据用户类型来查询不同的表（员工表和客户信息表）。
                                if (opertortype.equals("0")){
                                    hrmstatusSql = "select status from hrmresource where id=" + opertor;
                                    tempStatus = resourceComInfo.getStatus(opertor);
                                    operatorname = resourceComInfo.getLastname(opertor);
                                }else{
                                    hrmstatusSql = "select status,name from CRM_CustomerInfo where id=" + opertor;
                                    rst.execute(hrmstatusSql);
                                    if (rst.next()) {
                                        tempStatus = rst.getString("status");
                                        operatornames = Util.null2String(rst.getString("name"));
                                    }
                                }

                                //非系统管理员且不是被代理人且为离职人员
                                if (opertortype.equals("0")){
                                    /* ①离职人员已经在RequestNodeFlow中进行处理，该处注释
                                        ②归档节点：离职人员不做处理，离职人员能接收到流程；
                                       ③ 非归档节点：指定人不做处理，其他类型均过滤；当选择指定人时，如果该人离职且没有设置代理，那流程就是显示在离职人的待办
                                    if (!"".equals(tempStatus) && ("5".equals(tempStatus) || "4".equals(tempStatus) || "6".equals(tempStatus))) {
    							    if(typeid != -3 && typeid != -4 && typeid != -5){
    							        operatornames += operatorname+",";
    							    }
                                        continue;
                                    }
                                    */
                                }
                            }
                        }else{
                            if (!"3".equals(nextnodetype)) {
                                //根据用户类型来查询不同的表（员工表和客户信息表）。
                                hrmstatusSql = "select status,lastname from hrmresource where id=" + agenterId;
                                rst.execute(hrmstatusSql);
                                if (rst.next()) {
                                    tempStatus = rst.getString("status");
                                    operatorname = Util.null2String(rst.getString("lastname"));

                                }
                                //非系统管理员且不是被代理人且为离职人员
                                if (opertortype.equals("0")){
                                    if (!"".equals(tempStatus) && ("5".equals(tempStatus) || "4".equals(tempStatus) || "6".equals(tempStatus))) {
//    							    if(typeid != -3 && typeid != -4 && typeid != -5){
//    							        operatornames += operatorname+",";
//    							    }
                                        isbeAgent = false;
                                    }
                                }
                            }
                        }
                        if(typeid != -3 && typeid != -4 && typeid != -5) verSuccussPerson++;

                        //当符合代理条件时添加代理人
                        String Procpara1="";

                        int tempremark=0;
                        if (typeid==-3){//抄送（不需提交）
                            tempremark=8;
                        }
                        if (typeid==-4){//抄送（需提交）
                            tempremark=9;
                        }
                        if (typeid==-5){//抄送协办人
                            tempremark=7;
                            rst.executeSql("update workflow_CurrentOperator set isremark='2',processUser = "+userid+" where isremark='7' and requestid="+requestid+" and userid="+opertor+" and usertype="+opertortype+" and nodeid="+nodeid);
                        }


                        //如下变量定义为避免合并节点重复提交作判断。如果是合并节点的抄送类型，则需保证只抄送一次。
                        //当前节点类型是分之的合并节点(3.按通过分支数合并节点; 4.指定分支合并节点)
                        boolean isMergeNode = (nextnodeattr == 3 || nextnodeattr == 4 || nextnodeattr == 5);
                        //当前操作者类型是抄送(7.抄送协办人; 8.抄送不需提交; 9.抄送需提交   )
                        boolean isCopyOperation = (tempremark == 7 || tempremark == 8 || tempremark == 9);

                        //如果既非合并节点，也不是抄送类型，则正常执行。
                        if(isMergeNode && isCopyOperation){
                            //如果既是合并节点，也是抄送类型，则进一步判断当前是否达到合并节点的条件。

                            //合并节点是否可以走到下一节点
//                            boolean canFlowToNextNode = false;
//                            canFlowToNextNode = wflinkinfo.FlowToNextNode(requestid, nodeid, nextnodeid, String.valueOf(nextnodeattr), Util.getIntValue((String) nextnodepassnums.get(n)), Util.getIntValue((String) linkismustpasss.get(n)));
//                            if(canFlowToNextNode){
                            if(canflowtonextnode){
                                //老数据, 相对 td2104 之前
                                if(isOldOrNewFlagTrans(requestid,rst)){
                                    if(isbeAgent){
                                        //设置被代理人已操作
                                        Procpara = "" + requestid + flag + opertor + flag + operatorgroup + flag
                                                + workflowid + flag + workflowtype + flag + opertortype + flag + "2" + flag + -1 +
                                                flag + -1 + flag + "0" + flag + -1+ flag +groupdetailid+flag+this.currentdate+flag+this.currenttime;
                                        rst.executeProc("workflow_CurrentOperator_I2", Procpara);
                                        //设置代理人
                                        Procpara1 = "" + requestid + flag + agenterId + flag + operatorgroup + flag
                                                + workflowid + flag + workflowtype + flag + opertortype + flag + tempremark + flag + -1 +
                                                flag + -1 + flag + "0" + flag + -1 + flag +groupdetailid+flag+this.currentdate+flag+this.currenttime;
                                        rst.executeProc("workflow_CurrentOperator_I2", Procpara1);
                                        if(tempremark==8 || tempremark==9){
                                            operator89List.add(""+opertor);
                                            operatortype89List.add("0");
                                            agentoperator89List.add(""+agenterId);
                                        }
                                    }else{
                                        Procpara = "" + requestid + flag + opertor + flag + operatorgroup + flag
                                                + workflowid + flag + workflowtype + flag + opertortype + flag + tempremark + flag + -1 +
                                                flag + -1 + flag + "0" + flag + -1 + flag +groupdetailid+flag+this.currentdate+flag+this.currenttime;
                                        rst.executeProc("workflow_CurrentOperator_I2", Procpara);
                                        if(tempremark==8 || tempremark==9){
                                            operator89List.add(""+opertor);
                                            operatortype89List.add(""+opertortype);
                                            agentoperator89List.add("0");
                                        }
                                    }
                                } else {
                                    if(isbeAgent){
                                        //设置被代理人已操作
                                        Procpara = "" + requestid + flag + opertor + flag + operatorgroup + flag
                                                + workflowid + flag + workflowtype + flag + opertortype + flag + "2" + flag + nextnodeid +
                                                flag + agenterId + flag + "1" + flag + showorder+ flag +groupdetailid+flag+this.currentdate+flag+this.currenttime;
                                        rst.executeProc("workflow_CurrentOperator_I2", Procpara);
                                        if("reject".equals(src)){
                                            rst.executeUpdate("update workflow_CurrentOperator set isbereject='1' " +
                                                    "where requestid=? and userid=? and workflowid=? and islasttimes=1 and usertype=? and groupid=? and nodeid=?",requestid,opertor,workflowid,opertortype,operatorgroup,nextnodeid);
                                        }
                                        //设置代理人
                                        Procpara1 = "" + requestid + flag + agenterId + flag + operatorgroup + flag
                                                + workflowid + flag + workflowtype + flag + opertortype + flag + tempremark + flag + nextnodeid +
                                                flag + opertor + flag + "2" + flag + showorder+ flag +groupdetailid+flag+this.currentdate+flag+this.currenttime;
                                        rst.executeProc("workflow_CurrentOperator_I2", Procpara1);
                                        if("reject".equals(src)){
                                            rst.executeUpdate("update workflow_CurrentOperator set isbereject='1' " +
                                                    "where requestid=? and userid=? and workflowid=? and islasttimes=1 and usertype=? and groupid=? and nodeid=?",requestid,agenterId,workflowid,opertortype,operatorgroup,nextnodeid);
                                        }
                                        if(tempremark==8 || tempremark==9){
                                            operator89List.add(""+opertor);
                                            operatortype89List.add("0");
                                            agentoperator89List.add(""+agenterId);
                                        }
                                    }else{
                                        Procpara = "" + requestid + flag + opertor + flag + operatorgroup + flag
                                                + workflowid + flag + workflowtype + flag + opertortype + flag + tempremark + flag + nextnodeid +
                                                flag + -1 + flag + "0" + flag + showorder+ flag +groupdetailid+flag+this.currentdate+flag+this.currenttime;
                                        rst.executeProc("workflow_CurrentOperator_I2", Procpara);
                                        if("reject".equals(src)){
                                            rst.executeUpdate("update workflow_CurrentOperator set isbereject='1' " +
                                                    "where requestid=? and userid=? and workflowid=? and islasttimes=1 and usertype=? and groupid=? and nodeid=?",requestid,opertor,workflowid,opertortype,operatorgroup,nextnodeid);
                                        }
                                        if(tempremark==8 || tempremark==9){
                                            operator89List.add(""+opertor);
                                            operatortype89List.add(""+opertortype);
                                            agentoperator89List.add("0");
                                        }
                                    }

                                }

                                //-----------------------------------------------------------------
                                //操作者循环过程中，可能需要用到，上一个操作者的信息，
                                //为了优化性能，不再每次都将查询结果保存下来，而是将原始的操作者信息保存下来
                                //待需要用到结果信息时，再使用保存下来 信息进行查询
                                // start
                                //-----------------------------------------------------------------
                                // currentopratorInsFirstid为0时，查询一次，为其赋值，后续不再执行sql
                                if (currentopratorInsFirstid == 0) {
                                    if(isbeAgent){
                                        sql = "select id from workflow_CurrentOperator where requestid=" + requestid + " and userid=" + agenterId + " and usertype=" + usertype + " and isremark='" + tempremark + "' and nodeid=" + nextnodeid + " order by id desc";
                                    }else{
                                        sql = "select id from workflow_CurrentOperator where requestid=" + requestid + " and userid=" + opertor + " and usertype=" + usertype + " and isremark='" + tempremark + "' and nodeid=" + nextnodeid + " order by id desc";
                                    }
                                    rst.execute(sql);
                                    if (rst.next()) {
                                        currentopratorInsFirstid = rst.getInt("id");
                                    }
                                }
                                //如果是协办人，则根据保存的原始信息进行查询
                                //先查询出上次的信息，再查处本次需要的信息
                                if (tempremark == 7) {
                                    sql = "select id from workflow_CurrentOperator where requestid=" + requestid + " and userid=" + prevOperatorid + " and usertype=" + prevOperatortype + " and isremark='" + prevOperatorisremark + "' and nodeid=" + prevOperatornodeid + " order by id desc";
                                    rst.execute(sql);
                                    if (rst.next()) {
                                        organizedid = rst.getInt("id");
                                    }

                                    if(isbeAgent){
                                        sql = "select id from workflow_CurrentOperator where requestid=" + requestid + " and userid=" + agenterId + " and usertype=" + usertype + " and isremark='" + tempremark + "' and nodeid=" + nextnodeid + " order by id desc";
                                    }else{
                                        sql = "select id from workflow_CurrentOperator where requestid=" + requestid + " and userid=" + opertor + " and usertype=" + usertype + " and isremark='" + tempremark + "' and nodeid=" + nextnodeid + " order by id desc";
                                    }
                                    rst.execute(sql);
                                    if (rst.next()) {
                                        int currentid = rst.getInt("id");
                                        coadjutantmanager.getCoadjutantRights(groupdetailid);
                                        coadjutantmanager.SaveCoadjutantRights(requestid, organizedid, currentid,rst);
                                    }
                                } else {
                                    //非协办人，保存当前操作人的信息
                                    if(isbeAgent){
                                        prevOperatorid = agenterId;
                                    }else{
                                        prevOperatorid = opertor;
                                    }
                                    prevOperatortype = usertype;
                                    prevOperatorisremark = tempremark;
                                    prevOperatornodeid = nextnodeid;
                                }
                                //-----------------------------
                                //end
                                //-----------------------------

    						/*
    						//保存协办人操作权限
    	                    //sql = "select id from workflow_CurrentOperator where requestid=" + requestid + " and userid=" + opertor + " and usertype=" + usertype + " and isremark='" + tempremark + "' and nodeid=" + nextnodeid + " order by id desc";
    						if(isbeAgent){
    		                    sql = "select id from workflow_CurrentOperator where requestid=" + requestid + " and userid=" + agenterId + " and usertype=" + usertype + " and isremark='" + tempremark + "' and nodeid=" + nextnodeid + " order by id desc";
    						}else{
    		                    sql = "select id from workflow_CurrentOperator where requestid=" + requestid + " and userid=" + opertor + " and usertype=" + usertype + " and isremark='" + tempremark + "' and nodeid=" + nextnodeid + " order by id desc";
    						}
    	                    rst.execute(sql);
    	                    if (rst.next()) {
    	                        int currentid = rst.getInt("id");
    	                        if(currentopratorInsFirstid==0) currentopratorInsFirstid=currentid;
    	                        if (tempremark == 7) {
    	                            coadjutantmanager.getCoadjutantRights(groupdetailid);
    	                            coadjutantmanager.SaveCoadjutantRights(requestid, organizedid, currentid,rst);
    	                        } else {
    	                            organizedid = currentid;
    	                        }
    	                    }
    	                    */
                            }
                        } else {
                            //老数据, 相对 td2104 之前
                            if(isOldOrNewFlagTrans(requestid,rst)){
                                if(isbeAgent){
                                    //设置被代理人已操作
                                    Procpara = "" + requestid + flag + opertor + flag + operatorgroup + flag
                                            + workflowid + flag + workflowtype + flag + opertortype + flag + "2" + flag + -1 +
                                            flag + -1 + flag + "0" + flag + -1+ flag +groupdetailid+flag+this.currentdate+flag+this.currenttime;
                                    rst.executeProc("workflow_CurrentOperator_I2", Procpara);
                                    //设置代理人
                                    Procpara1 = "" + requestid + flag + agenterId + flag + operatorgroup + flag
                                            + workflowid + flag + workflowtype + flag + opertortype + flag + tempremark + flag + -1 +
                                            flag + -1 + flag + "0" + flag + -1 + flag +groupdetailid+flag+this.currentdate+flag+this.currenttime;
                                    rst.executeProc("workflow_CurrentOperator_I2", Procpara1);
                                    if(tempremark==8 || tempremark==9){
                                        operator89List.add(""+opertor);
                                        operatortype89List.add("0");
                                        agentoperator89List.add(""+agenterId);
                                    }
                                }else{
                                    Procpara = "" + requestid + flag + opertor + flag + operatorgroup + flag
                                            + workflowid + flag + workflowtype + flag + opertortype + flag + tempremark + flag + -1 +
                                            flag + -1 + flag + "0" + flag + -1 + flag +groupdetailid+flag+this.currentdate+flag+this.currenttime;
                                    rst.executeProc("workflow_CurrentOperator_I2", Procpara);
                                    if(tempremark==8 || tempremark==9){
                                        operator89List.add(""+opertor);
                                        operatortype89List.add(""+opertortype);
                                        agentoperator89List.add("0");
                                    }
                                }
                            } else {

                                if (this.hasCoadjutant || currentopratorInsFirstid == 0) {
                                    if (isbeAgent) {
                                        //设置被代理人已操作
                                        //QC152344,防止代理抄送引起的问题
                                        if (!wfCurrentOperatorAgent(rst, opertor, operatorgroup, opertortype, agenterId, showorder)) {
                                            Procpara = "" + requestid + flag + opertor + flag + operatorgroup + flag
                                                    + workflowid + flag + workflowtype + flag + opertortype + flag + "2" + flag + nextnodeid +
                                                    flag + agenterId + flag + "1" + flag + showorder + flag + groupdetailid + flag + this.currentdate + flag + this.currenttime;
                                            rst.executeProc("workflow_CurrentOperator_I2", Procpara);
                                        }
                                        if("reject".equals(src)){
                                            rst.executeUpdate("update workflow_CurrentOperator set isbereject='1' " +
                                                    "where requestid=? and userid=? and workflowid=? and islasttimes=1 and usertype=? and groupid=? and nodeid=?",requestid,opertor,workflowid,opertortype,operatorgroup,nextnodeid);
                                        }
                                        //设置代理人
                                        Procpara1 = "" + requestid + flag + agenterId + flag + operatorgroup + flag
                                                + workflowid + flag + workflowtype + flag + opertortype + flag + tempremark + flag + nextnodeid +
                                                flag + opertor + flag + "2" + flag + showorder + flag + groupdetailid + flag + this.currentdate + flag + this.currenttime;
                                        rst.executeProc("workflow_CurrentOperator_I2", Procpara1);
                                        if("reject".equals(src)){
                                            rst.executeUpdate("update workflow_CurrentOperator set isbereject='1' " +
                                                    "where requestid=? and userid=? and workflowid=? and islasttimes=1 and usertype=? and groupid=? and nodeid=?",requestid,agenterId,workflowid,opertortype,operatorgroup,nextnodeid);
                                        }
                                        if (tempremark == 8 || tempremark == 9) {
                                            operator89List.add("" + opertor);
                                            operatortype89List.add("0");
                                            agentoperator89List.add("" + agenterId);
                                        }
                                    } else {
                                        Procpara = "" + requestid + flag + opertor + flag + operatorgroup + flag
                                                + workflowid + flag + workflowtype + flag + opertortype + flag + tempremark + flag + nextnodeid +
                                                flag + -1 + flag + "0" + flag + showorder + flag + groupdetailid + flag + this.currentdate + flag + this.currenttime;
                                        rst.executeProc("workflow_CurrentOperator_I2", Procpara);
                                        if("reject".equals(src)){
                                            rst.executeUpdate("update workflow_CurrentOperator set isbereject='1' " +
                                                    "where requestid=? and userid=? and workflowid=? and islasttimes=1 and usertype=? and groupid=? and nodeid=?",requestid,opertor,workflowid,opertortype,operatorgroup,nextnodeid);
                                        }
                                        if (tempremark == 8 || tempremark == 9) {
                                            operator89List.add("" + opertor);
                                            operatortype89List.add("" + opertortype);
                                            agentoperator89List.add("0");
                                        }
                                    }

                                }else {
                                    if(isbeAgent){
                                        List<Object> insertSqlParamList = new ArrayList();
                                        //insertSqlParamList.add(requestid);
                                        insertSqlParamList.add(opertor);
                                        insertSqlParamList.add(operatorgroup);
                                        //insertSqlParamList.add(workflowid);
                                        //insertSqlParamList.add(workflowtype);
                                        insertSqlParamList.add(opertortype);
                                        insertSqlParamList.add(2);
                                        insertSqlParamList.add(nextnodeid);
                                        insertSqlParamList.add(agenterId);
                                        insertSqlParamList.add(1);
                                        insertSqlParamList.add(showorder);
                                        //insertSqlParamList.add(groupdetailid);
                                        insertSqlParamList.add(currentdate);
                                        insertSqlParamList.add(currenttime);
                                        insertSqlParamList.add(groupdetailid);
                                        insertSqlParamList.add(tempremark==8 || tempremark==9 ?tempremark:"2");
                                        insertOperatorParamsList.add(insertSqlParamList);
                                        insertSqlParamList = new ArrayList();

                                        //insertSqlParamList.add(requestid);
                                        insertSqlParamList.add(agenterId);
                                        insertSqlParamList.add(operatorgroup);
                                        //insertSqlParamList.add(workflowid);
                                        //insertSqlParamList.add(workflowtype);
                                        insertSqlParamList.add(opertortype);
                                        insertSqlParamList.add(tempremark);
                                        insertSqlParamList.add(nextnodeid);
                                        insertSqlParamList.add(opertor);
                                        insertSqlParamList.add(2);
                                        insertSqlParamList.add(showorder);
                                        //insertSqlParamList.add(groupdetailid);
                                        insertSqlParamList.add(currentdate);
                                        insertSqlParamList.add(currenttime);
                                        insertSqlParamList.add(groupdetailid);
                                        insertSqlParamList.add(tempremark);
                                        insertOperatorParamsList.add(insertSqlParamList);

                                        if(tempremark==8 || tempremark==9){
                                            operator89List.add(""+opertor);
                                            operatortype89List.add("0");
                                            agentoperator89List.add(""+agenterId);
                                        }
                                    }else{
                                        List<Object> insertSqlParamList = new ArrayList();
                                        //insertSqlParamList.add(requestid);
                                        insertSqlParamList.add(opertor);
                                        insertSqlParamList.add(operatorgroup);
                                        //insertSqlParamList.add(workflowid);
                                        //insertSqlParamList.add(workflowtype);
                                        insertSqlParamList.add(opertortype);
                                        insertSqlParamList.add(tempremark);
                                        insertSqlParamList.add(nextnodeid);
                                        insertSqlParamList.add(-1);
                                        insertSqlParamList.add(0);
                                        insertSqlParamList.add(showorder);
                                        //insertSqlParamList.add(groupdetailid);
                                        insertSqlParamList.add(currentdate);
                                        insertSqlParamList.add(currenttime);
                                        insertSqlParamList.add(groupdetailid);
                                        insertSqlParamList.add(tempremark);
                                        insertOperatorParamsList.add(insertSqlParamList);

                                        if(tempremark==8 || tempremark==9){
                                            operator89List.add(""+opertor);
                                            operatortype89List.add(""+opertortype);
                                            agentoperator89List.add("0");
                                        }
                                    }
                                }
                            }
                            //-----------------------------------------------------------------
                            //操作者循环过程中，可能需要用到，上一个操作者的信息，
                            //为了优化性能，不再每次都将查询结果保存下来，而是将原始的操作者信息保存下来
                            //待需要用到结果信息时，再使用保存下来 信息进行查询
                            // start
                            //-----------------------------------------------------------------
                            // currentopratorInsFirstid为0时，查询一次，为其赋值，后续不再执行sql
                            if (currentopratorInsFirstid == 0) {
                                if(isbeAgent){
                                    sql = "select id from workflow_CurrentOperator where requestid=" + requestid + " and userid=" + agenterId + " and usertype=" + usertype + " and isremark='" + tempremark + "' and nodeid=" + nextnodeid + " order by id desc";
                                }else{
                                    sql = "select id from workflow_CurrentOperator where requestid=" + requestid + " and userid=" + opertor + " and usertype=" + usertype + " and isremark='" + tempremark + "' and nodeid=" + nextnodeid + " order by id desc";
                                }
                                rst.execute(sql);
                                if (rst.next()) {
                                    currentopratorInsFirstid = rst.getInt("id");
                                }
                            }
                            //如果是协办人，则根据保存的原始信息进行查询
                            //先查询出上次的信息，再查处本次需要的信息
                            if (tempremark == 7) {
                                sql = "select id from workflow_CurrentOperator where requestid=" + requestid + " and userid=" + prevOperatorid + " and usertype=" + prevOperatortype + " and isremark='" + prevOperatorisremark + "' and nodeid=" + prevOperatornodeid + " order by id desc";
                                rst.execute(sql);
                                if (rst.next()) {
                                    organizedid = rst.getInt("id");
                                }

                                if(isbeAgent){
                                    sql = "select id from workflow_CurrentOperator where requestid=" + requestid + " and userid=" + agenterId + " and usertype=" + usertype + " and isremark='" + tempremark + "' and nodeid=" + nextnodeid + " order by id desc";
                                }else{
                                    sql = "select id from workflow_CurrentOperator where requestid=" + requestid + " and userid=" + opertor + " and usertype=" + usertype + " and isremark='" + tempremark + "' and nodeid=" + nextnodeid + " order by id desc";
                                }
                                rst.execute(sql);
                                if (rst.next()) {
                                    int currentid = rst.getInt("id");
                                    coadjutantmanager.getCoadjutantRights(groupdetailid);
                                    coadjutantmanager.SaveCoadjutantRights(requestid, organizedid, currentid,rst);
                                }
                            } else {
                                //非协办人，保存当前操作人的信息
                                if(isbeAgent){
                                    prevOperatorid = agenterId;
                                }else{
                                    prevOperatorid = opertor;
                                }
                                prevOperatortype = usertype;
                                prevOperatorisremark = tempremark;
                                prevOperatornodeid = nextnodeid;
                            }
                            //-----------------------------
                            //end
                            //-----------------------------

    					/*
    					//保存协办人操作权限
                        //sql = "select id from workflow_CurrentOperator where requestid=" + requestid + " and userid=" + opertor + " and usertype=" + usertype + " and isremark='" + tempremark + "' and nodeid=" + nextnodeid + " order by id desc";
    					if(isbeAgent){
    	                    sql = "select id from workflow_CurrentOperator where requestid=" + requestid + " and userid=" + agenterId + " and usertype=" + usertype + " and isremark='" + tempremark + "' and nodeid=" + nextnodeid + " order by id desc";
    					}else{
    	                    sql = "select id from workflow_CurrentOperator where requestid=" + requestid + " and userid=" + opertor + " and usertype=" + usertype + " and isremark='" + tempremark + "' and nodeid=" + nextnodeid + " order by id desc";
    					}
                        rst.execute(sql);
                        if (rst.next()) {
                            int currentid = rst.getInt("id");
                            if(currentopratorInsFirstid==0) currentopratorInsFirstid=currentid;
                            if (tempremark == 7) {
                                coadjutantmanager.getCoadjutantRights(groupdetailid);
                                coadjutantmanager.SaveCoadjutantRights(requestid, organizedid, currentid,rst);
                            } else {
                                organizedid = currentid;
                            }
                        }
                        */
                        }

                        //对代理人判断提醒
                        Procpara = opertor + flag + opertortype + flag + requestid;

                        if (nextnodetype.equals("3")){
                            if(isbeAgent){
                                //update by fanggsh for TD4739  20060808 果归档前的最后一个操作者是本人的话，则从提醒中去掉。
                                if(!operatorsWfEnd.contains(agenterId+"_"+opertortype)&&!(userid+"_"+usertype).equals(agenterId+"_"+opertortype)){
                                    //poppupRemindInfoUtil.insertPoppupRemindInfo(Integer.parseInt(agenterId),1,opertortype,requestid,requestname,workflowid);
                                    Map popmap=new HashMap();
                                    popmap.put("userid",""+Integer.parseInt(agenterId));
                                    popmap.put("type","1");
                                    popmap.put("logintype",""+opertortype);
                                    popmap.put("requestid",""+requestid);
                                    popmap.put("requestname",""+requestname);
                                    popmap.put("workflowid",""+workflowid);
                                    popmap.put("creater",""+creater);
                                    poppuplist.add(popmap);
                                    operatorsWfEnd.add(agenterId+"_"+opertortype);
                                }
                            }else{
                                //update by fanggsh for TD4739  20060808 果归档前的最后一个操作者是本人的话，则从提醒中去掉。
                                if(!operatorsWfEnd.contains(opertor+"_"+opertortype)&&!(userid+"_"+usertype).equals(opertor+"_"+opertortype)){
                                    //poppupRemindInfoUtil.insertPoppupRemindInfo(Integer.parseInt(opertor),1,opertortype,requestid,requestname,workflowid);
                                    Map popmap=new HashMap();
                                    popmap.put("userid",""+Integer.parseInt(opertor));
                                    popmap.put("type","1");
                                    popmap.put("logintype",""+opertortype);
                                    popmap.put("requestid",""+requestid);
                                    popmap.put("requestname",""+requestname);
                                    popmap.put("workflowid",""+workflowid);
                                    popmap.put("creater",""+creater);
                                    poppuplist.add(popmap);
                                    operatorsWfEnd.add(opertor+"_"+opertortype);
                                }
                            }
                        }else{
                            if(isbeAgent){
                                if(!operatorsWfNew.contains(agenterId+"_"+opertortype)){
                                    //poppupRemindInfoUtil.insertPoppupRemindInfo(Integer.parseInt(agenterId),0,opertortype,requestid,requestname,workflowid);
                                    Map popmap=new HashMap();
                                    popmap.put("userid",""+Integer.parseInt(agenterId));
                                    popmap.put("type","0");
                                    popmap.put("logintype",""+opertortype);
                                    popmap.put("requestid",""+requestid);
                                    popmap.put("requestname",""+requestname);
                                    popmap.put("workflowid",""+workflowid);
                                    popmap.put("creater",""+creater);
                                    poppuplist.add(popmap);
                                    operatorsWfNew.add(agenterId+"_"+opertortype);
                                }
                            }else{
                                if(!operatorsWfNew.contains(opertor+"_"+opertortype)){
                                    //poppupRemindInfoUtil.insertPoppupRemindInfo(Integer.parseInt(opertor),0,opertortype,requestid,requestname,workflowid);
                                    Map popmap=new HashMap();
                                    popmap.put("userid",""+Integer.parseInt(opertor));
                                    popmap.put("type","0");
                                    popmap.put("logintype",""+opertortype);
                                    popmap.put("requestid",""+requestid);
                                    popmap.put("requestname",""+requestname);
                                    popmap.put("workflowid",""+workflowid);
                                    popmap.put("creater",""+creater);
                                    poppuplist.add(popmap);
                                    operatorsWfNew.add(opertor+"_"+opertortype);
                                }
                            }
                        }
                    }
                    //poppupRemindInfoUtil.insertPoppupRemindInfo(poppuplist);
                }

                if (insertOperatorParamsList != null && !insertOperatorParamsList.isEmpty()) {
                    //防止workflowtype的值为空
                    if ("".equals(Util.null2String(workflowtype))) {
                        WorkflowAllComInfo workflowComInfo = new WorkflowAllComInfo();
                        workflowtype = workflowComInfo.getWorkflowtype(""+workflowid);
                    }
                    rst.executeBatchSql("INSERT INTO workflow_currentoperator ( requestid, userid, groupid, workflowid, workflowtype, usertype, isremark, nodeid" +
                            ", agentorbyagentid, agenttype, showorder, receivedate, receivetime, viewtype, iscomplete, islasttimes, groupdetailid, preisremark, needwfback ) " +
                            " VALUES (" + requestid + ", ?, ?, " + workflowid + ", " + workflowtype + ", ?, ?, ?, ?, ?, " +
                            " ?, ?, ?, 0,0,1, ?, ?, '1' )", insertOperatorParamsList);
                    if("reject".equals(src)){
                        //这里只对isremark=0的更新被退回字段
                        List<List<Object>> newinsertOperatorParamsList = new ArrayList<>();
                        for(List<Object> list : insertOperatorParamsList){
                            if(0==(Integer) list.get(3)){
                                newinsertOperatorParamsList.add(list);
                            }
                        }
                        rst.executeBatchSql("update workflow_CurrentOperator set isbereject='1' " +
                                "where requestid="+requestid+" and userid=? and groupid=? and workflowid="+workflowid+" and workflowtype="+workflowtype+" and usertype=? and isremark=? and nodeid=?" +
                                " and agentorbyagentid=? and agenttype=? and showorder=? and receivedate=? and receivetime=? and viewtype=0 and iscomplete=0 and islasttimes=1 " +
                                " and groupdetailid=? and preisremark=? and needwfback='1'",newinsertOperatorParamsList);
                    }
                }
                //d2 = new Date();
                //System.out.println("人员计算插入完成，耗时：" + (d2.getTime() - d1.getTime())/1000 + "秒");
                //System.out.println("人员提醒信息插入完成，耗时：" + (new Date().getTime() - d2.getTime())/1000 + "秒");
                //抄送
                String tempNextNodeId = String.valueOf(nextnodeid);
                operator89mp.put(tempNextNodeId, operator89List);
                operatortype89mp.put(tempNextNodeId, operatortype89List);
                agentoperator89mp.put(tempNextNodeId, agentoperator89List);
                System.out.println();
                //没有下一节点操作者
                if (verSuccussPerson == 0 && nextnodeattr !=3 && nextnodeattr != 4 && nextnodeattr != 5 && canflowtonextnode) {
                    this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_07);
                    if(StringUtil.isNotNull(operatornames)){
                        operatornames =  operatornames.substring(0,operatornames.length()-1);
                    }
                    this.setMessagecontent(WorkflowRequestMessage.getRMOperatorOutInfo(nextnodeid,userlanguage,workflowid,operatornames));
                    System.out.println();
                    throw new Exception();
                }
                //操作人更新结束
                //更新当前节点表
                if(canflowtonextnode){
                    if(nodeattr==2&&nextnodeattr!=2 && !FreeNodeBiz.isFreeNode(nextnodeid)){//中间节点退回到主干节点
                        //rst.executeSql("update workflow_currentoperator set isremark=2 ,operatedate='"+this.currentdate+"',operatetime='"+this.currenttime+"' where nodeid!="+nextnodeid+" and (isremark=0 or (isremark=2 and (operatedate is null or operatedate=''))) and requestid="+requestid+" and preisremark=0");//所有节点操作人的待办 改成已办
                        rst.executeSql("update workflow_currentoperator set isremark=2 ,operatedate='"+this.currentdate+"',operatetime='"+this.currenttime+"',processUser = "+userid+" where nodeid!="+nextnodeid+" and isremark=0 and requestid="+requestid+" and preisremark=0");//所有节点操作人的待办 改成已办
                        rs.executeSql("select id,groupid,nodeid from workflow_currentoperator  where nodeid!="+nextnodeid+" and (isremark=2 and ( operatedate is null or operatedate='')) and requestid="+requestid+" and preisremark=0");//所有节点操作人的待办 改成已办
                        while(rs.next()){
                            String _tempid = rs.getString(1);
                            String _tempgroupid = rs.getString(2);
                            String _tempnodeid = rs.getString(3);
                            rst.executeSql("select operatedate,operatetime from workflow_currentoperator where requestid="+requestid+" and nodeid="+nodeid+" and isremark=2 and preisremark=0 and groupid="+_tempgroupid);
                            if(rst.next()){
                                String _tempdate = rst.getString(1);
                                String _temptime = rst.getString(2);
                                rst.executeSql("update workflow_currentoperator set operatedate='"+_tempdate+"',operatetime='"+_temptime+"' where id="+_tempid);
                            }
                        }
                        rst.executeSql("delete from workflow_nownode where requestid="+requestid);//删掉所有的当前节点
                    }
                    try{
                        if(innodeids.equals("")||innodeids.equals("0")){
                            innodeids=nodeid+"";
                        }
                        rst.executeSql("delete from workflow_nownode where nownodeid in("+innodeids+") and requestid="+requestid);
                        if(nextnodeattr==3 || nextnodeattr==4|| nextnodeattr==5) {
                            rst.executeQuery("select nownodeid from workflow_nownode n,workflow_currentoperator c where n.requestid = c.requestid and n.nownodeid = c.nodeid and c.requestid = ? and isremark=2 and preisremark = 0 and islasttimes = 1", requestid);
                            while (rst.next()) {
                                int nodeid = Util.getIntValue(rst.getInt("nownodeid"));
                                if (FreeNodeBiz.isFreeNode(nodeid)) {
                                    rst.executeUpdate("delete from workflow_nownode where nownodeid  =? and requestid=" + requestid, nodeid);
                                }
                            }
                        }
                        rst.executeSql("insert into workflow_nownode(requestid,nownodeid,nownodetype,nownodeattribute) values("+requestid+","+nextnodeid+","+nextnodetype+","+nextnodeattr+")");
                    }catch(Exception e){
                        System.out.println(e.getMessage());
                    }
                }
                requestFlowInfoEntity.setDestnodeid(nextnodeid);
                requestFlowInfoEntity.setLinkId(linkid);
                RequestBaseBiz.saveRequestFlowInfo(requestFlowInfoEntity,rst);
            }catch(Exception exception){
                writeLog(exception);
                throw exception;
            }

            try{
                boolean isautoApprove = wfautoApproveUtil.isAutoApprove(this, rst, nodeInfoCache,poppuplist,nextnodeattr);
                if(!isautoApprove){




                    //poppupRemindInfoUtil.insertPoppupRemindInfo(poppuplist);
                    //WFPathUtil wfutil = new WFPathUtil();
                    //wfutil.getFixedThreadPool().execute(poppupRemindInfoUtil);
                }

                //System.out.println("人员提醒信息插入完成，耗时：" + (new Date().getTime() - d2.getTime())/1000 + "秒");
            }catch(Exception exception2){
                throw exception2;
            }
        }

    }

    public void setOperatorByremark5(ArrayList operators,ArrayList operatorsType,RecordSetTrans rst)throws Exception{
        setOperatorByremark5(operators,operatorsType,rst,"", null);
    }

    /**
     * 流程干预插入流转人至currentoperator
     * @param operators 操作者
     */
    public void setOperatorByremark5(ArrayList operators,ArrayList operatorsType,RecordSetTrans rst, String ccType, List<Integer> ccIndex)throws Exception{
        //记录日志
        WFAutoApproveUtils.processApproveLog(rst,this);
        ArrayList poppuplist=new ArrayList();
        ArrayList operatorsWfNew = new ArrayList();
        ArrayList operatorsWfEnd = new ArrayList();

        //流程密级相关
        HrmClassifiedProtectionBiz hrmSecBiz = new HrmClassifiedProtectionBiz();
        boolean isOpenSec = HrmClassifiedProtectionBiz.isOpenClassification();//是否开启涉密系统
        RequestSecLevelBiz requestSecBiz = new RequestSecLevelBiz();
        int requestSecLevel = 0;
        if (isOpenSec) {
            requestSecLevel = requestSecBiz.getSecLevelByRequestId(this.requestid+"");//当前流程密级
        }

        for(int n=0;n<nextnodeids.size();n++){
            nextnodeid=Util.getIntValue((String)nextnodeids.get(n),0);
            nextnodetype=Util.null2String((String)nextnodetypes.get(n));
            nextnodeattr=Util.getIntValue((String)nextnodeattrs.get(n),0);
            wfAgentCondition wfAgentCondition=new wfAgentCondition();
            //操作人更新结束
            int showorder = 0;
            String opertortype = "0";
            groupdetailid=0;
            try{
                for (int i = 0; i < operators.size(); i++) {
                    //依次逐个处理
                    if(SignType==2){
                        if(i > 0 && (ccIndex == null || (ccIndex != null && ccIndex.indexOf(i) == -1)) && !nextnodetype.equals("3")) {
                            continue;
                        }
                        //节点操作者
                        if((ccIndex == null || (ccIndex != null && ccIndex.indexOf(i) == -1))) {
                            operatorgroup = -2;
                            groupdetailid = -2;
                            String tempStr = "";
                            String tempStrType = "";
                            for (int k = i + 1; k < operators.size(); k++) {
                                if ((ccIndex == null || (ccIndex != null && ccIndex.indexOf(k) == -1))) {
                                    tempStr += operators.get(k) + ",";
                                }
                            }
                            rst.executeProc("workflow_groupdetail_Insert", "" + operatorgroup + flag + 5 + flag + operatorgroup + flag + 0 + flag + -1 + flag + "" + flag + "" + flag + 0 + flag + 2 + flag + "" + flag + "" + flag + "" + flag + "" + flag + "" + flag + "" + flag + "" + flag + "" + flag + "" + flag + "" + flag + "");
                            if (rst.next()) {
                                groupdetailid = rst.getInt(1);
                            }

                            if (FreeNodeBiz.isFreeNode(nodeid)) {
                                rst.executeSql("delete from workflow_agentpersons where requestid=" + requestid + " and  groupdetailid = " + nodeid);
                            }
                            if (FreeNodeBiz.isFreeNode(nextnodeid)) {
                                rst.executeSql("delete from workflow_agentpersons where requestid=" + requestid + " and  groupdetailid = " + nextnodeid);
                                rst.executeSql("insert into workflow_agentpersons(requestid,receivedpersons,groupdetailid,coadjutants) values (" + requestid + ",'" + tempStr.trim() + "'," + nextnodeid + ",'')");
                            } else {
                                rst.executeSql("delete from workflow_agentpersons where requestid=" + requestid + " and  (groupdetailid in(select b.id from workflow_nodegroup a,workflow_groupdetail b where a.id=b.groupid and a.nodeid in(" + nodeid + "," + nextnodeid + ")) or groupdetailid is null)");//groupdetailid is null主要为了兼容老的数据
                                rst.executeSql("insert into workflow_agentpersons(requestid,receivedpersons,groupdetailid,coadjutants) values (" + requestid + ",'" + tempStr.trim() + "'," + groupdetailid + ",'')");
                            }
                        }
                    }
                    showorder++; //xwj for td2104 on 20050802
                    int opertor = Util.getIntValue((String)operators.get(i));
                    //默认为内部员工
                    if (operatorsType != null && i < operatorsType.size()) {
                        opertortype = (String)operatorsType.get(i);
                    } else {
                        opertortype = "0";
                    }

                    int tempremark=0;

                    if (ccIndex != null && ccIndex.indexOf(i) != -1) {
                        if ("-3".equals(ccType)){//抄送（不需提交）
                            tempremark=8;
                        }
                        if ("-4".equals(ccType)){//抄送（需提交）
                            tempremark=9;
                        }
                    }


                    if(opertor>0){

                        //modify by xhheng @20050109 for 流程代理
                        //代理数据检索
                        boolean isbeAgent=false;
                        String agenterId="";
                        // 代理逻辑处理
                        if (opertortype.equals("0")){
                            agenterId=wfAgentCondition.getAgentid(""+workflowid,""+opertor,""+ requestid);
                            if(!agenterId.equals("")){
                                isbeAgent=true;
                            }

                            if (isbeAgent && isOpenSec) {//开启涉密系统后，代理需根据人员密级来判断，代理人密级不够，则不发生代理
                                int agenterSecLevel = Util.getIntValue(hrmSecBiz.getMaxResourceSecLevelById2(agenterId));
                                if (requestSecLevel < agenterSecLevel) {//被代理人不满足条件，则不发生代理
                                    isbeAgent = false;
                                }
                            }
                        }
                        //当符合代理条件时添加代理人
                        String Procpara1="";

                        /*-------- xwj for td2104 on 20050802  begin --------- */
                        if(isOldOrNewFlagTrans(requestid,rst)){//老数据, 相对 td2104 之前
                            if(isbeAgent){
                                //设置被代理人已操作
                                Procpara = "" + requestid + flag + opertor + flag + operatorgroup + flag
                                        + workflowid + flag + workflowtype + flag + opertortype + flag + "2" + flag + -1 +
                                        flag + -1 + flag + "0" + flag + -1+ flag +groupdetailid;
                                rst.executeProc("workflow_CurrentOperator_I", Procpara);
                                //设置代理人
                                Procpara1 = "" + requestid + flag + agenterId + flag + operatorgroup + flag
                                        + workflowid + flag + workflowtype + flag + opertortype + flag + tempremark + flag + -1 +
                                        flag + -1 + flag + "0" + flag + -1 + flag +groupdetailid;
                                rst.executeProc("workflow_CurrentOperator_I", Procpara1);
                                if (tempremark == 8 || tempremark == 9) {
                                    operator89List.add("" + opertor);
                                    operatortype89List.add("" + opertortype);
                                    agentoperator89List.add(agenterId);
                                }
                            }else{
                                Procpara = "" + requestid + flag + opertor + flag + operatorgroup + flag
                                        + workflowid + flag + workflowtype + flag + opertortype + flag + tempremark + flag + -1 +
                                        flag + -1 + flag + "0" + flag + -1 + flag +groupdetailid;
                                rst.executeProc("workflow_CurrentOperator_I", Procpara);
                                if (tempremark == 8 || tempremark == 9) {
                                    operator89List.add("" + opertor);
                                    operatortype89List.add("" + opertortype);
                                    agentoperator89List.add("0");
                                }
                            }
                        }else{
                            if(isbeAgent){
                                //设置被代理人已操作
                                Procpara = "" + requestid + flag + opertor + flag + operatorgroup + flag
                                        + workflowid + flag + workflowtype + flag + opertortype + flag + "2" + flag + nextnodeid +
                                        flag + agenterId + flag + "1" + flag + showorder+ flag +groupdetailid;
                                rst.executeProc("workflow_CurrentOperator_I", Procpara);
                                //设置代理人
                                Procpara1 = "" + requestid + flag + agenterId + flag + operatorgroup + flag
                                        + workflowid + flag + workflowtype + flag + opertortype + flag + tempremark + flag + nextnodeid +
                                        flag + opertor + flag + "2" + flag + showorder+ flag +groupdetailid;
                                rst.executeProc("workflow_CurrentOperator_I", Procpara1);
                                if (tempremark == 8 || tempremark == 9) {
                                    operator89List.add("" + opertor);
                                    operatortype89List.add("" + opertortype);
                                    agentoperator89List.add(agenterId);
                                }
                            }else{
                                Procpara = "" + requestid + flag + opertor + flag + operatorgroup + flag
                                        + workflowid + flag + workflowtype + flag + opertortype + flag + tempremark + flag + nextnodeid +
                                        flag + -1 + flag + "0" + flag + showorder+ flag +groupdetailid;
                                rst.executeProc("workflow_CurrentOperator_I", Procpara);
                                if (tempremark == 8 || tempremark == 9) {
                                    operator89List.add("" + opertor);
                                    operatortype89List.add("" + opertortype);
                                    agentoperator89List.add("0");
                                }
                            }
                        }

                        //对代理人判断提醒

                        /*--xwj for td3450 20060111 begin--*/
                        Procpara = opertor + flag + opertortype + flag + requestid;

                        if (nextnodetype.equals("3")){
                            if(isbeAgent){
                                //update by fanggsh for TD4739  20060808 果归档前的最后一个操作者是本人的话，则从提醒中去掉。
                                if(!operatorsWfEnd.contains(agenterId+"_"+opertortype)&&!(userid+"_"+usertype).equals(agenterId+"_"+opertortype)){
                                    //poppupRemindInfoUtil.insertPoppupRemindInfo(Integer.parseInt(agenterId),1,opertortype,requestid,requestname,workflowid);
                                    Map popmap=new HashMap();
                                    popmap.put("userid",""+Integer.parseInt(agenterId));
                                    popmap.put("type","1");
                                    popmap.put("logintype",""+opertortype);
                                    popmap.put("requestid",""+requestid);
                                    popmap.put("requestname",""+requestname);
                                    popmap.put("workflowid",""+workflowid);
                                    popmap.put("creater",""+creater);
                                    poppuplist.add(popmap);
                                    operatorsWfEnd.add(agenterId+"_"+opertortype);
                                }
                            }else{
                                //update by fanggsh for TD4739  20060808 果归档前的最后一个操作者是本人的话，则从提醒中去掉。
                                if(!operatorsWfEnd.contains(opertor+"_"+opertortype)&&!(userid+"_"+usertype).equals(opertor+"_"+opertortype)){
                                    //poppupRemindInfoUtil.insertPoppupRemindInfo(opertor,1,opertortype,requestid,requestname,workflowid);
                                    Map popmap=new HashMap();
                                    popmap.put("userid",""+opertor);
                                    popmap.put("type","1");
                                    popmap.put("logintype",""+opertortype);
                                    popmap.put("requestid",""+requestid);
                                    popmap.put("requestname",""+requestname);
                                    popmap.put("workflowid",""+workflowid);
                                    popmap.put("creater",""+creater);
                                    poppuplist.add(popmap);
                                    operatorsWfEnd.add(opertor+"_"+opertortype);
                                }
                            }
                        }
                        else{
                            if(isbeAgent){
                                if(!operatorsWfNew.contains(agenterId+"_"+opertortype)){
                                    //poppupRemindInfoUtil.insertPoppupRemindInfo(Integer.parseInt(agenterId),0,opertortype,requestid,requestname,workflowid);
                                    Map popmap=new HashMap();
                                    popmap.put("userid",""+Integer.parseInt(agenterId));
                                    popmap.put("type","0");
                                    popmap.put("logintype",""+opertortype);
                                    popmap.put("requestid",""+requestid);
                                    popmap.put("requestname",""+requestname);
                                    popmap.put("workflowid",""+workflowid);
                                    popmap.put("creater",""+creater);
                                    poppuplist.add(popmap);
                                    operatorsWfNew.add(agenterId+"_"+opertortype);
                                }
                            }else{
                                if(!operatorsWfNew.contains(opertor+"_"+opertortype)){
                                    //poppupRemindInfoUtil.insertPoppupRemindInfo(opertor,0,opertortype,requestid,requestname,workflowid);
                                    Map popmap=new HashMap();
                                    popmap.put("userid",""+opertor);
                                    popmap.put("type","0");
                                    popmap.put("logintype",""+opertortype);
                                    popmap.put("requestid",""+requestid);
                                    popmap.put("requestname",""+requestname);
                                    popmap.put("workflowid",""+workflowid);
                                    popmap.put("creater",""+creater);
                                    poppuplist.add(popmap);
                                    operatorsWfNew.add(opertor+"_"+opertortype);
                                }
                            }
                        }
                        if(SignType==1){
                            if(nextnodeattr==2){
                                operatorgroup--;
                            }else{
                                operatorgroup++;
                            }
                        }

                    }

                    // poppupRemindInfoUtil.insertPoppupRemindInfo(poppuplist);
                    //操作人更新结束
                    //更新当前节点表
                    if(canflowtonextnode){
                        //自由节点干预
                        if("intervenor".equals(src) && FreeNodeBiz.isFreeNode(nodeid) && innodeids!=null && !"".equals(innodeids)) {
                            rst.executeSql("delete from workflow_nownode where nownodeid in("+innodeids+") and requestid="+requestid);
                        } else if(!"intervenor".equals(src) || !FreeNodeBiz.isFreeNode(nodeid)){

                            if (nextnodeattr != 2) {//中间推荐退回到主干节点
                                rst.executeSql("delete from workflow_nownode where requestid=" + requestid);//删掉所有的当前节点
                            }
                            if(innodeids.equals("")||innodeids.equals("0")) innodeids=nodeid+"";
                            rst.executeSql("delete from workflow_nownode where nownodeid in("+innodeids+") and requestid="+requestid);
                            rst.executeSql("delete from workflow_nownode where nownodeid="+nodeid+" and requestid="+requestid);
                        }
                        rst.executeSql("insert into workflow_nownode(requestid,nownodeid,nownodetype,nownodeattribute) values("+requestid+","+nextnodeid+","+nextnodetype+","+nextnodeattr+")");
                    }
                }
                requestFlowInfoEntity.setDestnodeid(nextnodeid);
                if("intervenor".equals(src) && FreeNodeBiz.isFreeNode(nodeid)) {
                    String[] tempnodeids = Util.splitString(innodeids,",");
                    for(String tempnodeid : tempnodeids) {
                        int __tempnodeid  = Util.getIntValue(tempnodeid);
                        if(FreeNodeBiz.isFreeNode(__tempnodeid)) {
                            requestFlowInfoEntity.setNodeid(__tempnodeid);
                            RequestBaseBiz.saveRequestFlowInfo(requestFlowInfoEntity,rst);
                        }
                    }
                }
                String tempNextNodeId = String.valueOf(nextnodeid);
                operator89mp.put(tempNextNodeId, operator89List);
                operatortype89mp.put(tempNextNodeId, operatortype89List);
                agentoperator89mp.put(tempNextNodeId, agentoperator89List);
            }catch(Exception exception){
                throw exception;
            }
        }

    }


    /**
     * 获取当前操作人最新一次操作的日志编号
     *
     * @param userId
     * @param requestid
     * @return
     */
    private int getNewRequestLogId(int userId, int requestid) {
        int logid = 0;
        StringBuffer sb = new StringBuffer()
                .append(
                        "SELECT MAX(LOGID) AS ID FROM WORKFLOW_REQUESTLOG WHERE OPERATOR=")
                .append(userId).append(" AND REQUESTID=").append(requestid);
        RecordSet rs = new RecordSet();
        rs.executeSql(sb.toString());
        if (rs.next()) {
            logid = rs.getInt("ID");
        }
        return logid;
    }

    /**
     * 判断表是否有记录
     *
     * @param workflowid
     * @param requestid
     * @param requestLogId
     * @return
     */
    private int loadRequestLogId(String workflowid, int requestid,
                                 int requestLogId) {
        int logtype = 0;
        StringBuffer sb = new StringBuffer().append("SELECT LOGTYPE FROM ")
                .append(OpinionFieldConstant.TABLE_NAME_PREFIX + workflowid).append(" WHERE REQUESTID=")
                .append(requestid).append(" AND REQUESTLOGID=").append(
                        requestLogId);
        RecordSet rs = new RecordSet();
        rs.executeSql(sb.toString());
        if (rs.next()) {
            logtype = rs.getInt("LOGTYPE");
        }
        return logtype;
    }


    /**
     * 获取日志类型
     *
     * @return  日志类型
     */
    private int getLogType() {
        int logtype = 0;
        if (src.equals("save")) {
            if (isremark == 1){
                logtype = 9; // 批注日志类型为9
            }else if(isremark == -1){
                logtype = 2;
            }else{
                logtype = 1; // 保存日志类型为1
            }
        } else if (src.equals("submit")) {
            if (isremark == 7){
                logtype = 9; // 批注日志类型为9
            }else{
                logtype = 2;
            }
        }
        return logtype;
    }

    /**
     * 判断创建的表是否存在。存在返回true.不存在返回false;
     *
     * @param tablename 表名
     * @return 存在返回true.不存在返回false;
     */
    private boolean isExistTable(String tablename) {
        StringBuffer sb = new StringBuffer().append(
                "SELECT ID FROM WFOpinionTableNames ").append(" WHERE NAME='")
                .append(tablename).append("'");
        RecordSet rs = new RecordSet();
        rs.executeSql(sb.toString());
        if (rs.next()) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * 返回附件目录上传所选字段id
     * @param workflowid 流程ID
     * @return 字段id
     */
    public String getUpLoadTypeForSelect(int workflowid){
        int type = 0;
        String selectedCateLog = "";
        String result = "";
        StringBuffer sb = new StringBuffer().append(
                "select * from workflow_base ").append(" WHERE id=")
                .append(workflowid);
        RecordSet rs = new RecordSet();
        rs.executeSql(sb.toString());
        if (rs.next()) {
            type = Util.getIntValue(rs.getString("catelogType"),0);   //解决升级过程后数据库中catelogType字段一般为NULL的情况 by ben

            selectedCateLog = Util.null2String(rs.getString("selectedCateLog"));
            result = selectedCateLog + "," + type;
        }
        return result;
    }

    /**
     * 返回附件上传目录的类型 0：固定目录 1：选择目录
     * @param workflowid 流程ID
     * @return 0：固定目录 1：选择目录
     */
    public int getUpLoadType(int workflowid){
        int type = 0;
        StringBuffer sb = new StringBuffer().append(
                "select * from workflow_base ").append(" WHERE id=")
                .append(workflowid);
        RecordSet rs = new RecordSet();
        rs.executeSql(sb.toString());
        if (rs.next()) {
            type = rs.getInt("catelogType");
        }
        return type;
    }

    /**
     * 判断当为选择目录时附件上传目录是否设置完全
     * @param workflowid 流程ID
     * @return 是否设置完全
     */
    public boolean hasUsedType(int workflowid) {
        boolean isuse = true;
        StringBuffer sb = new StringBuffer().append(
                "select a.* from workflow_selectitem a ")
                .append(" left join workflow_base b ")
                .append(" on a.fieldid = b.selectedCateLog ")
                .append(" where (a.docPath is null or a.docCategory is null ")
                .append(" or a.docPath='' or a.docCategory='') ")
                .append(" and a.isAccordToSubCom='0'")
                .append(" and b.id=").append(workflowid);
        RecordSet rs = new RecordSet();
        rs.executeSql(sb.toString());
        if (rs.next()) {
            isuse = false;
        }
        return isuse;
    }

    /**
     * 获取IP地址
     * @return
     */
    public String getIp() {
        String ip = "";
        if(isRequest){
            if (request != null)
                ip = Util.null2String(request.getRemoteAddr());
        }else{
            if (fu != null)
                ip = Util.null2String(fu.getRemoteAddr());
        }
        return ip;
    }
    /**
     * 发生流程提醒邮件
     * @param mailtoaddress   邮件地址
     * @param mailobject      邮件标题
     * @param mailrequestname 邮件内容
     */
    private void SendRemindMail(String mailtoaddress,String mailobject,String mailrequestname){
        try{
            mailtoaddress = mailtoaddress.substring(0,mailtoaddress.length()-1);
            new Thread(new EmailWorkRunnable(mailtoaddress, mailobject, mailrequestname)).start();
        }catch(Exception e){
            writeLog(e);
        }
    }

    /**
     *获得billid，billid为单据主表的id
     *在这地方队billid重新赋值是因为，在operation页面有些billid是错误的
     *这样导致获得节点操作人出错
     */
    public void getBillId(){
        RecordSet rs=new RecordSet();
        if(isbill == 1){
            rs.executeSql("select tablename from workflow_bill where id = " + formid);
            rs.next();
            String tablename = Util.null2String(rs.getString("tablename"));
            if(!tablename.equals("")){
                rs.executeSql("select id from " + tablename + " where requestid = " + requestid);
                if(rs.next()){
                    billid = rs.getInt("id");
                }
            }
        }
    }

    /**
     * 获得是否为图形化
     * @return
     */
    public boolean getModeid(int curworkflowid,int curnodeid,int curformid,int curisbill){
        RecordSet currs=new RecordSet();
        String ismode="";
        int modeid=0;
        int showdes=0;
        currs.executeSql("select ismode,showdes from workflow_flownode where workflowid="+curworkflowid+" and nodeid="+curnodeid);
        if(currs.next()){
            ismode=Util.null2String(currs.getString("ismode"));
            showdes=Util.getIntValue(Util.null2String(currs.getString("showdes")),0);
        }
        if(ismode.equals("1") && showdes!=1){
            currs.executeSql("select id from workflow_nodemode where isprint='0' and workflowid="+curworkflowid+" and nodeid="+curnodeid);
            if(currs.next()){
                modeid=currs.getInt("id");
            }else{
                currs.executeSql("select id from workflow_formmode where isprint='0' and formid="+curformid+" and isbill='"+curisbill+"'");
                if(currs.next()){
                    modeid=currs.getInt("id");
                }
            }
        }
        return modeid>0?true:false;
    }

    public String getDocrowindex()
    {
        return docrowindex;
    }

    public void setDocrowindex(String docrowindex)
    {
        this.docrowindex = docrowindex;
    }

    private void updatePoppupRemindInfoThisJava(RecordSetTrans rst,int requestId )throws Exception{
        String remindusers="";
        String usertypes="";
        rst.executeSql("select wfreminduser,wfusertypes from workflow_currentoperator where (isremark='0' or isremark='7') and requestid="+requestid);
        if(rst.next()){
            remindusers=rst.getString("wfreminduser");
            usertypes=rst.getString("wfusertypes");
        }
        ArrayList wfremindusers=Util.TokenizerString(remindusers,",");
        ArrayList wfusertypes=Util.TokenizerString(usertypes,",");
        rst.executeSql("select userid,usertype from workflow_currentoperator where requestid="+requestid +" group by userid,usertype");
        while(rst.next()){
            String tempuserid=rst.getString("userid");
            String tempusertype=rst.getString("usertype");
            if(wfremindusers.indexOf(tempuserid)<0){
                wfremindusers.add(tempuserid);
                wfusertypes.add(tempusertype);
            }
        }

    }

    private void updateworkflowcurrentoperator(RecordSetTrans rst,ArrayList submituserids,ArrayList submitusertypes, String finishndgpids)throws Exception{
        //各组人员个数
        Map<String, Integer> peopleCountMap = new HashMap<>();

        rst.executeSql("select distinct userid,usertype, groupid from workflow_currentoperator where isremark = '"+isremark+"' and requestid= " + requestid + " and nodeid=" + nodeid + " and groupid in(select distinct groupid from workflow_currentoperator where isremark = '"+isremark+"' and requestid=" + requestid + " and userid=" + userid + " and usertype=" + usertype + " and nodeid=" + nodeid + ")");
        while (rst.next()) {
            submituserids.add(rst.getString("userid"));
            submitusertypes.add(rst.getString("usertype"));
            String temp_groupId = rst.getString("groupid");
            Integer peopleCcount = peopleCountMap.get(temp_groupId);
            if (peopleCcount == null) {
                peopleCcount = new Integer(0);
            }
            peopleCountMap.put(temp_groupId, (peopleCcount.intValue() + 1));

        }

        List tmpgroupidList=new ArrayList();

        //需要更新已经完成操作组的其他人员
        if (!"".equals(finishndgpids)) {
            rst.executeSql("select distinct groupid from workflow_currentoperator where isremark = '"+isremark+"' and requestid=" + requestid + " and nodeid="+nodeid + " and (groupdetailid in (SELECT id FROM workflow_groupdetail WHERE groupid in (" + finishndgpids + ")) OR (userid=" + userid + " and usertype=" + usertype + "))");
        } else {
            rst.executeSql("select distinct groupid from workflow_currentoperator where isremark = '"+isremark+"' and requestid=" + requestid + " and userid=" + userid + " and usertype=" + usertype+" and nodeid="+nodeid);
        }

        while(rst.next()){
            tmpgroupidList.add(""+Util.getIntValue(rst.getString(1), 0));
        }

        for(int i=0;i<tmpgroupidList.size();i++) {
            int tmpgroupid = Util.getIntValue((String)tmpgroupidList.get(i), 0);

            //增加判断，如果一个group中只有一个人， 则不根据groupid进行范围更新
            boolean isManyPeople = true;
            Integer peopleCcount = peopleCountMap.get(tmpgroupid + "");
            if (peopleCcount != null && peopleCcount == 1) {
                isManyPeople = false;
            }
            if(!"0".equals(needwfback)){
                //rst.executeProc("workflow_CurOpe_UpdatebySubmit", "" +userid +flag + requestid + flag + tmpgroupid+flag+nodeid+flag+isremark + flag + this.currentdate + flag + this.currenttime);
                workflow_CurOpe_UpdatebySubmit(rst, requestid, nodeid, userid, usertype, currentdate, currenttime, tmpgroupid, isremark, isManyPeople);
                rst.executeSql("update workflow_currentoperator set operatedate='"+currentdate+"',operatetime='"+currenttime+"' where (isremark = '5' or isremark='0' or isremark='1' or isremark='8' or isremark='9' or isremark='7') and requestid ="+requestid+" and userid="+userid+" and nodeid="+nodeid+" and groupid="+tmpgroupid);
                if (isManyPeople) {
                    this.updateworkflowcurrenttakingopsoperator(rst, tmpgroupid);
                }
            }else{
                //rst.executeProc("workflow_CurOpe_UbySubmitNB", "" +userid +flag + requestid + flag + tmpgroupid+flag+nodeid+flag+isremark + flag + this.currentdate + flag + this.currenttime);
                workflow_CurOpe_UbySubmitNB(rst, requestid, nodeid, userid, usertype, currentdate, currenttime, tmpgroupid, isremark, isManyPeople);
                rst.executeSql("update workflow_currentoperator set operatedate='"+currentdate+"',operatetime='"+currenttime+"' where (isremark = '5' or isremark='0' or isremark='1' or isremark='8' or isremark='9' or isremark='7') and requestid ="+requestid+" and userid="+userid+" and nodeid="+nodeid+" and groupid="+tmpgroupid);
                if (isManyPeople) {
                    this.updateworkflowcurrenttakingopsoperator(rst, tmpgroupid);
                }
            }
        }
    }

    private void updateworkflowcurrenttakingopsoperator(RecordSetTrans rst, int tmpgroupid)throws Exception{
        //System.out.println("----8239+====sql=="+"update workflow_currentoperator set viewtype=-2 , isremark=2 ,  operatedate='"+currentdate+"',operatetime='"+currenttime+"' where (isremark = '1' and takisremark='2') and requestid ="+requestid+" and nodeid="+nodeid+" and groupid="+tmpgroupid);
        rst.executeSql("update workflow_currentoperator set viewtype=-2 , isremark=2 ,  operatedate='"+currentdate+"',operatetime='"+currenttime+"',processUser = "+userid+" where (isremark = '1' and takisremark='2') and requestid ="+requestid+" and nodeid="+nodeid+" and groupid="+tmpgroupid);
        //修复一个节点中操作组1 abc三人非会签 操作组2 b 操作组3 c 关系时，b意见征询d未回复时，a或c提交流程导致流程回不到b的待办问题
//        updateworkflowcurrenttakingothergroup(rst,tmpgroupid);
    }
//
//    private void updateworkflowcurrenttakingothergroup(RecordSetTrans rst, int tmpgroupid)throws Exception{
//        rst.executeSql("select userid from workflow_currentoperator where requestid = "+requestid + " and nodeid = "+nodeid+" and isremark = 2 and preisremark = 0 and takisremark = -2 ");
//        if(rst.next()){
//            int userid = Util.getIntValue(rst.getString("userid"),0);
//            rst.executeUpdate("update workflow_currentoperator set takisremark = 0 where requestid = "+requestid + " and nodeid="+nodeid+" and isremark = 0 and preisremark= 0 and takisremark = -2 and userid = "+userid);
//        }
//    }

    private void updateworkflowcurrenttakingopsoperator(RecordSetTrans rst, String nodeids, int tmpgroupid)throws Exception{
        //System.out.println("----8239+====sql=="+"update workflow_currentoperator set viewtype=-2 , isremark=2 ,  operatedate='"+currentdate+"',operatetime='"+currenttime+"' where (isremark = '1' and takisremark='2') and requestid ="+requestid+" and nodeid in ("+nodeids+")  and groupid="+tmpgroupid);
        rst.executeSql("update workflow_currentoperator set viewtype=-2 , isremark=2 ,  operatedate='"+currentdate+"',operatetime='"+currenttime+"',processUser = "+userid+" where (isremark = '1' and takisremark='2') and requestid ="+requestid+" and nodeid in ("+nodeids+") and groupid="+tmpgroupid);

    }


    private static void workflow_CurOpe_UpdatebySubmit(RecordSetTrans rst, int requestid, int nodeid, int userid, int usertype, String currentdate, String currenttime, int tmpgroupid, int isremark) throws Exception {
        workflow_CurOpe_UpdatebySubmit(rst, requestid, nodeid, userid, usertype, currentdate, currenttime, tmpgroupid, isremark, true);
    }

    private static void workflow_CurOpe_UbySubmitNB(RecordSetTrans rst, int requestid, int nodeid, int userid, int usertype, String currentdate, String currenttime, int tmpgroupid, int isremark) throws Exception {
        workflow_CurOpe_UbySubmitNB(rst, requestid, nodeid, userid, usertype, currentdate, currenttime, tmpgroupid, isremark, true);
    }

    /**
     * 从PROCEDURE workflow_CurOpe_UpdatebySubmit改造
     * @param rst
     * @param nodeid
     * @param tmpgroupid
     * @param isremark
     * @throws Exception
     */
    private static void workflow_CurOpe_UpdatebySubmit(RecordSetTrans rst, int requestid, int nodeid, int userid, int usertype, String currentdate, String currenttime, int tmpgroupid, int isremark, boolean isUpdateIdenticalGroupRecord) throws Exception {

        String upSql = "update workflow_currentoperator set operatedate ='" + currentdate + "', operatetime='" + currenttime + "', viewtype=-2 "
                + " where requestid=" + requestid
                + " and userid=" + userid + " and usertype=" + usertype + " and isremark='" + isremark + "' " + " and groupid=" + tmpgroupid + " and nodeid=" + nodeid;
        rst.executeSql(upSql);

        //本次提交影响多个group 或多个人时 才更新， 否则不更新。
        if (isUpdateIdenticalGroupRecord) {
            upSql = "update workflow_currentoperator set isremark = '2',processUser = " + userid + " where requestid = " + requestid + " and isremark='" + isremark + "' and groupid=" + tmpgroupid + " and nodeid=" + nodeid;
            rst.executeSql(upSql);
        } else {
            upSql = "update workflow_currentoperator set isremark = '2',processUser = " + userid + " where requestid = " + requestid + " and isremark='" + isremark + "' and groupid=" + tmpgroupid + " and nodeid=" + nodeid + " and userid=" + userid;
            rst.executeSql(upSql);
        }
        WFLinkInfo wflinkinfo = new WFLinkInfo();
        int nodeattr = wflinkinfo.getNodeAttribute(nodeid);

        if (nodeattr == 2) {
            upSql = " update workflow_currentoperator set isremark = '2',processUser = "+userid
                    + " where requestid = " + requestid
                    + " and (isremark = '5' or isremark = '8' or isremark = '9') and userid = " + userid + " and nodeid =" + nodeid;
        } else {
            upSql = "update workflow_currentoperator set isremark = '2',processUser = "+userid
                    + " where requestid = " + requestid + " and (isremark = '5' or isremark = '8' or isremark = '9') and userid=" + userid;
        }
        rst.executeSql(upSql);
    }

    /**
     * PROCEDURE workflow_CurOpe_UbySubmitNB 改造而来
     * @param rst
     * @param nodeid
     * @param tmpgroupid
     * @param isremark
     * @throws Exception
     */
    private static void workflow_CurOpe_UbySubmitNB(RecordSetTrans rst, int requestid, int nodeid, int userid, int usertype, String currentdate, String currenttime, int tmpgroupid, int isremark, boolean isUpdateIdenticalGroupRecord) throws Exception {

        String upSql = "update workflow_currentoperator set operatedate ='" + currentdate + "', operatetime ='" + currenttime + "', viewtype=-2"
                + " where requestid=" + requestid
                + " and userid = " + userid
				+ " and usertype = " + usertype
                + " and isremark = '" + isremark + "' "
                + " and groupid = " + tmpgroupid
                + " and nodeid = " + nodeid;
        rst.executeSql(upSql);

        //本次提交影响多个group 或多个人时 才更新， 否则不更新。
        if (isUpdateIdenticalGroupRecord) {
            upSql = "update workflow_currentoperator set isremark = '2', needwfback = '0',processUser = " + userid
                    + " where requestid = " + requestid
                    + " and isremark = '" + isremark + "' "
                    + " and groupid = " + tmpgroupid
                    + " and nodeid = " + nodeid;
            rst.executeSql(upSql);
        } else {
            upSql = "update workflow_currentoperator set isremark = '2', needwfback = '0',processUser = " + userid
                    + " where requestid = " + requestid
                    + " and isremark = '" + isremark + "' "
                    + " and groupid = " + tmpgroupid
                    + " and nodeid = " + nodeid
					+ " and usertype = " + usertype
                    + " and userid = " + userid;
            rst.executeSql(upSql);
        }
        WFLinkInfo wflinkinfo = new WFLinkInfo();
        int nodeattr = wflinkinfo.getNodeAttribute(nodeid);

        if (nodeattr == 2) {
            upSql = " update workflow_currentoperator set isremark = '2', needwfback = '0',processUser = "+userid
                    + " where requestid = " + requestid
                    + " and (isremark = '5' or isremark = '8' or isremark = '9') "
                    + " and userid = " + userid
					+ " and usertype = " + usertype
                    + " and nodeid = " + nodeid;
        } else {
            upSql = " update workflow_currentoperator set isremark = '2', needwfback = '0',processUser = "+userid
                    + " where requestid = " + requestid
                    + " and (isremark = '5' or isremark = '8' or isremark = '9')"
					+ " and usertype = " + usertype
                    + " and userid = " + userid;
        }
        rst.executeSql(upSql);
    }

    /**
     * PROCEDURE workflow_CurOpe_UbyForward 改造而来
     * @param rst
     * @throws Exception
     */
    private static void workflow_CurOpe_UbyForward(RecordSetTrans rst, int requestid, int userid, int usertype, String currentdate, String currenttime) throws Exception {
        String upSql = "update workflow_currentoperator set isremark = 2, operatedate = '" + currentdate + "', operatetime = '" + currenttime + "',processUser = "+userid
                + " where requestid = " + requestid + " and userid =" + userid
                + " and usertype = " + usertype + " and (isremark = 1 or isremark = 8 or isremark = 9 or isremark = 11)";
        rst.executeSql(upSql);
    }

    /**
     * PROCEDURE workflow_CurOpe_UbyForwardNB 改造而来
     * @param rst
     * @throws Exception
     */
    private static void workflow_CurOpe_UbyForwardNB(RecordSetTrans rst, int requestid, int userid, int usertype, String currentdate, String currenttime) throws Exception {
        String upSql = " update workflow_currentoperator set isremark='2', operatedate = '" + currentdate + "', operatetime = '" + currenttime + "', needwfback  = '0',processUser = "+userid
                + " where requestid = " + requestid
                + " and userid = " + userid
                + " and usertype = " + usertype
                + " and (isremark = 1 or isremark = 8 or isremark = 9 or isremark = 11)";

        rst.executeSql(upSql);
    }
    public void setRejectToNodeid(int rejectToNodeid) {
        RejectToNodeid = rejectToNodeid;
    }

    public void setRejectToType(int RejectToType) {
        this.RejectToType = RejectToType;
    }

    public void setSubmitToNodeid(int submitToNodeid) {
        this.SubmitToNodeid = submitToNodeid;
    }

    public String getClientType() {
        return clientType;
    }

    public void setClientType(String clientType) {
        this.clientType = clientType;
    }

    public String getHandWrittenSign() {
        return handWrittenSign;
    }

    public void setHandWrittenSign(String handWrittenSign) {
        this.handWrittenSign = handWrittenSign;
    }

    public void setHandWrittenSign(int handWrittenSign) {
        setHandWrittenSign(String.valueOf(handWrittenSign));
    }

    public int getSpeechAttachment() {
        return speechAttachment;
    }

    public void setSpeechAttachment(int speechAttachment) {
        this.speechAttachment = speechAttachment;
    }
    public int getEnableIntervenor() {
        return enableIntervenor;
    }

    public void setEnableIntervenor(int enableIntervenor) {
        this.enableIntervenor = enableIntervenor;
    }

    //add by liaodong for qc53580 in 20130916 start
    public String fillFullNull(String obj){
        if("".equals(obj.trim())){
            return "";
        }else{
            return obj;
        }

    }

    public String getSignatureAppendfix() {
        return signatureAppendfix;
    }

    public void setSignatureAppendfix(String signatureAppendfix) {
        this.signatureAppendfix = signatureAppendfix;
    }
    public String getChatsType() {
        return chatsType;
    }

    public void setChatsType(String chatsType) {
        if(chatsType==null || chatsType.equals("")){
            chatsType="0";
        }
        this.chatsType = chatsType;
    }

    private String[] parseArgument(String s, char separator)
    {
        String[] args;
        int i = 0;
        int j = 0;
        if(s.trim().equals("")){
            args=new String[0];
            return args;
        }
        for(j = 0; j < s.length(); j++)
            if(s.charAt(j) == separator)
                i++;

        args = new String[i + 1];
        j = 0;
        i = 0;
        while((j = s.indexOf(separator)) != -1)
        {
            args[i++] = s.substring(0, j);
            s = s.substring(j + 1);
        }
        args[i] = s;
        return args;
    }

    /**
     * 代替存储过程保存签字意见信息,新增接收人id,clob类型
     * para rstlogpara flag
     * talbe workflow_requestlog
     * ***/
    public String execRequestlog(String rstlogpara , RecordSet rslog , char flag , String remarknew){
        String returnStr = "";
        if(!"".equals(rstlogpara)){
            //String [] arraypara = Util.TokenizerString2(rstlogpara, String.valueOf(flag));
            String [] arraypara = rstlogpara.split(String.valueOf(flag));
            if(arraypara.length < 22) {
                arraypara = this.parseArgument(rstlogpara, flag);
            }
            //System.out.println("arraypara.length = "+arraypara.length);
            String requestidlog = arraypara[0];
            String workflowidlog = arraypara[1];
            String nodeidlog = arraypara[2];
            String logtypelog = arraypara[3];
            String logdatelog = arraypara[4];
            String logtimelog = arraypara[5];
            String useridlog = arraypara[6];
            //String remarklog = arraypara[7];
            String clientiplog = arraypara[7];
            String usertypelog = arraypara[8];
            String nextnodeidlog = arraypara[9];
            String operate1log = arraypara[10];
            String agentorbyagentid1log = arraypara[11];
            String agenttype1log = arraypara[12];
            String showorder1log = arraypara[13];
            String annexdocidslog = arraypara[14];
            String requestLogIdlog = arraypara[15];
            String signdocidslog = arraypara[16];
            String signworkflowidslog = arraypara[17];
            String clientTypelog = arraypara[18];
            String speechAttachmentlog = arraypara[19];
            String handWrittenSignlog = arraypara[20];
            //处理签字意见附件  流程草稿('9')改为生效/正常('1')
            if(annexdocidslog!=null && !"".equals(annexdocidslog.trim())){
                DocExtUtil deu = new DocExtUtil();
                deu.updateDoc(annexdocidslog,user,"1");
            }

            //如果receivedPersonids为空，split的length就会少1，所以可能出现指针越界
            String receivedPersonids = "";
            String remarkLocation = "";
            String fulltextannotation = "";
            String speechAttachmente9 = "";
            String remarkquote = ""; //签字意见引用
            if(arraypara.length > 21) {
                receivedPersonids = arraypara[21];
            }
            //抄送签字意见不记录位置
            if(arraypara.length > 22 && !"t".equals(logtypelog)){
                remarkLocation = arraypara[22];
            }
            if(arraypara.length > 23) {
                fulltextannotation = arraypara[23];
            }
            if(arraypara.length > 24) {
                speechAttachmente9 = arraypara[24];
            }
            if(arraypara.length > 25) {
                remarkquote = arraypara[25];
            }

            int count2 = 0;
            Date date = new Date();
            SimpleDateFormat sdfdate = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

            String currentStr = sdfdate.format(date);
            String currentdate = "";
            String currenttime = "";
            if (logdatelog.equals("")){
                currentdate = currentStr.substring(0,10).trim();
                currenttime = currentStr.substring(10).trim();
            }else{
                currentdate = logdatelog;
                currenttime = logtimelog;
            }
            returnStr = currentdate+"~~current~~"+currenttime;
            int operatorDept1 = Util.getIntValue(resourceComInfo.getDepartmentID(""+useridlog),0);
            int operatorSub = Util.getIntValue(resourceComInfo.getSubCompanyID(""+useridlog),0);
            int operatorJob = Util.getIntValue(resourceComInfo.getJobTitle(""+useridlog),0);
            String seclevel = Util.getIntValue(resourceComInfo.getSeclevel(""+useridlog),0) + "";
            ConnStatement logstatement = null;
            if("1".equals(logtypelog) && !"".equals(remarkquote)) {
                remarknew = remarkquote;
            }
            remarkquote = "";
            try {
                if(("0".equals(usertypelog) || "1".equals(usertypelog) || "2".equals(usertypelog)) && !(this.istest == 1 && "i".equals(logtypelog) && this.istestwf == 1)){//流程测试干预时，不记录requestlog
                    if("1".equals(logtypelog)){
                        String logsql = " SELECT 1 FROM workflow_requestlog WHERE requestid="+requestidlog +
                                " AND nodeid="+nodeidlog+" AND logtype='"+logtypelog+"' AND OPERATOR = "+useridlog +
                                " AND operatortype = "+usertypelog;
                        rslog.executeSql(logsql);
                        int count1 =  rslog.getCounts();
                        if(count1 > 0){
                            String updatelogsql = " UPDATE workflow_requestlog SET operatedate= ?,operatetime= ?," +
                                    " remark= ?, clientip= ?, destnodeid= ?, annexdocids= ?, " +
                                    " requestLogId= ?, signdocids= ?, signworkflowids= ?, isMobile= ?," +
                                    " SpeechAttachment= ?, HandWrittenSign= ?, remarkLocation=?,remarkquote=?,fulltextannotation = ?,speechAttachmente9 = ? where requestid="+requestidlog +
                                    " AND nodeid="+nodeidlog+" AND logtype='"+logtypelog+"' AND OPERATOR = "+useridlog +
                                    " AND operatortype = "+usertypelog;
                            logstatement = new ConnStatement();
                            logstatement.setStatementSql(updatelogsql);
                            logstatement.setString(1, currentdate);
                            logstatement.setString(2, currenttime);
                            logstatement.setString(3, remarknew);
                            logstatement.setString(4, clientiplog);
                            logstatement.setInt(5, Integer.parseInt(nodeidlog));
                            logstatement.setString(6, annexdocidslog);
                            logstatement.setInt(7, Util.getIntValue(requestLogIdlog,0));
                            logstatement.setString(8, signdocidslog);
                            logstatement.setString(9, signworkflowidslog);
                            logstatement.setString(10, clientTypelog);
                            logstatement.setInt(11, Util.getIntValue(speechAttachmentlog,0));
                            logstatement.setString(12, Util.null2String(handWrittenSignlog,""));
                            logstatement.setString(13, remarkLocation);
                            logstatement.setString(14, remarkquote);
                            logstatement.setString(15, fulltextannotation);
                            logstatement.setString(16, speechAttachmente9);
                            logstatement.executeUpdate();
                        }else{
                            String insertlogsql = " INSERT INTO workflow_requestlog (requestid,workflowid,nodeid,logtype, operatedate, " +
                                    " operatetime,OPERATOR, remark,clientip,operatortype,destnodeid,receivedPersons, " +
                                    " agentorbyagentid,agenttype,showorder,annexdocids,requestLogId,operatorDept, " +
                                    " signdocids,signworkflowids,isMobile,HandWrittenSign,SpeechAttachment,receivedPersonids,remarkLocation,remarkquote,fulltextannotation,speechAttachmente9,operatorSub,operatorJob,seclevel) " +
                                    " VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?) ";
                            logstatement = new ConnStatement();
                            logstatement.setStatementSql(insertlogsql);
                            logstatement.setInt(1, Integer.parseInt(requestidlog));
                            logstatement.setInt(2, Integer.parseInt(workflowidlog));
                            logstatement.setInt(3, Integer.parseInt(nodeidlog));
                            logstatement.setString(4, logtypelog);
                            logstatement.setString(5, currentdate);
                            logstatement.setString(6, currenttime);
                            logstatement.setInt(7, Integer.parseInt(useridlog));
                            logstatement.setString(8, remarknew);
                            logstatement.setString(9, clientiplog);
                            logstatement.setInt(10, Integer.parseInt(usertypelog));
                            logstatement.setInt(11, Integer.parseInt(nextnodeidlog));
                            logstatement.setString(12, operate1log);
                            logstatement.setInt(13, Integer.parseInt(agentorbyagentid1log));
                            logstatement.setString(14, agenttype1log);
                            logstatement.setInt(15, Integer.parseInt(showorder1log));
                            logstatement.setString(16, annexdocidslog);
                            logstatement.setInt(17, Util.getIntValue(requestLogIdlog,0));
                            logstatement.setString(18, String.valueOf(operatorDept1));
                            logstatement.setString(19, signdocidslog);
                            logstatement.setString(20, signworkflowidslog);
                            logstatement.setString(21, clientTypelog);
                            logstatement.setString(22, Util.null2String(handWrittenSignlog,""));
                            logstatement.setInt(23, Util.getIntValue(speechAttachmentlog,0));
                            logstatement.setString(24, receivedPersonids);
                            logstatement.setString(25, remarkLocation);
                            logstatement.setString(26, remarkquote);
                            logstatement.setString(27, fulltextannotation);
                            logstatement.setString(28, speechAttachmente9);
                            logstatement.setInt(29, operatorSub);
                            logstatement.setInt(30, operatorJob);
                            logstatement.setString(31, seclevel);
                            logstatement.executeUpdate();
                        }
                    }else{
                        String deletelogsql = " DELETE from workflow_requestlog WHERE requestid="+requestidlog+" AND nodeid="+nodeidlog +
                                " AND (logtype='1') AND OPERATOR = "+useridlog+" AND operatortype = "+usertypelog;
                        rslog.executeSql(deletelogsql);
                        String insertlog = " INSERT INTO workflow_requestlog (requestid,workflowid,nodeid,logtype, operatedate, " +
                                " operatetime,OPERATOR, remark,clientip,operatortype,destnodeid,receivedPersons, " +
                                " agentorbyagentid,agenttype,showorder,annexdocids,requestLogId,operatorDept, " +
                                " signdocids,signworkflowids,isMobile,HandWrittenSign,SpeechAttachment,receivedPersonids,remarkLocation,remarkquote,fulltextannotation,speechAttachmente9,operatorSub,operatorJob,seclevel) " +
                                " VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?) ";
                        logstatement = new ConnStatement();
                        logstatement.setStatementSql(insertlog);
                        logstatement.setInt(1, Integer.parseInt(requestidlog));
                        logstatement.setInt(2, Integer.parseInt(workflowidlog));
                        logstatement.setInt(3, Integer.parseInt(nodeidlog));
                        logstatement.setString(4, logtypelog);
                        logstatement.setString(5, currentdate);
                        logstatement.setString(6, currenttime);
                        logstatement.setInt(7, Integer.parseInt(useridlog));
                        logstatement.setString(8, remarknew);
                        logstatement.setString(9, clientiplog);
                        logstatement.setInt(10, Integer.parseInt(usertypelog));
                        logstatement.setInt(11, Integer.parseInt(nextnodeidlog));
                        logstatement.setString(12, operate1log);
                        logstatement.setInt(13, Integer.parseInt(agentorbyagentid1log));
                        logstatement.setString(14, agenttype1log);
                        logstatement.setInt(15, Integer.parseInt(showorder1log));
                        logstatement.setString(16, annexdocidslog);
                        logstatement.setInt(17, Util.getIntValue(requestLogIdlog,0));
                        logstatement.setString(18, String.valueOf(operatorDept1));
                        logstatement.setString(19, signdocidslog);
                        logstatement.setString(20, signworkflowidslog);
                        logstatement.setString(21, clientTypelog);
                        logstatement.setString(22, Util.null2String(handWrittenSignlog,""));
                        logstatement.setInt(23, Util.getIntValue(speechAttachmentlog, 0));
                        logstatement.setString(24, receivedPersonids);
                        logstatement.setString(25, remarkLocation);
                        logstatement.setString(26, remarkquote);
                        logstatement.setString(27, fulltextannotation);
                        logstatement.setString(28, speechAttachmente9);
                        logstatement.setInt(29, operatorSub);
                        logstatement.setInt(30, operatorJob);
                        logstatement.setString(31, seclevel);
                        logstatement.executeUpdate();
                    }
                }
                
                if(logstatement != null) {
                    logstatement.close();    //先关闭，让插入log的操作先提交,否则会导致下面的查询语句，查询不到logid,for oracle
                }
                String logsql = " select logid from workflow_requestlog where workflowid = "
                        + workflowidlog
                        + " and nodeid = "
                        + nodeidlog
                        + " and logtype = '"
                        + logtypelog
                        + "' and requestid = "
                        + requestidlog
                        + " and operatedate = '"
                        + currentdate
                        + "' and operatetime = '"
                        + currenttime
                        + "' and operator = " + useridlog;

                rslog.executeSql(logsql);
                int logid = -1;
                if (rslog.next()) {
                    logid = rslog.getInt("logid");
                }

                if("1".equals(isRobotNode) && ("1".equals(logtypelog) || "0".equals(logtypelog) || "2".equals(logtypelog) || "3".equals(logtypelog))){
                    //签字意见标记成机器节点，因为机器人节点可以自定义操作名称
                    rslog.executeUpdate("update workflow_requestlog set isRobotNode = '1' where requestid = ? and logid = ?", requestidlog, logid);
                }

                //意见类型
                if("0".equals(logtypelog) || "2".equals(logtypelog)) {
                    if(nodeInfoCache != null && nodeInfoCache.size() > 0) {
                        for(Map.Entry<Integer,AutoApproveParams> item : nodeInfoCache.entrySet()) {
                            item.getValue().setStartLogId(logid);
                        }
                    }
                }

                /**
                 * 处理签字意见的权限,督办(s)所有人都有权限，其他的都只给日志的操作人赋予权限
                 */
                if ("s".equals(logtypelog) || "9".equals(logtypelog)
                        || "2".equals(logtypelog) || "3".equals(logtypelog)
                        || "4".equals(logtypelog) || "5".equals(logtypelog)
                        || "6".equals(logtypelog) || "e".equals(logtypelog)
                        || "0".equals(logtypelog) || "t".equals(logtypelog)
                        || "i".equals(logtypelog) || "7".equals(logtypelog)
                        || "h".equals(logtypelog) || "a".equals(logtypelog)
                        || "b".equals(logtypelog) || "j".equals(logtypelog)
                        || "c".equals(logtypelog) || "z".equals(logtypelog)
                        || "y".equals(logtypelog) || "x".equals(logtypelog)
                        || "r".equals(logtypelog)) {

                    String rsql = "select currentnodeid,currentnodetype from workflow_requestbase where requestid = " + requestidlog;
                    rslog.executeSql(rsql);
                    String curnodeid = "";
                    String curnodetype = "";
                    if(rslog.next()){
                        curnodeid = rslog.getString("currentnodeid");
                        curnodetype = rslog.getString("currentnodetype");
                    }
                    int nodeattr = wflinkinfo.getNodeAttribute(Util.getIntValue(curnodeid,-1));
                    Set<String> branchNodeSet = new HashSet<String>();
                    if(nodeattr == 2){   //分支中间节点
                        String branchnodes = "";
                        branchnodes = wflinkinfo.getNowNodeids(Util.getIntValue(requestidlog,-1));
                        if(!"".equals(branchnodes)){
                            String [] strs = branchnodes.split(",");
                            for(int k = 0; k < strs.length; k++){
                                String nodestr = strs[k];
                                if(!"-1".equals(nodestr)){
                                    branchNodeSet.add(nodestr);
                                }
                            }
                        }
                    }

                    //流程的非归档节点，且插入日志的节点仍然是流程的当前节点，则需要日志权限控制
                    if(!"3".equals(curnodetype) && (curnodeid.equals(nodeidlog) || branchNodeSet.contains(nodeidlog))){


                        int loguserid = Util.getIntValue(useridlog, 0);
                        if ("s".equals(logtypelog)) { // 督办所有人有权限
                            loguserid = -1;
                        }

                        String rightSql = "insert into workflow_logviewusers (logid,userid) values (? , ?)";
                        logstatement.close();
                        logstatement = new ConnStatement();
                        logstatement.setStatementSql(rightSql);
                        logstatement.setInt(1, logid);
                        logstatement.setInt(2, loguserid);
                        logstatement.executeUpdate();
                    }
                }
                //插入@信息，并发提醒
                if(!"1".equals(logtypelog)) {
                    RequestSignRelevanceWithMe reqsignwm = new RequestSignRelevanceWithMe();
                    reqsignwm.inertRelevanceInfo(workflowidlog + "", requestidlog + "", nodeidlog + "", logtypelog + "", logdatelog, logtimelog, useridlog, remarknew);

                    //提醒
                    List<String> atResourceids = reqsignwm.parseRemark(remarknew);
                    if(atResourceids.size() > 0) {
                        RequestOperationMsgManager romm = new RequestOperationMsgManager();
                        romm.remarkAtMsg(requestidlog,useridlog,atResourceids);
                    }


                }
            } catch (Exception e) {
                log.info(new StringBuilder().append("~requestlog~rstlogpara:").append(rstlogpara).append(",remark:").append(remarknew).toString());
                log.error(e);
            } finally {
                if(logstatement!=null) logstatement.close();
            }
        }

        return returnStr;
    }

    /**
     * 资源权限过滤器
     * @param resstr
     * @return
     */
    public String resourceAuthorityFilter(String fieldhtmltype, String fieldtype, String resstr, String fieldid) {
        String result = resstr;

        if ("".equals(resstr) || this.istest == 1) {
            return result;
        }

        if ("3".equals(fieldhtmltype)) {
            if (fieldtype.equals("9") || fieldtype.equals("37")) {  // 文档字段
                //result = new DocShareUtil().docRightFilter(user, resstr);
                if(resstr.startsWith(","))	resstr = resstr.substring(1);
                if(resstr.endsWith(","))	resstr = resstr.substring(0, resstr.length()-1);
                result = new DocShareUtil().docRightFilterForRequestId(user, resstr, requestid);
            } else if (fieldtype.equals("8")|| fieldtype.equals("135")) { //项目
                RecordSet rs = new RecordSet();
                String workflow_filter = "";
                rs.executeQuery("select workflow_filter from Prj_Settings where id=-1");
                if(rs.next()){
                    workflow_filter = Util.null2String(rs.getString("workflow_filter"));
                }
                if(workflow_filter.equals("0")){
                    return result;
                }
                result = new weaver.cpt.util.CommonShareManager().getPrjFilterids(resstr, user);
            } else if (fieldtype.equals("23")) { //资产
                RecordSet rs = new RecordSet();
                String workflow_filter = "";
                rs.executeQuery("select workflow_filter from cpt_barcodesettings where id=-1");
                if(rs.next()){
                    workflow_filter = Util.null2String(rs.getString("workflow_filter"));
                }
                if(workflow_filter.equals("0")||user.getLoginid().equalsIgnoreCase("sysadmin")){
                    return result;
                }
                result = new weaver.cpt.util.CommonShareManager().getCptFilterids(resstr, user);
            } else if (fieldtype.equals("7") || fieldtype.equals("18")) { //客户
                result = weaver.crm.customer.CustomerShareUtil.customerRightFilter(String.valueOf(user.getUID()), resstr);
            }
            result = result == null ? "" : result;
            if(!"".equals(resstr) && "".equals(result)){	//权限校验清空了值情况
                String original_ids = "";
                RecordSet rsAuth = new RecordSet();
                rsAuth.executeQuery("select * from workflow_requestbase where requestid=?", this.requestid);
                if(rsAuth.next()){
                    if (fieldtype.equals("9") || fieldtype.equals("37")) {  // 文档字段
                        original_ids = Util.null2String(rsAuth.getString("docids"));
                    } else if (fieldtype.equals("8")|| fieldtype.equals("135")) { //项目
                        original_ids = Util.null2String(rsAuth.getString("prjids"));
                    } else if (fieldtype.equals("23")) { //资产
                        original_ids = Util.null2String(rsAuth.getString("cptids"));
                    } else if (fieldtype.equals("7") || fieldtype.equals("18")) { //客户
                        original_ids = Util.null2String(rsAuth.getString("crmids"));
                    }
                }
                //如修改前workflow_base存在此值，不清空值，当校验通过处理
                if(!"".equals(original_ids) && (","+original_ids+",").indexOf(","+resstr+",") > -1){
                    result = resstr;
                }else{
//                    writeLog("RequestManager submit authClearValue--"+this.requestid+"--fieldtype--"+fieldtype+"--clearValue--"+resstr);
                    /**
                     * ysh 2019-10-11
                     * 字段清空记录不做日志输出，而是存数据库
                     *
                     */
                    new SaveFieldAuthClearLogBiz(user).daSave(requestid,fieldid,fieldtype,resstr);


                }
            }
        }
        return result;
    }

    public static String filterClause(String causes){
        String returnval="";
        Map<String,String> tempMap = new HashMap<String,String>();
        StringTokenizer tokens = new StringTokenizer(causes,",");
        while(tokens.hasMoreElements()){
            String setKV = tokens.nextToken();
            if(null == tempMap.get(setKV))
                returnval += setKV+",";
            tempMap.put(setKV,setKV);
        }
        return returnval.substring(0,returnval.length()-1);
    }

    /**
     * 替换多行文本编辑字段从word拷贝带过来的类似<?xml:namespace prefix="o" ns="urn:schemas-microsoft-com:office:office"><o:p></o:p></?xml:namespace>标记
     */
    private String rePlaceWordMark(String content){
        String text = content;
        String mark = "xml:namespace";
        int xmlIdx_b = text.indexOf(mark);
        if(xmlIdx_b > -1){
            String str_f = text.substring(0, xmlIdx_b);
            str_f = str_f.substring(0, str_f.lastIndexOf("<"));
            String str_e = text.substring(xmlIdx_b+mark.length());
            int xmlIdx_e = str_e.indexOf(mark);
            if(xmlIdx_e > -1){
                str_e = str_e.substring(xmlIdx_e+mark.length());
                str_e = str_e.substring(str_e.indexOf(">")+1);
                text = str_f + str_e;
            }
        }
        return text;
    }

    /**
     * 流转异常处理，由用户指定操作者，PC端信息封装
     */
    public void createEh_operatorMap_pc(){
        String eh_setoperator = "";
        if(isRequest && request != null)
            eh_setoperator = Util.null2String(request.getParameter("eh_setoperator"));
        else if(fu != null)
            eh_setoperator = Util.null2String(fu.getParameter("eh_setoperator"));
        eh_operatorMap.put("eh_setoperator", eh_setoperator);
        String eh_relationship = "";
        if(isRequest && request != null)
            eh_relationship = Util.null2String(request.getParameter("eh_relationship"));
        else if(fu != null)
            eh_relationship = Util.null2String(fu.getParameter("eh_relationship"));
        eh_operatorMap.put("eh_relationship", eh_relationship);
        String eh_operators = "";
        if(isRequest && request != null)
            eh_operators = Util.null2String(request.getParameter("eh_operators"));
        else if(fu != null)
            eh_operators = Util.null2String(fu.getParameter("eh_operators"));
        eh_operatorMap.put("eh_operators", eh_operators);
    }

    /**
     * 判断当前自己操作的节点是否已意见征询
     * @param requestid
     * @param userid
     * @return
     */
    public boolean checkNodeOperatorComment(int requestid,int userid,int nodeid){
        return false;	//QC204474,不可以此条件阻止流程提交
    }

    /**
     * 流转异常处理，由用户指定操作者，Mobile端信息封装
     */
    public void createEh_operatorMap_mobile(Map<String,Object> _eh_operatorMap){
        this.eh_operatorMap = _eh_operatorMap;
    }

    public String getIsFirstSubmit() {
        return isFirstSubmit;
    }

    public void setIsFirstSubmit(String isFirstSubmit) {
        this.isFirstSubmit = isFirstSubmit;
    }

    public String getRemarkLocation() {
        return remarkLocation;
    }

    public void setRemarkLocation(String remarkLocation) {
        this.remarkLocation = remarkLocation;
    }

    /**
     * 清除session中的消息内容
     */
    public void removeErrorMsg(){
        if(!isRequest){
            request=fu.getRequest();
        }
        if(request != null && !(request instanceof WeaverRequest)){
            HttpSession session = request.getSession(false);
            if(session != null) {
                session.removeAttribute("errormsg_" + user.getUID() + "_" + requestid);
                session.removeAttribute("errormsgid_" + user.getUID() + "_" + requestid);
            }
        }
    }
    /**
     * 重写插入节点操作者的方法(被代理人，未操作的情况下不将islasttimes设定为0)
     * @param rst
     * @param opertor
     * @param operatorgroup
     * @param opertortype
     * @param agenterId
     * @param showorder
     * @return
     */
    private boolean wfCurrentOperatorAgent(RecordSetTrans rst,
                                           String opertor,
                                           String operatorgroup,
                                           String opertortype,
                                           String agenterId,
                                           int showorder){
        boolean returnFlag = false;

        try {
            if(requestid > 0 &&  !"".equals(opertor)){
                //判断当前操作者的状态是否为被代理人，是否未操作
                String execSql = " select * from workflow_currentoperator where requestid = ? ";
                execSql += " AND userid = ? ";
                execSql += " AND usertype = ? ";
                execSql += " AND nodeid = ? ";
                execSql += " AND isremark = 0 ";
                execSql += " AND agenttype = 2 ";
                rst.executeQuery(execSql,requestid,opertor,opertortype,nextnodeid);
                if(rst.next()){
                    String workflowtype2 = "0";
                    //如果workflowtype为空，则从workflow_base中获取
                    if(workflowtype == null || workflowtype.equals("")){
                        execSql = "SELECT workflowtype FROM workflow_base WHERE id = ? ";
                        rst.executeQuery(execSql,workflowid);
                        if(rst.next()){
                            workflowtype2 = rst.getString("workflowtype");
                        }
                    }else{
                        workflowtype2 = workflowtype;
                    }
                    //拼接SQL
                    execSql = "";
                    execSql += "        INSERT INTO workflow_currentoperator  ";
                    execSql += "          (requestid,    ";
                    execSql += "           userid,   ";
                    execSql += "           groupid,  ";
                    execSql += "           workflowid,   ";
                    execSql += "           workflowtype,     ";
                    execSql += "           usertype,     ";
                    execSql += "           isremark,     ";
                    execSql += "           nodeid,   ";
                    execSql += "           agentorbyagentid,     ";
                    execSql += "           agenttype,    ";
                    execSql += "           showorder,    ";
                    execSql += "           receivedate,  ";
                    execSql += "           receivetime,  ";
                    execSql += "           viewtype,     ";
                    execSql += "           iscomplete,   ";
                    execSql += "           islasttimes,  ";
                    execSql += "           groupdetailid,    ";
                    execSql += "           preisremark,  ";
                    execSql += "           needwfback)   ";
                    execSql += "        VALUES   ";
                    execSql += "          (" + requestid + ",   ";
                    execSql += "           " + opertor + ",  ";
                    execSql += "           " + operatorgroup + ",     ";
                    execSql += "           " + workflowid + ",  ";
                    execSql += "           " + workflowtype2 + ",    ";
                    execSql += "           " + opertortype + ",    ";
                    execSql += "           2,    ";
                    execSql += "           " + nextnodeid + ",   ";
                    execSql += "           " + agenterId + ",     ";
                    execSql += "           1,    ";
                    execSql += "           " + showorder + ",    ";
                    execSql += "           '" + this.currentdate + "',  ";
                    execSql += "           '" + this.currenttime + "',  ";
                    execSql += "           0,    ";
                    execSql += "           0,    ";
                    execSql += "           0,    ";
                    execSql += "           " + groupdetailid + ",  ";
                    execSql += "           2,    ";
                    execSql += "           '1')     ";
                    rst.executeSql(execSql);
                    returnFlag = true;
                }else{
                    return false;
                }
            }else{
                return false;
            }
        } catch (Exception e) {
            return false;
        }
        return returnFlag;
    }

    public void setMakeOperateLog(boolean isMakeOperateLog) {
        this.isMakeOperateLog = isMakeOperateLog;
    }

    public void CheckUserIsLasttimes(int requestid,int currentnodeid,User user){
        RecordSet rs = new RecordSet();
        try{
            String sql = "select id from workflow_currentoperator where requestid="+requestid+" and nodeid="+currentnodeid+" and userid="+user.getUID()+" and isremark=2 and islasttimes=1 and preisremark=0 " ;
            System.out.println(sql);
            rs.executeSql(sql);
            if(rs.next()){
                int tempid = rs.getInt("id");
                int otempid = 0 ;
                sql = "select c.id from workflow_currentoperator c where c.requestid="+requestid+" and c.nodeid!="+currentnodeid+" and c.nodeid in (select nownodeid from workflow_nownode where requestid=c.requestid) and userid="+user.getUID()+" and c.isremark=0 and c.islasttimes=0 and c.preisremark=0 order by c.id";
                rs.executeSql(sql);
                if(rs.next()){
                    otempid = rs.getInt("id");
                }
                System.out.println("tempid = "+tempid+" otempid="+otempid);
                if(otempid>0){
                    rs.executeSql("update workflow_currentoperator set islasttimes=0 where requestid="+requestid+" and id="+tempid);
                    rs.executeSql("update workflow_currentoperator set islasttimes=1 where requestid="+requestid+" and id="+otempid);
                }
            }
        }catch(Exception e){

        }
    }

    public Map<String, Integer> getNewAddDetailRowPerInfo() {
        return newAddDetailRowPerInfo;
    }

    private static void init() {
        // 增加配置文件：workflowFlowLogicConfig.properties,
        // 在此文件中配置是否执行老的逻辑（同一操作组同批次之间的关系为会签），此配置文件供技术支持同事修改
        // 注意：老逻辑不再维护
        try {
            isExeOldFlowlogic = Util.getIntValue((new BaseBean()).getPropValue("workflowFlowLogicConfig", "oldlogic"), 0) == 1;
        } catch (Exception e) {
        }
    }

    public static Map<String, Object> isFlowNextNode(int requestid, int nodeid, int isremark, int userid, int usertype, RecordSetTrans prst, String tempisremark, WFCoadjutantManager wfcm) throws Exception {

        Map<String, Object> result = new HashMap<>();

        int copnodeid = nodeid;
        String finishndgpids = "";
        RecordSet rs1 = new RecordSet();
        RecordSet rs2 = new RecordSet();
        RecordSet rs3 = new RecordSet();
        RecordSet rs4 = new RecordSet();

        String groupdetailids = "";
        String groupdetailid4sql = "";

        int passedgroups = 0;
        int submitgroups = -1;
        int totalunsubmitgroups = 0;

        RecordSetTrans rst = prst;
        if (rst == null) {
            rst = new RecordSetTrans();
            rst.setAutoCommit(true);
        }

        // 如果是提交节点, 查询当前用户提交组数和总共的未提交组数
        rst.executeSql("select nodeid from workflow_currentoperator where "+tempisremark+" and requestid=" + requestid + " and userid=" + userid + " and usertype=" + usertype+" and nodeid="+nodeid + " order by id desc");
        if (rst.next()){
            copnodeid = Util.getIntValue(Util.null2String(rst.getString(1)), 0);
        }else{
            rst.executeSql("select nodeid from workflow_currentoperator where "+tempisremark+" and requestid=" + requestid + " and userid=" + userid + " and usertype=" + usertype + " order by id desc");
            if (rst.next()) copnodeid = Util.getIntValue(Util.null2String(rst.getString(1)), 0);
        }
        //---------------------------------------------------------------------------
        // 同一操作组中的操作项之间的关系为非会签，操作组与操作组之间为会签关系（改造） START
        //---------------------------------------------------------------------------
        int canPassGroupCount = 0;
        //创建节点提交或者操作组被删除（流下下一节点的判断）
        boolean isCreateNdOrNdgpNotExist = false;
        // 查询当前节点需要提交用户所在的操作组，并迭代
        // 当且仅当 每一个操作组都可以通过时，才可以向下流转
        // 同一操作组，所有的操作项的关系为：非会签关系，当当前用户所在的操作项为非会签或所在操作组为会签且其他人已经提交时，此操作组通过！
        // 否则，请求不可以向下流转
        String notpassgpnumsql = "SELECT distinct wg.groupid "
                + " FROM workflow_currentoperator wc LEFT JOIN workflow_groupdetail wg "
                + "     ON wc.groupdetailid=wg.id "
                + " WHERE " + tempisremark + " and requestid=" + requestid
                + " and nodeid=" + nodeid;
        rst.executeSql(notpassgpnumsql);
        int nodegroupcount = rst.getCounts();
        while (rst.next()){
            int tempgrouid = Util.getIntValue(Util.null2String(rst.getString(1)), 0);
            //操作组被删除或者是创建节点
            if (tempgrouid == 0) {
                isCreateNdOrNdgpNotExist = true;
            }
            //当前用户是否在当前操作组中，如果不在，则流程不需要流转到下一节点！（非同一操作组，关系为：会签）
            String smgroupsql = "SELECT distinct groupdetailid, groupid "
                    + " FROM workflow_currentoperator "
                    + " WHERE " + tempisremark + " and requestid=" + requestid
                    + " and userid=" + userid + " and usertype=" + usertype
                    + " and nodeid=" + nodeid
                    + " and groupdetailid in (SELECT id FROM workflow_groupdetail WHERE groupid=" + tempgrouid + ")";
            //add by jym
            rs2.executeSql(smgroupsql);
            if(!rs2.next()){
                String smgroupsqlc = "SELECT handleforwardid "
                        + " FROM workflow_currentoperator "
                        + " WHERE preisremark = '0' and requestid=" + requestid
                        + " and userid=" + userid + " and usertype=" + usertype
                        + " and nodeid=" + nodeid;
                rs2.executeSql(smgroupsqlc);
                if(rs2.next()){
                    int handleforwardidc = Util.getIntValue(Util.null2String(rs2.getString(1)), 0);
                    if(handleforwardidc>0){

                        String smgroupsqlbb = "SELECT  userid "
                                + " FROM workflow_currentoperator "
                                + " WHERE preisremark = '0' and requestid=" + requestid
                                + " and id in ("+handleforwardidc+") and usertype=" + usertype
                                + " and nodeid=" + nodeid;


                        rs2.executeSql(smgroupsqlbb);
                        int useridc = 0;
                        if(rs2.next()){
                            useridc = Util.getIntValue(Util.null2String(rs2.getString(1)), 0);

                        }

                        String smgroupsqlb = "SELECT distinct groupdetailid "
                                + " FROM workflow_currentoperator "
                                + " WHERE preisremark = '0' and requestid=" + requestid
                                + " and userid in ("+userid+","+useridc+") and usertype=" + usertype
                                + " and nodeid=" + nodeid
								+ " and groupdetailid in (SELECT id FROM workflow_groupdetail WHERE groupid=" + tempgrouid + ")";
                        rs2.executeSql(smgroupsqlb);
                        int countb =  rs2.getCounts();

                        if(countb>1){
                            smgroupsql = "SELECT distinct groupdetailid, groupid "
                                    + " FROM workflow_currentoperator "
                                    + " WHERE preisremark = '0' and requestid=" + requestid
                                    + " and userid=" + userid + " and usertype=" + usertype
                                    + " and nodeid=" + nodeid ;
                        }
                    }
                }


            }
            //end add by jym
            //当同一操作组通过时候，其中包含的“依次逐个处理”组，则不需要继续流程
            String temp_groupdetailids = "";
            String temp_groupdetailid4sql = "";


            rs2.executeSql(smgroupsql);
            while (rs2.next()){
                int tempGroupDetailID = Util.getIntValue(Util.null2String(rs2.getString(1)), 0);

                int tempsubmitgroups = 0;
                int temptotalgroups = 0;
                //查找：当前用户在当前操作项中可以提交的 组数
                rs3.executeSql("select count(distinct groupid) from workflow_currentoperator "
                        + " where " + tempisremark + " and requestid=" + requestid
                        + " and userid=" + userid + " and usertype=" + usertype
                        + " and nodeid=" + nodeid + " and groupdetailid=" + tempGroupDetailID
                );
                if (rs3.next()){
                    tempsubmitgroups = Util.getIntValue(Util.null2String(rs3.getString(1)), 0);
                }

                //查询当前节点是否存在协办人，如果存在则按协办人条件进行判断（当存在协办人时，主办人不再局限于部门的人员而是整个节点操作组都将是主办人）
                rs3.executeSql("select groupdetailid from workflow_currentoperator "
                        + " where (isremark='7' or preisremark='7') and requestid='"+requestid + "'"
                        + " and nodeid='" + nodeid + "' and groupdetailid='" + wfcm.getGroupdetailid() + "'"
                        + " and groupdetailid=" + tempGroupDetailID);
                if(rs3.next() && (isremark==0 || isremark==7)){
                    temptotalgroups = wfcm.getTotalnumSubmitGroups(isremark,nodeid,requestid,userid,rst);
                }else{
                    rs3.executeSql("select count(distinct groupid) from workflow_currentoperator "
                            + " where " + tempisremark + " and requestid=" + requestid
                            + " and nodeid=" + nodeid + " and groupdetailid=" + tempGroupDetailID);
                    if (rs3.next()){
                        temptotalgroups = Util.getIntValue(Util.null2String(rs3.getString(1)), 0);
                    }
                }

                //判断该人所在组是否含有依次逐个递交的组，如果有一个，则passedgroups-1，并且进入得到下个操作者的方法
                rs4.execute("select * from workflow_groupdetail where id=" + tempGroupDetailID);
                if (rs4.next()) {
                    int type = rs4.getInt("type");
                    int signorder = rs4.getInt("signorder");
                    //如果是依次逐个处理，则需要判断是否转办多人
                    boolean oneByOneFlag = signorder == 2;
                    if(signorder == 2) {
                        rs3.executeQuery("select distinct userid,usertype,handleforwardid from workflow_currentoperator where " + tempisremark +" and requestid=" + requestid
                                + " and nodeid=" + nodeid + " and groupdetailid=" + tempGroupDetailID);
                        while (rs3.next()) {
                            int handleforwardid = rs3.getInt("handleforwardid");
                            if(handleforwardid > 0 && rs3.getInt("userid") != userid) {
                                oneByOneFlag = false;
                            }
                        }
                    }
                    if (WFPathUtil.isContinuousProcessing(type) && oneByOneFlag && isremark!=7) {
                        rs3.execute("select * from workflow_agentpersons where requestid="+requestid+" and (groupdetailid="+rs2.getInt("groupdetailid")+" or groupdetailid is null)");
                        if (rs3.next() && !rs3.getString("receivedPersons").equals("")) {
                            tempsubmitgroups--;
                            if (temp_groupdetailids.equals("")) {
                                temp_groupdetailids = rs2.getString("groupdetailid") + "_" + rs2.getString("groupid");
                            } else {
                                temp_groupdetailids = temp_groupdetailids + "," + rs2.getString("groupdetailid") + "_" + rs2.getString("groupid");
                            }

                            if (temp_groupdetailid4sql.equals("")) {
                                temp_groupdetailid4sql = rs2.getString("groupdetailid");
                            } else {
                                temp_groupdetailid4sql = temp_groupdetailid4sql + "," + rs2.getString("groupdetailid");
                            }
                        }
                    }

                }

                //同一操作项，有其他未提交的用户，则不能向下流转
                if (tempsubmitgroups >= temptotalgroups) {
                    //通过的操作数
                    canPassGroupCount++;
                    //通过的操作组ID
                    if ("".equals(finishndgpids)) {
                        finishndgpids += tempgrouid;
                    } else {
                        finishndgpids += "," + tempgrouid;
                    }
                    //该操作组通过, 清空该操作组内的依次逐个处理
                    temp_groupdetailids = "";
                    temp_groupdetailid4sql = "";
                    break;
                }
            }

            //该操作组内的依次逐个处理项
            if (groupdetailids.equals("")) {
                groupdetailids = temp_groupdetailids;
            } else if (!"".equals(temp_groupdetailids)){
                groupdetailids = groupdetailids + "," + temp_groupdetailids;
            }
            if (groupdetailid4sql.equals("")) {
                groupdetailid4sql = temp_groupdetailid4sql;
            } else if (!"".equals(temp_groupdetailid4sql)){
                groupdetailid4sql = groupdetailid4sql + "," + temp_groupdetailid4sql;
            }

        }

        //操作组被删除，或者是创建节点提交
        if (isCreateNdOrNdgpNotExist) {
            rst.executeSql("select count(distinct groupid) from workflow_currentoperator where "+tempisremark+" and requestid=" + requestid + " and userid=" + userid + " and usertype=" + usertype+" and nodeid="+nodeid);
            if (rst.next()){
                passedgroups += Util.getIntValue(rst.getString(1), 0);
                submitgroups = Util.getIntValue(rst.getString(1), 0);
            }

            rst.executeSql("select count(distinct groupid) from workflow_currentoperator where "+tempisremark+" and requestid=" + requestid +" and nodeid="+nodeid);
            if (rst.next()){
                totalunsubmitgroups = Util.getIntValue(rst.getString(1), 0);
            }
        } else {
            submitgroups = canPassGroupCount > 0 ? canPassGroupCount : -1;
            totalunsubmitgroups = nodegroupcount;
        }
        //---------------------------------------------------------------------------
        // 同一操作组中的操作项之间的关系为非会签，操作组与操作组之间为会签关系（改造） END
        //---------------------------------------------------------------------------

        result.put("copnodeid", copnodeid);
        result.put("finishndgpids", finishndgpids);
        result.put("groupdetailids", groupdetailids);
        result.put("groupdetailid4sql", groupdetailid4sql);
        result.put("passedgroups", passedgroups);
        result.put("submitgroups", submitgroups);
        result.put("totalunsubmitgroups", totalunsubmitgroups);
        return result;
    }

    /**
     *流程提交失败时，不记录位置字段的值，恢复到之前的值
     */
    public void rollbackLocationFieldValue() {
        if (isoracle) {
            try {
                String locatesql = "";
                if (isbill == 1) {
                    locatesql = " update " + billtablename + " set";
                } else {
                    locatesql = "update workflow_form set ";
                }
                int locateindex = 0;
                String locatesp = " ";
                Iterator fdit = locationPreValueMap.entrySet().iterator();
                while (fdit.hasNext()) {
                    locateindex++;
                    Map.Entry entry = (Map.Entry) fdit.next();
                    String key = entry.getKey().toString();
                    String value = "";
                    if (entry.getValue() != null) {
                        if (String.valueOf(entry.getValue()).equals(" ")) value = "";
                        else value = String.valueOf(entry.getValue());
                    }
                    if (locateindex > 1) {
                        locatesql += locatesp + " , " + key + "=? ";
                    } else {
                        locatesql += locatesp + " " + key + "=? ";
                    }
                }
                if (isbill == 1) {
                    locatesql += " where id = " + billid;
                } else {
                    locatesql += " where requestid=" + requestid;
                }

                //System.out.println("hrmsql = "+hrmsql);
                if (locateindex > 0) {
                    ConnStatement locateStatement = null;
                    try {
                        locateStatement = new ConnStatement();
                        locateStatement.setStatementSql(locatesql);
                        fdit = locationPreValueMap.entrySet().iterator();
                        locateindex = 0;
                        while (fdit.hasNext()) {
                            locateindex++;
                            Map.Entry entry = (Map.Entry) fdit.next();
                            String key = entry.getKey().toString();
                            String value = "";
                            if (entry.getValue() != null) {
                                if (String.valueOf(entry.getValue()).equals(" ")) value = "";
                                else value = String.valueOf(entry.getValue());
                            }
                            locateStatement.setString(locateindex, value);
                        }
                        locateStatement.executeUpdate();
                    } catch (Exception e) {
                        writeLog(e);
                    } finally {
                        if (locateStatement != null) locateStatement.close();
                    }
                }
            } catch (Exception e) {
                writeLog(e);
            }
        } else {
            String updateclause = "";
            Set<String> locationKeySet = locationPreValueMap.keySet();
            for(String fieldName : locationKeySet) {
                String preFieldValue = locationPreValueMap.get(fieldName);
                updateclause += fieldName + " = '" + fillFullNull(preFieldValue) + "',";
            }
            if(!"".equals(updateclause)) {

                updateclause = updateclause.substring(0, updateclause.length() - 1);

                if (isbill == 1) {
                    updateclause = " update " + billtablename + " set " + updateclause + " where id = " + billid;
                } else {
                    updateclause = "update workflow_form set " + updateclause + " where requestid=" + requestid;
                }
                RecordSet rs = new RecordSet();
                rs.executeUpdate(updateclause);
            }
        }
    }

    public boolean isOneVoteApprove() {
        return isOneVoteApprove;
    }

    public void setOneVoteApprove(boolean oneVoteApprove) {
        isOneVoteApprove = oneVoteApprove;
    }

    public void setCurrentdate(String currentdate) { this.currentdate = currentdate; }
    public void setCurrenttime(String currenttime) {
        this.currenttime = currenttime;
    }
    public void setLogdate(String logdate) { this.logdate = logdate; }
    public void setLogtime(String logtime) {
        this.logtime = logtime;
    }
    public Map<String, String> getLocationPreValueMap() {
        return locationPreValueMap;
    }

    public void setLocationPreValueMap(Map<String, String> locationPreValueMap) {
        this.locationPreValueMap = locationPreValueMap;
    }

    public ArrayList getNextnodeids() {
        return nextnodeids;
    }

    public Map<Integer, AutoApproveParams> getNodeInfoCache() {
        return nodeInfoCache;
    }

    private void WriteSubmitErrorLog() {
        log.error(new StringBuilder("流程提交失败requestid:").append(requestid).append(",userid:").append(userid).append(",nodeid").append(nodeid).toString());
    }

    private String getRequestParamValue(String paramKey) {
        String value = null;
        if(isRequest){
            if (request != null)
                value = Util.null2String(request.getParameter(paramKey));
        }else{
            if (fu != null) {
                value = Util.null2String(fu.getParameter(paramKey));
            } else if(otherParams != null) {
                value = Util.null2String(otherParams.get(paramKey));
            }
        }
        return value;
    }

    /**
     * 处理文档消息推送
     */
    private void processDocPush() {
        try {
            List<String> list = new ArrayList<>();
            RecordSet rs = new RecordSet();
            for (Map<String, Object> docInfo : this.pushMsgDocIds) {
                if (docInfo != null) {
                    String pushDocId = Util.null2String(docInfo.get("docId"));
                    String shareIds = Util.null2String(docInfo.get("shareIds"));
                    if (!"".equals(pushDocId)&&!list.contains(pushDocId)) {
                        rs.executeUpdate("update sendtoalltemp set status = '0' where docid = ? and status= '2'", pushDocId);
                        list.add(pushDocId);
                        ThreadForAllForNew sendToAllfornew = new ThreadForAllForNew(pushDocId,shareIds,user);
                        sendToAllfornew.start();
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void setAutoApproveReceiveUser(){
        RecordSet rs = new RecordSet();
        String tempisremark = "isremark in ('0','4','6')";  //f 自动提交 或 自动批准
        //如果当前节点存在协办人并且协办人关系为会签或者非会签 主办人关系为会签或依次处理 则接收人应包含协办人
        rs.executeSql("select signorder,signtype from workflow_groupdetail where type=42 and groupid in (select id from workflow_nodegroup where nodeid="+nodeid+")");
        if(rs.next()){
            int signorder = rs.getInt("signorder");
            int signtype = rs.getInt("signtype");
            if(signtype!=2 && (signorder==0 || signorder==1 || signorder==2 ||(signorder==0 && src.equals("reject")))){
                tempisremark = "isremark in ('0','4','7','6')";
            }
        }
        //TODO JHY 签字意见保存改造
        Map<String,Object> receivePersonInfo = RequestLogSaveBiz.getReceivePersons(showcoadjutant,currentopratorInsFirstid,user,operator89mp,operator89List,
                operatortype89List,agentoperator89List,operatortype89mp,agentoperator89mp,nextnodeids,workflowid,requestid,"0",tempisremark,src,nodeid);

        //针对分叉起始节点和一条中间节点的第一个节点自动批准的情况 重新计算接收人
        Map<String,Object> fixReceivePersonInfo = fixReceiveDatas(autoApproveParams.getStartLogId(),tempisremark);
        if(fixReceivePersonInfo.size()>1){
            receivePersonInfo = fixReceivePersonInfo;
        }
        String personStr = Util.null2String(receivePersonInfo.get("receivePersonNames"));
        String receivedPersonids = Util.null2String(receivePersonInfo.get("receivePersonids"));
        String personStr1 = Util.null2String(receivePersonInfo.get("ccPersonNames"));
        String receivedPersonids1 = Util.null2String(receivePersonInfo.get("ccPersonids"));

        if ((freeNodeFlowBiz != null && freeNodeFlowBiz.isBranchMerge() && "".equals(receivedPersonids.trim())) ||(!canflowtonextnode && (nextnodeattr == 3 || nextnodeattr == 4|| nextnodeattr==5))) {
            personStr = SystemEnv.getHtmlLabelName(21399, user.getLanguage()) + ",";
        }

        autoApproveParams.setReceiveUserIds(receivedPersonids);
        autoApproveParams.setReceiveUserNames(personStr);
        autoApproveParams.setCcUserIds(receivedPersonids1);
        autoApproveParams.setCcUserNames(personStr1);

    }

    private Map<String,Object> fixReceiveDatas(int startLogid,String tempisremark){
        RecordSet rs1= new RecordSet();
        RecordSet rs2= new RecordSet();
        RecordSet rs3= new RecordSet();
        Map<String,Object> receivePersonInfo = new HashMap<>();
        ArrayList nextnodeidstemp = new ArrayList();
        String sql1 = "select t2.nodeattribute from workflow_requestlog t1,workflow_nodebase t2 where logid=? and t1.nodeid=t2.id";
        String sql2 = "select distinct nodeid from workflow_currentoperator where requestid = ? and isremark in('0','4','6')";
        rs1.executeQuery(sql1,startLogid);
        if(rs1.next()){
            String nodeattrtemp = Util.null2String(rs1.getString("nodeattribute"));
            if(nodeattrtemp.equals("0") || nodeattrtemp.equals("1")){
                rs2.executeQuery(sql2,requestid);
                while(rs2.next()){
                    nextnodeidstemp.add(rs2.getString("nodeid"));
                }
                if(nextnodeidstemp.size()>1){
                    receivePersonInfo = RequestLogSaveBiz.getReceivePersons(showcoadjutant,currentopratorInsFirstid,user,operator89mp,operator89List,
                            operatortype89List,agentoperator89List,operatortype89mp,agentoperator89mp,nextnodeidstemp,workflowid,requestid,"0",tempisremark,src,nodeid);
                    // receivePersonInfo.put("destnodeids",)
                }
            }
        }
        return receivePersonInfo;

    }

    /**
     * 更新表单中manager字段
     * @param currentOperatorid 当前操作者
     * @return
     */
    public boolean updateManagerFieldValue(int currentOperatorid) {
        RecordSet rs = new RecordSet();
        String formtablename = "";
        int formid = this.getFormid();
        int isbill = this.getIsbill();
        String usermanager = this.getUser().getManagerid();
        rs.executeQuery("select userid,agenttype,agentorbyagentid from workflow_currentoperator where id = ?",currentOperatorid);
        if(rs.next()){
            if("2".equals(Util.null2String(rs.getString("agenttype")))) {
                try {
                    ResourceComInfo resourceComInfo = new ResourceComInfo();
                    usermanager = resourceComInfo.getManagerID(rs.getString("agentorbyagentid"));
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
        if (isbill == 1) {
            //rs.executeQuery(" select tablename from workflow_bill a where exists (select 1 from workflow_billfield b where b.billid = a.id and b.billid  = ? and b.fieldname = 'manager')", formid);
            rs.executeQuery("select a.tablename from workflow_bill a inner join workflow_billfield b on a.id = b.billid and b.billid = ? where b.fieldname = 'manager'", formid);
            if (rs.next()) {
                formtablename = Util.null2String(rs.getString("tablename"));
            }
        } else {
            rs.executeQuery("select fieldname from workflow_formfield a left join workflow_formdict b on a.fieldid  = b.id where a.formid  = ? and b.fieldname ='manager'", formid);
            if (rs.next()) {
                formtablename = "workflow_form";
            }
        }
        if(usermanager==null || "".equals(usermanager)){
            usermanager="0";
        }
        if (!"".equals(formtablename)) {
            return rs.executeUpdate("update " + formtablename + " set manager = ?  where requestid  = ?", usermanager, this.getRequestid());
        }

        return true;
    }

    public String getClientIp() {
        String clientIp = "";
        if(isRequest){
            if (request != null)
                clientIp = Util.null2String(request.getRemoteAddr());
        }else{
            if (fu != null)
                clientIp = Util.null2String(fu.getRemoteAddr());
        }
        return clientIp;
    }

    /**
     * 将指定流转的节点转化成List
     * @param selectFlowNodes
     * @return
     */
    private List<Integer> generateSelectFlowNodeList(String selectFlowNodes) {
        List<Integer> selectFlowNodeList = new ArrayList<>();

        String[] selectFlowNodeArr = Util.null2String(selectFlowNodes).split(",");
        for (String node : selectFlowNodeArr) {
            int nodeInt = Util.getIntValue(node, -1);
            if(nodeInt != -1) {
                selectFlowNodeList.add(nodeInt);
            }
        }

        return selectFlowNodeList;
    }

    /**
     * 流程提交时，设置指定流转下一节点、出口等相关信息
     */
    private void setSelectNextFlowInfo(RequestNodeFlow requestNodeFlow) {

        this.nextnodeids.clear();
        this.nextnodetypes.clear();
		this.nextnodeattrs.clear();
        this.nextlinkids.clear();
        this.nextlinknames.clear();
        this.operatorshts.clear();
		this.eh_operatorMap = new HashMap<>();

        String[] selectNextNodeIds = Util.null2String(this.selectNodeFlowNodeIds).split(",");
        for (int i = 0; i < selectNextNodeIds.length; i++) {
            String[] nodeIdArray = getRequestParamValue("selectNodeFlow_nodeId_" + i).split("_");

            this.nextnodeids.add(nodeIdArray[0]);
            this.nextnodetypes.add(nodeIdArray[1]);
            this.nextnodeattrs.add(nodeIdArray[2]);


            String selectNextFlowType = "";
            RecordSet linkIdRs = new RecordSet();
            linkIdRs.executeQuery("select selectnextflowtype from workflow_flownode where nodeid = ?", this.nodeid);
            if (linkIdRs.next()) {
                selectNextFlowType = linkIdRs.getString(1);
            }

            String addNextLinkId = "-1";
            String addNextLinkName = "";
            //按出口选择，获取指定的出口ID
            if("0".equals(selectNextFlowType)) {
                linkIdRs.executeQuery("select id,linkname,isBulidCode,newrule from workflow_nodelink where workflowId = ? and nodeid = ? and destnodeid = ? and (isreject='' or isreject is null or isreject = '0') order by nodepasstime,id",this.workflowid,this.nodeid,nodeIdArray[0]);
                while (linkIdRs.next()) {
                    String nextLinkId = Util.null2String(linkIdRs.getString(1));
                    String nextLinkNames = Util.null2String(linkIdRs.getString(2));
                    String isBuildCode = Util.null2String(linkIdRs.getString(3));
                    String newRule = Util.null2String(linkIdRs.getString(4));

                    RuleInterface rif = new RuleInterface();
                    rif.setUserid(this.userid + "");
                    if(rif.compareRuleforWF(newRule, requestid + "", nextLinkId, RuleInterface.RULESRC_CK)){
                        addNextLinkId = nextLinkId;
                        addNextLinkName = nextLinkNames;

                        //指定流转，找到对应出口，生成编号
                        if("1".equals(isBuildCode) && requestNodeFlow.getIsGetFlowCodeStr()) {
                            CodeBuild cbuild = new CodeBuild(formid, String.valueOf(isbill), this.workflowid, this.creater, this.creatertype);
                            String codeFields = cbuild.haveCode(this.workflowid, formid, String.valueOf(isbill));
                            if (!codeFields.equals("")) {
                                Map<String, Object> formLogParams = new HashMap<>();
                                formLogParams.put("user", user);
                                formLogParams.put("nodeId", nodeid);
                                formLogParams.put("clientIp", getClientIp());
                                cbuild.getFlowCodeStr(requestid, isbill, formid, this.workflowid, this.creater, this.creatertype, formLogParams);
                            }
                        }
                        break;
                    }
                }
            }
            this.nextlinkids.add(addNextLinkId);
            this.nextlinknames.add(addNextLinkName);
            this.operatorshts.add(new Hashtable());
        }
    }

    /**
     * 指定流转插入下一节点操作者
     * @param operatorsList 操作者列表
     * @param operatorsTypeList 操作者类型列表
     * @param rst
     * @param ccTypeList 抄送类型列表
     * @param ccIndexList 抄送标志位列表
     * @param signTypeList 会签关系列表
     * @throws Exception
     */
    public void setOperator4SelectNextFlow(List<List<String>> operatorsList,List<List<String>> operatorsTypeList,RecordSetTrans rst,
                                           List<String> ccTypeList, List<List<Integer>> ccIndexList, List<Integer> signTypeList) throws Exception {


		if (!canflowtonextnode) {
            for(int n=0;n<nextnodeids.size();n++){
                requestFlowInfoEntity.setDestnodeid(Util.getIntValue((String)nextnodeids.get(n),0));
                requestFlowInfoEntity.setLinkId(Util.getIntValue((String)nextlinkids.get(n),0));
                RequestBaseBiz.saveRequestFlowInfo(requestFlowInfoEntity,rst);
            }
            return;
        }

		//记录日志
        WFAutoApproveUtils.processApproveLog(rst,this);
        ArrayList poppuplist=new ArrayList();
        ArrayList operatorsWfNew = new ArrayList();
        ArrayList operatorsWfEnd = new ArrayList();

        //流程密级相关
        HrmClassifiedProtectionBiz hrmSecBiz = new HrmClassifiedProtectionBiz();
        boolean isOpenSec = HrmClassifiedProtectionBiz.isOpenClassification();//是否开启涉密系统
        RequestSecLevelBiz requestSecBiz = new RequestSecLevelBiz();
        int requestSecLevel = 0;
        if (isOpenSec) {
            requestSecLevel = requestSecBiz.getSecLevelByRequestId(this.requestid+"");//当前流程密级
        }

        for(int n=0;n<nextnodeids.size();n++){
            nextnodeid=Util.getIntValue((String)nextnodeids.get(n),0);
            nextnodetype=Util.null2String((String)nextnodetypes.get(n));
            nextnodeattr=Util.getIntValue((String)nextnodeattrs.get(n),0);
			int nextLinkId = Util.getIntValue((String)nextlinkids.get(n),0);
            List<String> operators = operatorsList.get(n);
            List<Integer> ccIndex = ccIndexList.get(n);
            List<String> operatorsType = operatorsTypeList.get(n);
            int SignType = signTypeList.get(n);
            String ccType = ccTypeList.get(n);

            wfAgentCondition wfAgentCondition=new wfAgentCondition();
            //操作人更新结束
            int showorder = 0;
            String opertortype = "0";
            groupdetailid=0;
            try{
                for (int i = 0; i < operators.size(); i++) {
                    //依次逐个处理
                    if(SignType==2){
                        if(i > 0 && (ccIndex == null || (ccIndex != null && ccIndex.indexOf(i) == -1)) && !nextnodetype.equals("3")) {
                            continue;
                        }
                        //节点操作者
                        if((ccIndex == null || (ccIndex != null && ccIndex.indexOf(i) == -1))) {
                            operatorgroup = -2;
                            groupdetailid = -2;
                            String tempStr = "";
                            String tempStrType = "";
                            for (int k = i + 1; k < operators.size(); k++) {
                                if ((ccIndex == null || (ccIndex != null && ccIndex.indexOf(k) == -1))) {
                                    tempStr += operators.get(k) + ",";
                                }
                            }
                            rst.executeProc("workflow_groupdetail_Insert", "" + operatorgroup + flag + 5 + flag + operatorgroup + flag + 0 + flag + -1 + flag + "" + flag + "" + flag + 0 + flag + 2 + flag + "" + flag + "" + flag + "" + flag + "" + flag + "" + flag + "" + flag + "" + flag + "" + flag + "" + flag + "" + flag + "");
                            if (rst.next()) {
                                groupdetailid = rst.getInt(1);
                            }

                            if (FreeNodeBiz.isFreeNode(nodeid)) {
                                rst.executeSql("delete from workflow_agentpersons where requestid=" + requestid + " and  groupdetailid = " + nodeid);
                            }
                            if (FreeNodeBiz.isFreeNode(nextnodeid)) {
                                rst.executeSql("delete from workflow_agentpersons where requestid=" + requestid + " and  groupdetailid = " + nextnodeid);
                                rst.executeSql("insert into workflow_agentpersons(requestid,receivedpersons,groupdetailid,coadjutants) values (" + requestid + ",'" + tempStr.trim() + "'," + nextnodeid + ",'')");
                            } else {
                                rst.executeSql("delete from workflow_agentpersons where requestid=" + requestid + " and  (groupdetailid in(select b.id from workflow_nodegroup a,workflow_groupdetail b where a.id=b.groupid and a.nodeid in(" + nodeid + "," + nextnodeid + ")) or groupdetailid is null)");//groupdetailid is null主要为了兼容老的数据
                                rst.executeSql("insert into workflow_agentpersons(requestid,receivedpersons,groupdetailid,coadjutants) values (" + requestid + ",'" + tempStr.trim() + "'," + groupdetailid + ",'')");
                            }
                        }
                    }
                    showorder++; //xwj for td2104 on 20050802
                    int opertor = Util.getIntValue((String)operators.get(i));
                    //默认为内部员工
                    if (operatorsType != null && i < operatorsType.size()) {
                        opertortype = (String)operatorsType.get(i);
                    } else {
                        opertortype = "0";
                    }

                    int tempremark=0;

                    if (ccIndex != null && ccIndex.indexOf(i) != -1) {
                        if ("-3".equals(ccType)){//抄送（不需提交）
                            tempremark=8;
                        }
                        if ("-4".equals(ccType)){//抄送（需提交）
                            tempremark=9;
                        }
                    }


                    if(opertor>0){

                        //modify by xhheng @20050109 for 流程代理
                        //代理数据检索
                        boolean isbeAgent=false;
                        String agenterId="";
                        // 代理逻辑处理
                        if (opertortype.equals("0")){
                            agenterId=wfAgentCondition.getAgentid(""+workflowid,""+opertor,""+ requestid);
                            if(!agenterId.equals("")){
                                isbeAgent=true;
                            }

                            if (isbeAgent && isOpenSec) {//开启涉密系统后，代理需根据人员密级来判断，代理人密级不够，则不发生代理
                                int agenterSecLevel = Util.getIntValue(hrmSecBiz.getMaxResourceSecLevelById2(agenterId));
                                if (requestSecLevel < agenterSecLevel) {//被代理人不满足条件，则不发生代理
                                    isbeAgent = false;
                                }
                            }
                        }
                        //当符合代理条件时添加代理人
                        String Procpara1="";

                        /*-------- xwj for td2104 on 20050802  begin --------- */
                        if(isOldOrNewFlagTrans(requestid,rst)){//老数据, 相对 td2104 之前
                            if(isbeAgent){
                                //设置被代理人已操作
                                Procpara = "" + requestid + flag + opertor + flag + operatorgroup + flag
                                        + workflowid + flag + workflowtype + flag + opertortype + flag + "2" + flag + -1 +
                                        flag + -1 + flag + "0" + flag + -1+ flag +groupdetailid;
                                rst.executeProc("workflow_CurrentOperator_I", Procpara);
                                //设置代理人
                                Procpara1 = "" + requestid + flag + agenterId + flag + operatorgroup + flag
                                        + workflowid + flag + workflowtype + flag + opertortype + flag + tempremark + flag + -1 +
                                        flag + -1 + flag + "0" + flag + -1 + flag +groupdetailid;
                                rst.executeProc("workflow_CurrentOperator_I", Procpara1);
                                if (tempremark == 8 || tempremark == 9) {
                                    operator89List.add("" + opertor);
                                    operatortype89List.add("" + opertortype);
                                    agentoperator89List.add(agenterId);
                                }
                            }else{
                                Procpara = "" + requestid + flag + opertor + flag + operatorgroup + flag
                                        + workflowid + flag + workflowtype + flag + opertortype + flag + tempremark + flag + -1 +
                                        flag + -1 + flag + "0" + flag + -1 + flag +groupdetailid;
                                rst.executeProc("workflow_CurrentOperator_I", Procpara);
                                if (tempremark == 8 || tempremark == 9) {
                                    operator89List.add("" + opertor);
                                    operatortype89List.add("" + opertortype);
                                    agentoperator89List.add("0");
                                }
                            }
                        }else{
                            if(isbeAgent){
                                //设置被代理人已操作
                                Procpara = "" + requestid + flag + opertor + flag + operatorgroup + flag
                                        + workflowid + flag + workflowtype + flag + opertortype + flag + "2" + flag + nextnodeid +
                                        flag + agenterId + flag + "1" + flag + showorder+ flag +groupdetailid;
                                rst.executeProc("workflow_CurrentOperator_I", Procpara);
                                //设置代理人
                                Procpara1 = "" + requestid + flag + agenterId + flag + operatorgroup + flag
                                        + workflowid + flag + workflowtype + flag + opertortype + flag + tempremark + flag + nextnodeid +
                                        flag + opertor + flag + "2" + flag + showorder+ flag +groupdetailid;
                                rst.executeProc("workflow_CurrentOperator_I", Procpara1);
                                if (tempremark == 8 || tempremark == 9) {
                                    operator89List.add("" + opertor);
                                    operatortype89List.add("" + opertortype);
                                    agentoperator89List.add(agenterId);
                                }
                            }else{
                                Procpara = "" + requestid + flag + opertor + flag + operatorgroup + flag
                                        + workflowid + flag + workflowtype + flag + opertortype + flag + tempremark + flag + nextnodeid +
                                        flag + -1 + flag + "0" + flag + showorder+ flag +groupdetailid;
                                rst.executeProc("workflow_CurrentOperator_I", Procpara);
                                if (tempremark == 8 || tempremark == 9) {
                                    operator89List.add("" + opertor);
                                    operatortype89List.add("" + opertortype);
                                    agentoperator89List.add("0");
                                }
                            }
                        }

                        //对代理人判断提醒

                        /*--xwj for td3450 20060111 begin--*/
                        Procpara = opertor + flag + opertortype + flag + requestid;

                        if (nextnodetype.equals("3")){
                            if(isbeAgent){
                                //update by fanggsh for TD4739  20060808 果归档前的最后一个操作者是本人的话，则从提醒中去掉。
                                if(!operatorsWfEnd.contains(agenterId+"_"+opertortype)&&!(userid+"_"+usertype).equals(agenterId+"_"+opertortype)){
                                    //poppupRemindInfoUtil.insertPoppupRemindInfo(Integer.parseInt(agenterId),1,opertortype,requestid,requestname,workflowid);
                                    Map popmap=new HashMap();
                                    popmap.put("userid",""+Integer.parseInt(agenterId));
                                    popmap.put("type","1");
                                    popmap.put("logintype",""+opertortype);
                                    popmap.put("requestid",""+requestid);
                                    popmap.put("requestname",""+requestname);
                                    popmap.put("workflowid",""+workflowid);
                                    popmap.put("creater",""+creater);
                                    poppuplist.add(popmap);
                                    operatorsWfEnd.add(agenterId+"_"+opertortype);
                                }
                            }else{
                                //update by fanggsh for TD4739  20060808 果归档前的最后一个操作者是本人的话，则从提醒中去掉。
                                if(!operatorsWfEnd.contains(opertor+"_"+opertortype)&&!(userid+"_"+usertype).equals(opertor+"_"+opertortype)){
                                    //poppupRemindInfoUtil.insertPoppupRemindInfo(opertor,1,opertortype,requestid,requestname,workflowid);
                                    Map popmap=new HashMap();
                                    popmap.put("userid",""+opertor);
                                    popmap.put("type","1");
                                    popmap.put("logintype",""+opertortype);
                                    popmap.put("requestid",""+requestid);
                                    popmap.put("requestname",""+requestname);
                                    popmap.put("workflowid",""+workflowid);
                                    popmap.put("creater",""+creater);
                                    poppuplist.add(popmap);
                                    operatorsWfEnd.add(opertor+"_"+opertortype);
                                }
                            }
                        }
                        else{
                            if(isbeAgent){
                                if(!operatorsWfNew.contains(agenterId+"_"+opertortype)){
                                    //poppupRemindInfoUtil.insertPoppupRemindInfo(Integer.parseInt(agenterId),0,opertortype,requestid,requestname,workflowid);
                                    Map popmap=new HashMap();
                                    popmap.put("userid",""+Integer.parseInt(agenterId));
                                    popmap.put("type","0");
                                    popmap.put("logintype",""+opertortype);
                                    popmap.put("requestid",""+requestid);
                                    popmap.put("requestname",""+requestname);
                                    popmap.put("workflowid",""+workflowid);
                                    popmap.put("creater",""+creater);
                                    poppuplist.add(popmap);
                                    operatorsWfNew.add(agenterId+"_"+opertortype);
                                }
                            }else{
                                if(!operatorsWfNew.contains(opertor+"_"+opertortype)){
                                    //poppupRemindInfoUtil.insertPoppupRemindInfo(opertor,0,opertortype,requestid,requestname,workflowid);
                                    Map popmap=new HashMap();
                                    popmap.put("userid",""+opertor);
                                    popmap.put("type","0");
                                    popmap.put("logintype",""+opertortype);
                                    popmap.put("requestid",""+requestid);
                                    popmap.put("requestname",""+requestname);
                                    popmap.put("workflowid",""+workflowid);
                                    popmap.put("creater",""+creater);
                                    poppuplist.add(popmap);
                                    operatorsWfNew.add(opertor+"_"+opertortype);
                                }
                            }
                        }
                        if(SignType==1){
                            if(nextnodeattr==2){
                                operatorgroup--;
                            }else{
                                operatorgroup++;
                            }
                        }

                    }

                    //操作人更新结束
                    //更新当前节点表
                    if(canflowtonextnode){
                        if(!"intervenor".equals(src) || !FreeNodeBiz.isFreeNode(nodeid)){

                            if (nextnodeattr != 2) {//中间推荐退回到主干节点
                                rst.executeSql("delete from workflow_nownode where requestid=" + requestid);//删掉所有的当前节点
                            }
                            if(innodeids.equals("")||innodeids.equals("0")) innodeids=nodeid+"";
                            rst.executeSql("delete from workflow_nownode where nownodeid in("+innodeids+") and requestid="+requestid);
                            rst.executeSql("delete from workflow_nownode where nownodeid="+nodeid+" and requestid="+requestid);
                        }
                        rst.executeSql("insert into workflow_nownode(requestid,nownodeid,nownodetype,nownodeattribute) values("+requestid+","+nextnodeid+","+nextnodetype+","+nextnodeattr+")");
                    }
                }
                requestFlowInfoEntity.setDestnodeid(nextnodeid);
                String tempNextNodeId = String.valueOf(nextnodeid);
                operator89mp.put(tempNextNodeId, operator89List);
                operatortype89mp.put(tempNextNodeId, operatortype89List);
                agentoperator89mp.put(tempNextNodeId, agentoperator89List);

				requestFlowInfoEntity.setDestnodeid(nextnodeid);
                requestFlowInfoEntity.setLinkId(nextLinkId);
                RequestBaseBiz.saveRequestFlowInfo(requestFlowInfoEntity,rst);
            }catch(Exception exception){
                throw exception;
            }
        }


    }

    private boolean verifySubmit(){
        if(!src.equals("supervise")&&!src.equals("intervenor")){
            RecordSet rs = new RecordSet();
            if(isremark!=9){
                if(!CanModify){
                    rs.executeSql("select 1 from workflow_currentoperator where (isremark NOT IN ('1','2', '4','11' ) or agenttype = 1 or (isremark =1 and takisremark=2)) and (takisremark<>-2 or takisremark is null) and requestid="+requestid+" and userid="+userid+" and nodeid="+nodeid);
                    if(rs.getCounts()<1){
                        this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_02); //已经流转到下一节点，不可以再提交
                        return false;
                    }
                }
                rs.executeSql("select 1 from workflow_currentoperator where (isremark NOT IN ('2', '4','11' ) or agenttype = 1) and (takisremark<>-2 or takisremark is null) and requestid="+requestid+" and userid="+userid+" and nodeid="+nodeid);
                if(rs.getCounts()<1){
                    this.setMessage(WorkflowRequestMessage.WF_REQUEST_ERROR_CODE_02); //已经流转到下一节点，不可以再提交
                    return false;
                }
            }
        }
        return true;
    }

    public String getIsRobotNode() {
        return isRobotNode;
    }

    public void setIsRobotNode(String isRobotNode) {
        this.isRobotNode = isRobotNode;
    }

    public boolean conformCheck() {
        if("submit".equals(src) && isremark ==0 && !conformCheckExecuted){
            try{
                RuleCompareResult ruleCompareResult = new ConformCheckBiz().compareRules4NodeCheck(requestid,workflowid, RuleSource.NODE_CHECK,nodeid+"",user,needConformCheck);
                if(ruleCompareResult.getProcessType()==0 && !ruleCompareResult.isResult()){
                    writeLog("合规校验未通过,流程禁止提交：requestid：" + requestid + "===nodeid:" + nodeid);
                    String message = "";
                    if(isBatchSubmit){
                        message = SystemEnv.getHtmlLabelName(533851,weaver.general.Util.getIntValue(user.getLanguage()));
                    }else{
                        message = SystemEnv.getHtmlLabelName(533505,weaver.general.Util.getIntValue(user.getLanguage()));
                    }
                    String messagecontent = "<a href='javascript:void(0)' onClick='window.showRuleCompareResult()'>" +  SystemEnv.getHtmlLabelNames(String.valueOf(83110), user.getLanguage()) + "</a>&nbsp;";
                    RequestOperationResultBean resultBean = new  RequestOperationResultBean();
                    resultBean.setMessageInfo(SubmitErrorMsgBiz.getMsgInfo(request,user,message,messagecontent));
                    resultBean.setType(RequestExecuteType.FAILD);
                    String sessionkey = "ConformCheck_" + requestid + "_" + nodeid;
                    Util_TableMap.setObjVal(Util.null2String(sessionkey+"_"+userid), "0");
                    Util_TableMap.setObjVal(Util.null2String(sessionkey), resultBean);
                    return false;
                }
            }catch (Exception e){
                writeLog("节点字段校验异常:"+e);
                return false;
            }
        }
        return true;
    }
}